	.globl	_u
_u	=	0x3a8000
	.globl	_exclint
_exclint	=	0x0
SYSSP	=	0x40000
SYSMODE	=	0x2000
SPL0	=	0x2000
SPL1	=	0x2100
SPL2	=	0x2200
SPL3	=	0x2300
SPL4	=	0x2400
SPL5	=	0x2500
SPL6	=	0x2600
SPL7	=	0x2700
WDOGW	=	0x810100
CIOPA	=	0x800105
CIOPB	=	0x800103
CIOPC	=	0x800101
CIOCTL	=	0x800107
SEGMAP	=	0x800000
PAGEMAP	=	0x800080
CONTEXT	=	0x800103
PAGERO	=	0x0
PAGERW	=	0x4000
PAGENX	=	0x8000
PAGEIO	=	0xc000
PAGESIZE	=	0x800
PAGEMASK	=	0x7ff
PAGEDELTA	=	0x800
MAXPAGE	=	0x800
SEGDELTA	=	0x8000
MAXSEG	=	0x80
PROMSIZE	=	0x4000
TEMPADR	=	0x10000
TEMPSEG	=	0x810000
TRAPSTK	=	0x8
MINMEM	=	0x80000
MAXMEM	=	0x400000
UDFC	=	0x1
UPAGEN	=	0x750
UPAGE	=	0x3a8000
UPAGEA	=	0xba8080
XPAGE	=	0x3a8800
XPAGEA	=	0xba8880
YPAGE	=	0x3a9000
YPAGEA	=	0xba9080
OPC_CMP	=	0x884
OPC_ID11	=	0xbe
OPC_ID9	=	0x3e
OPC_SFSR	=	0x3084
FP_RDDATA	=	0x820110
FP_WRDATA	=	0x820110
FP_RDSTAT	=	0x820120
FP_WRID	=	0x820130
FP_DONE	=	0x820180
FPS_DONE	=	0x0
ANTVECT	=	0xc0


vector:

	.globl	_firstve
_firstve:

	.globl	_firstvec
_firstvec:
	subql	#6,sp

	.globl	_endvec
_endvec:
	moveml	#0xfffe,-(sp)	| d0 d1 d2 d3 d4 d5 d6 d7 a0 a1 a2 a3 a4 a5 a6
	clrl	d0
	movw	0x48(sp),d0
	andw	#0xfff,d0
	asrl	#2,d0

dotrap0:
	movb	0x800103,0x41(sp)
	clrb	0x800103

dotrap:
	movl	usp,a0
	movl	a0,0x3c(sp)

dotrap1:
	movl	d0,-(sp)
	jsr	_trap
	addql	#4,sp
	movl	0x3c(sp),a0
	movl	a0,usp

notrap:
	moveq	#0xf,d0
	andb	0x41(sp),d0
	beqs	TS2059
	movb	_ccontex,d0

TS2059:
	movb	d0,0x800103
	moveml	(sp)+,#0x7fff	| d0 d1 d2 d3 d4 d5 d6 d7 a0 a1 a2 a3 a4 a5 a6
	addql	#6,sp
	rte

	.globl	_execstk
_execstk:
	movl	0x4(sp),a0
	subql	#8,a0
	cmpl	#0xade,(a0)
	bnes	TS2811
	movl	#0xa68,(a0)

TS2811:
	rts

	.globl	clrregs
clrregs:
        addql   #0x4,a7
        lea     (a7),a0
        moveml  (a0)+,#<d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6>
        bra     v32cont

	.globl	tnorm
tnorm:
        subql   #0x6,a7
        moveml  #<d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6>,-(a7)
        moveq   #0x00000020,d0
        bra     dotrap0

	.globl	vector32
vector32:
        tstb    0x3a8123
        bnes    tnorm
        btst    #0x5,(a7)
        bnes    tnorm
        subw    #0x42,a7
        movl    a0,32.(a7)
        movl    a1,36.(a7)
        clrb    CIOPB
        movl    usp,a0
        movl    a0,60.(a7)
        movl    d0,0x3a811e
        movl    d0,(a7)
        lea     (a7),a0
        movl    a0,0x3a801a
        moveq   #0x3F,d1
        andl    d1,d0
        movl    #_uxnargs,a0
        movb    0.(a0,d0:l),d1
        beqs    v32narg
        asll    #0x2,d0
        movl    #_uxfuncs,a0
        movl    0.(a0,d0:l),a1
        movl    usp,a0
        addql   #0x4,a0
        movl    d1,d0
        movl    a1,-(a7)
        bsr     argcallr

	.globl	v32aret
v32aret:
        addql   #0x4,a7
        bras    v32sret

	.globl	v32narg
v32narg:
        asll    #0x2,d0
        movl    #_uxfuncs,a0
        movl    0.(a0,d0:l),a0
        jsr     (a0)

	.globl	v32sret
v32sret:
        tstl    d0
        bges    P1001
        movl    (a7),d1
        cmpw    #0x1A,d1
        beqs    P1001
        negl    d0
        moveq   #0x1,d1
        orb     d1,67.(a7)
        bras    v32cont
P1001:
        moveq   #0xFFFFFFFE,d1
        andb    d1,67.(a7)

	.globl	v32cont
v32cont:
        movl    d0,d1
        movl    _runtcb,a0
        tstl    42.(a0)
        bnes    P1082
        tstb    _reschf
        bnes    P1070
        tstb    _iodnflg
        bnes    P1070
P1030:             
        movl    60.(a7),a0
        movl    a0,usp
        movb    _ccontext,d0
        movb    d0,CIOPB
        movl    36.(a7),a1
        movl    32.(a7),a0
        movl    _u+286,d0
        exg     d0,d1
        addw    #0x42,a7
        rte
P1070:
        movl    d1,(a7)
        jsr     _exitlv2
        movl    (a7),d1
	bras    P1030
P1082:
        movl    d1,(a7)
        movl    _u+286,d0
        movl    d0,4.(a7)

	.globl	v32sig1
v32sig1:
        lea     32.(a7),a0
        moveml  #<d2,d3,d4,d5,d6,d7>,-(a0)
        lea     60.(a7),a0
        moveml  #<a2,a3,a4,a5,a6>,-(a0)
        moveq   #0x0,d0
        movb    #0x1,65.(a7)
        bra     dotrap1

	.globl	icioa0
icioa0:
        btst    #0x0,CIOPA
        bne     icioa
        movb    #0x8,CIOCTL
        movb    #0x20,CIOCTL
        rte
	
	.globl	icioa
icioa:
        subql   #0x4,a7
        movw    #0x820,-(a7)
        bras    int1

	.globl	int
int:
        subql   #0x4,a7
        clrw    -(a7)

	.globl	int1
int1:
        subw    #0x3C,a7
        movl    a1,36.(a7)
        movl    a0,32.(a7)
        movl    d1,4.(a7)
        movl    d0,(a7)
        clrl    d0
        movw    72.(a7),d0
        andw    #0xFFF,d0
        movb    CIOPB,65.(a7)
        clrb    CIOPB
        clrw    _idleflg
        movl    #0x300,a1
        addl    d0,a1
        movl    (a1)+,a0
        movl    (a1),-(a7)
        jsr     (a0)

	.globl	iretloc
iretloc:
        addql   #0x4,a7
        movw    60.(a7),d0
        beqs    P2024
        movl    d0,d1
        lsrl    #0x8,d1
        movb    d1,CIOCTL
        movb    d0,CIOCTL
P2024:
        btst    #0x5,66.(a7)
        bnes    P2040
        tstb    _iodnflg
        bnes    P2080
P2040:
        moveq   #0xF,d0
        andb    65.(a7),d0
        beqs    P2054
        movb    _ccontext,d0
P2054:
        movb    d0,CIOPB
        movl    (a7),d0
        movl    4.(a7),d1
        movl    32.(a7),a0
        movl    36.(a7),a1
        addw    #0x42,a7
        rte
P2080:
        movl    usp,a0
        movl    a0,60.(a7)
        jsr     _exitlv2
        movl    _runtcb,a0
        tstl    42.(a0)
        bne     v32sig1
        movl    60.(a7),a0
        movl    a0,usp
        bras    P2040

	.globl	baderr
baderr:
        btst    #0x5,(a7)
        beq     P3080
        movl    d0,-(a7)
        movw    proflag,d0
        bne     P3042
        movw    12.(a7),d0
        andw    #0x7,d0
        cmpw    #0x1,d0
        bne     P3078
        movl    a1,d0
        bne     P3078
P3042:
        movw    10.(a7),d0
        andw    #0xFFF,d0
        movw    d0,60.(a7)
        movl    #berr0,56.(a7)
        movw    4.(a7),54.(a7)
        movl    (a7)+,d0
        addl    #0x32,a7
        rte
P3078:       
        movl    (a7)+,d0
P3080:       
        subql   #0x6,a7
        moveml  #<d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6>,-(a7)
        clrl    d0
        movw    72.(a7),d0
        andw    #0xFFF,d0
        asrl    #0x2,d0
        movb    CIOPB,65.(a7)
        clrb    CIOPB
        movl    usp,a0
        movl    a0,60.(a7)
        movl    d0,-(a7)
        jsr     _trap
        addql   #0x4,a7
        movl    60.(a7),a0
        movl    a0,usp
        moveq   #0xF,d0
        andb    65.(a7),d0
        beq     P3150
        movb    _ccontext,d0
P3150:             
	movb    d0,CIOPB
        moveml  (a7)+,#<d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6>
        addql   #0x6,a7
        movl    d0,-(a7)
        movw    10.(a7),d0
        andl    #0xF000,d0
        beq     P3182
        movl    (a7)+,d0
        rte
P3182:             
	movw    10.(a7),d0
        andw    #0xFFF,d0
        movw    d0,60.(a7)
        movl    6.(a7),56.(a7)
        movw    4.(a7),54.(a7)
        movl    (a7)+,d0
        addl    #0x32,a7
        rte

	.globl	_start
_start:
	movw	#0x2700,sr
	movl	(sp),d0
	movl	d0,_btargc
	asll	#2,d0
	movl	sp@(0xc,d0:w),a0
	movl	a0,_bootjt
	movl	0x4(sp),a0
	movl	a0,_btargv
	movl	sp@(0x10,d0:w),a0
	movl	a0,_bootrp
	movl	#_end,d0
	addl	#0x7ff,d0
	andl	#0xfffff800,d0
	movl	d0,_ednix
	addl	#0x800,d0
	movl	d0,_umem
	movl	#_edata,a0
	moveq	#0x0,d1

TS2:
	movl	d1,(a0)+
	cmpl	a0,d0
	bgts	TS2
	clrb	0x800103
	movb	#0x1,_ccontex
	movl	_ednix,d0
	addl	#0x7fc,d0
	movl	d0,sp
	asrl	#8,d0
	asrl	#3,d0
	orw	#0x4000,d0
	movw	d0,0xba8080
	movl	sp,d0
	andl	#0x7ff,d0
	addl	#0x3a8000,d0
	movl	d0,sp
	movl	#0x1,d0
	movec	d0,sfc
	movec	d0,dfc
	movl	#0x100,d2
	movl	#0x1234,-(sp)
	clrl	-(sp)

TS2060:
	movw	0x810100,d0
	movw	d2,d1
	orw	#0x4000,d1
	movb	_ccontex,0x800103
	movw	#0x8010,0x800000
	movw	d1,0x800080
	bsr	probe
	cmpl	#0x1234,d0
	bne	TS3
	addql	#1,d2
	cmpw	#0x800,d2
	bcs	TS2060

TS3:
	movl	d2,_mempage
	addql	#8,sp
	movw	#0x4,-(sp)
	clrl	-(sp)
	clrw	-(sp)
	movb	#0x1,0x800103
	bra	vector

	.globl	_save
_save:
	movl	(sp)+,a1
	movl	(sp),a0
	moveml	#0xfefc,(a0)	| d2 d3 d4 d5 d6 d7 a1 a2 a3 a4 a5 a6 sp
	clrl	d0
	jmp	(a1)

	.globl	_resume
_resume:
	movl	0x4(sp),d0
	orw	#0x4000,d0
	movl	0x8(sp),a0
	movw	#0x2700,sr
	movl	#SYSTACK,sp
	movw	d0,0xba8080
	moveml	(a0),#0xfefc	| d2 d3 d4 d5 d6 d7 a1 a2 a3 a4 a5 a6 sp
	movw	#0x2000,sr
	moveq	#0x1,d0
	jmp	(a1)

	.globl	_spl7
_spl7:
	movw	sr,d0
	movw	#0x2700,sr
	rts

	.globl	_spl6
_spl6:
	movw	sr,d0
	movw	#0x2600,sr
	rts

	.globl	_spl5
_spl5:
	movw	sr,d0
	movw	#0x2500,sr
	rts

	.globl	_spl4
_spl4:
	movw	sr,d0
	movw	#0x2400,sr
	rts

	.globl	_spl3
_spl3:
	movw	sr,d0
	movw	#0x2300,sr
	rts

	.globl	_spl2
_spl2:
	movw	sr,d0
	movw	#0x2200,sr
	rts

	.globl	_spl1
_spl1:
	movw	sr,d0
	movw	#0x2100,sr
	rts

	.globl	_spl0
_spl0:
	movw	sr,d0
	movw	#0x2000,sr
	rts

	.globl	_splx
_splx:
	movl	0x4(sp),d1
	movw	sr,d0
	andw	#0x2700,d1
	movw	d1,sr
	rts

	.globl	_getsr
_getsr:
	clrl	d0
	movw	sr,d0
	rts

	.globl	_idle
_idle:
	movw	#0x1,_idleflg
	movw	sr,d0
	movw	#0x2000,sr

	.globl	_waitloc
_waitloc:
	tstw	_idleflg
	bne	_waitloc
	movw	d0,sr
	rts

	.globl	_copy_zp
_copy_zp:
	movl	0x4(sp),d0
	orl	#0x4000,d0
	movw	0xba8880,-(sp)
	movw	d0,0xba8880
	movl	#0x3a8800,a1
	movl	#0x200,d0
	clrl	d1
	bra	TS1014

TS1015:
	movl	d1,(a1)+

TS1014:
	dbf	d0,TS1015
	movw	(sp)+,0xba8880
	rts

	.globl	_copy_cp
_copy_cp:
	movl	0x4(sp),d0
	orw	#0x0,d0
	movl	0x8(sp),d1
	orl	#0x4000,d1
	movw	0xba8880,-(sp)
	movw	0xba9080,-(sp)
	movw	d0,0xba8880
	movw	d1,0xba9080
	movl	#0x3a8800,a0
	movl	#0x3a9000,a1
	movl	#0x200,d0
	bra	TS847

TS848:
	movl	(a0)+,(a1)+

TS847:
	dbf	d0,TS848
	movw	(sp)+,0xba9080
	movw	(sp)+,0xba8880
	rts

	.globl	_copy_sp
_copy_sp:
	movl	0x4(sp),d0
	orw	#0x4000,d0
	movl	0x8(sp),d1
	orl	#0x4000,d1
	movw	0xba8880,-(sp)
	movw	0xba9080,-(sp)
	movw	d0,0xba8880
	movw	d1,0xba9080
	movl	#0x3a8800,a0
	movl	#0x3a9000,a1
	movl	#0x200,d0
	bra	TS1039

TS1040:
	movl	(a0),d1
	movl	(a1),(a0)+
	movl	d1,(a1)+

TS1039:
	dbf	d0,TS1040
	movw	(sp)+,0xba9080
	movw	(sp)+,0xba8880
	rts

	.globl	_haltcpu
_haltcpu:
	movw	#0x2700,sr
	bra	_haltcpu

	.globl	_debug
_debug:
	trap	#0xe
	rts

	.globl	_dlymicro
_dlymicro:

	.globl	_dlymicr
_dlymicr:
	movl	0x4(sp),d0
	lsrl	#3,d0

TS1324:
	movw	0x810100,d1

TS1323:
	nop
	nop
	dbf	d0,TS1323
	subl	#0x10000,d0
	bcc	TS1324
	rts

	.globl	_watchdg
_watchdg:
	movw	0x810100,d0
	rts

	.globl	_put_pgrp
_put_pgrp:
	movl	0x4(sp),d1
	asll	#8,d1
	asll	#7,d1
	orl	#0x800000,d1
	movl	d1,a0
	movb	_ccontex,d0
	movb	d0,0x800103
	movw	0xa(sp),(a0)
	clrb	0x800103
	rts

	.globl	_get_pgrp
_get_pgrp:
	movl	0x4(sp),d1
	asll	#8,d1
	asll	#7,d1
	orl	#0x800000,d1
	movl	d1,a0
	movb	_ccontex,d0
	movb	d0,0x800103
	movw	(a0),d0
	andl	#0x807f,d0
	clrb	0x800103
	rts

	.globl	_copy_out
_copy_out:
	movb	_ccontex,d0
	beq	_copy_ss
	movb	d0,0x800103
	moveml	#0x2020,-(sp)	| d2 a2
	movl	#berr1,a1
	movl	0xc(sp),a0
	movl	0x10(sp),a2
	movl	0x14(sp),d2
	beq	TS709
	movl	a0,d0
	btst	#0,d0
	beq	TS710
	movb	(a0)+,d0
	.word	0xe1a		| moves.b d0,(a2)+
	.word   0x800
	subql   #0x1,d2

TS710:
	movl	a2,d0
	btst	#0,d0
	bne	TS711
	movl	d2,d1
	lsrl	#2,d1
	bcc	TS713
	movw	(a0)+,d0
	.word	0xe5a		| moves.w d0,(a2)+
	.word   0x800
	bras	TS713

TS714:
	movl	(a0)+,d0
	.word	0xe9a		| moves.l d0,(a2)+
	.word	0x800

TS713:
	dbf	d1,TS714
	andl	#0x1,d2
	bras	TS711

TS712:
	movb	(a0)+,d0
	.word	0xe1a		| moves.b d0,(a2)+
	.word	0x800

TS711:
	dbf	d2,TS712

TS709:
	clrb	0x800103
	moveml	(sp)+,#0x404	| d2 a2
	clrl	d0
	rts

	.globl	_copy_in
_copy_in:
	movb	_ccontex,d0
	beq	_copy_ss
	movb	d0,0x800103
	moveml	#0x2020,-(sp)	| d2 a2
	movl	#berr1,a1
	movl	0xc(sp),a0
	movl	0x10(sp),a2
	movl	0x14(sp),d2
	beq	TS795
	movl	a0,d0
	btst	#0,d0
	beq	TS796
	.word	0xe18		| moves.b (a0)+,d0
	.word	0x000
	movb	d0,(a2)+
	subql	#1,d2

TS796:
	movl	a2,d0
	btst	#0,d0
	bne	TS797
	movl	d2,d1
	lsrl	#2,d1
	bcc	TS799
	.word	0xe58		| moves.w (a0)+,d0
	.word	0x000
	movw	d0,(a2)+
	bras	TS799

TS800:
	.word	0xe98		| moves.l (a0)+,d0
	.word	0x000
	movl	d0,(a2)+

TS799:
	dbf	d1,TS800
	andl	#0x1,d2
	bras	TS797

TS798:
	.word	0xe18		| moves.b (a0)+,d0
	.word	0x000
	movb	d0,(a2)+

TS797:
	dbf	d2,TS798

TS795:
	clrb	0x800103
	moveml	(sp)+,#0x404	| d2 a2
	clrl	d0
	rts

	.globl	_copy_ss
_copy_ss:
	movl	0x4(sp),a0
	movl	0x8(sp),a1
	movl	0xc(sp),d1
	beq	TS514
	movl	a0,d0
	btst	#0,d0
	beq	TS515
	movb	(a0)+,(a1)+
	subql	#1,d1

TS515:
	movl	a1,d0
	btst	#0,d0
	bne	TS516
	movl	d1,d0
	lsrl	#2,d0
	bcc	TS518
	movw	(a0)+,(a1)+
	bras	TS518

TS519:
	movl	(a0)+,(a1)+

TS518:
	dbf	d0,TS519
	andl	#0x1,d1
	bras	TS516

TS517:
	movb	(a0)+,(a1)+

TS516:
	dbf	d1,TS517

TS514:
	clrl	d0
	rts

	.globl	_copy_arg
_copy_arg:
	movl	0xc(sp),d1
	bne	TS2018
	movl	0x4(sp),a0
	jmp	(a0)

TS2018:
	movl	0x8(sp),a0

argcallr:
	moveml	#0x2020,-(sp)	| d2 a2
	movl	#berr2,a1
	movl	d1,d2
	asll	#2,d2
	subl	d2,sp
	movl	sp,a2
	movb	_ccontex,d0
	movb	d0,0x800103
	bras	TS2019

TS2020:
	.word	0xe98		| moves.l (a0)+,d0
	.word	0x000
	movl	d0,(a2)+

TS2019:
	dbf	d1,TS2020
	clrb	0x800103
	movl	0xc(a2),a0
	jsr	(a0)
	addl	d2,sp
	moveml	(sp)+,#0x404	| d2 a2
	rts

	.globl	_copy_sts
_copy_sts:
	movl	0x4(sp),a0
	movl	0x8(sp),d1
	moveml	#0x2020,-(sp)	| d2 a2
	movl	#berr1,a1
	clrl	d2
	movb	_ccontex,d0
	movb	d0,0x800103

TS2062:
	addql	#1,d2
	.word	0xe18		| moves.b (a0)+,d0
	.word	0x000
	tstb	d0
	beq	TS2061
	dbf	d1,TS2062

TS2061:
	movl	d2,d0
	moveml	(sp)+,#0x404	| d2 a2
	clrb	0x800103
	rts

	.globl	_copy_fb
_copy_fb:
	movl	#berr0,a1
	movb	_ccontex,d0
	movl	0x4(sp),a0
	movb	d0,0x800103
	clrl	d0
	.word	0xe10		| moves.b (a0),d0
	.word   0x000
        clrb    CIOPB
        rts


	.globl	_copy_fl
_copy_fl:
	movl	#berr0,a1
	movb	_ccontex,d0
	movl	0x4(sp),a0
	movb	d0,0x800103
	.word	0xe90		| moves.l (a0),d0
	.word   0x000
        clrb    CIOPB
        rts


	.globl	_copy_sb
_copy_sb:
	movl	#berr0,a1
	movb	_ccontex,d0
	movl	0x4(sp),a0
	movl	0x8(sp),d1
	movb	d0,0x800103
	clrl	d0
	.word	0xe10		| moves.b a0,(a0)
	.word	0x1800
	clrb	0x800103
	rts

probe:
	movb	_ccontex,d0
	movl	0x4(sp),a0
	movl	0x8(sp),d1
	movl	#0x0,a1
	movb	d0,0x800103
	clrl	d0
	.word	0xe50		| moves.w a0,(a0)
	.word   0x1800
	.word	0xe50		| moves.w (a0),d0
	.word	0x000
	clrb    CIOPB
        rts


	.globl	_probyte
_probyte:
	movw	#0x1,proflag
	movl	#0x0,a1
	movl	0x4(sp),a0
	clrl	d0
	movb	(a0),d0
	clrw	proflag
	rts

	.globl	_proshor
_proshor:
	movw	#0x1,proflag
	movl	#0x0,a1
	movl	0x4(sp),a0
	clrl	d0
	movw	(a0),d0
	clrw	proflag
	rts

berr2:
	addl	d2,sp

berr1:
	moveml	(sp)+,#0x404	| d2 a2

berr0:
	clrb	0x800103
	clrw	proflag
	movl	#0xffffffff,d0
	rts

	.globl	_out2b
_out2b:
	movl	0x4(sp),a0
	movw	sr,d1
	movw	#0x2700,sr
	movb	0xa(sp),(a0)
	movb	0xb(sp),(a0)
	movw	d1,sr
	rts

	.globl	fpsub11
fpsub11:
	movw	#0xbe,0x820130
	movl	#0x820120,a1
	movw	a0,0xfffe(a1)
	moveml	#0xf000,-(a1)	| d0 d1 d2 d3
	clrl	d2
	movl	#0x820180,a1
	movw	#0x3e8,d1

	.globl	fp11wait
fp11wait:
	movw	(a1),d0
	btst	#0,d0
	bne	fp11done
	dbf	d1,fp11wait

fptout:
	moveq	#0xffffffff,d2
	rte

fp11done:
	movl	#0x820110,a1
	movw	0x820120,d0
	btst	#0,d0
	bne	fp11trap
	exg	d0,a0
	btst	#11,d0
	bne	fpcmp
	movl	(a1),d1
	swap	d1
	movl	(a1),d0
	swap	d0
	rte

fpcmp:
	exg	d0,a0
	lsrb	#4,d0
	andb	#0xc,d0
	movb	d0,0x1(sp)
	rte

fp11trap:
	movw	#0x3e,0x820130
	movw	#0x3084,0x820110
	movl	(a1),d2
	swap	d2
	clrl	d0
	clrl	d1
	rte

	.globl	_trap
_trap:
	link	a6,#0xfff4
	moveml	#0xf04,-(sp)	| d4 d5 d6 d7 a5
	movl	0x3a807a,0xfffc(a6)
	cmpl	#0x19,0x8(a6)
	bnes	TS4
	jsr	_watchdg
	movw	d0,d7
	tstw	0xfffffc
	beqs	TS2056
	clrl	0xfff8(a6)

TS2056:
	btst	#14,d7
	beqs	TS4
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)		| status
	movw	d7,d0
	andl	#0x3f,d0
	moveq	#0x10,d1
	asll	d1,d0
	movl	d0,-(sp)		| address
	movw	d7,d0
	extl	d0
	btst	#15,d0
	beqs	TS2057

	| "Unc"
	movl	#_swapdev+47,d0
	bras	TS2058

TS2057:
	| "C\0"
	movl	#_swapdev+51,d0

TS2058:
	movl	d0,-(sp)

	| "%sorrectable error at adr 0x%X, status=0x%x\n"
	movl	#_swapdev+2,-(sp)	
	jsr	_PRINT
	addw	#0x10,sp
	bra	TS1361

TS4:
	btst	#5,0x4e(a6)
	beq	TS5
	cmpl	#0x2,0x8(a6)
	beqs	TS2046
	cmpl	#0x3,0x8(a6)
	bnes	TS2047

TS2046:
	movl	0x54(a6),d0
	andl	#0x7,d0
	cmpl	#0x1,d0
	bnes	TS2047
	cmpl	#0x2,0x8(a6)
	bnes	TS2055
	movl	0x54(a6),-(sp)
	movl	0x58(a6),-(sp)
	jsr	_pg_fault
	addql	#8,sp
	tstl	d0
	bne	TS1361

TS2055:
	movl	0x30(a6),0x50(a6)
	pea	0xc(a6)
	jsr	_setnsf
	addql	#4,sp
	bra	TS1361

TS2047:
	movl	0x8(a6),d0
	cmpl	#0x9,d0
	beqs	TS2048
	cmpl	#0x1f,d0
	beq	TS1361
	cmpl	#0x2,0x50(a6)
	bnes	TS2049
	cmpl	#0x20,d0
	bnes	TS2049
	lea	0x54(a6),a0
	movl	a0,0xfff4(a6)
	movl	a0,d0
	addql	#2,d0
	movl	d0,0xfff4(a6)
	movl	d0,a0
	movl	(a0),d0
	cmpl	_iretloc,d0
	bnes	TS2049
	moveq	#0x4,d0
	movl	d0,-(sp)
	movl	0x34(a6),-(sp)
	jsr	ldiv
	addql	#8,sp
	subql	#2,d0
	movl	d0,-(sp)

	| "\nOS: WARNING: Illegal int., vector=%x\n"
	movl	#_swapdev+53,-(sp)
	jsr	_PRINT
	addql	#8,sp
	movl	_ilintcnt,d0
	addql	#1,_ilintcnt
	cmpl	#0x5,d0
	bges	TS2049
	bra	TS1361

TS2048:
	cmpl	#0xa00,0x50(a6)
	blt	TS1361
	cmpl	#0xa02,0x50(a6)
	bge	TS1361
	bra	TS1361

TS2049:
	cmpl	#0x2e,0x8(a6)
	beqs	TS2050

	| "\nOS: PANIC: Trap in system mode - SYSTEM HALTED!\n"
	movl	#_swapdev+92,-(sp)
	jsr	_PRINT
	addql	#4,sp

TS2050:
	movl	0x58(a6),-(sp)		| fad
	movl	0x50(a6),-(sp)		| pc
	movl	0x54(a6),-(sp)		| ssr
	movl	0x4c(a6),-(sp)		| sr
	pea	0xc(a6)			| ssp
	movl	0x8(a6),-(sp)		| trap
	movl	#_swapdev+142,-(sp)

	| "\nTrap=%d, ssp=%X, sr=%X, ssr=%X, pc=%X, fad=%X\n"
	jsr	_PRINT
	addw	#0x1c,sp
	movl	0x28(a6),-(sp)		| d7
	movl	0x24(a6),-(sp)		| d6
	movl	0x20(a6),-(sp)		| d5
	movl	0x1c(a6),-(sp)		| d4
	movl	0x18(a6),-(sp)		| d3
	movl	0x14(a6),-(sp)		| d2
	movl	0x10(a6),-(sp)		| d1
	movl	0xc(a6),-(sp)		| d0

	| "d0-d7 %X %X %X %X  %X %X %X %X\n"
	movl	#_swapdev+190,-(sp)
	jsr	_PRINT
	addw	#0x24,sp
	movl	0x48(a6),-(sp)		| a7
	movl	0x44(a6),-(sp)		| a6
	movl	0x40(a6),-(sp)		| a5
	movl	0x3c(a6),-(sp)		| a4
	movl	0x38(a6),-(sp)		| a3
	movl	0x34(a6),-(sp)		| a2
	movl	0x30(a6),-(sp)		| a1
	movl	0x2c(a6),-(sp)		| a0

	| "a0-a7 %X %X %X %X  %X %X %X %X\n"
	movl	#_swapdev+222,-(sp)
	jsr	_PRINT
	addw	#0x24,sp

	| "System stack:"
	movl	#_swapdev+254,-(sp)
	jsr	_PRINT
	addql	#4,sp
	movl	0x44(a6),a5
	clrw	d7
	bras	TS2051

TS2052:
	cmpl	#0x3a87fc,a5
	bccs	TS2053
	cmpw	#0x40,d7
	bgts	TS2053
	movw	d7,d0
	andw	#0x7,d0
	bnes	TS2054

	| "\n\0"
	movl	#_swapdev+268,-(sp)
	jsr	_PRINT
	addql	#4,sp

TS2054:
	addqw	#1,d7
	movl	0x4(a5),-(sp)

	| "%X "
	movl	#_swapdev+270,-(sp)
	jsr	_PRINT
	addql	#8,sp
	movl	(a5),a5

TS2051:
	cmpl	#0x3a8000,a5
	bhis	TS2052

TS2053:
	movl	#_swapdev+274,-(sp)

	| "\n\0"
	jsr	_PRINT
	addql	#4,sp
	moveq	#0x1,d0
	movl	d0,-(sp)
	bsr	_stopcpu
	addql	#4,sp

TS5:
	lea	0xc(a6),a0
	movl	a0,0x3a801a
	cmpl	#0x2,0x8(a6)
	bnes	TS6
	movl	_runtcb,a0
	movw	0x22(a0),d0
	btst	#0,d0
	beqs	TS2025
	jsr	_pg_swproc

TS2025:
	movl	0x54(a6),-(sp)
	movl	0x58(a6),-(sp)
	jsr	_pg_fault
	addql	#8,sp
	tstl	d0
	bne	TS1361

TS6:
	cmpl	#0x20,0x8(a6)
	bne	TS7
	movl	0xc(a6),d0
	andl	#0x3f,d0
	movl	d0,d6
	clrl	d5
	movl	0xc(a6),0x3a811e
	movl	d6,d0
	addl	#_uxnargs,d0
	movl	d0,a0
	clrl	d0
	movb	(a0),d0
	movl	d0,d4
	beqs	TS2022
	movl	d4,-(sp)
	movl	0x48(a6),d0
	addql	#4,d0
	movl	d0,-(sp)
	movl	d6,d0
	asll	#2,d0
	addl	#_uxfuncs,d0
	movl	d0,a0
	movl	(a0),-(sp)
	jsr	_copy_arg
	addw	#0xc,sp
	bras	TS2024

TS2022:
	movl	d6,d0
	asll	#2,d0
	addl	#_uxfuncs,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)

TS2024:
	movl	d0,d5
	bges	TS2023
	cmpl	#0x1a,d6
	beqs	TS2023
	bset	#0,0x4f(a6)
	movl	d5,d0
	negl	d0
	movl	0x3a801a,a0
	movl	d0,(a0)
	bra	TS1576

TS2023:
	bclr	#0,0x4f(a6)
	movl	0x3a801a,a0
	movl	d5,(a0)
	movl	0x3a801a,a0
	movl	0x3a811e,0x4(a0)
	bra	TS1576

TS7:
	cmpl	#0x24,0x8(a6)
	bne	TS8
	movl	0x48(a6),d0
	addql	#4,d0
	movl	d0,-(sp)
	jsr	_copy_fl
	addql	#4,sp
	movl	d0,0xfff8(a6)
	andl	#0x7f,d0
	movl	d0,d6
	clrl	d5
	cmpl	#0x5a,d6
	bgts	TS2010
	tstl	d6
	bnes	TS2014

TS2010:
	moveq	#0xffffffcc,d5
	bras	TS2011

TS2014:
	cmpl	#0x1e,d6
	bges	TS2015
	moveq	#0x8,d0
	movl	d0,-(sp)
	movl	0x48(a6),d0
	addql	#4,d0
	movl	d0,-(sp)
	movl	d6,d0
	asll	#2,d0
	addl	#_t1dnixc,d0

TS2017:
	movl	d0,a0
	movl	(a0),-(sp)
	jsr	_copy_arg
	addw	#0xc,sp
	bras	TS2021

TS2015:
	movl	d6,d0
	subl	#0x1e,d0
	movl	d0,d6
	movl	d6,d0
	addl	#_dx2narg,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	movl	d0,d4
	beqs	TS2016
	movl	d4,-(sp)
	movl	0x48(a6),d0
	addql	#8,d0
	movl	d0,-(sp)
	movl	d6,d0
	asll	#2,d0
	addl	#_dx2func,d0
	bras	TS2017

TS2016:
	movl	d6,d0
	asll	#2,d0
	addl	#_dx2func,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)

TS2021:
	movl	d0,d5

TS2011:
	tstl	d5
	bges	TS2012
	bset	#0,0x4f(a6)
	bras	TS2013

TS2012:
	bclr	#0,0x4f(a6)

TS2013:
	movl	0x3a801a,a0
	movl	d5,(a0)
	bras	TS1576

TS8:
	movl	0x8(a6),d0
	cmpl	#0x4,d0
	beq	TS9
	bgt	TS1569
	tstl	d0
	beqs	TS1576
	cmpl	#0x1,d0
	beq	TS1577
	cmpl	#0x2,d0
	beq	TS2008
	cmpl	#0x3,d0
	beq	TS2009

TS1575:
	moveq	#0xa,d7

TS10:
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	movl	_runtcb,-(sp)
	jsr	_psignal
	addql	#8,sp

TS1576:
	movl	_runtcb,a0
	tstl	0x2a(a0)
	beqs	TS19
	jsr	_issig
	tstl	d0
	beqs	TS19
	jsr	_psig

TS19:
	clrw	_idleflg
	tstb	_iodnflg
	bnes	TS20
	tstb	_reschf
	beqs	TS1363

TS20:
	jsr	_exitlv2

TS1363:
	tstb	0x3a8123
	beq	TS1361
	movl	0x3a807a,d0
	subl	0xfffc(a6),d0
	movl	d0,-(sp)
	movl	#0x3a810e,-(sp)
	movl	0x50(a6),-(sp)
	jsr	_addupc
	addw	#0xc,sp
	bra	TS1361

TS1577:
	pea	0xc(a6)
	jsr	_main
	addql	#4,sp
	jsr	_exitlv2
	bras	TS1361

TS9:
	moveq	#0x4,d7
	bra	TS10

TS1570:
	moveq	#0x8,d7
	bra	TS10

TS1571:
	bclr	#7,0x4e(a6)

TS1574:
	moveq	#0x5,d7
	bra	TS10

TS1572:
	moveq	#0x6,d7
	bra	TS10

TS1573:
	moveq	#0x7,d7
	bra	TS10

TS2009:
	pea	0xc(a6)
	jsr	_setnsf
	addql	#4,sp
	bra	TS1575

TS2008:
	moveq	#0xb,d7
	pea	0xc(a6)
	jsr	_setnsf
	addql	#4,sp
	bra	TS10

TS1569:
	cmpl	#0x5,d0
	beqs	TS1570
	cmpl	#0x9,d0
	beqs	TS1571
	cmpl	#0xa,d0
	beqs	TS1572
	cmpl	#0xb,d0
	beqs	TS1573
	cmpl	#0x22,d0
	beqs	TS1574
	bra	TS1575

TS1361:
	moveml	(sp)+,#0x20f0	| d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_gadnuxa
_gadnuxa:
	link	a6,#0x0
	movl	0x3a801a,a0
	movl	0x3c(a0),d0
	movl	0x8(a6),d1
	addql	#1,d1
	asll	#2,d1
	addl	d1,d0
	unlk	a6
	rts

	.globl	_stopcpu
_stopcpu:
	link	a6,#0x0
	movl	d7,-(sp)
	jsr	_spl7
	tstb	_autoflg
	beqs	TS1322
	clrl	d7

TS1325:
	movl	#0x4e20,-(sp)
	jsr	_dlymicro
	addql	#4,sp
	addql	#1,d7
	cmpl	#0xbb8,d7
	blts	TS1325

TS1322:
	clrl	-(sp)
	jsr	_haltcpu
	addql	#4,sp
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_sendsig
_sendsig:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x3a801a,a0
	movl	0x3c(a0),d0
	subql	#6,d0
	movl	d0,d7
	movl	0x40(a0),-(sp)
	movl	d7,-(sp)
	jsr	_sushort
	addql	#8,sp
	movl	0x3a801a,a0
	movl	0x44(a0),-(sp)
	movl	d7,d0
	addql	#2,d0
	movl	d0,-(sp)
	jsr	_suword
	addql	#8,sp
	movl	0x3a801a,a0
	movl	d7,0x3c(a0)
	movl	0x3a801a,a0
	bclr	#7,0x42(a0)
	movl	0x8(a6),d0
	movl	0x3a801a,a0
	movl	d0,0x44(a0)
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_clocki
_clocki:
	link	a6,#0x0
	cmpw	#0x1f4,_lbolt
	bges	TS2063
	jsr	_watchdg

TS2063:
	movl	0x4c(a6),-(sp)
	movl	0x50(a6),-(sp)
	jsr	_clock
	addql	#8,sp
	unlk	a6
	rts

	.globl	_startup
_startup:
	link	a6,#0x0
	movl	_bootrp,a0
	movw	0x8(a0),_swapdev
	movw	0x6(a0),_rootdev
	clrl	d0
	movb	0x2(a0),d0
	movw	d0,_sspeed
	cmpw	#0xffff,_rootdev
	bnes	TS1578
	movw	0x4(a0),_rootdev

TS1578:
	movl	_bootrp,a0
	cmpb	#0x2,0x3(a0)
	blss	TS1579
	movb	#0x1,_autoflg
	bras	TS1659

TS1579:
	clrb	_autoflg

TS1659:
	movl	_bootrp,a0
	movw	0xc(a0),d0
	muls	#0x3c,d0
	negl	d0
	movl	d0,_Timezone
	movb	0x1e(a0),d0
	extw	d0
	extl	d0
	movl	d0,_Dstflag
	movl	_bootrp,a0
	movl	0x20(a0),DS1580
	movl	DS1580,DS524
	jsr	_pg_init
	bsrs	_localinit
	bsr	_clkstart
	unlk	a6
	rts

	.globl	_localinit
_localinit:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	bsr	_finvini
	bsrs	_cioinit
	movl	#0x480800,-(sp)
	jsr	_probyte
	addql	#4,sp
	movl	d0,d7
	blts	TS1658
	btst	#0,d7
	bnes	TS1658
	movb	#0x1,_graphp
	jsr	_loadf0
	jsr	_defwind
	jsr	_spl7
	movl	d0,d6
	movb	#0x27,0x800107
	clrl	d0
	movb	0x800107,d0
	bclr	#1,d0
	orl	#0x2700,d0
	movl	d0,-(sp)
	movl	#0x800107,-(sp)
	jsr	_out2b
	addql	#8,sp
	movl	d6,-(sp)
	jsr	_splx
	addql	#4,sp

TS1658:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_cioinit
_cioinit:
	link	a6,#0x0
	moveml	#0x904,-(sp)	| d4 d7 a5
	clrl	d4
	moveq	#0x4,d0
	movl	d0,-(sp)
	movl	#0x800107,-(sp)
	bsr	_gdynvek
	addql	#8,sp
	movl	d0,d7
	clrl	-(sp)
	movl	#0x19ec,-(sp)
	clrl	-(sp)
	movl	d7,-(sp)
	bsr	_setint
	addw	#0x10,sp
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#0x19ec,-(sp)
	clrl	-(sp)
	movl	d7,d0
	addql	#3,d0
	movl	d0,-(sp)
	bsr	_setint
	addw	#0x10,sp
	movb	#0xd0,0xfdb041
	movl	d7,d0
	addl	d0,d0
	addl	#0x400,d0
	movl	d0,-(sp)
	movl	#0x800107,-(sp)
	jsr	_out2b
	addql	#8,sp
	movl	#_cioinidat,a5
	bras	TS1656

TS1657:
	movw	(a5)+,d0
	extl	d0
	movl	d0,-(sp)
	movl	#0x800107,-(sp)
	jsr	_out2b
	addql	#8,sp

TS1656:
	tstw	(a5)
	bnes	TS1657
	moveml	(sp)+,#0x2090	| d4 d7 a5
	unlk	a6
	rts

	.globl	_dbpsetup
_dbpsetup:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d0
	andl	#0x3f,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#0xfe0001,d0
	movl	d0,a4
	movl	a4,(a5)
	lea	0x4(a4),a0
	movl	a0,0x4(a5)
	lea	0x8(a4),a0
	movl	a0,0x8(a5)
	movl	a4,0xc(a5)
	lea	0x8(a4),a0
	movl	a0,0x10(a5)
	lea	0xc(a4),a0
	movl	a0,0x14(a5)
	lea	0x10(a4),a0
	movl	a0,0x18(a5)
	lea	0x14(a4),a0
	movl	a0,0x1c(a5)
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_setint
_setint:
	link	a6,#0x0
	movl	d7,-(sp)
	subl	#0x20,0x8(a6)
	jsr	_spl7
	movl	d0,d7
	movw	#0x4000,0x800080
	movl	0x8(a6),d0
	asll	#3,d0
	addl	#0x400,d0
	movl	d0,a0
	movl	0x10(a6),(a0)
	movl	0x8(a6),d0
	asll	#3,d0
	addl	#0x404,d0
	movl	d0,a0
	movl	0x14(a6),(a0)
	clrw	0x800080
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	tstl	0xc(a6)
	beqs	TS1655
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1655:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_finvini
_finvini:
	link	a6,#0x0
	movl	d7,-(sp)
	moveq	#0x1,d7

TS1632:
	movl	d7,d0
	asll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	movl	#0xffffffff,(a0)
	addql	#1,d7
	cmpl	#0x6,d7
	blts	TS1632
	movl	#0xfdb041,_intport
	movl	#0xfd6000,BS1633
	movl	#0xfd5000,BS1634
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_gdynvek
_gdynvek:
	link	a6,#0xfff8
	moveml	#0x1f00,-(sp)	| d3 d4 d5 d6 d7
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	cmpl	#0xfe0001,d7
	bcss	TS1635
	cmpl	#0xfff801,d7
	bhis	TS1635
	movl	d7,a0
	movb	0x40(a0),d0
	notb	d0
	andl	#0xff,d0
	movl	d0,-(sp)
	bsr	_masktobn
	addql	#4,sp
	movl	d0,0xfff8(a6)
	bges	TS1646
	bra	TS1639

TS1638:
	movl	d5,d0

TS1646:
	addl	#0x20,d0
	bras	TS1639

TS1635:
	movl	d7,d7
	clrl	d5
	bras	TS1636

TS1637:
	movl	d5,d0
	lsll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	movl	(a0),d0
	cmpl	d7,d0
	beqs	TS1638
	addl	d6,d5

TS1636:
	cmpl	_antvect,d5
	bcss	TS1637
	movl	_antvect,d0
	subl	d6,d0
	movl	d0,0xfffc(a6)
	clrl	d5
	bras	TS1640

TS1642:
	movl	d4,d0
	addql	#1,d4
	lsll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	tstl	(a0)
	beqs	TS1643

TS1640:
	cmpl	0xfffc(a6),d5
	bhis	TS1641
	movl	d5,d4
	movl	d4,d3
	addl	d6,d5

TS1643:
	cmpl	d5,d4
	bcss	TS1642
	movl	d3,d4
	bras	TS1644

TS1645:
	movl	d4,d0
	lsll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	movl	d7,(a0)
	addql	#1,d4

TS1644:
	cmpl	d5,d4
	bcss	TS1645
	movl	d3,d0
	bras	TS1646

TS1641:
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp
	clrl	d0

TS1639:
	moveml	(sp)+,#0xf8	| d3 d4 d5 d6 d7
	unlk	a6
	rts

	.globl	_clkstart
_clkstart:
	link	a6,#0x0
	movl	#0xc24,-(sp)
	movl	#0x800107,-(sp)
	jsr	_out2b
	addql	#8,sp
	unlk	a6
	rts

	.globl	_addupc
_addupc:
	link	a6,#0xfff8
	movl	0x3a8116,d0
	subl	d0,0x8(a6)
	movl	0x3a811a,d0
	lsrl	#1,d0
	movl	d0,-(sp)
	movl	0x8(a6),d0
	lsrl	#1,d0
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp
	movl	d0,0xfffc(a6)
	moveq	#0xe,d1
	asrl	d1,d0
	movl	d0,0xfff8(a6)
	addql	#1,d0
	bclr	#0,d0
	movl	d0,0xfff8(a6)
	cmpl	0x3a8112,d0
	bhis	TS1362
	movl	0x3a810e,d0
	addl	0xfff8(a6),d0
	movl	d0,-(sp)
	jsr	_copy_fl
	addql	#4,sp
	addl	0x10(a6),d0
	movl	d0,-(sp)
	movl	0x3a810e,d0
	addl	0xfff8(a6),d0
	movl	d0,-(sp)
	jsr	_suword
	addql	#8,sp

TS1362:
	unlk	a6
	rts

	.globl	_masktobn
_masktobn:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	movl	0x8(a6),d7
	clrl	d6
	tstl	d7
	beqs	TS1647

TS1654:
	btst	#0,d7
	bnes	TS1649
	addql	#1,d6
	lsrl	#1,d7
	bras	TS1654

TS1650:
	movl	#_sccbtbl+32,-(sp)
	jsr	_PRINT
	addql	#4,sp
	bras	TS1651

TS1652:
	btst	#0,d7
	beqs	TS1653
	movl	d6,-(sp)
	movl	#_sccbtbl+43,-(sp)
	jsr	_PRINT
	addql	#8,sp

TS1653:
	addql	#1,d6
	lsrl	#1,d7

TS1651:
	tstl	d7
	bnes	TS1652
	movl	#_sccbtbl+47,-(sp)
	jsr	_PRINT
	addql	#4,sp

TS1647:
	moveq	#0xffffffff,d0
	bras	TS1648

TS1649:
	movl	d7,d0
	bclr	#0,d0
	tstl	d0
	bnes	TS1650
	movl	d6,d0

TS1648:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_setbaud
_setbaud:
	link	a6,#0x0
	moveml	#0xf04,-(sp)	| d4 d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	cmpl	#0x1,d6
	blt	TS2095
	cmpl	#0xf,d6
	bgt	TS2095
	jsr	_spl5
	movl	d0,d4
	movl	d6,d0
	addl	d0,d0
	addl	#_sccbtbl,d0
	movl	d0,a0
	movw	(a0),d5
	movl	d7,d0
	asll	#2,d0
	addl	#_sioaddr,d0
	movl	d0,a0
	movl	(a0),d0
	subql	#2,d0
	movl	d0,a5
	tstb	_graphp
	beqs	TS2096
	cmpl	#0x1,d7
	bnes	TS2096
	movl	#0xb05,-(sp)
	bras	TS2097

TS2096:
	movw	d5,d0
	andl	#0xff,d0
	addl	#0xc00,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_out2b
	addql	#8,sp
	movw	d5,d0
	extl	d0
	asrl	#8,d0
	addl	#0xd00,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_out2b
	addql	#8,sp
	movl	#0xe03,-(sp)
	pea	(a5)
	jsr	_out2b
	addql	#8,sp
	movl	#0xb56,-(sp)

TS2097:
	pea	(a5)
	jsr	_out2b
	addql	#8,sp
	movl	d4,-(sp)
	jsr	_splx
	addql	#4,sp

TS2095:
	moveml	(sp)+,#0x20f0	| d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_setsccr
_setsccr:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),d7
	movl	d7,d0
	asll	#2,d0
	addl	#_sioaddr,d0
	movl	d0,a0
	movl	(a0),d0
	subql	#2,d0
	movl	d0,a5
	movl	#0xf08,-(sp)
	pea	(a5)
	jsr	_out2b
	addql	#8,sp
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_setnsf
_setnsf:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	andl	#0xfffffff,0x48(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_fpsave
_fpsave:
	link	a6,#0x0
	unlk	a6
	rts

	.globl	_main
_main:
	link	a6,#0xfff4
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	jsr	_startup
	movw	DS1455,d0
	mulu	#0xa,d0
	moveq	#0x9,d1
	lsrl	d1,d0
	movl	d0,d7
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp
	movl	d7,d1
	subl	d0,d1
	movl	d1,-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,-(sp)
	movl	_mempage,d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	_ednix,d1
	subl	_sdnix,d1
	subl	d1,d0
	moveq	#0xa,d1
	lsrl	d1,d0
	movl	d0,-(sp)
	movl	_ednix,d0
	subl	_sdnix,d0
	moveq	#0xa,d1
	lsrl	d1,d0
	movl	d0,-(sp)
	movl	#_sysinfo+27,-(sp)
	movl	#_sysinfo+18,-(sp)
	movl	#_sysinfo,-(sp)
	movl	#_init+10,-(sp)
	jsr	_PRINT
	addw	#0x20,sp
	jsr	_bldnode
	jsr	_initrdq
	movw	#0x1,BS1670
	movl	#_alarmq,_alarmq
	movl	_alarmq,BS1671
	movw	#0x1,BS1672
	movl	#_napq,_napq
	movl	_napq,BS1673
	movw	#0x1,BS1674
	movl	#_logq,_logq
	movl	_logq,BS1675
	jsr	_inisem
	jsr	_inimsg
	jsr	_inishm
	jsr	_cinit
	jsr	_gsystcb
	movl	d0,_runtcb
	clrl	0x3a8132
	movl	0x8(a6),0x3a801a
	movw	DS1698,0x3a8028
	clrb	0x3a8026
	clrb	0x3a8027
	clrb	0x3a8123
	movl	#0x3a8000,0x3a8000
	movb	#0x4f,0x3a8142
	movb	#0x53,0x3a8143
	movb	#0xff99,0x3a816e
	jsr	_pg_upg0
	jsr	_spl0
	jsr	_clkstart
	jsr	_openrq
	movl	d0,d5
	moveq	#0x16,d0
	movl	d0,-(sp)
	movl	d5,-(sp)
	jsr	_setdlu
	addql	#8,sp
	movl	d5,-(sp)
	jsr	_close2
	addql	#4,sp
	movl	#0x1000,-(sp)
	clrl	-(sp)
	moveq	#0x16,d0
	movl	d0,-(sp)
	jsr	_openlur
	addw	#0xc,sp
	movl	d0,d6
	moveq	#0x15,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	_setdlu
	addql	#8,sp
	movl	d6,-(sp)
	jsr	_close2
	addql	#4,sp
	moveq	#0x17,d0
	movl	d0,-(sp)
	moveq	#0x15,d0
	movl	d0,-(sp)
	jsr	_setdlu
	addql	#8,sp
	movl	_runtcb,-(sp)
	moveq	#0x15,d0
	movl	d0,-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a0
	movl	0x2a(a0),_fhrqp
	jsr	_fh_start
	movl	_mempage,d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,-(sp)
	movl	_ednix,d0
	subl	_sdnix,d0
	movl	d0,-(sp)
	bsr	_logstart
	addql	#8,sp
	jsr	_creproc
	movl	d0,a5
	tstl	d0
	bnes	TS1826
	moveq	#0x12,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1826:
	movb	#0x3,0x26(a5)
	movl	a5,_inittcb
	movb	0x25(a5),d0
	extw	d0
	movw	d0,_initppn
	pea	(a5)
	jsr	_startpr
	addql	#4,sp
	tstl	d0
	beq	TS1829
	movb	#0xf,0x3a8027
	clrb	0x3a8026
	clrl	d7

TS1857:
	movl	d7,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	clrl	(a0)
	addql	#1,d7
	cmpl	#0x12,d7
	blts	TS1857
	movl	#0x1ffff,0x2e(a5)
	moveq	#0x9,d0
	movl	d0,-(sp)
	pea	0xfff6(a6)
	movl	#_init,-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	movl	#0x400,-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x9,d0
	movl	d0,-(sp)
	pea	0xfff6(a6)
	moveq	#0x15,d0
	movl	d0,-(sp)
	jsr	_fexec
	addw	#0x18,sp
	tstl	d0
	beqs	TS2006
	moveq	#0x12,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2006:
	moveq	#0x16,d0
	movl	d0,-(sp)
	jsr	_close2
	addql	#4,sp
	jsr	_clkstart
	bras	TS2007

TS1829:
	jsr	_pg_hndl

TS2007:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_logstart
_logstart:
	link	a6,#0xff90
	movl	a5,-(sp)
	lea	0xff90(a6),a0
	movl	a0,a5
	movl	0xc(a6),(a5)
	movl	0x8(a6),0x4(a5)
	moveq	#0x4e,d0
	movl	d0,-(sp)
	pea	0x8(a5)
	movl	#_sysinfo,-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	moveq	#0x1a,d0
	movl	d0,-(sp)
	pea	0x56(a5)
	movl	#_oscfig,-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	moveq	#0x70,d0
	movl	d0,-(sp)
	pea	(a5)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x2,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_pg_fault
_pg_fault:
	link	a6,#0x0
	moveml	#0xf3c,-(sp)	| d4 d5 d6 d7 a2 a3 a4 a5
	movl	0xc(a6),d7
	movl	_runtcb,a5
	movl	0x8(a6),d0
	moveq	#0xb,d1
	lsrl	d1,d0
	movl	d0,d6
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	cmpl	#0x7c0,d6
	bccs	TS2026
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	cmpl	_vpdbase,d0
	beqs	TS2026
	btst	#8,d7
	bne	TS2044
	btst	#0,(a4)
	beq	TS2044

TS2027:
	clrl	d0
	bra	TS2028

TS2026:
	clrl	d0
	movw	0x11c(a5),d0
	subl	d6,d0
	movl	d0,d4
	clrl	d0
	movw	0x11c(a5),d0
	cmpl	d0,d6
	bccs	TS2027
	cmpl	#0x40,d4
	bgts	TS2027
	clrl	d0
	movw	0x11c(a5),d0
	clrl	d1
	movw	0x116(a5),d1
	subl	d1,d0
	cmpl	#0x80,d0
	bcss	TS2027
	tstl	0xf0(a5)
	beqs	TS2029
	clrl	-(sp)
	movl	0xf0(a5),-(sp)
	movl	d6,-(sp)
	jsr	_shmchk
	addw	#0xc,sp
	tstl	d0
	bnes	TS2027

TS2029:
	movl	d6,d5
	bras	TS2030

TS2031:
	jsr	_getvpd
	movl	d0,a4
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a4,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d5,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d5

TS2030:
	movl	d4,d0
	subql	#1,d4
	tstl	d0
	bnes	TS2031
	btst	#2,0x23(a5)
	beqs	TS2032
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	d5,d0
	subql	#1,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp

TS2032:
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	movl	_runtcb,-(sp)
	jsr	_pg_demap
	addql	#4,sp
	movw	d6,0x11c(a5)

TS2044:
	addql	#1,0x128(a5)
	movl	d7,d0
	andl	#0x100,d0
	movl	d0,-(sp)
	pea	(a5)
	pea	(a4)
	movl	d6,-(sp)
	bsr	_inpage
	addw	#0x10,sp
	movl	d0,a4
	movb	_ccontex,d0
	extw	d0
	extl	d0
	bclr	#4,d0
	movb	_pfctx,d1
	extw	d1
	extl	d1
	cmpl	d1,d0
	bne	TS2033
	movw	_pfpage,d0
	cmpw	0x2(a4),d0
	bne	TS2033
	addqb	#1,_pfcnt
	bne	TS2034
	clrl	-(sp)
	jsr	_debug
	addql	#4,sp
	clrl	d0
	movw	0x2(a4),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a3
	movl	#_errpf,a2
	movl	0x8(a6),(a2)
	movw	0x2(a4),0x4(a2)
	movb	_ccontex,d0
	extw	d0
	extl	d0
	bclr	#4,d0
	movw	d0,0x6(a2)
	movb	0x6(a3),d0
	extw	d0
	movw	d0,0x8(a2)
	movw	0x4(a3),0xa(a2)
	movl	d7,0xc(a2)
	moveq	#0x10,d0
	movl	d0,-(sp)
	pea	(a2)
	pea	(a5)
	movl	#0xc0,-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	pea	(a4)
	jsr	_demap
	addql	#4,sp
	tstw	(a3)
	bnes	TS2035
	movw	#0x1,(a3)

TS2035:
	clrw	0x2(a4)
	bra	TS2027

TS2033:
	movw	0x2(a4),_pfpage
	movb	_ccontex,d0
	extw	d0
	extl	d0
	bclr	#4,d0
	movb	d0,_pfctx
	clrb	_pfcnt

TS2034:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d6,-(sp)
	pea	(a4)
	jsr	_map
	addql	#8,sp
	moveq	#0x1,d0

TS2028:
	moveml	(sp)+,#0x3cf0	| d4 d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_inpage
_inpage:
	link	a6,#0x0
	moveml	#0x73c,-(sp)	| d5 d6 d7 a2 a3 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),a5
	movl	0x10(a6),a4
	movl	0x14(a6),d6
	bras	TS818

TS819:
	bset	#2,(a5)
	movl	a5,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,-(sp)
	jsr	_waitvpd
	addql	#4,sp
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a5

TS818:
	btst	#1,(a5)
	bnes	TS819
	tstw	0x2(a5)
	beqs	TS820
	tstl	d6
	bne	TS1018
	cmpb	#0x1,0x1(a5)
	ble	TS1018

TS820:
	movl	a5,a3
	bset	#1,(a5)
	tstw	0x2(a5)
	bnes	TS821
	pea	(a5)
	jsr	_getpage
	addql	#4,sp
	btst	#4,(a5)
	beqs	TS851
	clrl	d0
	movw	0x2(a5),d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	bclr	#4,(a5)
	bset	#3,(a5)
	bras	TS821

TS851:
	addql	#1,0x12c(a4)
	pea	(a5)
	movl	d7,-(sp)
	movl	0x10a(a4),-(sp)
	jsr	_pg_swapin
	addw	#0xc,sp

TS821:
	tstl	d6
	bne	TS822
	cmpb	#0x1,0x1(a5)
	ble	TS822
	pea	(a5)
	jsr	_demap
	addql	#4,sp
	jsr	_getvpd
	movl	d0,a5
	movb	#0x8,(a5)
	pea	(a5)
	jsr	_getpage
	addql	#4,sp
	clrl	d0
	movw	0x2(a5),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x2(a3),d0
	movl	d0,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	subqb	#1,0x1(a3)
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a5,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d7,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	btst	#2,0x23(a4)
	bnes	TS849
	btst	#5,(a3)
	beq	TS822
	tstw	0x120(a4)
	beqs	TS850
	clrl	d0
	movw	0x11c(a4),d0
	cmpl	d0,d7
	bccs	TS849

TS850:
	tstw	0x124(a4)
	beqs	TS822
	clrl	d0
	movw	0x114(a4),d0
	cmpl	d0,d7
	bcss	TS822
	clrl	d0
	movw	0x116(a4),d0
	cmpl	d0,d7
	bhis	TS822

TS849:
	movb	(a3),d0
	andl	#0x60,d0
	orb	d0,(a5)
	andb	#0xff9f,(a3)
	movw	0x2(a5),d5
	movw	0x2(a3),0x2(a5)
	movw	d5,0x2(a3)
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	movl	a5,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movw	d0,0x2(a2)
	clrl	d0
	movw	0x2(a3),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	movl	a3,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movw	d0,0x2(a2)

TS822:
	btst	#2,(a3)
	beqs	TS823
	movl	a3,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,-(sp)
	jsr	_unwaitvpd
	addql	#4,sp

TS823:
	andb	#0xfff9,(a3)

TS1018:
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	tstl	d6
	beqs	TS824
	movl	#0x1000,d0
	bras	TS825

TS824:
	movl	#0x3000,d0

TS825:
	andl	#0xffff,d0
	orw	d0,0x4(a2)
	movl	a5,d0
	moveml	(sp)+,#0x3ce0	| d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_config
_pg_config:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	moveq	#0x10,d0
	movl	d0,-(sp)
	movl	#_sysinfo+61,-(sp)
	movl	_btargv,-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	clrb	DS1589
	movl	#_oscfig,a5
	cmpl	#0x1,_btargc
	bles	TS1590
	movw	#0x40,(a5)
	movw	#0x40,0x2(a5)
	movw	#0x100,0x4(a5)
	movw	#0x40,0x6(a5)
	movw	#0x60,0x8(a5)
	movw	#0x80,0xa(a5)
	movw	#0x4,0xc(a5)
	movw	#0x1000,0xe(a5)
	movw	#0x14,0x10(a5)
	movw	#0x14,0x12(a5)
	movw	#0x80,0x14(a5)
	movw	#0x14,0x16(a5)
	movw	#0x80,0x18(a5)

TS1590:
	clrl	d0
	movw	0xe(a5),d0
	cmpl	_mempage,d0
	bccs	TS1591
	movw	_mempage+2,0xe(a5)

TS1591:
	movl	_umem,d0
	movl	d0,d7
	movl	d7,_tnodbuf
	movw	(a5),d0
	mulu	#0x130,d0
	addl	d0,d7
	movl	d7,_tadbase
	movw	0x2(a5),d0
	mulu	#0x3e,d0
	addl	d0,d7
	movl	d7,_ppdbase
	movl	_mempage,d0
	lsll	#3,d0
	addl	d0,d7
	movl	d7,_vpdbase
	clrl	d0
	movw	0xe(a5),d0
	lsll	#3,d0
	addl	d0,d7
	movl	d7,_msgarray
	movw	0x10(a5),d0
	mulu	#0x32,d0
	addl	d0,d7
	movl	d7,_semarray
	movw	0x12(a5),d0
	mulu	#0x26,d0
	addl	d0,d7
	movl	d7,_adjarray
	movw	0x14(a5),d0
	mulu	#0xa,d0
	addl	d0,d7
	movl	d7,_shmarray
	movw	0x16(a5),d0
	mulu	#0x2a,d0
	addl	d0,d7
	movl	d7,_shmatarray
	movw	0x18(a5),d0
	mulu	#0xe,d0
	addl	d0,d7
	movl	d7,_nodebuf
	movw	0x4(a5),d0
	mulu	#0x78,d0
	addl	d7,d0
	addl	#0x7ff,d0
	moveq	#0xb,d1
	lsrl	d1,d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,d7
	moveq	#0x78,d0
	movl	d0,-(sp)
	movl	_nodebuf,d0
	movl	d7,d1
	subl	d0,d1
	movl	d1,-(sp)
	jsr	ldiv
	addql	#8,sp
	movw	d0,0x4(a5)
	mulu	#0x78,d0
	addl	_nodebuf,d0
	movl	d0,_mnodebuf
	pea	(a5)
	movl	d7,-(sp)
	jsr	_szrfh
	addql	#8,sp
	addl	d0,d7
	movl	d7,d0
	addl	#0x7ff,d0
	moveq	#0xb,d1
	lsrl	d1,d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,_ednix
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_pg_init
_pg_init:
	link	a6,#0xfff8
	moveml	#0x3338,-(sp)	| d2 d3 d6 d7 a2 a3 a4
	movw	#0x1,BS1581
	movl	#_tadq,_tadq
	movl	_tadq,BS1582
	movw	#0x1,BS1583
	movl	#_wpio,_wpio
	movl	_wpio,BS1584
	movw	#0x1,BS1585
	movl	#_wvpd,_wvpd
	movl	_wvpd,BS1586
	movw	#0x1,BS1587
	movl	#_wfpg,_wfpg
	movl	_wfpg,BS1588
	bsr	_pg_config
	clrb	_ccontex
	movl	_umem,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,d3
	movl	_ednix,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,d2
	bras	TS1597

TS1598:
	movw	d3,d0
	andw	#0xf,d0
	bnes	TS1599
	clrl	d0
	movw	d3,d0
	lsrl	#4,d0
	movw	d0,0xbb0000

TS1599:
	clrl	d0
	movw	d3,d0
	andl	#0xf,d0
	moveq	#0xb,d1
	lsll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,0xfff8(a6)
	clrl	d0
	movw	d3,d0
	bset	#14,d0
	movl	0xfff8(a6),a0
	movw	d0,(a0)
	movw	d3,d0
	addqw	#1,d3
	andl	#0xffff,d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	jsr	_watchdg

TS1597:
	cmpw	d2,d3
	bnes	TS1598
	movw	d3,_iobpage
	addqw	#1,d3
	clrl	d0
	movw	_iobpage,d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movw	d3,_fppage
	movl	_mempage,d0
	subql	#1,d0
	movw	d0,d2
	movw	d2,_lppage
	bras	TS1600

TS1601:
	clrl	d0
	movw	d2,d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movw	d2,d0
	subqw	#1,d2
	andl	#0xffff,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,-(sp)
	jsr	_putppd
	addql	#4,sp
	jsr	_watchdg

TS1600:
	cmpw	d3,d2
	bccs	TS1601
	movl	_OS_PAGE,_OS_MAXP
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	_OS_PAGE,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,_OS_TRIG
	clrl	d0
	movw	DS1455,d0
	subql	#1,d0
	movw	d0,d2
	bras	TS1602

TS1603:
	clrl	d0
	movw	d2,d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	movw	_fvpage,0x2(a4)
	movw	d2,_fvpage
	subqw	#1,d2

TS1602:
	tstw	d2
	bnes	TS1603
	movl	_vpdbase,a0
	movw	#0x8000,0x2(a0)
	jsr	_watchdg
	movl	_ednix,d0
	addl	#0x7fff,d0
	moveq	#0xf,d1
	lsrl	d1,d0
	movl	d0,d6
	movw	d6,0xbb0000
	clrl	d7

TS1605:
	tstl	d7
	bnes	TS1604
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,0xfff8(a6)
	movl	_umem,d0
	subl	#0x800,d0
	moveq	#0xb,d1
	asrl	d1,d0
	bset	#14,d0
	movl	0xfff8(a6),a0
	movw	d0,(a0)
	bras	TS1631

TS1604:
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)

TS1631:
	addql	#1,d7
	cmpl	#0x10,d7
	blts	TS1605
	movl	d6,-(sp)
	moveq	#0x75,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	addql	#1,d6
	movl	d6,_nopgrp
	movl	d6,d0
	movw	d0,0xbb0000
	clrl	d7

TS1606:
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)
	addql	#1,d7
	cmpl	#0x10,d7
	blts	TS1606
	movl	d6,d0
	addql	#1,d0
	movl	d0,0xfffc(a6)
	clrl	d7
	clrw	0xbb0000
	bras	TS1607

TS1608:
	movl	d7,d0
	andl	#0xf,d0
	bnes	TS1609
	movl	d7,d0
	asrl	#4,d0
	movw	d0,0xbb0000

TS1609:
	movl	d7,d0
	andl	#0xf,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,0xfff8(a6)
	movl	d0,a0
	movw	d7,(a0)
	jsr	_watchdg
	addql	#1,d7

TS1607:
	movl	_antvect,d0
	moveq	#0xb,d1
	asrl	d1,d0
	cmpl	d0,d7
	bles	TS1608
	movl	_ednix,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d7
	movl	d7,d0
	asrl	#4,d0
	movw	d0,0xbb0000
	bras	TS1610

TS1611:
	movl	d6,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)
	addql	#1,d7

TS1610:
	movl	d7,d0
	andl	#0xf,d0
	movl	d0,d6
	bnes	TS1611
	movl	d7,d0
	asrl	#4,d0
	movl	d0,d6
	bras	TS1612

TS1613:
	movl	_nopgrp,-(sp)
	movl	d6,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	addql	#1,d6

TS1612:
	cmpl	#0x75,d6
	blts	TS1613
	movw	#0x7b,0xbb0000
	clrl	d7

TS1615:
	tstl	d7
	bnes	TS1614
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,0xfff8(a6)
	clrl	d0
	movw	_iobpage,d0
	bset	#14,d0
	movl	0xfff8(a6),a0
	movw	d0,(a0)
	bras	TS1630

TS1614:
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)

TS1630:
	addql	#1,d7
	cmpl	#0x10,d7
	blts	TS1615
	moveq	#0x7b,d0
	movl	d0,-(sp)
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	#0x770,d7
	movl	#0x7b0,d6

TS1617:
	movl	d7,d0
	andl	#0xf,d0
	bnes	TS1616
	movl	d7,d0
	asrl	#4,d0
	movw	d0,0xbb0000

TS1616:
	movl	d7,d0
	andl	#0xf,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0xc000,(a0)
	addql	#1,d7
	cmpl	d6,d7
	blts	TS1617
	tstw	0xfffffc
	beqs	TS1618
	clrl	d7

TS1618:
	moveq	#0x7c,d6

TS1619:
	movl	d6,-(sp)
	movl	d6,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	addql	#1,d6
	cmpl	#0x80,d6
	blts	TS1619
	movb	0xffff(a6),_nxpgrp
	movb	_nxpgrp,_ffpgrp
	movb	_ffpgrp,_fpgrp
	movl	0xfffc(a6),d7
	bras	TS1620

TS1621:
	movl	d7,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a2
	movl	d7,d0
	addql	#1,d0
	movb	d0,(a2)
	movw	d7,0xbb0000
	clrl	d6

TS1622:
	movl	d6,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)
	addql	#1,d6
	cmpl	#0x10,d6
	blts	TS1622
	clrl	d6

TS1623:
	lea	0x2(a2),a0
	movl	d6,d0
	addl	d0,d0
	addl	d0,a0
	movw	#0x7c,(a0)
	addql	#1,d6
	cmpl	#0xf,d6
	blts	TS1623
	addql	#1,d7

TS1620:
	cmpl	#0x77,d7
	blts	TS1621
	clrb	(a2)
	movb	#0x1,_ccontex

TS1625:
	movb	_ccontex,d0
	extw	d0
	addqw	#1,d0
	extl	d0
	movb	_ccontex,d1
	extw	d1
	extl	d1
	asll	#2,d1
	addl	#_ctx,d1
	movl	d1,a0
	movl	d0,(a0)
	clrl	d6

TS1624:
	movl	_nopgrp,-(sp)
	movl	d6,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	addql	#1,d6
	cmpl	#0x7c,d6
	blts	TS1624
	addqb	#1,_ccontex
	cmpb	#0x10,_ccontex
	blts	TS1625
	clrl	BS1626
	movb	#0x1,_nxctx
	movb	_nxctx,_fctx
	clrl	d0
	movw	DS1627,d0
	movl	d0,d7
	movl	_tadbase,a3
	bras	TS1628

TS1629:
	movw	#0x7,0x8(a3)
	pea	(a3)
	movl	#_tadq,-(sp)
	jsr	_addlq
	addql	#8,sp
	addw	#0x3e,a3

TS1628:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS1629
	moveml	(sp)+,#0x1ccc	| d2 d3 d6 d7 a2 a3 a4
	unlk	a6
	rts

	.globl	_pg_cleanup
_pg_cleanup:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	clrl	d0
	movw	DS1455,d0
	subql	#1,d0
	movl	d0,d7
	movl	_vpdbase,a5
	bras	TS1456

TS1457:
	btst	#7,(a5)
	beqs	TS1458
	movl	#0x800,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_fh_segchk
	addql	#8,sp
	tstl	d0
	bnes	TS1458
	movl	#0x800,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_fh_dealloc
	addql	#8,sp

TS1458:
	addql	#8,a5

TS1456:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS1457
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_pg_swapin
_pg_swapin:
	link	a6,#0x0
	moveml	#0x1f0c,-(sp)	| d3 d4 d5 d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),a4
	clrl	d0
	movw	0x2(a4),d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,d6
	movl	0x4(a4),d5
	btst	#7,(a4)
	bnes	TS852
	movw	0x32(a5),d0
	extl	d0
	cmpl	d0,d7
	bnes	TS865
	clrl	d0
	movw	0x2(a4),d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	bset	#3,(a4)
	movl	0x24(a5),d0
	bras	TS1017

TS866:
	movl	0x28(a5),d0
	moveq	#0xb,d1
	asrl	d1,d0
	cmpl	d0,d7
	bnes	TS867
	clrl	d0
	movw	0x2(a4),d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movl	0x28(a5),d0

TS1017:
	andl	#0x7ff,d0
	movl	d0,d4
	bras	TS1016

TS865:
	cmpw	#0x7c0,0x2c(a5)
	blts	TS866

TS867:
	movl	#0x800,d4

TS1016:
	movl	d4,-(sp)
	movl	d6,-(sp)
	movl	d5,-(sp)
	movl	0x10(a5),-(sp)
	bsr	_pg_read
	addw	#0x10,sp
	bras	TS1013

TS852:
	movl	#0x800,d4
	clrl	-(sp)
	clrl	-(sp)
	movl	d4,-(sp)
	movl	d5,-(sp)
	movl	d6,-(sp)
	movw	_rootdev,d0
	extl	d0
	movl	d0,-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	jsr	_physio
	addw	#0x1c,sp

TS1013:
	movl	d0,d3
	cmpl	d4,d3
	bnes	TS860
	moveq	#0x1,d0
	bras	TS864

TS860:
	movl	_runtcb,-(sp)
	movl	d3,-(sp)
	movl	d4,-(sp)
	movl	d5,-(sp)
	movl	d6,-(sp)
	bsr	_swaperror
	addw	#0x14,sp
	clrl	d0

TS864:
	moveml	(sp)+,#0x30f8	| d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_open
_pg_open:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x3,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	movl	0x14(a6),d0
	addql	#1,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d7
	bges	TS1858
	movl	d7,d0
	bras	TS1859

TS1858:
	movl	_runtcb,d0
	addl	#0x6c,d0
	movl	d7,d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	movl	(a0),a5
	movl	_runtcb,d0
	addl	#0x6c,d0
	movl	d7,d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	clrl	(a0)
	movl	a5,d0

TS1859:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_pg_close
_pg_close:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	movl	a5,d0
	beqs	TS1864
	subqw	#1,0x26(a5)
	pea	(a5)
	jsr	_closeop
	addql	#4,sp

TS1864:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_pg_read
_pg_read:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	movl	a5,d0
	bnes	TS868
	clrl	d0
	bras	TS1012

TS868:
	movl	0xc(a6),-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0x1c(a5),-(sp)
	jsr	_fh_load
	addw	#0x10,sp

TS1012:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_pg_stat
_pg_stat:
	link	a6,#0x0
	tstl	0x8(a6)
	bnes	TS1900
	clrl	d0
	bras	TS1903

TS1900:
	movl	0xc(a6),-(sp)
	movl	0x8(a6),a0
	movl	0x1c(a0),-(sp)
	jsr	_fh_fstat
	addql	#8,sp
	movl	0x10(a6),d0

TS1903:
	unlk	a6
	rts

	.globl	_swaperror
_swaperror:
	link	a6,#0x0
	movl	0x8(a6),_swerr
	movl	0xc(a6),BS861
	movl	0x10(a6),BS862
	movl	0x14(a6),BS863
	moveq	#0x10,d0
	movl	d0,-(sp)
	movl	#_swerr,-(sp)
	movl	0x18(a6),-(sp)
	movl	#0xc0,-(sp)
	moveq	#0x15,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	unlk	a6
	rts

	.globl	_lockmem
_lockmem:
	link	a6,#0x0
	moveml	#0x3f3c,-(sp)	| d2 d3 d4 d5 d6 d7 a2 a3 a4 a5
	movl	0x10(a6),d0
	subl	0xc(a6),d0
	addql	#1,d0
	movl	d0,d7
	movl	0x8(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	jsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	beqs	TS1022
	movl	0x8(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	jsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	beqs	TS1022
	movl	0x8(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	jsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	bnes	TS1043

TS1022:
	movl	d7,-(sp)
	bsr	_getcm
	addql	#4,sp
	movl	d0,d5
	bnes	TS1030

TS1043:
	clrl	-(sp)
	clrl	-(sp)
	movl	_runtcb,-(sp)
	movl	#0x80,-(sp)
	moveq	#0x7,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	clrl	d0
	bra	TS1042

TS1030:
	movl	0xc(a6),d6
	movl	d5,d3
	bra	TS1031

TS1032:
	movl	0x8(a6),a0
	movl	0x102(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x8(a6),a0
	movl	0x106(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a5
	pea	(a5)
	jsr	_demap
	addql	#4,sp
	clrl	d0
	movw	0x2(a5),d0
	movl	d0,d4
	movl	d4,d0
	asll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a3
	movl	d3,d0
	asll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	tstw	0x2(a2)
	beqs	TS1033
	clrl	d0
	movw	0x2(a2),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	pea	(a4)
	jsr	_demap
	addql	#4,sp
	movl	d3,-(sp)
	movl	d4,-(sp)
	jsr	_copy_sp
	addql	#8,sp
	movw	d4,0x2(a4)
	bras	TS1041

TS1033:
	movl	d3,-(sp)
	movl	d4,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	pea	(a3)
	jsr	_putppd
	addql	#4,sp

TS1041:
	movw	d3,0x2(a5)
	bset	#5,(a5)
	clrl	d0
	movw	0x2(a2),d0
	movl	d0,d2
	movw	0x2(a3),0x2(a2)
	movw	d2,0x2(a3)
	movb	0x7(a2),d0
	extw	d0
	extl	d0
	movl	d0,d2
	movb	0x7(a3),0x7(a2)
	movb	d2,0x7(a3)
	clrl	d0
	movw	0x4(a2),d0
	movl	d0,d2
	clrl	d0
	movw	0x4(a3),d0
	andl	#0xf000,d0
	orl	d3,d0
	movw	d0,0x4(a2)
	movl	d2,d0
	andl	#0xf000,d0
	orl	d4,d0
	movw	d0,0x4(a3)
	addql	#1,d3
	addql	#1,d6

TS1031:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bne	TS1032
	movl	d5,d0

TS1042:
	moveml	(sp)+,#0x3cfc	| d2 d3 d4 d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_getcm
_getcm:
	link	a6,#0x0
	moveml	#0x1f1c,-(sp)	| d3 d4 d5 d6 d7 a3 a4 a5
	movl	0x8(a6),d7
	movl	_runtcb,a3
	clrl	d0
	movw	_fppage,d0
	movl	d0,d6
	clrl	d0
	movw	_lppage,d0
	movl	d0,d5
	movl	d6,d0
	asll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a5
	clrl	d3
	bras	TS1023

TS1024:
	movl	0xfe(a3),a0
	clrl	d0
	movw	0x2(a0),d0
	cmpl	d0,d6
	beqs	TS1025
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	cmpl	_vpdbase,d0
	beqs	TS1026
	movb	(a4),d0
	andb	#0x22,d0
	bnes	TS1025

TS1026:
	tstl	d3
	bnes	TS1027
	movl	d6,d4

TS1027:
	addql	#1,d3
	cmpl	d7,d3
	bnes	TS1028
	movl	d4,d0
	bras	TS1029

TS1025:
	clrl	d3

TS1028:
	addql	#8,a5
	addql	#1,d6

TS1023:
	cmpl	d5,d6
	bnes	TS1024
	clrl	d0

TS1029:
	moveml	(sp)+,#0x38f8	| d3 d4 d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_ulockmem
_ulockmem:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	tstl	0xc(a6)
	beqs	TS1048
	clrl	d0
	movw	0x114(a5),d0
	movl	d0,d7
	clrl	d0
	movw	0x116(a5),d0
	movl	d0,d6
	clrw	0x124(a5)
	clrw	0x126(a5)
	bras	TS1051

TS1048:
	clrl	d0
	movw	0x11c(a5),d0
	movl	d0,d7
	movl	#0x7bf,d6
	clrw	0x120(a5)
	clrw	0x122(a5)

TS1051:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	bras	TS1049

TS1050:
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	addql	#1,d7
	bset	#3,(a4)
	bclr	#5,(a4)

TS1049:
	cmpl	d6,d7
	bles	TS1050
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_memres
_memres:
	link	a6,#0x0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),d6
	movl	0x14(a6),d5
	bras	TS1417

TS1418:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	tstl	d5
	beqs	TS1419
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a5)
	pea	(a4)
	movl	d7,-(sp)
	jsr	_inpage
	addw	#0x10,sp
	movl	d0,a4
	bset	#6,(a4)
	bras	TS1420

TS1419:
	bclr	#6,(a4)

TS1420:
	addql	#1,d7

TS1417:
	cmpl	d6,d7
	bles	TS1418
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_map
_map:
	link	a6,#0xfffc
	moveml	#0x3f3c,-(sp)	| d2 d3 d4 d5 d6 d7 a2 a3 a4 a5
	movl	0xc(a6),d7
	movb	_ccontex,d0
	extw	d0
	extl	d0
	movl	d0,d4
	movl	0x8(a6),a5
	movl	d7,d0
	asrl	#4,d0
	movl	d0,d3
	pea	(a5)
	bsr	_demap
	addql	#4,sp
	movl	d3,-(sp)
	jsr	_get_pgrp
	addql	#4,sp
	movl	d0,d6
	cmpl	_nopgrp,d0
	beqs	TS596
	movl	d6,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a4
	bra	TS614

TS596:
	subl	a4,a4
	btst	#0,(a5)
	beqs	TS597
	movl	d3,d0
	asll	#4,d0
	movw	d0,d2
	clrl	d5

TS613:
	cmpl	#0x10,d5
	bges	TS611
	movw	d2,d0
	addqw	#1,d2
	andl	#0xffff,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a5
	cmpl	_vpdbase,d0
	beq	TS612
	tstw	0x2(a5)
	beq	TS612
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a3
	movb	0x6(a3),d0
	extw	d0
	extl	d0
	movl	d0,d6
	beq	TS612
	movl	d6,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a4

TS611:
	movl	0x8(a6),a5

TS597:
	movl	a4,d0
	bnes	TS598
	bsr	_pg_getpg
	movl	d0,d6
	movl	d6,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a4

TS598:
	addqb	#1,(a4)
	lea	0x2(a4),a0
	movl	d4,d0
	subql	#1,d0
	bclr	#4,d0
	addl	d0,d0
	addl	d0,a0
	movl	a0,0xfffc(a6)
	movw	d3,(a0)
	movl	d6,-(sp)
	movl	d3,-(sp)
	jsr	_put_pgrp
	addql	#8,sp

TS614:
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a3
	addqb	#1,0x1(a4)
	movl	d7,d0
	andl	#0xf,d0
	movb	d0,0x7(a3)
	movb	d6,0x6(a3)
	clrl	d0
	movw	0x4(a3),d0
	andl	#0x3000,d0
	clrl	d1
	movw	0x2(a5),d1
	orl	d1,d0
	movw	d0,0x4(a3)
	cmpb	#0x1,0x1(a5)
	bnes	TS599
	btst	#0,(a5)
	bnes	TS599
	bset	#6,0x4(a3)
	cmpb	#0x1,(a4)
	bles	TS599
	lea	0x2(a4),a0
	movl	a0,a2
	moveq	#0x1,d5

TS601:
	movl	d4,d0
	bclr	#4,d0
	cmpl	d0,d5
	beqs	TS600
	movw	(a2),d2
	cmpw	#0x7c,d2
	beqs	TS600
	movw	#0x7c,(a2)+
	movb	d5,_ccontex
	movl	_nopgrp,-(sp)
	clrl	d0
	movw	d2,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	subqb	#1,(a4)
	bras	TS602

TS612:
	addql	#1,d5
	bra	TS613

TS600:
	addql	#2,a2

TS602:
	addql	#1,d5
	cmpl	#0x10,d5
	blts	TS601
	movb	d4,_ccontex

TS599:
	movw	d6,0xbb0000
	movb	0x7(a3),d0
	extw	d0
	extl	d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	0x4(a3),(a0)
	moveml	(sp)+,#0x3cfc	| d2 d3 d4 d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_demap
_demap:
	link	a6,#0x0
	moveml	#0xf3c,-(sp)	| d4 d5 d6 d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	tstw	0x2(a5)
	beq	TS592
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	movb	0x6(a2),d0
	extw	d0
	extl	d0
	movl	d0,d6
	beq	TS592
	movl	d6,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a3
	movw	d6,0xbb0000
	movb	0x7(a2),d0
	extw	d0
	extl	d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	(a0),d0
	orw	d0,0x4(a2)
	movb	0x7(a2),d0
	extw	d0
	extl	d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)
	clrb	0x6(a2)
	movb	0x1(a3),d0
	subqb	#1,0x1(a3)
	cmpb	#0x1,d0
	bnes	TS592
	lea	0x2(a3),a0
	movl	a0,a4
	movb	_ccontex,d4
	moveq	#0x1,d7

TS594:
	clrl	d0
	movw	(a4),d0
	movl	d0,d5
	cmpl	#0x7c,d0
	beqs	TS593
	movw	#0x7c,(a4)+
	movb	d7,_ccontex
	movl	_nopgrp,-(sp)
	movl	d5,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	subqb	#1,(a3)
	bras	TS595

TS593:
	addql	#2,a4

TS595:
	addql	#1,d7
	cmpl	#0x10,d7
	blts	TS594
	movb	d4,_ccontex
	movb	_fpgrp,(a3)
	movl	a3,d0
	subl	#_pgrp,d0
	asrl	#5,d0
	movb	d0,_fpgrp

TS592:
	moveml	(sp)+,#0x3cf0	| d4 d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_getpg
_pg_getpg:
	link	a6,#0x0
	moveml	#0xf1c,-(sp)	| d4 d5 d6 d7 a3 a4 a5
	movb	_fpgrp,d0
	extw	d0
	extl	d0
	movl	d0,d7
	beqs	TS603
	movl	d7,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a5
	movb	(a5),_fpgrp
	clrb	(a5)
	bra	TS610

TS603:
	movb	_nxpgrp,d0
	addqb	#1,_nxpgrp
	extw	d0
	extl	d0
	movl	d0,d7
	cmpl	#0x76,d0
	bnes	TS604
	movb	_ffpgrp,_nxpgrp

TS604:
	movl	d7,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a5
	movw	d7,0xbb0000
	clrl	d6

TS606:
	movl	d6,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	(a0),d4
	cmpw	#0x8000,d4
	bccs	TS605
	movl	d6,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	#0x8000,(a0)
	subqb	#1,0x1(a5)
	clrl	d0
	movw	d4,d0
	andl	#0xfff,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a4
	orw	d4,0x4(a4)
	clrb	0x6(a4)

TS605:
	addql	#1,d6
	cmpl	#0x10,d6
	blts	TS606
	movb	_ccontex,d0
	extw	d0
	extl	d0
	movl	d0,d5
	lea	0x2(a5),a0
	movl	a0,a3
	moveq	#0x1,d6

TS608:
	movw	(a3),d4
	cmpw	#0x7c,d4
	beqs	TS607
	movw	#0x7c,(a3)+
	movb	d6,_ccontex
	movl	_nopgrp,-(sp)
	clrl	d0
	movw	d4,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	subqb	#1,(a5)
	bras	TS609

TS607:
	addql	#2,a3

TS609:
	addql	#1,d6
	cmpl	#0x10,d6
	blts	TS608
	movb	d5,_ccontex

TS610:
	movl	d7,d0
	moveml	(sp)+,#0x38f0	| d4 d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_map
_pg_map:
	link	a6,#0x0
	moveml	#0x71c,-(sp)	| d5 d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	cmpb	#0x99,0x3a816e
	beqs	TS562
	clrl	-(sp)
	clrl	-(sp)
	movl	_runtcb,-(sp)
	movl	#0xc0,-(sp)
	moveq	#0xb,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	moveq	#0xb,d0
	movl	d0,-(sp)
	movl	_runtcb,-(sp)
	jsr	_psignal
	addql	#8,sp

TS562:
	tstb	0xfc(a5)
	bne	TS563
	cmpl	_proc,a5
	beq	TS563
	movb	_fctx,d7
	beqs	TS564
	movb	d7,d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_ctx,d0
	movl	d0,a0
	movl	(a0),d0
	movb	d0,_fctx
	bras	TS621

TS564:
	movb	_nxctx,d0
	addqb	#1,_nxctx
	movb	d0,d7
	cmpb	#0xf,d0
	bnes	TS565
	movb	#0x1,_nxctx

TS565:
	movb	d7,d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_ctx,d0
	movl	d0,a0
	movl	(a0),a4
	btst	#4,0x22(a4)
	beqs	TS566
	clrl	-(sp)
	pea	(a4)
	bsr	_pg_mapiop
	addql	#8,sp

TS566:
	pea	(a4)
	bsr	_pg_demap
	addql	#4,sp
	clrb	0xfc(a4)

TS621:
	movb	d7,0xfc(a5)
	movb	d7,d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_ctx,d0
	movl	d0,a0
	movl	a5,(a0)
	movb	0xfc(a5),_ccontex
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	cmpw	#0x7c0,0x110(a5)
	bccs	TS579
	clrl	d0
	movw	0x110(a5),d0
	movl	d0,d6
	clrl	d0
	movw	0x112(a5),d0
	movl	d0,d5
	bras	TS618

TS619:
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a3
	tstw	0x2(a3)
	beqs	TS620
	btst	#1,(a3)
	bnes	TS620
	movl	d6,-(sp)
	pea	(a3)
	bsr	_map
	addql	#8,sp

TS620:
	addql	#1,d6

TS618:
	cmpl	d5,d6
	bles	TS619

TS579:
	clrl	d0
	movw	0x114(a5),d0
	movl	d0,d6
	beqs	TS580
	clrl	d0
	movw	0x116(a5),d0
	movl	d0,d5
	bras	TS615

TS616:
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a3
	tstw	0x2(a3)
	beqs	TS617
	btst	#1,(a3)
	bnes	TS617
	movl	d6,-(sp)
	pea	(a3)
	bsr	_map
	addql	#8,sp

TS617:
	addql	#1,d6

TS615:
	cmpl	d5,d6
	bles	TS616

TS580:
	clrl	d0
	movw	0x11c(a5),d0
	movl	d0,d6
	beqs	TS581
	movl	#0x7bf,d5
	bras	TS589

TS590:
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a3
	tstw	0x2(a3)
	beqs	TS591
	btst	#1,(a3)
	bnes	TS591
	movl	d6,-(sp)
	pea	(a3)
	bsr	_map
	addql	#8,sp

TS591:
	addql	#1,d6

TS589:
	cmpl	d5,d6
	bles	TS590

TS581:
	btst	#4,0x22(a5)
	beqs	TS582
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a5)
	bsr	_pg_mapiop
	addql	#8,sp

TS582:
	btst	#3,0x22(a5)
	beqs	TS583
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a5)
	bsr	_pg_mapgraf
	addql	#8,sp
	bras	TS583

TS563:
	movb	0xfc(a5),_ccontex

TS583:
	moveml	(sp)+,#0x38e0	| d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_demap
_pg_demap:
	link	a6,#0x0
	moveml	#0x1f1c,-(sp)	| d3 d4 d5 d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	movb	0xfc(a5),d0
	extw	d0
	extl	d0
	bclr	#4,d0
	movb	d0,d4
	beq	TS567
	movb	_ccontex,d3
	movb	d4,_ccontex
	clrl	d0
	movw	0x116(a5),d0
	lsrl	#4,d0
	movl	d0,d7
	bras	TS568

TS569:
	movl	d7,-(sp)
	jsr	_get_pgrp
	addql	#4,sp
	movl	d0,d5
	cmpl	_nopgrp,d0
	beqs	TS570
	movl	_nopgrp,-(sp)
	movl	d7,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	d5,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a4
	lea	0x2(a4),a0
	movb	d4,d0
	extw	d0
	subqw	#1,d0
	extl	d0
	addl	d0,d0
	addl	d0,a0
	movw	#0x7c,(a0)
	subqb	#1,(a4)

TS570:
	subql	#1,d7

TS568:
	tstl	d7
	bges	TS569
	clrl	d0
	movw	0x11c(a5),d0
	lsrl	#4,d0
	movl	d0,d7
	bras	TS571

TS572:
	movl	d7,-(sp)
	jsr	_get_pgrp
	addql	#4,sp
	movl	d0,d5
	cmpl	_nopgrp,d0
	beqs	TS573
	movl	_nopgrp,-(sp)
	movl	d7,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	d5,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a4
	lea	0x2(a4),a0
	movb	d4,d0
	extw	d0
	subqw	#1,d0
	extl	d0
	addl	d0,d0
	addl	d0,a0
	movw	#0x7c,(a0)
	subqb	#1,(a4)

TS573:
	addql	#1,d7

TS571:
	cmpl	#0x7c,d7
	bnes	TS572
	movl	0xf0(a5),a3
	bras	TS574

TS575:
	movl	0x4(a3),a0
	movl	0xa(a0),d0
	addl	0x8(a3),d0
	subql	#1,d0
	moveq	#0xf,d1
	lsrl	d1,d0
	movl	d0,d6
	movl	0x8(a3),d0
	moveq	#0xf,d1
	lsrl	d1,d0
	movl	d0,d7
	bras	TS576

TS577:
	movl	d7,-(sp)
	jsr	_get_pgrp
	addql	#4,sp
	movl	d0,d5
	cmpl	_nopgrp,d0
	beqs	TS578
	movl	_nopgrp,-(sp)
	movl	d7,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	d5,d0
	asll	#5,d0
	addl	#_pgrp,d0
	movl	d0,a4
	lea	0x2(a4),a0
	movb	d4,d0
	extw	d0
	subqw	#1,d0
	extl	d0
	addl	d0,d0
	addl	d0,a0
	movw	#0x7c,(a0)
	subqb	#1,(a4)

TS578:
	addql	#1,d7

TS576:
	cmpl	d6,d7
	bles	TS577
	movl	(a3),a3

TS574:
	movl	a3,d0
	bnes	TS575
	movb	d3,_ccontex

TS567:
	moveml	(sp)+,#0x38f8	| d3 d4 d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_dma
_pg_dma:
	link	a6,#0x0
	moveml	#0x2f04,-(sp)	| d2 d4 d5 d6 d7 a5
	movl	0x8(a6),a5
	movl	0x10(a6),d7
	movl	a5,d0
	beqs	TS2098
	tstl	0x14(a6)
	beqs	TS2098
	movl	d7,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d6
	movl	0x14(a6),d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	addql	#2,d0
	movl	d0,d5
	cmpl	#0x10,d0
	bles	TS2099
	clrl	d0
	bras	TS2102

TS2099:
	movl	0xc(a6),d0
	addl	#0x7c,d0
	asll	#4,d0
	movl	d0,d4
	movl	d4,d0
	moveq	#0xb,d1
	asll	d1,d0
	movl	d7,d1
	andl	#0x7ff,d1
	addl	d1,d0
	movl	d0,d7
	bras	TS2100

TS2101:
	movl	d6,d0
	bset	#14,d0
	movl	d4,d1
	moveq	#0xb,d2
	asll	d2,d1
	addl	#0x800080,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d6
	addql	#1,d4

TS2100:
	movl	d5,d0
	subql	#1,d5
	tstl	d0
	bnes	TS2101

TS2098:
	movl	d7,d0

TS2102:
	moveml	(sp)+,#0x20f4	| d2 d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_pg_mapiop
_pg_mapiop:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movb	_ccontex,d0
	extw	d0
	extl	d0
	movl	d0,d7
	movb	0xfc(a5),_ccontex
	tstl	0xc(a6)
	beqs	TS587
	btst	#4,0x22(a5)
	beqs	TS587
	moveq	#0x77,d0
	movl	d0,-(sp)
	moveq	#0x7c,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	moveq	#0x78,d0
	movl	d0,-(sp)
	moveq	#0x7d,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	moveq	#0x79,d0
	movl	d0,-(sp)
	moveq	#0x7e,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	moveq	#0x7a,d0
	movl	d0,-(sp)
	moveq	#0x7f,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	moveq	#0x7b,d0
	movl	d0,-(sp)
	bras	TS588

TS587:
	movl	_nopgrp,-(sp)
	moveq	#0x7c,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	_nopgrp,-(sp)
	moveq	#0x7d,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	_nopgrp,-(sp)
	moveq	#0x7e,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	_nopgrp,-(sp)
	moveq	#0x7f,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movl	_nopgrp,-(sp)

TS588:
	movl	#0x107fff,d0
	moveq	#0xf,d1
	lsrl	d1,d0
	movl	d0,-(sp)
	jsr	_put_pgrp
	addql	#8,sp
	movb	d7,_ccontex
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_pg_mapgraf
_pg_mapgraf:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	tstl	0xc(a6)
	beqs	TS584
	btst	#3,0x22(a5)
	beqs	TS584
	bset	#4,0xfc(a5)
	bras	TS586

TS584:
	bclr	#4,0xfc(a5)

TS586:
	movl	_runtcb,a5
	movl	a5,d0
	beqs	TS585
	movb	0xfc(a5),_ccontex

TS585:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_copy_uu
_copy_uu:
	link	a6,#0x0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	0x10(a6),d5
	movl	0x14(a6),a5
	movl	0x18(a6),a4
	tstl	d5
	ble	TS45
	cmpl	#0x3e0000,d7
	bhis	TS46
	cmpl	#0x3e0000,d6
	blss	TS1330

TS46:
	clrl	-(sp)
	clrl	-(sp)
	movl	_runtcb,-(sp)
	movl	#0xc0,-(sp)
	moveq	#0x13,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp

TS1330:
	pea	(a5)
	movl	d7,d0
	addl	d5,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,-(sp)
	movl	d7,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,-(sp)
	bsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	bnes	TS1330
	pea	(a4)
	movl	d6,d0
	addl	d5,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,-(sp)
	movl	d6,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,-(sp)
	bsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	beqs	TS1331
	bras	TS1330

TS1332:
	pea	(a4)
	pea	(a5)
	movl	#0x1800,-(sp)
	movl	d6,-(sp)
	movl	d7,-(sp)
	bsr	_move_data
	addw	#0x14,sp
	addl	#0x1800,d7
	addl	#0x1800,d6
	subl	#0x1800,d5

TS1331:
	cmpl	#0x1800,d5
	bgts	TS1332
	pea	(a4)
	pea	(a5)
	movl	d5,-(sp)
	movl	d6,-(sp)
	movl	d7,-(sp)
	bsr	_move_data
	addw	#0x14,sp

TS45:
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_copy_ld
_copy_ld:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	0x10(a6),d5
	movl	0x14(a6),a5

TS2103:
	pea	(a5)
	movl	d7,d0
	addl	d5,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,-(sp)
	movl	d7,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,-(sp)
	bsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	bnes	TS2103
	movl	d6,d0
	moveq	#0xb,d1
	asrl	d1,d0
	bset	#14,d0
	movw	d0,0xbae080
	clrl	-(sp)
	pea	(a5)
	movl	d5,-(sp)
	movl	d6,d0
	andl	#0x7ff,d0
	addl	#0x3ae000,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	bsrs	_move_data
	addw	#0x14,sp
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_copy_sm
_copy_sm:
	link	a6,#0x0
	movl	0xc(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	bset	#14,d0
	movw	d0,0xbae080
	movl	0x10(a6),-(sp)
	movl	0xc(a6),d0
	andl	#0x7ff,d0
	addl	#0x3ae000,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_move_data
_move_data:
	link	a6,#0xfff4
	moveml	#0x3f0c,-(sp)	| d2 d3 d4 d5 d6 d7 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	0x10(a6),d5
	movl	0x14(a6),a5
	movl	0x18(a6),a4
	movl	a5,d0
	beq	TS1333
	movl	d7,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d3
	movl	d7,d0
	addl	d5,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d2
	movl	#0x758,d4
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	bras	TS1338

TS1339:
	movl	d4,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0x800080,d0
	movl	d0,0xfff4(a6)
	movl	d3,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a0
	movl	0xfff4(a6),a1
	movw	0x2(a0),(a1)
	addql	#1,d3
	addql	#1,d4

TS1338:
	cmpl	d2,d3
	bles	TS1339
	movl	d7,d0
	andl	#0x7ff,d0
	addl	#0x3ac000,d0
	movl	d0,0xfffc(a6)
	bras	TS1340

TS1333:
	movl	d7,0xfffc(a6)

TS1340:
	movl	a4,d0
	beq	TS1334
	movl	d6,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d3
	movl	d6,d0
	addl	d5,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d2
	movl	#0x75c,d4
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	bras	TS1335

TS1336:
	movl	d4,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0x800080,d0
	movl	d0,0xfff4(a6)
	movl	d3,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movl	0xfff4(a6),a0
	movw	d0,(a0)
	addql	#1,d3
	addql	#1,d4

TS1335:
	cmpl	d2,d3
	bles	TS1336
	movl	d6,d0
	andl	#0x7ff,d0
	addl	#0x3ae000,d0
	movl	d0,0xfff8(a6)
	bras	TS1337

TS1334:
	movl	d6,0xfff8(a6)

TS1337:
	movl	d5,-(sp)
	movl	0xfff8(a6),-(sp)
	movl	0xfffc(a6),-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	moveml	(sp)+,#0x30fc	| d2 d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_loadpages
_loadpages:
	link	a6,#0x0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	0x10(a6),a5
	movl	a5,d0
	bnes	TS814
	clrl	d0
	bras	TS1021

TS814:
	clrl	d5
	bras	TS815

TS816:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	btst	#1,(a4)
	bnes	TS817
	tstw	0x2(a4)
	beqs	TS817
	cmpb	#0x1,0x1(a4)
	bles	TS1020

TS817:
	clrl	-(sp)
	pea	(a5)
	pea	(a4)
	movl	d7,-(sp)
	jsr	_inpage
	addw	#0x10,sp
	moveq	#0x1,d5
	bras	TS1019

TS1020:
	bset	#3,(a4)

TS1019:
	addql	#1,d7

TS815:
	cmpl	d6,d7
	bles	TS816
	movl	d5,d0

TS1021:
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_ssuword
_ssuword:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	movw	0x4a(a5),d0
	andl	#0x200,d0
	movl	d0,-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	movl	0x1e(a5),-(sp)
	movl	0x56(a5),-(sp)
	pea	0xc(a6)
	bsr	_copysu
	addw	#0x14,sp
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_fushort
_fushort:
	link	a6,#0xfffc
	moveq	#0x2,d0
	movl	d0,-(sp)
	pea	0xfffe(a6)
	movl	0x8(a6),-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	beqs	TS2104
	moveq	#0xffffffff,d0
	bras	TS2105

TS2104:
	clrl	d0
	movw	0xfffe(a6),d0

TS2105:
	unlk	a6
	rts

	.globl	_sushort
_sushort:
	link	a6,#0x0
	moveq	#0x2,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	pea	0xe(a6)
	jsr	_copy_out
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_suword
_suword:
	link	a6,#0x0
	moveq	#0x4,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	pea	0xc(a6)
	jsr	_copy_out
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_supoint
_supoint:
	link	a6,#0x0
	moveq	#0x4,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	pea	0xc(a6)
	jsr	_copy_out
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_copytim
_copytim:
	link	a6,#0xfffc
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movw	0xba8880,d7
	movl	#0x3a8800,0xfffc(a6)
	movl	0xfe(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba8880
	movl	0xfffc(a6),a0
	movl	0xc(a6),d0
	addl	d0,0x7e(a0)
	movl	0xfffc(a6),a0
	movl	0x10(a6),d0
	addl	d0,0x82(a0)
	movw	d7,0xba8880
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_cpySMU
_cpySMU:
	link	a6,#0x0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0x14(a6),d7
	cmpl	#0x3a8000,0x10(a6)
	bcss	TS2106
	movl	0x10(a6),d0
	addl	d7,d0
	cmpl	#0x3a8800,d0
	blss	TS2109

TS2106:
	moveq	#0x11,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2109:
	movw	0xba8880,d5
	movl	0x10(a6),d0
	addl	#0x800,d0
	movl	d0,a4
	bras	TS2107

TS2108:
	movl	a5,-(sp)
	addql	#1,a5
	jsr	_copy_fb
	addql	#4,sp
	movb	d0,d6
	movl	0xc(a6),a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba8880
	movb	d6,(a4)+

TS2107:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS2108
	movw	d5,0xba8880
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_cpySUM
_cpySUM:
	link	a6,#0x0
	moveml	#0x50c,-(sp)	| d5 d7 a4 a5
	movl	0x10(a6),a5
	movl	0x14(a6),d7
	cmpl	#0x3a8000,0xc(a6)
	bcss	TS2110
	movl	0xc(a6),d0
	addl	d7,d0
	cmpl	#0x3a8800,d0
	blss	TS2113

TS2110:
	moveq	#0x11,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2113:
	movw	0xba8880,d5
	movl	0xc(a6),d0
	addl	#0x800,d0
	movl	d0,a4
	bras	TS2111

TS2112:
	movl	0x8(a6),a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba8880
	movb	(a4)+,d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	movl	a5,-(sp)
	addql	#1,a5
	jsr	_copy_sb
	addql	#8,sp

TS2111:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS2112
	movw	d5,0xba8880
	moveml	(sp)+,#0x30a0	| d5 d7 a4 a5
	unlk	a6
	rts

	.globl	_cpySUU
_cpySUU:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0x10(a6),a4
	movl	0x14(a6),d7
	cmpl	#0x3a8000,a4
	bcss	TS1341
	movl	a4,d0
	addl	d7,d0
	cmpl	#0x3a8800,d0
	blss	TS1344

TS1341:
	moveq	#0x11,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1344:
	movw	0xba8880,d6
	movl	0xc(a6),a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba8880
	lea	0x800(a4),a0
	movl	a0,a4
	bras	TS1342

TS1343:
	movb	(a5)+,(a4)+

TS1342:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS1343
	movw	d6,0xba8880
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_cpyUSU
_cpyUSU:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0x10(a6),a4
	movl	0x14(a6),d7
	cmpl	#0x3a8000,a4
	bcss	TS48
	movl	a4,d0
	addl	d7,d0
	cmpl	#0x3a8800,d0
	blss	TS51

TS48:
	moveq	#0x11,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS51:
	movw	0xba8880,d6
	movl	0xc(a6),a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba8880
	lea	0x800(a4),a0
	movl	a0,a4
	bras	TS49

TS50:
	movb	(a4)+,(a5)+

TS49:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS50
	movw	d6,0xba8880
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_copysu
_copysu:
	link	a6,#0x0
	moveml	#0x13c,-(sp)	| d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0x10(a6),a3
	movl	0x14(a6),d7
	movl	a4,d0
	beqs	TS42
	movl	_runtcb,a2
	cmpl	a4,a2
	bnes	TS43
	tstl	0x18(a6)
	beqs	TS1345

TS1346:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	beqs	TS42
	movb	(a5),(a3)
	addql	#1,a3
	addql	#1,a5
	bras	TS1346

TS1345:
	movl	d7,-(sp)
	pea	(a3)
	pea	(a5)
	jsr	_copy_out
	addw	#0xc,sp
	bras	TS42

TS43:
	tstl	0x18(a6)
	beqs	TS44
	movl	d7,-(sp)
	pea	(a3)
	pea	(a4)
	pea	(a5)
	bsr	_cpySUU
	addw	#0x10,sp
	bras	TS42

TS44:
	pea	(a4)
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a3)
	pea	(a5)
	bsr	_copy_uu
	addw	#0x14,sp

TS42:
	moveml	(sp)+,#0x3c80	| d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_urdwr
_urdwr:
	link	a6,#0x0
	moveml	#0x13c,-(sp)	| d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0x10(a6),d7
	movl	0x56(a5),a3
	movl	0x1e(a5),d0
	addl	0x14(a6),d0
	movl	d0,a2
	tstl	d7
	bnes	TS2114
	clrl	d0
	bra	TS2117

TS2114:
	tstl	0x18(a6)
	beqs	TS2115
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a4)
	jsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2121

TS2116:
	moveq	#0xffffffea,d0
	bra	TS2117

TS2121:
	btst	#1,0x4a(a5)
	beqs	TS2122
	cmpb	#0x2,0x47(a5)
	bnes	TS2124
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	pea	(a2)
	pea	(a4)
	bsr	_copy_ld

TS2119:
	addw	#0x10,sp
	bras	TS2120

TS2124:
	movl	d7,-(sp)
	pea	(a2)
	pea	(a3)
	pea	(a4)
	bsr	_cpySMU
	bras	TS2119

TS2122:
	pea	(a3)
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	pea	(a2)
	pea	(a4)
	bras	TS2123

TS2115:
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a4)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	bnes	TS2116
	btst	#1,0x4a(a5)
	beqs	TS2118
	movl	d7,-(sp)
	pea	(a4)
	pea	(a2)
	pea	(a3)
	bsr	_cpySUM
	bras	TS2119

TS2118:
	movl	_runtcb,-(sp)
	pea	(a3)
	movl	d7,-(sp)
	pea	(a4)
	pea	(a2)

TS2123:
	bsr	_copy_uu
	addw	#0x14,sp

TS2120:
	movl	d7,d0

TS2117:
	moveml	(sp)+,#0x3c80	| d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_PG_alloc
_PG_alloc:
	link	a6,#0x0
	moveml	#0xf04,-(sp)	| d4 d5 d6 d7 a5
	movl	_proc,a5
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	_ednix,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d5
	movl	0x8(a6),d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	addql	#1,d0
	movl	d0,d7
	clrl	d4
	movl	d4,d6

TS2133:
	cmpl	#0x750,d5
	bges	TS2125
	movl	d5,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	tstw	(a0)
	bnes	TS2132
	tstl	d6
	bnes	TS2134
	movl	d5,d4

TS2134:
	addql	#1,d6
	cmpl	d7,d6
	bnes	TS2135

TS2125:
	cmpl	d7,d6
	beqs	TS2126
	moveq	#0xffffffe4,d0
	bra	TS2131

TS2132:
	clrl	d6

TS2135:
	addql	#1,d5
	bras	TS2133

TS2126:
	movl	d4,d5
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	bras	TS2127

TS2128:
	movl	d5,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	movw	#0x1,(a0)
	addql	#1,d5

TS2127:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS2128
	movl	d6,d7
	movl	d4,d5
	bras	TS2129

TS2130:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	jsr	_getvpd
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d5,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d5

TS2129:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS2130
	movl	d4,d0
	moveq	#0xb,d1
	asll	d1,d0

TS2131:
	moveml	(sp)+,#0x20f0	| d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_PG_free
_PG_free:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	_proc,a5
	movl	0x8(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d7
	movl	0x8(a6),d0
	addl	0xc(a6),d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d6
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	bras	TS1188

TS1189:
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrw	(a0)
	addql	#1,d7

TS1188:
	cmpl	d6,d7
	bles	TS1189
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_PG_map
_PG_map:
	link	a6,#0x0
	moveml	#0x2704,-(sp)	| d2 d5 d6 d7 a5
	movl	_proc,a5
	movl	0x8(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d7
	movl	0x8(a6),d0
	addl	0xc(a6),d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d6

TS1503:
	pea	(a5)
	movl	d6,-(sp)
	movl	d7,-(sp)
	bsr	_loadpages
	addw	#0xc,sp
	tstl	d0
	bnes	TS1503
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	#0x758,d5
	bras	TS1504

TS1505:
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movl	d5,d1
	moveq	#0xb,d2
	asll	d2,d1
	addl	#0x800080,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d7
	addql	#1,d5

TS1504:
	cmpl	d6,d7
	bles	TS1505
	movl	#0x3ac000,d0
	moveml	(sp)+,#0x20e4	| d2 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_PG_attach
_PG_attach:
	link	a6,#0x0
	moveml	#0x1f0c,-(sp)	| d3 d4 d5 d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0x10(a6),d7
	movl	d7,-(sp)
	movl	0xc(a6),-(sp)
	pea	(a5)
	bsr	_PG_salloc
	addw	#0xc,sp
	movl	d0,0xc(a6)
	bgts	TS2145
	moveq	#0xffffffe4,d0
	bra	TS2148

TS2145:
	movl	_proc,a4
	movl	0xc(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d6
	movl	0x14(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d4
	movl	0xc(a6),d0
	addl	d7,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d5
	bras	TS2146

TS2147:
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d4,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	movl	d0,d3
	addql	#1,d4
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d6,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	movw	d3,(a0)
	addql	#1,d6

TS2146:
	cmpl	d5,d6
	bles	TS2147
	movl	0xc(a6),d0

TS2148:
	moveml	(sp)+,#0x30f8	| d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_PG_salloc
_PG_salloc:
	link	a6,#0x0
	moveml	#0x3f04,-(sp)	| d2 d3 d4 d5 d6 d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	beqs	TS2136
	movl	d7,d0
	andl	#0x7fff,d0
	beqs	TS2136

TS2138:
	moveq	#0xffffffe4,d0
	bra	TS2139

TS2136:
	movl	0x10(a6),d0
	subql	#1,d0
	moveq	#0xf,d1
	asrl	d1,d0
	addql	#1,d0
	movl	d0,d2
	clrl	d0
	movw	0x116(a5),d0
	lsrl	#4,d0
	addql	#2,d0
	movl	d0,d6
	clrl	d0
	movw	0x11c(a5),d0
	lsrl	#4,d0
	subql	#2,d0
	movl	d0,d5
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	tstl	d7
	bnes	TS2137
	clrl	d3
	movl	d3,d4
	bras	TS2142

TS2144:
	clrl	d4

TS2142:
	cmpl	d5,d6
	bgts	TS2138
	tstl	d4
	bnes	TS2143
	movl	d6,d3

TS2143:
	movl	d6,d0
	addql	#1,d6
	asll	#4,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	tstw	(a0)
	bnes	TS2144
	addql	#1,d4
	cmpl	d2,d4
	bnes	TS2142
	movl	d3,d0
	moveq	#0xf,d1
	asll	d1,d0
	bras	TS2139

TS2137:
	movl	d7,d0
	moveq	#0xf,d1
	asrl	d1,d0
	movl	d0,d3
	cmpl	d6,d3
	blt	TS2138
	movl	d3,d0
	addl	d2,d0
	cmpl	d5,d0
	bgt	TS2138
	movl	d3,d6

TS2141:
	movl	d2,d0
	subql	#1,d2
	tstl	d0
	beqs	TS2140
	movl	d6,d0
	addql	#1,d6
	asll	#4,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	tstw	(a0)
	beqs	TS2141
	bra	TS2138

TS2140:
	movl	d7,d0

TS2139:
	moveml	(sp)+,#0x20fc	| d2 d3 d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_PG_detach
_PG_detach:
	link	a6,#0x0
	moveml	#0xf04,-(sp)	| d4 d5 d6 d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),d6
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d5
	movl	d7,d0
	addl	d6,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d4
	bras	TS1429

TS1430:
	movl	d5,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrw	(a0)
	addql	#1,d5

TS1429:
	cmpl	d4,d5
	bles	TS1430
	moveml	(sp)+,#0x20f0	| d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_getpage
_getpage:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	bras	TS830

TS831:
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#_wfpg,-(sp)
	jsr	_sleep
	addql	#8,sp

TS830:
	tstw	_freelist
	beqs	TS831
	clrl	d0
	movw	_freelist,d0
	movl	d0,d6
	asll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a4
	tstl	_sortlist
	beqs	TS832
	tstw	0x2(a4)
	beqs	TS832
	clrl	_sortlist
	bsr	_dosort
	clrl	d0
	movw	_freelist,d0
	movl	d0,d6
	asll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a4

TS832:
	movw	_freelist,d0
	cmpw	_lastlist,d0
	bnes	TS833
	clrw	_lastlist
	movw	_lastlist,_freelist
	bras	TS836

TS833:
	movw	(a4),_freelist

TS836:
	clrw	(a4)
	subql	#1,_OS_PAGE
	tstw	0x2(a4)
	beqs	TS834
	clrl	d0
	movw	0x2(a4),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a3
	movb	(a3),d0
	andb	#0x28,d0
	bne	TS830
	movb	0x6(a4),d0
	extw	d0
	extl	d0
	movl	d0,d7
	beqs	TS835
	movw	d7,0xbb0000
	movb	0x7(a4),d0
	extw	d0
	extl	d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	(a0),d0
	orw	d0,0x4(a4)

TS835:
	movw	0x4(a4),d0
	andw	#0x3000,d0
	bne	TS830
	pea	(a3)
	jsr	_demap
	addql	#4,sp
	clrw	0x2(a3)

TS834:
	movw	d6,0x2(a5)
	movl	a5,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movw	d0,0x2(a4)
	movl	d6,d0
	bset	#12,d0
	movw	d0,0x4(a4)
	clrb	0x6(a4)
	clrb	0x7(a4)
	movl	d6,d0
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_dosort
_dosort:
	link	a6,#0x0
	moveml	#0x3f0c,-(sp)	| d2 d3 d4 d5 d6 d7 a4 a5
	movw	_freelist,d7
	clrw	d2
	movw	d2,d3
	movw	d3,d4
	movw	d4,d5
	bras	TS837

TS839:
	tstw	d5
	bnes	TS840
	movw	d6,d4
	movw	d4,d5
	movw	#0x1,(a5)
	bras	TS837

TS840:
	movw	d5,(a5)
	movw	d6,d5
	bras	TS837

TS841:
	clrw	(a5)
	subql	#1,_OS_PAGE
	bras	TS837

TS838:
	movw	d7,d6
	clrl	d0
	movw	d6,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a5
	movw	(a5),d7
	tstw	0x2(a5)
	beqs	TS839
	movw	0x4(a5),d0
	andw	#0x3000,d0
	bnes	TS841
	movw	#0x1,(a5)
	tstw	d3
	bnes	TS842
	movw	d6,d2
	movw	d2,d3
	bras	TS837

TS842:
	clrl	d0
	movw	d2,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a4
	movw	d6,d2
	movw	d2,(a4)

TS837:
	cmpw	#0x1,d7
	bnes	TS838
	tstw	d5
	bnes	TS843
	movw	d3,_freelist
	bras	TS846

TS843:
	tstw	d3
	bnes	TS844
	movw	d5,_freelist
	movw	d4,_lastlist
	bras	TS845

TS844:
	clrl	d0
	movw	d4,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a5
	movw	d3,(a5)
	movw	d5,_freelist

TS846:
	movw	d2,_lastlist

TS845:
	moveml	(sp)+,#0x30fc	| d2 d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_putppd
_putppd:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	tstw	(a5)
	bne	TS1034
	addql	#1,_OS_PAGE
	tstw	_freelist
	bnes	TS1036
	movw	#0x1,(a5)
	movl	a5,d0
	subl	_ppdbase,d0
	asrl	#3,d0
	movw	d0,_lastlist
	movw	d0,_freelist
	bras	TS1038

TS1036:
	tstw	0x2(a5)
	beqs	TS1037
	movw	#0x1,(a5)
	clrl	d0
	movw	_lastlist,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a4
	movl	a5,d0
	subl	_ppdbase,d0
	asrl	#3,d0
	movw	d0,_lastlist
	movw	d0,(a4)
	bras	TS1038

TS1037:
	movw	_freelist,(a5)
	movl	a5,d0
	subl	_ppdbase,d0
	asrl	#3,d0
	movw	d0,_freelist

TS1038:
	movl	_wfpg,a0
	cmpw	#0x1,0x8(a0)
	beqs	TS1035
	movl	#_wfpg,-(sp)
	jsr	_wakeup
	addql	#4,sp
	bras	TS1035

TS1034:
	tstw	0x2(a5)
	bnes	TS1035
	movl	#0x1,_sortlist

TS1035:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_pg_scan
_pg_scan:
	link	a6,#0x0
	moveml	#0x3f0c,-(sp)	| d2 d3 d4 d5 d6 d7 a4 a5
	movl	0x8(a6),a5
	bras	TS1836

TS1838:
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	cmpl	_vpdbase,d0
	beqs	TS1836
	movb	(a4),d0
	andb	#0x62,d0
	bnes	TS1836
	movb	0x6(a5),d0
	extw	d0
	extl	d0
	movl	d0,d6
	beqs	TS1839
	movw	d6,0xbb0000
	movb	0x7(a5),d0
	extw	d0
	extl	d0
	movl	d0,d5
	movl	d5,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	(a0),d0
	orw	d0,0x4(a5)

TS1839:
	btst	#4,0x4(a5)
	beqs	TS1840
	bclr	#4,0x4(a5)
	tstl	d6
	beqs	TS1836
	movl	d5,d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	#0xbb0080,d0
	movl	d0,a0
	movw	0x4(a5),(a0)

TS1836:
	movl	a5,a0
	addql	#8,a5
	cmpl	_lastppd,a0
	bnes	TS1837
	movl	_firstppd,a5

TS1837:
	movl	a5,d0
	subl	_ppdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,d7
	tstw	(a5)
	bnes	TS1836
	bra	TS1838

TS1840:
	pea	(a4)
	jsr	_demap
	addql	#4,sp
	btst	#3,(a4)
	bnes	TS1841
	btst	#5,0x4(a5)
	beq	TS1845

TS1841:
	bclr	#5,0x4(a5)
	bclr	#3,(a4)
	bset	#1,(a4)
	movw	#0x1,(a5)
	btst	#7,(a4)
	bnes	TS1842
	movl	#0x800,-(sp)
	jsr	_fh_alloc
	addql	#4,sp
	movl	d0,0x4(a4)
	bnes	TS1846
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x40,d0
	movl	d0,-(sp)
	moveq	#0x16,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	clrw	(a5)
	bra	TS1847

TS1846:
	orb	#0xff80,(a4)

TS1842:
	movl	0x4(a4),d4
	clrl	d0
	movw	0x2(a4),d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,d3
	moveq	#0xffffffff,d2
	movl	#0x800,-(sp)
	movl	d4,-(sp)
	jsr	_fh_segchk
	addql	#8,sp
	tstl	d0
	bnes	TS1843
	clrl	-(sp)
	movl	#0x800,-(sp)
	movl	d4,-(sp)
	movl	d3,-(sp)
	movw	_rootdev,d0
	extl	d0
	movl	d0,-(sp)
	moveq	#0x5,d0
	movl	d0,-(sp)
	jsr	_physio
	addw	#0x18,sp
	movl	d0,d2

TS1843:
	clrw	(a5)
	btst	#2,(a4)
	beqs	TS1844
	movl	a4,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,-(sp)
	jsr	_unwaitvpd
	addql	#4,sp

TS1844:
	andb	#0xfff9,(a4)
	cmpl	#0x800,d2
	beqs	TS1845
	clrl	-(sp)
	movl	d2,-(sp)
	movl	#0xfffff800,-(sp)
	movl	d4,-(sp)
	movl	d3,-(sp)
	jsr	_swaperror
	addw	#0x14,sp

TS1845:
	pea	(a5)
	jsr	_putppd
	addql	#4,sp

TS1847:
	movl	a5,d0
	moveml	(sp)+,#0x30fc	| d2 d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_hndl
_pg_hndl:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movw	#0x1,BS1830
	movl	#_swpr,_swpr
	movl	_swpr,BS1831
	clrl	d0
	movw	_fppage,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,_firstppd
	clrl	d0
	movw	_lppage,d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,_lastppd
	movl	_firstppd,a5

TS1833:
	movl	#_swpr,-(sp)
	jsr	_wakeup
	addql	#4,sp
	tstl	_syncout
	bgts	TS1832
	jsr	_fh_sync
	movl	_OS_SYNC,_syncout

TS1832:
	jsr	_spl6
	movl	_runtcb,a0
	movb	#0x1,0x24(a0)
	movl	#0x1,_swapidle

TS1849:
	jsr	_swtch
	movl	_OS_PAGE,d0
	cmpl	_OS_TRIG,d0
	bgts	TS1833
	tstl	_OS_NSWP
	beqs	TS1834
	jsr	_spl6
	movl	#_swpr,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	beqs	TS1856
	movl	_time,d0
	subl	0xe8(a4),d0
	cmpl	_OS_SWAP,d0
	blts	TS1856
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	jsr	_addrdq
	addql	#4,sp

TS1856:
	jsr	_spl0

TS1834:
	tstl	_OS_SWAP
	beqs	TS1835
	movl	_wfpg,a0
	cmpw	#0x1,0x8(a0)
	beqs	TS1835
	bsr	_swproc

TS1835:
	pea	(a5)
	bsr	_pg_scan
	addql	#4,sp
	movl	d0,a5
	tstl	_syncout
	bgts	TS1848
	jsr	_fh_sync
	movl	_OS_SYNC,_syncout

TS1848:
	jsr	_spl6
	movl	_OS_TRIG,-(sp)
	movl	_OS_PAGE,d0
	asll	#6,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	addql	#2,d0
	movl	d0,_OS_SCAN
	movl	_runtcb,a0
	movb	#0x1,0x24(a0)
	bra	TS1849
	rts

	.globl	_pg_swproc
_pg_swproc:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	_runtcb,a5
	tstl	_swapidle
	bnes	TS2045
	movl	_time,0xe8(a5)
	clrl	0x12c(a5)
	addql	#1,_OS_NSWP
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#_swpr,-(sp)
	jsr	_sleep
	addql	#8,sp
	subql	#1,_OS_NSWP
	movl	_time,0xe8(a5)

TS2045:
	bclr	#0,0x23(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_swproc
_swproc:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	subl	a3,a3
	movl	#_proc+4,a5
	bras	TS1850

TS1851:
	movl	(a5),a4
	movl	a4,d0
	beqs	TS1852
	cmpb	#0x1,0x24(a4)
	beqs	TS1853
	cmpb	#0x3,0x24(a4)
	bnes	TS1852

TS1853:
	movw	0x22(a4),d0
	andw	#0x17,d0
	bnes	TS1852
	movl	a3,d0
	beqs	TS1854
	movl	0x12c(a3),d0
	cmpl	0x12c(a4),d0
	bccs	TS1852

TS1854:
	movl	a4,a3

TS1852:
	addql	#4,a5

TS1850:
	cmpl	#_nodebuf,a5
	bcss	TS1851
	movl	a3,d0
	beqs	TS1855
	bset	#0,0x23(a3)

TS1855:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_itcb
_pg_itcb:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	clrl	0x10a(a5)
	clrw	0x10e(a5)
	movl	_vpdbase,0x102(a5)
	movl	_vpdbase,0x106(a5)
	movw	#0x7c0,0x110(a5)
	clrw	0x112(a5)
	clrw	0x126(a5)
	movw	0x126(a5),0x116(a5)
	movw	0x116(a5),0x124(a5)
	movw	0x124(a5),0x114(a5)
	clrw	0x122(a5)
	movw	0x122(a5),0x120(a5)
	movw	0x120(a5),0x11c(a5)
	clrb	0x11f(a5)
	movb	0x11f(a5),0x11e(a5)
	clrl	0x12c(a5)
	movl	0x12c(a5),0x128(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_pg_upg0
_pg_upg0:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	_runtcb,a5
	jsr	_getvpd
	movl	d0,a4
	movb	#0x40,(a4)
	movl	a4,0xfe(a5)
	movl	_umem,d0
	subl	#0x800,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x2(a4)
	clrl	d0
	movw	0x2(a4),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a3
	movl	0xfe(a5),d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movw	d0,0x2(a3)
	jsr	_getvpd
	movl	d0,0x102(a5)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movl	0x102(a5),a0
	movb	#0x40,(a0)
	jsr	_getvpd
	movl	d0,0x106(a5)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movl	0x106(a5),a0
	movb	#0x40,(a0)
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_retus
_pg_retus:
	link	a6,#0x0
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0x102(a5),d0
	cmpl	_vpdbase,d0
	beq	TS1393
	pea	(a5)
	jsr	_pg_demap
	addql	#4,sp
	andw	#0xe7ff,0x22(a5)
	tstl	0xf0(a5)
	beqs	TS1394
	pea	(a5)
	jsr	_shmexit
	addql	#4,sp

TS1394:
	tstw	0x124(a5)
	beqs	TS1395
	clrb	0x11e(a5)
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_ulockmem
	addql	#8,sp

TS1395:
	tstw	0x120(a5)
	beqs	TS1396
	clrb	0x11f(a5)
	clrl	-(sp)
	pea	(a5)
	jsr	_ulockmem
	addql	#8,sp

TS1396:
	movw	0x22(a5),d0
	andw	#0x6,d0
	beqs	TS1397
	clrl	-(sp)
	pea	(a5)
	bsr	_pg_memres
	addql	#8,sp

TS1397:
	cmpw	#0x7c0,0x110(a5)
	bccs	TS1398
	clrl	d0
	movw	0x110(a5),d0
	movl	d0,d7
	clrl	d0
	movw	0x112(a5),d0
	movl	d0,d6
	bras	TS1412

TS1413:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addql	#1,d7
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp

TS1412:
	cmpl	d6,d7
	bles	TS1413

TS1398:
	clrl	d0
	movw	0x114(a5),d0
	movl	d0,d7
	clrl	d0
	movw	0x116(a5),d0
	movl	d0,d6
	bras	TS1399

TS1400:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addql	#1,d7
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp

TS1399:
	cmpl	d6,d7
	bles	TS1400
	clrl	d0
	movw	0x11c(a5),d0
	movl	d0,d7
	movl	#0x7bf,d6
	bras	TS1401

TS1402:
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addql	#1,d7
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp

TS1401:
	cmpl	d6,d7
	bles	TS1402
	movl	0x102(a5),-(sp)
	jsr	_putvpd
	addql	#4,sp
	movl	0x106(a5),-(sp)
	jsr	_putvpd
	addql	#4,sp
	movl	0x10a(a5),a4
	subqw	#1,0xa(a4)
	cmpw	#0x1,0xa(a4)
	bne	TS1403
	tstl	0x10(a4)
	beqs	TS1404
	movl	0x10(a4),-(sp)
	jsr	_fh_utxtbusy
	addql	#4,sp

TS1404:
	movl	0x1c(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x20(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	cmpw	#0x7c0,0x2c(a4)
	bges	TS1405
	movw	0x2c(a4),d0
	extl	d0
	movl	d0,d7
	movw	0x2e(a4),d0
	extl	d0
	movl	d0,d6
	bras	TS1408

TS1409:
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a3
	addql	#1,d7
	tstw	0x2(a3)
	beqs	TS1408
	cmpw	#0x8000,0x2(a3)
	beqs	TS1408
	pea	(a3)
	jsr	_demap
	addql	#4,sp
	clrl	d0
	movw	0x2(a3),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	andw	#0xfff,0x4(a2)
	pea	(a2)
	jsr	_putppd
	addql	#4,sp

TS1408:
	cmpl	d6,d7
	bles	TS1409

TS1405:
	movw	0x30(a4),d0
	extl	d0
	movl	d0,d7
	movw	0x32(a4),d0
	extl	d0
	movl	d0,d6
	bras	TS1406

TS1407:
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a3
	addql	#1,d7
	tstw	0x2(a3)
	beqs	TS1406
	cmpw	#0x8000,0x2(a3)
	beqs	TS1406
	pea	(a3)
	jsr	_demap
	addql	#4,sp
	clrl	d0
	movw	0x2(a3),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a2
	andw	#0xfff,0x4(a2)
	pea	(a2)
	jsr	_putppd
	addql	#4,sp

TS1406:
	cmpl	d6,d7
	bles	TS1407

TS1403:
	pea	(a5)
	bsr	_pg_itcb
	addql	#4,sp

TS1393:
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_retss
_pg_retss:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xfe(a5),-(sp)
	jsr	_putvpd
	addql	#4,sp
	movb	0xfc(a5),d0
	extw	d0
	extl	d0
	bclr	#4,d0
	movl	d0,d7
	beqs	TS1451
	movb	_fctx,d0
	extw	d0
	extl	d0
	movl	d7,d1
	asll	#2,d1
	addl	#_ctx,d1
	movl	d1,a0
	movl	d0,(a0)
	movb	d7,_fctx
	clrb	0xfc(a5)

TS1451:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_sbreak
_sbreak:
	link	a6,#0x0
	moveml	#0x1f0c,-(sp)	| d3 d4 d5 d6 d7 a4 a5
	movl	0x8(a6),d7
	movl	_runtcb,a5
	clrl	d0
	movw	0x114(a5),d0
	moveq	#0xb,d1
	lsll	d1,d0
	addl	0x118(a5),d0
	movl	d0,d4
	tstl	d7
	beq	TS2149
	tstl	d7
	bges	TS2150
	movl	d7,d0
	negl	d0
	cmpl	0x118(a5),d0
	bles	TS2150
	movl	0x118(a5),d0
	negl	d0
	movl	d0,d7

TS2150:
	movl	0x118(a5),d0
	addl	d7,d0
	movl	d0,d3
	movl	d3,d0
	moveq	#0xb,d1
	asrl	d1,d0
	clrl	d1
	movw	0x114(a5),d1
	addl	d0,d1
	movl	d1,d6
	clrl	d0
	movw	0x11c(a5),d0
	subl	d6,d0
	cmpl	#0x40,d0
	bges	TS2151

TS2158:
	moveq	#0xffffffff,d0
	bra	TS2159

TS2151:
	clrl	d0
	movw	0x116(a5),d0
	cmpl	d0,d6
	bls	TS2152
	tstl	0xf0(a5)
	beqs	TS2160
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	0xf0(a5),-(sp)
	movl	d6,-(sp)
	jsr	_shmchk
	addw	#0xc,sp
	tstl	d0
	bnes	TS2158

TS2160:
	clrl	d0
	movw	0x116(a5),d0
	addql	#1,d0
	movl	d0,d5
	bras	TS2161

TS2162:
	jsr	_getvpd
	movl	d0,a4
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a4,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d5,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d5

TS2161:
	cmpl	d6,d5
	bles	TS2162
	btst	#2,0x23(a5)
	beq	TS2163
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	clrl	d0
	movw	0x116(a5),d0
	addql	#1,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp
	bra	TS2163

TS2152:
	clrl	d0
	movw	0x116(a5),d0
	cmpl	d0,d6
	bcc	TS2153
	tstb	0x11e(a5)
	beqs	TS2154
	movl	#_syncout+4,-(sp)
	movl	_runtcb,-(sp)
	movl	#0x80,-(sp)
	jsr	_ERR_MESS
	addw	#0xc,sp
	bra	TS2158

TS2154:
	tstw	0x124(a5)
	beqs	TS2155
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_ulockmem
	addql	#8,sp

TS2155:
	clrl	d0
	movw	0x114(a5),d0
	moveq	#0xb,d1
	lsll	d1,d0
	addl	d3,d0
	movl	d0,d4
	clrl	d0
	movw	0x116(a5),d0
	movl	d0,d5
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	bras	TS2156

TS2157:
	movl	d5,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d5,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrw	(a0)
	subql	#1,d5

TS2156:
	cmpl	d5,d6
	blts	TS2157

TS2163:
	movl	_runtcb,-(sp)
	jsr	_pg_demap
	addql	#4,sp

TS2153:
	movl	d3,0x118(a5)
	movw	d6,0x116(a5)

TS2149:
	movl	d4,d0

TS2159:
	moveml	(sp)+,#0x30f8	| d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_gupage
_pg_gupage:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	jsr	_getvpd
	movl	d0,a4
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movb	#0x40,(a4)
	movl	a4,0xfe(a5)
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_pg_wrcm
_pg_wrcm:
	link	a6,#0x0
	moveml	#0xf0c,-(sp)	| d4 d5 d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),d6
	tstl	d7
	bnes	TS762

TS766:
	clrl	d0
	bras	TS767

TS762:
	cmpl	#0x3e0000,d7
	bhis	TS763
	cmpl	#0x3e0000,a5
	bhis	TS763
	movl	_runtcb,a4
	movl	a5,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d5
	movl	a5,d0
	addl	d7,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d4
	tstl	d6
	beqs	TS764
	cmpl	d4,d5
	bnes	TS768
	cmpl	#0x750,d5
	beqs	TS766

TS768:
	moveq	#0x11,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS764:
	clrl	d0
	movw	0x114(a4),d0
	cmpl	d0,d5
	bcss	TS765
	clrl	d0
	movw	0x116(a4),d0
	cmpl	d0,d4
	blss	TS766

TS765:
	clrl	d0
	movw	0x11c(a4),d0
	cmpl	d0,d5
	bcss	TS763
	cmpl	#0x7c0,d4
	blts	TS766

TS763:
	moveq	#0x1,d0

TS767:
	moveml	(sp)+,#0x30f0	| d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_rdcm
_pg_rdcm:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),d6
	movl	d6,-(sp)
	movl	d7,-(sp)
	pea	(a5)
	bsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS769
	movl	_runtcb,a4
	cmpw	#0x7c0,0x110(a4)
	bccs	TS770
	cmpl	#0x3e0000,a5
	bccs	TS770
	cmpl	#0x3e0000,d7
	bccs	TS770
	movl	a5,d0
	moveq	#0xb,d1
	asrl	d1,d0
	clrl	d1
	movw	0x110(a4),d1
	cmpl	d1,d0
	bcss	TS770
	movl	a5,d0
	addl	d7,d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	clrl	d1
	movw	0x112(a4),d1
	cmpl	d1,d0
	blss	TS769

TS770:
	moveq	#0x1,d0
	bras	TS771

TS769:
	clrl	d0

TS771:
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_lock
_pg_lock:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	movl	0x56(a5),a4
	movl	0x1e(a5),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d7
	movw	0x122(a4),d0
	cmpw	0x11c(a4),d0
	beqs	TS808
	tstb	0x11f(a4)
	beqs	TS1053

TS1047:
	clrl	-(sp)
	clrl	-(sp)
	movl	_runtcb,-(sp)
	movl	#0x80,-(sp)
	moveq	#0x7,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp

TS1045:
	clrl	d0
	bra	TS1046

TS1053:
	tstw	0x120(a4)
	beqs	TS808
	clrl	-(sp)
	pea	(a4)
	jsr	_ulockmem
	addql	#8,sp

TS808:
	movb	0x11f(a4),d0
	addqb	#1,0x11f(a4)
	tstb	d0
	bnes	TS809
	tstw	0x120(a4)
	bnes	TS809
	movl	#0x7bf,-(sp)
	clrl	d0
	movw	0x11c(a4),d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_lockmem
	addw	#0xc,sp
	movw	d0,0x120(a4)
	bnes	TS1052
	clrb	0x11f(a4)
	bras	TS1045

TS1052:
	movw	0x11c(a4),0x122(a4)

TS809:
	bset	#2,0x4a(a5)
	movw	0x126(a4),d0
	cmpw	0x116(a4),d0
	beqs	TS810
	tstb	0x11e(a4)
	bne	TS1047
	tstw	0x124(a4)
	beqs	TS810
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_ulockmem
	addql	#8,sp

TS810:
	movb	0x11e(a4),d0
	addqb	#1,0x11e(a4)
	tstb	d0
	bnes	TS811
	tstw	0x124(a4)
	bnes	TS811
	clrl	d0
	movw	0x116(a4),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x114(a4),d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_lockmem
	addw	#0xc,sp
	movw	d0,0x124(a4)
	bnes	TS1044
	clrb	0x11e(a4)
	bra	TS1045

TS1044:
	movw	0x116(a4),0x126(a4)

TS811:
	clrl	d0
	movw	0x11c(a4),d0
	cmpl	d0,d7
	bcss	TS812
	clrl	d0
	movw	0x11c(a4),d0
	movl	d7,d1
	subl	d0,d1
	clrl	d0
	movw	0x120(a4),d0
	bras	TS813

TS812:
	clrl	d0
	movw	0x114(a4),d0
	movl	d7,d1
	subl	d0,d1
	clrl	d0
	movw	0x124(a4),d0

TS813:
	addl	d1,d0
	movl	d0,d7
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	movl	0x1e(a5),d1
	andl	#0x7ff,d1
	addl	d1,d0

TS1046:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_ulock
_pg_ulock:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0x56(a5),a4
	subqb	#1,0x11e(a4)
	subqb	#1,0x11f(a4)
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_pg_load
_pg_load:
	link	a6,#0x0
	moveml	#0x73c,-(sp)	| d5 d6 d7 a2 a3 a4 a5
	movl	0x10(a6),a5
	movl	_runtcb,a4
	pea	(a5)
	movl	0x8(a6),-(sp)
	jsr	_gettad
	addql	#8,sp
	movl	d0,d5
	bges	TS1958
	movl	d5,d0
	bra	TS1968

TS1958:
	movl	d5,a3
	clrl	0x3a802a
	pea	(a4)
	bsr	_pg_retus
	addql	#4,sp
	jsr	_getvpd
	movl	d0,0x102(a4)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	0x102(a4),a0
	movb	#0x40,(a0)
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	movl	0x1c(a3),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	jsr	_getvpd
	movl	d0,0x106(a4)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	0x106(a4),a0
	movb	#0x40,(a0)
	movl	0x20(a3),d0
	cmpl	_vpdbase,d0
	beqs	TS1959
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	movl	0x20(a3),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	bras	TS1967

TS1959:
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp

TS1967:
	movw	0x2c(a3),0x110(a4)
	movw	0x2e(a3),0x112(a4)
	movw	0x30(a3),0x114(a4)
	movw	0x30(a3),d0
	extl	d0
	moveq	#0xb,d1
	asll	d1,d0
	addl	0x34(a3),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x116(a4)
	movl	0x34(a3),0x118(a4)
	movl	#0x3e0000,d0
	subl	0xc(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x11c(a4)
	movl	a3,0x10a(a4)
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	cmpw	#0x7c0,0x110(a4)
	bccs	TS1960
	clrl	d0
	movw	0x112(a4),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x110(a4),d0
	movl	d0,-(sp)
	bsr	_incracc
	addql	#8,sp

TS1960:
	movw	0x32(a3),d0
	extl	d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x114(a4),d0
	movl	d0,-(sp)
	bsr	_incracc
	addql	#8,sp
	movw	0x32(a3),d0
	extl	d0
	addql	#1,d0
	movl	d0,d7
	clrl	d0
	movw	0x116(a4),d0
	movl	d0,d6
	bras	TS1963

TS1964:
	jsr	_getvpd
	movl	d0,a2
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a2,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d7,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d7

TS1963:
	cmpl	d6,d7
	bles	TS1964
	clrl	d0
	movw	0x11c(a4),d0
	movl	d0,d7
	movl	#0x7bf,d6
	bras	TS1965

TS1966:
	jsr	_getvpd
	movl	d0,a2
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a2,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d7,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d7

TS1965:
	cmpl	d6,d7
	bles	TS1966
	movl	0x38(a3),d0
	bclr	#0,d0
	movl	0x3a801a,a0
	movl	d0,0x44(a0)
	clrl	d0

TS1968:
	moveml	(sp)+,#0x3ce0	| d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_fork
_pg_fork:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	_runtcb,a4
	movl	0x10a(a4),0x10a(a5)
	movl	0x10a(a5),a0
	addqw	#1,0xa(a0)
	jsr	_getvpd
	movl	d0,0x102(a5)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	0x102(a5),a0
	movb	#0x40,(a0)
	movl	0x102(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	jsr	_getvpd
	movl	d0,0x106(a5)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	0x106(a5),a0
	movb	#0x40,(a0)
	movl	0x106(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	movw	0x110(a4),0x110(a5)
	movw	0x112(a4),0x112(a5)
	movw	0x114(a4),0x114(a5)
	movw	0x116(a4),0x116(a5)
	movw	0x11c(a4),0x11c(a5)
	movl	0x118(a4),0x118(a5)
	movl	0x102(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	cmpw	#0x7c0,0x110(a4)
	bccs	TS2164
	clrl	d0
	movw	0x112(a4),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x110(a4),d0
	movl	d0,-(sp)
	bsrs	_incracc
	addql	#8,sp

TS2164:
	clrl	d0
	movw	0x116(a4),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x114(a4),d0
	movl	d0,-(sp)
	bsrs	_incracc
	addql	#8,sp
	movl	#0x7bf,-(sp)
	clrl	d0
	movw	0x11c(a4),d0
	movl	d0,-(sp)
	bsrs	_incracc
	addql	#8,sp
	moveq	#0x1,d0
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_incracc
_incracc:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	bras	TS1961

TS1962:
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a5
	addql	#1,d7
	addqb	#1,0x1(a5)
	pea	(a5)
	jsr	_demap
	addql	#4,sp

TS1961:
	cmpl	d6,d7
	bles	TS1962
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_pg_memres
_pg_memres:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	bne	TS1414
	btst	#1,0x23(a5)
	beqs	TS1422
	cmpw	#0x7c0,0x110(a5)
	bccs	TS1422
	movl	0x10a(a5),a0
	subqw	#1,0x3c(a0)
	bnes	TS1422
	clrl	-(sp)
	clrl	d0
	movw	0x112(a5),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x110(a5),d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp

TS1422:
	btst	#2,0x23(a5)
	beqs	TS1423
	clrl	-(sp)
	clrl	d0
	movw	0x116(a5),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x114(a5),d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp
	clrl	-(sp)
	movl	#0x7bf,-(sp)
	clrl	d0
	movw	0x11c(a5),d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp

TS1423:
	andw	#0xfff9,0x22(a5)
	bra	TS1416

TS1414:
	btst	#1,d7
	beqs	TS1415
	btst	#1,0x23(a5)
	bnes	TS1415
	cmpw	#0x7c0,0x110(a5)
	bccs	TS1421
	movl	0x10a(a5),a0
	addqw	#1,0x3c(a0)
	movw	0x3c(a0),d0
	subqw	#1,d0
	bnes	TS1421
	moveq	#0x1,d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x112(a5),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x110(a5),d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp

TS1421:
	bset	#1,0x23(a5)

TS1415:
	btst	#2,d7
	beqs	TS1416
	btst	#2,0x23(a5)
	bnes	TS1416
	moveq	#0x1,d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x116(a5),d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x114(a5),d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#0x7bf,-(sp)
	clrl	d0
	movw	0x11c(a5),d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_memres
	addw	#0x10,sp
	bset	#2,0x23(a5)

TS1416:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_pg_core
_pg_core:
	link	a6,#0xfff8
	moveml	#0xf04,-(sp)	| d4 d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	_runtcb,a5
	cmpw	#0x7c0,0x110(a5)
	bccs	TS2165
	clrl	d0
	movw	0x112(a5),d0
	clrl	d1
	movw	0x110(a5),d1
	subl	d1,d0
	addql	#1,d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,0x3a800a
	bras	TS2176

TS2165:
	clrl	0x3a800a

TS2176:
	clrl	d0
	movw	0x116(a5),d0
	clrl	d1
	movw	0x114(a5),d1
	subl	d1,d0
	addql	#1,d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,0x3a800e
	clrl	d0
	movw	0x11c(a5),d0
	movl	#0x7c0,d1
	subl	d0,d1
	moveq	#0xb,d0
	lsll	d0,d1
	movl	d1,0x3a8012
	movl	#0x3e0000,0x3a8016
	movw	d7,0x3a8008
	movl	#0x800,d5
	movw	d5,0x3a8006
	movl	#0x3a8000,0xfff8(a6)
	movl	#0x3a8000,d0
	subl	0xfff8(a6),d0
	movl	d0,d4
	movw	d4,0x3a8004
	movb	#0x63,0xfffc(a6)
	movb	#0x6f,0xfffd(a6)
	movb	#0x72,0xfffe(a6)
	movb	#0x65,0xffff(a6)
	movw	0x3a801e,d0
	cmpw	0x3a8022,d0
	bne	TS2166
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	#0x1b6,-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	0xfffc(a6)
	moveq	#0x17,d0
	movl	d0,-(sp)
	movl	#0x403,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movw	d0,d6
	blt	TS2166
	clrl	-(sp)
	clrl	-(sp)
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_seek
	addw	#0xc,sp
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d5,d0
	subl	d4,d0
	movl	d0,-(sp)
	movl	0xfff8(a6),d0
	addl	d4,d0
	movl	d0,-(sp)
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	movl	#0x405,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	tstl	d0
	ble	TS2167
	tstl	d4
	beqs	TS2168
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d4,-(sp)
	movl	0xfff8(a6),-(sp)
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	movl	#0x405,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	tstl	d0
	bles	TS2167

TS2168:
	clrl	d0
	movw	0x116(a5),d0
	clrl	d1
	movw	0x114(a5),d1
	subl	d1,d0
	addql	#1,d0
	movl	d0,-(sp)
	clrl	d0
	movw	d1,d0
	movl	d0,-(sp)
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	bsrs	_wrcore
	addw	#0xc,sp
	tstl	d0
	beqs	TS2167
	clrl	d0
	movw	0x11c(a5),d0
	movl	#0x7c0,d1
	subl	d0,d1
	movl	d1,-(sp)
	clrl	d0
	movw	0x11c(a5),d0
	movl	d0,-(sp)
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	bsrs	_wrcore
	addw	#0xc,sp
	tstl	d0
	beqs	TS2167
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_close
	addql	#4,sp
	moveq	#0x1,d0
	bras	TS2175

TS2167:
	movw	d6,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_close
	addql	#4,sp

TS2166:
	clrl	d0

TS2175:
	moveml	(sp)+,#0x20f0	| d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_wrcore
_wrcore:
	link	a6,#0x0
	moveml	#0x2f00,-(sp)	| d2 d4 d5 d6 d7
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	0x10(a6),d5
	bras	TS2169

TS2170:
	cmpl	#0x20,d5
	blts	TS2171
	moveq	#0x20,d0
	bras	TS2174

TS2171:
	movl	d5,d0

TS2174:
	movl	d0,d4
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d4,d0
	moveq	#0xb,d1
	asll	d1,d0
	movl	d0,-(sp)
	movl	d6,d0
	moveq	#0xb,d1
	asll	d1,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	moveq	#0x5,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d4,d1
	moveq	#0xb,d2
	asll	d2,d1
	cmpl	d1,d0
	beqs	TS2172
	clrl	d0
	bras	TS2173

TS2172:
	subl	d4,d5
	addl	d4,d6

TS2169:
	tstl	d5
	bnes	TS2170
	moveq	#0x1,d0

TS2173:
	moveml	(sp)+,#0xf4	| d2 d4 d5 d6 d7
	unlk	a6
	rts

	.globl	_pg_rdtrc
_pg_rdtrc:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	clrl	-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	(a5)
	bsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2177

TS2178:
	clrl	d0
	bras	TS2179

TS2177:
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	(a4)
	pea	(a5)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	bnes	TS2178
	moveq	#0x1,d0

TS2179:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_pg_wrtrc
_pg_wrtrc:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	_runtcb,a3
	clrl	-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	(a5)
	bsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2180
	clrl	d0
	bra	TS2183

TS2180:
	movl	a5,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d7
	lea	0x3(a5),a0
	movl	a0,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d6
	bras	TS2181

TS2182:
	movl	0x102(a3),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x106(a3),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	clrl	-(sp)
	pea	(a3)
	pea	(a4)
	movl	d7,-(sp)
	addql	#1,d7
	jsr	_inpage
	addw	#0x10,sp
	movl	d0,a4
	bclr	#0,(a4)
	bset	#3,(a4)

TS2181:
	cmpl	d6,d7
	bles	TS2182
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	(a5)
	pea	0xc(a6)
	jsr	_copy_out
	addw	#0xc,sp
	moveq	#0x1,d0

TS2183:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_ulimit
_ulimit:
	link	a6,#0x0
	moveml	#0x2104,-(sp)	| d2 d7 a5
	clrl	d7
	movl	_runtcb,a5
	movl	0x8(a6),d0
	subl	#0x1,d0
	cmpl	#0x4,d0
	bhis	TS2184
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)
	.word	0x0056
	.word	0x0062
	.word	0x00a2
	.word	0x0010
	.word	0x0030

TS2184:
	movl	d7,d0
	bra	TS2185
	cmpw	#0x7c0,0x110(a5)
	bccs	TS2184
	clrl	d0
	movw	0x112(a5),d0
	clrl	d1
	movw	0x110(a5),d1
	subl	d1,d0
	addql	#1,d0
	moveq	#0xb,d1
	lsrl	d1,d0

TS4347:
	movl	d0,d7
	bras	TS2184
	clrl	d0
	movw	0x11c(a5),d0
	movl	#0x7c0,d1
	subl	d0,d1
	clrl	d0
	movw	0x116(a5),d0
	clrl	d2
	movw	0x114(a5),d2
	subl	d2,d0
	addl	d0,d1
	moveq	#0xb,d0
	lsrl	d0,d1
	movl	d1,d7
	bras	TS2184
	movl	0x3a8132,d0
	moveq	#0x9,d1
	asrl	d1,d0
	bras	TS4347
	jsr	_suser
	tstl	d0
	bnes	TS4348
	movl	0x3a8132,d0
	moveq	#0x9,d1
	asrl	d1,d0
	movl	0xc(a6),d1
	cmpl	d0,d1
	bgts	TS4349

TS4348:
	movl	0x3a8132,d0
	moveq	#0x9,d1
	asrl	d1,d0
	movl	d0,d7
	movl	0xc(a6),d0
	moveq	#0x9,d1
	asll	d1,d0
	movl	d0,0x3a8132
	bra	TS2184

TS4349:
	moveq	#0xffffffff,d7
	bra	TS2184
	clrl	d0
	movw	0x11c(a5),d0
	subl	#0x40,d0
	moveq	#0xb,d1
	lsll	d1,d0
	subql	#1,d0
	bra	TS4347

TS2185:
	moveml	(sp)+,#0x2084	| d2 d7 a5
	unlk	a6
	rts

	.globl	_rettad
_rettad:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	a5,d0
	bnes	TS1909
	movl	#_tadq,-(sp)
	jsr	_firstq

TS1920:
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	bnes	TS1916

TS1917:
	movl	a5,d0
	beq	TS1918

TS1909:
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	clrw	0xa(a5)
	clrw	0xe(a5)
	movl	0x10(a5),-(sp)
	jsr	_pg_close
	addql	#4,sp
	cmpw	#0x7c0,0x2c(a5)
	bges	TS1910
	movw	0x2c(a5),d0
	extl	d0
	movl	d0,d7
	movw	0x2e(a5),d0
	extl	d0
	movl	d0,d6
	bras	TS1914

TS1916:
	tstw	0xa(a4)
	beqs	TS1917
	cmpw	#0x1,0xa(a4)
	bnes	TS1919
	movl	a4,a5

TS1919:
	pea	(a4)
	jsr	_nextq
	bras	TS1920

TS1915:
	movl	0x1c(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x20(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addql	#1,d7
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp

TS1914:
	cmpl	d6,d7
	bles	TS1915

TS1910:
	movw	0x30(a5),d0
	extl	d0
	movl	d0,d7
	movw	0x32(a5),d0
	extl	d0
	movl	d0,d6
	bras	TS1911

TS1912:
	movl	0x1c(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x20(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addql	#1,d7
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp

TS1911:
	cmpl	d6,d7
	bles	TS1912
	movl	0x1c(a5),-(sp)
	jsr	_putvpd
	addql	#4,sp
	movl	0x20(a5),d0
	cmpl	_vpdbase,d0
	beqs	TS1913
	movl	d0,-(sp)
	jsr	_putvpd
	addql	#4,sp

TS1913:
	pea	(a5)
	movl	#_tadq,-(sp)
	jsr	_addlq
	addql	#8,sp

TS1918:
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_gettad
_gettad:
	link	a6,#0xffac
	moveml	#0x233c,-(sp)	| d2 d6 d7 a2 a3 a4 a5
	movl	0xc(a6),a5
	clrl	0xfff0(a6)
	movl	#_tadq,-(sp)
	jsr	_firstq

TS1956:
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	beqs	TS1905
	tstw	0xa(a4)
	beqs	TS1905
	tstl	0x10(a4)
	beqs	TS1954
	movw	0xe(a4),d0
	cmpw	0x2(a5),d0
	bnes	TS1954
	movw	0xc(a4),d0
	cmpw	(a5),d0
	bnes	TS1954
	movl	0x14(a4),d0
	cmpl	0x1a(a5),d0
	bnes	TS1957
	movl	0x18(a4),d0
	cmpl	0x16(a5),d0
	beqs	TS1905

TS1957:
	pea	(a4)
	bsr	_rettad
	addql	#4,sp

TS1905:
	movl	a4,d0
	bnes	TS1906
	clrl	-(sp)
	clrl	-(sp)
	movl	_runtcb,-(sp)
	movl	#0x80,-(sp)
	moveq	#0xd,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp

TS1923:
	moveq	#0xfffffff8,d0
	bra	TS1924

TS1954:
	cmpw	#0x1,0xa(a4)
	bnes	TS1955
	addql	#1,0xfff0(a6)

TS1955:
	pea	(a4)
	jsr	_nextq
	bras	TS1956

TS1906:
	tstw	0xa(a4)
	beqs	TS1907
	cmpw	#0x1,0xa(a4)
	bnes	TS1952
	movl	0x10(a4),-(sp)
	jsr	_fh_txtbusy
	addql	#4,sp
	tstl	d0
	beqs	TS1952

TS1946:
	moveq	#0xffffffe6,d0
	bra	TS1924

TS1952:
	addqw	#1,0xa(a4)
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	movl	#_tadq,-(sp)
	jsr	_addfq
	addql	#8,sp
	movl	0x8(a6),-(sp)
	jsr	_pg_close
	addql	#4,sp
	bra	TS1953

TS1907:
	pea	(a4)
	jsr	_qout

TS1921:
	addql	#4,sp
	movl	0xfff0(a6),d0
	subql	#1,0xfff0(a6)
	cmpl	#0xa,d0
	bhi	TS1908
	moveq	#0x20,d0
	movl	d0,-(sp)
	movl	_runtcb,a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	moveq	#0xb,d1
	lsll	d1,d0
	lea	0xffc8(a6),a0
	movl	a0,d1
	andl	#0x7ff,d1
	addl	d1,d0
	movl	d0,-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_read
	addw	#0x10,sp
	cmpl	#0x20,d0
	bne	TS1922
	clrl	d0
	movw	0xffca(a6),d0
	addl	#0x20,d0
	movl	d0,0xffb0(a6)
	cmpw	#0x206,0xffc8(a6)
	bne	TS1922
	movw	0xffe6(a6),d0
	andw	#0x61,d0
	cmpw	#0x61,d0
	bne	TS1922
	cmpb	#0x85,0xffe4(a6)
	bne	TS1922
	clrl	0xffb4(a6)
	clrl	0xffb8(a6)
	clrl	0xffbc(a6)
	clrl	0xffc0(a6)
	clrl	0xffc4(a6)
	tstw	0xffca(a6)
	beqs	TS1925
	cmpw	#0x14,0xffca(a6)
	blss	TS1948
	moveq	#0x14,d0
	bras	TS1951

TS1908:
	clrl	-(sp)
	bsr	_rettad
	bra	TS1921

TS1948:
	clrl	d0
	movw	0xffca(a6),d0

TS1951:
	movl	d0,-(sp)
	movl	_runtcb,a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	moveq	#0xb,d1
	lsll	d1,d0
	lea	0xffb4(a6),a0
	movl	a0,d1
	andl	#0x7ff,d1
	addl	d1,d0
	movl	d0,-(sp)
	moveq	#0x20,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_read
	addw	#0x10,sp
	cmpw	#0x14,0xffca(a6)
	blss	TS1949
	moveq	#0x14,d1
	bras	TS1950

TS1949:
	clrl	d1
	movw	0xffca(a6),d1

TS1950:
	cmpl	d1,d0
	bnes	TS1922

TS1925:
	clrl	d0
	movw	0xffe6(a6),d0
	andl	#0x16,d0
	beqs	TS1926
	cmpl	#0x4,d0
	beqs	TS1947
	cmpl	#0x6,d0
	beqs	TS1947

TS1922:
	pea	(a4)
	movl	#_tadq,-(sp)
	jsr	_addlq
	addql	#8,sp
	bra	TS1923

TS1926:
	movl	0xffd0(a6),d0
	addl	0xffcc(a6),d0
	movl	d0,0xffe8(a6)
	tstl	0xffd0(a6)
	bnes	TS1927
	addql	#2,0xffe8(a6)

TS1927:
	movl	0xffe8(a6),0xffd0(a6)
	clrl	0xffcc(a6)

TS1947:
	clrl	0xfff8(a6)
	subl	a2,a2
	movl	0xffbc(a6),0xffec(a6)
	tstl	0xffcc(a6)
	beqs	TS1928
	movl	0xffcc(a6),d0
	addql	#2,d0
	movl	d0,0xfff8(a6)
	movl	0xffbc(a6),a2
	movl	0xffc0(a6),0xffec(a6)

TS1928:
	movl	0xffd0(a6),d0
	addl	0xffd4(a6),d0
	movl	d0,0xfff4(a6)
	movl	0xffbc(a6),d0
	andl	#0x7fff,d0
	bnes	TS1922
	tstl	0xfff8(a6)
	beqs	TS1929
	movl	0xffec(a6),d0
	andl	#0x7fff,d0
	bne	TS1922
	movl	0xfff8(a6),d0
	addl	#0x7ff,d0
	moveq	#0xb,d1
	lsrl	d1,d0
	movl	a2,d1
	moveq	#0xb,d2
	lsrl	d2,d1
	addl	d1,d0
	movl	0xffec(a6),d1
	moveq	#0xb,d2
	lsrl	d2,d1
	cmpl	d0,d1
	bcs	TS1922

TS1929:
	movl	0x8(a6),-(sp)
	jsr	_fh_txtbusy
	addql	#4,sp
	tstl	d0
	beqs	TS1933
	pea	(a4)
	movl	#_tadq,-(sp)
	jsr	_addlq
	addql	#8,sp
	bra	TS1946

TS1933:
	movl	0xffe0(a6),0x38(a4)
	tstl	0xfff8(a6)
	beqs	TS1934
	movl	a2,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x2c(a4)
	movl	a2,d0
	addl	0xfff8(a6),d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x2e(a4)
	movl	a2,d0
	addl	0xffcc(a6),d0
	movl	d0,0x28(a4)
	bras	TS1945

TS1934:
	movw	#0x7c0,0x2c(a4)
	movw	#0x7c0,0x2e(a4)
	clrl	0x28(a4)

TS1945:
	movl	0xfff4(a6),0x34(a4)
	movl	0xffec(a6),d0
	addl	0xffd0(a6),d0
	movl	d0,0x24(a4)
	movl	0xffec(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x30(a4)
	movl	0x24(a4),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	d0,0x32(a4)
	cmpw	#0x7c0,0x2c(a4)
	bges	TS1935
	movw	0x2e(a4),d0
	cmpw	0x30(a4),d0
	bges	TS1944

TS1935:
	movl	0xfff4(a6),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movw	0x30(a4),d1
	extl	d1
	addl	d0,d1
	cmpl	#0x780,d1
	blts	TS1936

TS1944:
	pea	(a4)
	movl	#_tadq,-(sp)
	jsr	_addlq
	addql	#8,sp
	moveq	#0xfffffff4,d0
	bra	TS1924

TS1936:
	movw	#0x2,0xa(a4)
	movw	(a5),0xc(a4)
	movw	0x2(a5),0xe(a4)
	movl	0x8(a6),0x10(a4)
	movl	0x1a(a5),0x14(a4)
	movl	0x16(a5),0x18(a4)
	jsr	_getvpd
	movl	d0,0x1c(a4)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movl	0x1c(a4),a0
	movb	#0x40,(a0)
	cmpw	#0x400,0x32(a4)
	blts	TS1937
	jsr	_getvpd
	movl	d0,0x20(a4)
	movl	d0,-(sp)
	jsr	_getpage
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_copy_zp
	addql	#4,sp
	movl	0x20(a4),a0
	movb	#0x40,(a0)
	bras	TS1943

TS1937:
	movl	_vpdbase,0x20(a4)

TS1943:
	cmpw	#0x7c0,0x2c(a4)
	bges	TS1938
	movw	0x2c(a4),d0
	extl	d0
	movl	d0,d7
	movw	0x2e(a4),d0
	extl	d0
	movl	d0,d6
	movl	0xffb0(a6),a2
	bras	TS1941

TS1942:
	jsr	_getvpd
	movl	d0,a3
	movl	a2,d0
	movl	d0,0x4(a3)
	movb	#0x1,(a3)
	movl	0x1c(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x20(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a3,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d7,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d7
	addw	#0x800,a2

TS1941:
	cmpl	d6,d7
	bles	TS1942

TS1938:
	movw	0x30(a4),d0
	extl	d0
	movl	d0,d7
	movw	0x32(a4),d0
	extl	d0
	movl	d0,d6
	movl	0xffb0(a6),d0
	addl	0xffcc(a6),d0
	movl	d0,a2
	bras	TS1939

TS1940:
	jsr	_getvpd
	movl	d0,a3
	clrb	(a3)
	movl	a2,d0
	movl	d0,0x4(a3)
	movl	0x1c(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x20(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	a3,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movl	d7,d1
	addl	d1,d1
	addl	#0x3a9800,d1
	movl	d1,a0
	movw	d0,(a0)
	addql	#1,d7
	addw	#0x800,a2

TS1939:
	cmpl	d6,d7
	bles	TS1940
	pea	(a4)
	movl	#_tadq,-(sp)
	jsr	_addfq
	addql	#8,sp

TS1953:
	movl	a4,d0

TS1924:
	moveml	(sp)+,#0x3cc4	| d2 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_pg_umount
_pg_umount:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movw	0xa(a6),d7
	movl	#_tadq,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	bras	TS2186

TS2187:
	movl	a5,a4
	pea	(a5)
	jsr	_nextq
	addql	#4,sp
	movl	d0,a5
	tstw	0xa(a4)
	beqs	TS2188
	movw	0xc(a4),d0
	cmpw	d7,d0
	bnes	TS2186
	cmpw	#0x1,0xa(a4)
	bles	TS2189
	moveq	#0xfffffff0,d0
	bras	TS2190

TS2189:
	pea	(a4)
	bsr	_rettad
	addql	#4,sp

TS2186:
	movl	a5,d0
	bnes	TS2187

TS2188:
	clrl	d0

TS2190:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_pg_ubusy
_pg_ubusy:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	#_tadq,-(sp)
	jsr	_firstq
	bras	TS2191

TS2195:
	moveq	#0xffffffe6,d0
	bra	TS2196

TS2192:
	cmpw	#0x1,0xa(a5)
	bles	TS2193
	tstl	0x10(a5)
	beqs	TS2193
	movl	0x10(a5),a0
	movl	0x1c(a0),d0
	cmpl	d7,d0
	beqs	TS2194

TS2193:
	pea	(a5)
	jsr	_nextq

TS2191:
	addql	#4,sp
	movl	d0,a5
	movl	a5,d0
	bnes	TS2192

TS2194:
	movl	a5,d0
	beqs	TS2195
	cmpw	#0x7c0,0x2c(a5)
	bges	TS2197
	movw	0x2c(a5),d0
	extl	d0
	movl	d0,d6
	movw	0x2e(a5),d0
	extl	d0
	movl	d0,d5
	bras	TS2205

TS2206:
	movl	d6,-(sp)
	addql	#1,d6
	pea	(a5)
	bsrs	_pg_sticky
	addql	#8,sp

TS2205:
	cmpl	d5,d6
	bles	TS2206

TS2197:
	movw	0x30(a5),d0
	extl	d0
	movl	d0,d6
	movw	0x32(a5),d0
	extl	d0
	movl	d0,d5
	bras	TS2198

TS2199:
	movl	d6,-(sp)
	addql	#1,d6
	pea	(a5)
	bsrs	_pg_sticky
	addql	#8,sp

TS2198:
	cmpl	d5,d6
	bles	TS2199
	movl	0x10(a5),-(sp)
	jsr	_fh_utxtbusy
	addql	#4,sp
	movl	0x10(a5),-(sp)
	jsr	_pg_close
	addql	#4,sp
	clrl	0x10(a5)
	clrl	d0

TS2196:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_pg_sticky
_pg_sticky:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x1c(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xba9880
	movl	0x20(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	bset	#14,d0
	movw	d0,0xbaa080
	movl	d7,d0
	addl	d0,d0
	addl	#0x3a9800,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a4
	bras	TS2200

TS2201:
	bset	#2,(a4)
	movl	a4,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,-(sp)
	jsr	_waitvpd
	addql	#4,sp

TS2200:
	btst	#1,(a4)
	bnes	TS2201
	movb	(a4),d0
	andb	#0x88,d0
	bnes	TS2202
	tstw	0x2(a4)
	bnes	TS2203
	bset	#1,(a4)
	pea	(a4)
	jsr	_getpage
	addql	#4,sp
	pea	(a4)
	movl	d7,-(sp)
	pea	(a5)
	jsr	_pg_swapin
	addw	#0xc,sp
	btst	#2,(a4)
	beqs	TS2204
	movl	a4,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,-(sp)
	jsr	_unwaitvpd
	addql	#4,sp

TS2204:
	andb	#0xfff9,(a4)

TS2203:
	bset	#3,(a4)

TS2202:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_getvpd
_getvpd:
	link	a6,#0x0
	movl	a5,-(sp)
	tstw	_fvpage
	bnes	TS828
	clrl	-(sp)
	clrl	-(sp)
	movl	_runtcb,-(sp)
	moveq	#0x40,d0
	movl	d0,-(sp)
	moveq	#0x16,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp

TS829:
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#_wvpd,-(sp)
	jsr	_sleep
	addql	#8,sp
	tstw	_fvpage
	beqs	TS829

TS828:
	clrl	d0
	movw	_fvpage,d0
	lsll	#3,d0
	addl	_vpdbase,d0
	movl	d0,a5
	movw	0x2(a5),_fvpage
	clrw	0x2(a5)
	movb	#0x10,(a5)
	movb	#0x1,0x1(a5)
	clrl	0x4(a5)
	movl	a5,d0
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_putvpd
_putvpd:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	cmpb	#0x1,0x1(a5)
	bles	TS1190
	subqb	#1,0x1(a5)
	bra	TS1194

TS1190:
	btst	#1,(a5)
	beqs	TS1191
	bset	#2,(a5)
	movl	a5,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	andl	#0xffff,d0
	movl	d0,-(sp)
	bsr	_waitvpd
	addql	#4,sp
	bras	TS1190

TS1191:
	tstw	0x2(a5)
	beqs	TS1192
	pea	(a5)
	jsr	_demap
	addql	#4,sp
	clrl	d0
	movw	0x2(a5),d0
	lsll	#3,d0
	addl	_ppdbase,d0
	movl	d0,a4
	clrw	0x2(a4)
	clrb	0x6(a4)
	clrw	0x4(a4)
	clrb	0x7(a4)
	pea	(a4)
	jsr	_putppd
	addql	#4,sp

TS1192:
	btst	#7,(a5)
	beqs	TS1193
	movl	0x4(a5),d7
	movl	#0x800,-(sp)
	movl	d7,-(sp)
	jsr	_fh_segchk
	addql	#8,sp
	tstl	d0
	bnes	TS1195
	movl	#0x800,-(sp)
	movl	d7,-(sp)
	jsr	_fh_dealloc
	addql	#8,sp
	bras	TS1193

TS1195:
	clrl	-(sp)
	clrl	-(sp)
	movl	#0x800,-(sp)
	movl	d7,-(sp)
	clrl	-(sp)
	jsr	_swaperror
	addw	#0x14,sp

TS1193:
	clrl	0x4(a5)
	clrb	0x1(a5)
	clrb	(a5)
	movw	_fvpage,0x2(a5)
	movl	a5,d0
	subl	_vpdbase,d0
	asrl	#3,d0
	movw	d0,_fvpage
	movl	_wvpd,a0
	cmpw	#0x1,0x8(a0)
	beqs	TS1194
	movl	#_wvpd,-(sp)
	jsr	_wakeup
	addql	#4,sp

TS1194:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_waitvpd
_waitvpd:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	0xa(a6),d7
	movl	_runtcb,a0
	movw	d7,0x10e(a0)
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#_wpio,-(sp)
	jsr	_sleep
	addql	#8,sp
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_unwaitvpd
_unwaitvpd:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movw	0xa(a6),d7
	jsr	_spl6
	movl	#_wpio,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	bras	TS826

TS827:
	pea	(a5)
	jsr	_nextq
	addql	#4,sp
	movl	d0,a5
	movw	0x10e(a4),d0
	cmpw	d7,d0
	bnes	TS826
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	jsr	_addrdq
	addql	#4,sp

TS826:
	movl	a5,a4
	movl	a4,d0
	bnes	TS827
	jsr	_spl0
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_nosysc
_nosysc:
	link	a6,#0x0
	moveq	#0xffffffea,d0
	unlk	a6
	rts

	.globl	_notcfc
_notcfc:
	link	a6,#0x0
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp
	unlk	a6
	rts

	.globl	_nosys
_nosys:
	link	a6,#0x0
	moveq	#0xffffffea,d0
	unlk	a6
	rts

	.globl	_cxenix40
_cxenix40:
	link	a6,#0x0
	movl	0x3a811e,d0
	asrl	#8,d0
	cmpl	#0xc,d0
	bhi	TS2207
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)
	.word	0x0078
	.word	0x001c
	.word	0x0078
	.word	0x0078
	.word	0x0078
	.word	0x0078
	.word	0x0078
	.word	0x0040
	.word	0x0078
	.word	0x0078
	.word	0x004e
	.word	0x0060
	.word	0x006c

	bras	TS4350
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0x0c(a6),d0
	addl	#0x10,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_uxlock
	addw	#0x10,sp
	bras	TS4350
	movl	0x8(a6),-(sp)
	jsr	_uxrdchk

TS4351:
	addql	#4,sp
	bras	TS4350
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_uxchsiz
	addql	#8,sp
	bras	TS4350
	movl	0x8(a6),-(sp)
	jsr	_uxftime
	bras	TS4351
	movl	0x8(a6),-(sp)
	jsr	_nap
	bras	TS4351

TS2207:
	moveq	#0xffffffea,d0

TS4350:
	unlk	a6
	rts

	.globl	_cxenix57
_cxenix57:
	link	a6,#0x0
	movl	0x3a811e,d0
	asrl	#8,d0
	cmpl	#0x14,d0
	bhi	TS2208
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)
	.word	0x002e
	.word	0x003e
	.word	0x0048
	.word	0x0150
	.word	0x0150
	.word	0x0150
	.word	0x0150
	.word	0x0150
	.word	0x0150
	.word	0x0150
	.word	0x005C
	.word	0x007A
	.word	0x0094
	.word	0x00A8
	.word	0x00BC
	.word	0x00D0
	.word	0x00E4
	.word	0x00F2
	.word	0x0106
	.word	0x0118
	.word	0x0132

	bra	TS2208
	movl	0x8(a6),-(sp)
	jsr	_uxuname

TS4353:
	addql	#4,sp
	bra	TS2208
	jsr	_uxgetprgp
	bra	TS2208
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_uxustat

TS4354:
	addql	#8,sp
	bra	TS2208
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_semctl

TS4355:
	addw	#0x10,sp
	bra	TS2208
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_semget

TS4352:
	addw	#0xc,sp
	bra	TS2208
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_semop
	bras	TS4352
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_shmctl
	bras	TS4352
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_shmget
	bras	TS4352
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_shmat
	bras	TS4352
	movl	0x8(a6),-(sp)
	jsr	_shmdt
	bra	TS4353
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_msgctl
	bras	TS4352
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_msgget
	bra	TS4354
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_msgsnd
	bra	TS4355
	movl	0x18(a6),-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_msgrcv
	addw	#0x14,sp

TS2208:
	unlk	a6
	rts

	.globl	_cancel
_cancel:
	link	a6,#0xfffc
	movl	a5,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2209
	cmpw	#0x5,0x8(a5)
	bnes	TS2209
	movl	0x56(a5),d0
	cmpl	_runtcb,d0
	beqs	TS2211

TS2209:
	movl	#0xffffffea,0xfffc(a6)
	bras	TS2210

TS2211:
	clrl	0xfffc(a6)
	pea	(a5)
	bsrs	_cancel2
	addql	#4,sp

TS2210:
	movl	0xfffc(a6),d0
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_cancel2
_cancel2:
	link	a6,#0x0
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0x8(a6),a5
	movb	0x46(a5),d0
	extw	d0
	movw	d0,d7
	movl	0x5a(a5),a3
	cmpw	#0x3,d7
	beq	TS630
	cmpw	#0x2,d7
	beq	TS630
	btst	#2,0x4b(a5)
	beqs	TS631
	pea	(a5)
	jsr	_pipecancel
	bras	TS731

TS638:
	pea	(a5)
	jsr	_iocanrq

TS731:
	addql	#4,sp
	bra	TS630

TS631:
	cmpw	#0x1,d7
	bnes	TS632
	btst	#5,0x4b(a5)
	bnes	TS638
	movl	a3,d0
	beq	TS630
	btst	#3,0x4b(a5)
	bne	TS630
	orw	#0x48,0x4a(a5)
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	pea	(a5)
	pea	(a3)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bne	TS630
	bclr	#6,0x4b(a5)
	pea	(a5)
	movb	0x49(a5),d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),d0
	addl	#0x44,d0
	movl	d0,-(sp)
	jsr	_addlq
	bras	TS721

TS632:
	tstw	d7
	beqs	TS633
	cmpw	#0x6,d7
	bnes	TS636

TS633:
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	tstw	d7
	bnes	TS634
	subqw	#1,0x3c(a3)
	bras	TS635

TS634:
	subqw	#1,0x3e(a3)
	bras	TS635

TS636:
	cmpw	#0x4,d7
	bnes	TS635
	pea	0x4c(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	beqs	TS637
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	pea	(a5)
	jsr	_addbq
	addql	#8,sp

TS637:
	pea	(a5)
	jsr	_qout
	addql	#4,sp

TS635:
	moveq	#0xfffffffc,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_termreq

TS721:
	addql	#8,sp

TS630:
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_cancex
_cancex:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	cmpb	#0x1,0x46(a5)
	beqs	TS1378
	btst	#0,0x4a(a5)
	beqs	TS1381

TS1378:
	btst	#0,0x4b(a5)
	beqs	TS1379
	pea	(a5)
	bsr	_cancel2
	addql	#4,sp
	bclr	#0,0x4b(a5)
	movl	0x1a(a5),a4
	subqw	#1,0x1c(a4)
	pea	(a4)
	jsr	_closetq
	addql	#4,sp

TS1379:
	bclr	#0,0x4a(a5)
	pea	(a5)
	jsr	_waitrq
	bras	TS1380

TS1381:
	pea	(a5)
	bsr	_cancel2

TS1380:
	addql	#4,sp
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_clock
_clock:
	link	a6,#0x0
	moveml	#0x203c,-(sp)	| d2 a2 a3 a4 a5
	jsr	_clkstart
	jsr	_spl5
	addql	#1,_clockticks
	tstw	_napdec
	beq	TS2064
	addqw	#1,_napinc
	subqw	#1,_napdec
	bne	TS2064
	movl	#_napq,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2089
	movl	_Hz,d0
	asll	#4,d0
	movw	d0,_napdec

TS2092:
	movl	a5,a4
	pea	(a4)
	jsr	_nextq
	addql	#4,sp
	movl	d0,a5
	movw	_napinc,d0
	extl	d0
	subl	d0,0x40(a4)
	bgts	TS2090
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	clrl	-(sp)
	pea	(a4)
	jsr	_waikpr
	addql	#8,sp
	bras	TS2094

TS2090:
	movw	_napdec,d0
	extl	d0
	cmpl	0x40(a4),d0
	bges	TS2091
	movw	_napdec,d0
	extl	d0
	bras	TS2093

TS2091:
	movl	0x40(a4),d0

TS2093:
	movw	d0,_napdec

TS2094:
	movl	a5,d0
	bnes	TS2092

TS2089:
	clrw	_napinc

TS2064:
	tstl	BS2065
	beqs	TS2066
	movl	#_callout,a2
	bras	TS2081

TS2082:
	tstl	0x6(a2)
	beqs	TS2083
	addw	#0xa,a2

TS2081:
	tstw	(a2)
	bles	TS2082

TS2083:
	subqw	#1,(a2)
	movl	0xc(a6),d0
	andl	#0x700,d0
	bnes	TS2066
	tstw	_callout
	bgts	TS2066
	movl	#_callout,a3
	bras	TS2084

TS2085:
	tstw	(a3)
	bgts	TS2086
	movl	0x2(a3),-(sp)
	movl	0x6(a3),a0
	jsr	(a0)
	addql	#4,sp
	addw	#0xa,a3

TS2084:
	tstl	0x6(a3)
	bnes	TS2085

TS2086:
	movl	#_callout,a2
	bras	TS2087

TS2088:
	movw	(a3),(a2)
	movl	0x2(a3),0x2(a2)
	addw	#0xa,a3
	addw	#0xa,a2

TS2087:
	movl	0x6(a3),0x6(a2)
	bnes	TS2088

TS2066:
	tstl	_swapidle
	beqs	TS2067
	movl	_OS_PAGE,d0
	cmpl	_OS_TRIG,d0
	bgts	TS2068
	clrl	_swapidle
	movl	#0x1,_OS_SCAN

TS2067:
	subql	#1,_OS_SCAN
	bnes	TS2068
	movl	_proc,a5
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	pea	(a5)
	jsr	_addrdq
	addql	#4,sp

TS2068:
	movl	0xc(a6),d0
	andl	#0x2000,d0
	cmpl	#0x2000,d0
	beq	TS2069
	addql	#1,0x3a8076
	tstb	0x3a8123
	beqs	TS2080
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	#0x3a810e,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_addupc
	addw	#0xc,sp

TS2080:
	tstl	_accounting
	beqs	TS2070
	movl	_runtcb,a5
	tstl	0x10a(a5)
	beqs	TS2070
	clrl	d0
	movw	0x116(a5),d0
	clrl	d1
	movw	0x114(a5),d1
	subl	d1,d0
	clrl	d1
	movw	0x11c(a5),d1
	movl	#0x7c0,d2
	subl	d1,d2
	addl	d2,d0
	addl	d0,0x3a813e
	cmpw	#0x7c0,0x110(a5)
	bccs	TS2070
	movl	0x10a(a5),a0
	movw	0xa(a0),d0
	extl	d0
	movl	d0,-(sp)
	clrl	d0
	movw	0x112(a5),d0
	clrl	d1
	movw	0x110(a5),d1
	subl	d1,d0
	movl	d0,-(sp)
	jsr	uldiv
	addql	#8,sp
	addl	d0,0x3a813e
	bras	TS2070

TS2069:
	tstl	_halted
	bnes	TS2070
	addql	#1,0x3a807a

TS2070:
	movl	_runtcb,a5
	subqb	#1,0x27(a5)
	bnes	TS2071
	movb	#0x1,_reschf
	movb	#0x1,_iodnflg

TS2071:
	addqw	#1,_lbolt
	movw	_lbolt,d0
	extl	d0
	cmpl	_Hz,d0
	blt	TS2072
	movl	0xc(a6),d0
	andl	#0x700,d0
	bne	TS2072
	movw	_Hz+2,d0
	subw	d0,_lbolt
	addql	#1,_time
	clrl	_ilintcnt
	tstl	_logtout
	beqs	TS2074
	movl	_logq,a0
	cmpw	#0x1,0x8(a0)
	bnes	TS2074
	subql	#1,_logtout

TS2074:
	subql	#1,_syncout
	bnes	TS2075
	tstl	_swapidle
	beqs	TS2075
	clrl	_swapidle
	movl	#0x1,_OS_SCAN

TS2075:
	jsr	_spl1
	movl	#_alarmq,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	bras	TS2076

TS2077:
	movl	a5,a4
	pea	(a4)
	jsr	_nextaq
	addql	#4,sp
	movl	d0,a5
	subqw	#1,0x3e(a4)
	bnes	TS2076
	pea	(a4)
	jsr	_aqout
	addql	#4,sp
	moveq	#0xe,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_psignal
	addql	#8,sp

TS2076:
	movl	a5,d0
	bnes	TS2077

TS2072:
	moveml	(sp)+,#0x3c04	| d2 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_timeout
_timeout:
	link	a6,#0xfffc
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x10(a6),d7
	movl	#_callout,a5
	jsr	_spl7
	movl	d0,0xfffc(a6)
	bras	TS350

TS351:
	movw	(a5),d0
	extl	d0
	cmpl	d7,d0
	bgts	TS352
	movw	(a5),d0
	extl	d0
	subl	d0,d7
	addw	#0xa,a5

TS350:
	tstl	0x6(a5)
	bnes	TS351

TS352:
	cmpl	#_callout+150,a5
	bcss	TS353
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	#0xc0,-(sp)
	moveq	#0xf,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	bras	TS358

TS353:
	subw	d7,(a5)
	movl	a5,a4
	bras	TS354

TS355:
	addw	#0xa,a4

TS354:
	tstl	0x6(a4)
	bnes	TS355
	bras	TS356

TS357:
	movw	(a4),0xa(a4)
	movl	0x6(a4),0x10(a4)
	movl	0x2(a4),0xc(a4)
	subw	#0xa,a4

TS356:
	cmpl	a5,a4
	bccs	TS357
	movw	d7,(a5)
	movl	0x8(a6),0x6(a5)
	movl	0xc(a6),0x2(a5)

TS358:
	movl	0xfffc(a6),-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_closeop
_closeop:
	link	a6,#0xfff4
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	tstw	0x26(a5)
	bne	TS1077
	tstb	_stmmode
	beqs	TS1078
	jsr	_stmreq

TS1078:
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	pea	(a5)
	jsr	_eqout
	addql	#4,sp
	tstl	0x32(a5)
	beqs	TS1079
	movl	0x32(a5),a0
	clrl	0x2(a0)

TS1079:
	btst	#0,0x1b(a5)
	beqs	TS1080
	pea	(a5)
	jsr	_pipeclose
	bras	TS1083

TS1080:
	movl	0x2a(a5),a3
	cmpl	_fhrqp,a3
	bnes	TS1081
	pea	(a5)
	jsr	_fh_close
	addql	#4,sp

TS1082:
	pea	(a5)
	jsr	_putnode
	bras	TS1083

TS1081:
	movl	a3,d0
	beqs	TS1082
	movl	0x1c(a5),0xfffc(a6)
	movl	0x38(a5),0xfff8(a6)
	movl	0x3c(a5),0xfff4(a6)
	movl	a5,a4
	pea	(a4)
	jsr	_inirn
	addql	#4,sp
	movb	#0x21,0x47(a4)
	movl	0xfffc(a6),0x32(a4)
	movl	0xfff8(a6),0x3a(a4)
	movl	0xfff4(a6),0x3e(a4)
	bset	#1,0x4b(a4)
	pea	(a4)
	pea	(a3)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS1077
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC

TS1083:
	addql	#4,sp

TS1077:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_closetq
_closetq:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	tstw	0x1a(a5)
	beqs	TS1217
	bra	TS1221

TS1222:
	pea	0x28(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	bnes	TS1223
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1223:
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	jsr	_eqout
	addql	#4,sp
	pea	(a4)
	jsr	_putnode
	addql	#4,sp
	subqw	#1,0x3c(a5)

TS1217:
	tstw	0x3c(a5)
	beqs	TS1218
	bras	TS1222

TS1219:
	pea	0x32(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	bnes	TS1220
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1220:
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	subqw	#1,0x3e(a5)
	moveq	#0xffffffcd,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_termreq
	addql	#8,sp

TS1218:
	tstw	0x3e(a5)
	bnes	TS1219
	tstw	0x1c(a5)
	bnes	TS1221
	pea	(a5)
	jsr	_putnode
	addql	#4,sp

TS1221:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_closerq
_closerq:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	tstw	0x1a(a5)
	bne	TS1200
	pea	(a5)
	jsr	_fh_closerq
	addql	#4,sp
	bras	TS1205

TS1206:
	pea	(a4)
	jsr	_eqout
	addql	#4,sp
	clrl	0x2a(a4)

TS1205:
	pea	0x1e(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	bnes	TS1206
	bras	TS1207

TS1213:
	movl	0x5a(a4),d0
	cmpl	a5,d0
	bnes	TS1214
	clrl	0x5a(a4)
	subqw	#1,0x1c(a5)

TS1214:
	moveq	#0xffffffcd,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_termreq

TS1215:
	addql	#8,sp

TS1207:
	tstw	0x3c(a5)
	beq	TS1208
	pea	0x28(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	bnes	TS1212
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1212:
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	subqw	#1,0x3c(a5)
	cmpb	#0x1,0x46(a4)
	bnes	TS1213
	bclr	#6,0x4b(a4)
	pea	(a4)
	movb	0x49(a4),d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),d0
	addl	#0x44,d0
	movl	d0,-(sp)
	jsr	_addlq
	bras	TS1215

TS1209:
	pea	0x32(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	bnes	TS1210
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1210:
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	subqw	#1,0x3e(a5)
	movl	0x5a(a4),d0
	cmpl	a5,d0
	bnes	TS1211
	clrl	0x5a(a4)
	subqw	#1,0x1c(a5)

TS1211:
	moveq	#0xfffffffc,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_termreq
	addql	#8,sp

TS1208:
	tstw	0x3e(a5)
	bnes	TS1209
	tstw	0x1c(a5)
	bnes	TS1200
	pea	(a5)
	jsr	_putnode
	addql	#4,sp

TS1200:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_closect
_closect:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvsnodpo
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	beqs	TS1390
	subqw	#1,(a5)
	tstw	(a5)
	bnes	TS1390
	tstl	0x2(a5)
	beqs	TS1391
	movl	0x2(a5),a0
	clrl	0x32(a0)

TS1391:
	pea	(a5)
	jsr	_putsnode
	addql	#4,sp

TS1390:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_close2
_close2:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	beqs	TS1072
	movl	_runtcb,-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movw	0x8(a5),d0
	extl	d0
	movl	d0,d7
	movl	d7,d0
	cmpl	#0x2,d0
	beqs	TS1076
	cmpl	#0x3,d0
	beqs	TS1199
	cmpl	#0x4,d0
	beqs	TS1216
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	bras	TS1198

TS1076:
	subqw	#1,0x26(a5)
	pea	(a5)
	bsr	_closeop
	bras	TS1198

TS1199:
	subqw	#1,0x1a(a5)
	pea	(a5)
	bsr	_closerq
	bras	TS1198

TS1216:
	subqw	#1,0x1a(a5)
	pea	(a5)
	bsr	_closetq

TS1198:
	addql	#4,sp

TS1072:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_close
_close:
	link	a6,#0x0
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	tstl	d0
	bnes	TS1489
	moveq	#0xfffffff7,d0
	bras	TS1490

TS1489:
	movl	0x8(a6),-(sp)
	bsr	_close2
	addql	#4,sp
	clrl	d0

TS1490:
	unlk	a6
	rts

	.globl	_fxexec
_fxexec:
	link	a6,#0x0
	clrl	-(sp)
	movl	0x18(a6),-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_fexec
	addw	#0x18,sp
	unlk	a6
	rts

	.globl	_fexec
_fexec:
	link	a6,#0xfef4
	moveml	#0x104,-(sp)	| d7 a5
	movw	#0xffff,0x3a8124
	clrb	0x3a8123
	movl	0x1c(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_open
	addw	#0x10,sp
	movl	d0,d7
	blts	TS1860
	movl	d7,a5
	btst	#0,0x29(a5)
	beqs	TS1863
	movl	0x2a(a5),d0
	cmpl	_fhrqp,d0
	beqs	TS1865

TS1863:
	moveq	#0xfffffff3,d7

TS1899:
	pea	(a5)
	jsr	_pg_close
	addql	#4,sp

TS1860:
	cmpw	#0xffff,0x3a8124
	beqs	TS1861
	bsr	_swclose

TS1861:
	movl	d7,d0
	bras	TS1862

TS1865:
	pea	0xfef4(a6)
	pea	0xfef8(a6)
	pea	0xfefc(a6)
	pea	0xff00(a6)
	movl	0x18(a6),-(sp)
	movl	0x14(a6),-(sp)
	bsr	_argget
	addw	#0x18,sp
	movl	d0,d7
	blts	TS1899
	movl	0xfef4(a6),d0
	addl	#0x400,d0
	movl	d0,-(sp)
	pea	(a5)
	bsr	_getxfile
	addql	#8,sp
	movl	d0,d7
	bnes	TS1899
	movl	0xfef4(a6),-(sp)
	movl	0xfef8(a6),-(sp)
	movl	0xfefc(a6),-(sp)
	pea	0xff00(a6)
	bsr	_argback
	addw	#0x10,sp
	bsr	_setregs
	clrl	d0

TS1862:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_fspawn
_fspawn:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	clrl	-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_open
	addw	#0x10,sp
	movl	d0,d7
	bges	TS2212
	movl	d7,d0
	bras	TS2214

TS2212:
	movl	d7,a5
	btst	#0,0x29(a5)
	beqs	TS2213
	movl	0x2a(a5),d0
	cmpl	_fhrqp,d0
	beqs	TS2215

TS2213:
	pea	(a5)
	jsr	_pg_close
	addql	#4,sp
	moveq	#0xfffffff3,d0
	bras	TS2214

TS2215:
	movl	0x18(a6),-(sp)
	movl	0x14(a6),-(sp)
	pea	(a5)
	bsrs	_mspawn
	addw	#0xc,sp

TS2214:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_mspawn
_mspawn:
	link	a6,#0xfee8
	movw	#0xffff,0x3a8124
	clrb	0x3a8123
	pea	0xfeec(a6)
	pea	0xfef0(a6)
	pea	0xfef4(a6)
	pea	0xfefc(a6)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	bsr	_argget
	addw	#0x18,sp
	movl	d0,0xfffc(a6)
	blts	TS2216
	jsr	_creproc
	movl	d0,0xfef8(a6)
	bnes	TS2219
	movl	#0xfffffff5,0xfffc(a6)

TS2216:
	movl	0x8(a6),-(sp)
	jsr	_pg_close
	addql	#4,sp
	cmpw	#0xffff,0x3a8124
	beqs	TS2217
	bsr	_swclose

TS2217:
	movl	0xfffc(a6),d0
	bra	TS2218

TS2219:
	movl	0xfef8(a6),a0
	movw	0x3a(a0),0xfeea(a6)
	movl	a0,-(sp)
	jsr	_startpr
	addql	#4,sp
	tstl	d0
	beqs	TS2220
	movl	0xfeec(a6),d0
	addl	#0x400,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_getxfile
	addql	#8,sp
	tstl	d0
	beqs	TS2222
	movl	#0xfffffff4,0xfffc(a6)
	movl	0x8(a6),-(sp)
	jsr	_pg_close
	addql	#4,sp
	cmpw	#0xffff,0x3a8124
	beqs	TS2224
	bsr	_swclose

TS2224:
	clrl	-(sp)
	jsr	_exitp
	addql	#4,sp

TS2223:
	clrl	d0
	bras	TS2218

TS2222:
	movl	0xfeec(a6),-(sp)
	movl	0xfef0(a6),-(sp)
	movl	0xfef4(a6),-(sp)
	pea	0xfefc(a6)
	bsr	_argback
	addw	#0x10,sp
	bsr	_setregs
	bras	TS2223

TS2220:
	cmpw	#0xffff,0x3a8124
	beqs	TS2221
	bsr	_swclose

TS2221:
	movw	0xfeea(a6),d0
	extl	d0

TS2218:
	unlk	a6
	rts

	.globl	_getxfile
_getxfile:
	link	a6,#0xffe0
	moveml	#0x104,-(sp)	| d7 a5
	movl	_runtcb,a5
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffe2(a6)
	movl	0x8(a6),-(sp)
	jsr	_pg_stat
	addw	#0xc,sp
	tstl	d0
	bges	TS1904
	moveq	#0xfffffff8,d0
	bras	TS1973

TS1904:
	pea	0xffe2(a6)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_load
	addw	#0xc,sp
	movl	d0,d7
	bges	TS1969
	movl	d7,d0
	bras	TS1973

TS1969:
	btst	#4,0x23(a5)
	beqs	TS1970
	moveq	#0x5,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_psignal
	addql	#8,sp
	bras	TS1972

TS1970:
	btst	#2,0xffe6(a6)
	beqs	TS1971
	movw	0xffec(a6),0x3a8020

TS1971:
	btst	#3,0xffe6(a6)
	beqs	TS1972
	tstw	0x3a801e
	beqs	TS1972
	movw	0xffea(a6),0x3a801e
	movw	0xffea(a6),0x36(a5)

TS1972:
	clrl	d0

TS1973:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_setregs
_setregs:
	link	a6,#0x0
	movl	d7,-(sp)
	clrl	d7

TS2002:
	movl	d7,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	cmpl	#0x1,(a0)
	beqs	TS2001
	movl	d7,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	clrl	(a0)

TS2001:
	addql	#1,d7
	cmpl	#0x12,d7
	blts	TS2002
	movl	_runtcb,a0
	clrl	0x32(a0)
	movl	_runtcb,a0
	andw	#0xffd6,0x22(a0)
	clrl	d7

TS2003:
	movl	d7,d0
	asll	#2,d0
	addl	0x3a801a,d0
	movl	d0,a0
	clrl	(a0)
	addql	#1,d7
	cmpl	#0xe,d7
	bles	TS2003
	clrl	d7

TS2005:
	movl	_runtcb,d0
	addl	#0xcc,d0
	addl	d7,d0
	movl	d0,a0
	movb	(a0),d0
	btst	#0,d0
	beqs	TS2004
	movl	d7,-(sp)
	jsr	_close2
	addql	#4,sp

TS2004:
	addql	#1,d7
	cmpl	#0x18,d7
	blts	TS2005
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_fpoint
_fpoint:
	link	a6,#0xfffc
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	0xfffc(a6)
	movl	0x8(a6),-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	beqs	TS1867
	moveq	#0xffffffff,d0
	bras	TS1868

TS1867:
	movl	0xfffc(a6),d0

TS1868:
	unlk	a6
	rts

	.globl	_argget
_argget:
	link	a6,#0xfffc
	moveml	#0x1e04,-(sp)	| d3 d4 d5 d6 a5
	movl	0x10(a6),0xfffc(a6)
	clrl	d5
	clrl	d4
	clrl	d3
	tstl	0x8(a6)
	bnes	TS1866
	bras	TS1898

TS1869:
	cmpl	#0xffffffff,a5
	bnes	TS1870

TS1894:
	moveq	#0xfffffff2,d0
	bra	TS1891

TS1870:
	movl	d3,-(sp)
	pea	(a5)
	pea	0xfffc(a6)
	movl	0x10(a6),-(sp)
	bsr	_argmove
	addw	#0x10,sp
	movl	d0,d6
	bges	TS1890

TS1895:
	movl	d6,d0
	bra	TS1891

TS1890:
	addl	d6,d3
	addql	#1,d5
	addql	#4,0x8(a6)

TS1866:
	movl	0x8(a6),-(sp)
	bsrs	_fpoint
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1869

TS1898:
	tstl	0xc(a6)
	bnes	TS1892
	bras	TS1897

TS1893:
	cmpl	#0xffffffff,a5
	beqs	TS1894
	movl	d3,-(sp)
	pea	(a5)
	pea	0xfffc(a6)
	movl	0x10(a6),-(sp)
	bsr	_argmove
	addw	#0x10,sp
	movl	d0,d6
	blts	TS1895
	addl	d6,d3
	addql	#1,d4
	addql	#4,0xc(a6)

TS1892:
	movl	0xc(a6),-(sp)
	bsr	_fpoint
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1893

TS1897:
	movl	d3,d0
	addql	#3,d0
	andl	#0xfffffffc,d0
	movl	d0,d3
	addl	d4,d5
	movl	0x14(a6),a0
	movl	d5,(a0)
	movl	0x18(a6),a0
	movl	d4,(a0)
	movl	0x1c(a6),a0
	movl	d3,(a0)
	cmpw	#0xffff,0x3a8124
	beqs	TS1896
	movl	#0x100,-(sp)
	movl	0x10(a6),-(sp)
	bsr	_swwrite
	addql	#8,sp
	tstl	d0
	blt	TS1894

TS1896:
	clrl	d0

TS1891:
	moveml	(sp)+,#0x2078	| d3 d4 d5 d6 a5
	unlk	a6
	rts

	.globl	_argback
_argback:
	link	a6,#0xfffc
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	#0x3dfffc,a4
	movl	a4,d0
	subl	0x14(a6),d0
	subql	#4,d0
	movl	d0,a5
	movl	a5,0x3a802a
	movl	0xc(a6),d0
	asll	#2,d0
	movl	a5,d1
	subl	d0,d1
	subl	#0xc,d1
	movl	d1,a4
	movl	a4,d0
	movl	0x3a801a,a0
	movl	d0,0x3c(a0)
	movl	0xc(a6),d0
	subl	0x10(a6),d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_suword
	addql	#8,sp
	cmpw	#0xffff,0x3a8124
	beqs	TS1974
	clrl	-(sp)
	bsr	_swseek
	addql	#4,sp
	movl	#0x100,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_swread
	addql	#8,sp

TS1974:
	movl	0x8(a6),a2
	movl	a2,0xfffc(a6)
	movl	#0x100,d7
	bras	TS1975

TS1976:
	movb	(a2)+,d6
	beqs	TS1977
	cmpb	#0x2f,d6
	bnes	TS1975
	movl	a2,0xfffc(a6)

TS1975:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS1976

TS1977:
	moveq	#0x8,d0
	movl	d0,-(sp)
	movl	#0x3a8142,-(sp)
	movl	0xfffc(a6),-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	movl	0x8(a6),a2
	bras	TS1978

TS1980:
	pea	(a5)
	pea	(a4)
	jsr	_supoint
	addql	#8,sp

TS1985:
	movl	a2,d0
	subl	0x8(a6),d0
	movl	#0x100,d1
	subl	d0,d1
	movl	d1,d7
	bnes	TS1981
	movl	#0x100,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_swread
	addql	#8,sp
	movl	0x8(a6),a2
	movl	#0x100,d7

TS1981:
	movl	a2,a3
	bras	TS1982

TS1983:
	movb	(a2)+,d6
	beqs	TS1984
	subql	#1,d7

TS1982:
	tstl	d7
	bnes	TS1983

TS1984:
	movl	a2,d0
	subl	a3,d0
	movl	d0,d7
	movl	d7,-(sp)
	pea	(a5)
	pea	(a3)
	jsr	_copy_out
	addw	#0xc,sp
	addl	d7,a5
	tstb	d6
	bnes	TS1985

TS1978:
	addql	#4,a4
	movl	0xc(a6),d0
	cmpl	0x10(a6),d0
	bnes	TS1979
	clrl	-(sp)
	pea	(a4)
	jsr	_supoint
	addql	#8,sp
	addql	#4,a4

TS1979:
	subql	#1,0xc(a6)
	bge	TS1980
	clrl	-(sp)
	pea	(a4)
	jsr	_supoint
	addql	#8,sp
	movl	a5,d0
	btst	#0,d0
	beqs	TS1987
	clrl	-(sp)
	movl	a5,-(sp)
	addql	#1,a5
	jsr	_copy_sb
	addql	#8,sp

TS1987:
	clrl	-(sp)
	pea	(a5)
	jsr	_suword
	addql	#8,sp
	cmpw	#0xffff,0x3a8124
	beqs	TS1988
	bsr	_swclose

TS1988:
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_argmove
_argmove:
	link	a6,#0xfffc
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x10(a6),a5
	movl	0x14(a6),d7
	movl	#0x1400,d0
	subl	d7,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_copy_sts
	addql	#8,sp
	movl	d0,d6
	movl	0xc(a6),a0
	movl	(a0),a4
	movl	d7,d0
	addl	d6,d0
	cmpl	#0x1400,d0
	blts	TS1871

	| "Too many parameters at exec"

	movl	#_swapname+12,-(sp)
	movl	_runtcb,-(sp)
	moveq	#0x40,d0
	movl	d0,-(sp)
	jsr	_ERR_MESS
	addw	#0xc,sp

TS1878:
	moveq	#0xfffffff2,d0
	bras	TS1879

TS1871:
	movl	d6,0xfffc(a6)
	bras	TS1872

TS1873:
	movl	a4,d0
	subl	0x8(a6),d0
	movl	#0x100,d1
	subl	d0,d1
	movl	d1,d5
	bnes	TS1874
	cmpw	#0xffff,0x3a8124
	bnes	TS1876
	bsrs	_swopen
	movw	d0,0x3a8124
	blts	TS1878

TS1876:
	movl	#0x100,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_swwrite
	addql	#8,sp
	tstl	d0
	blts	TS1878
	movl	0x8(a6),a4
	movl	#0x100,d5

TS1874:
	cmpl	d5,d6
	bges	TS1875
	movl	d6,d5

TS1875:
	movl	d5,-(sp)
	pea	(a4)
	pea	(a5)
	jsr	_copy_in
	addw	#0xc,sp
	subl	d5,d6
	addl	d5,a4
	addl	d5,a5

TS1872:
	tstl	d6
	bnes	TS1873
	movl	0xc(a6),a0
	movl	a4,(a0)
	movl	0xfffc(a6),d0

TS1879:
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_swopen
_swopen:
	link	a6,#0xfff4
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	moveq	#0x6,d6

TS1889:
	cmpl	#0x9,d6
	bges	TS1880
	movl	d6,d0

	| "tmp/OS000"

	addl	#_swapname,d0
	movl	d0,a0
	cmpb	#0x39,(a0)
	beqs	TS1888
	movl	d6,d0

	| "tmp/OS000"

	addl	#_swapname,d0
	movl	d0,a0
	addqb	#1,(a0)

TS1880:

	| "tmp/OS000"

	movl	#_swapname,a5
	lea	0xfff4(a6),a0
	movl	a0,a4

TS1881:
	movb	(a5)+,(a4)+
	bnes	TS1881
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	#0x1b6,-(sp)
	moveq	#0x9,d0
	movl	d0,-(sp)
	pea	0xfff4(a6)
	moveq	#0x15,d0
	movl	d0,-(sp)
	movl	#0x403,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	bges	TS1882
	movl	d6,-(sp)
	moveq	#0x3,d0

TS1887:
	movl	d0,-(sp)
	bsr	_swaperr
	addql	#8,sp

TS1885:
	movl	d6,d0
	bra	TS1886

TS1888:
	movl	d6,d0

	| "tmp/OS000"

	addl	#_swapname,d0
	movl	d0,a0
	movb	#0x30,(a0)
	addql	#1,d6
	bra	TS1889

TS1882:
	movl	d6,-(sp)
	jsr	_close
	addql	#4,sp
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x2,d0
	movl	d0,-(sp)
	moveq	#0x9,d0
	movl	d0,-(sp)
	pea	0xfff4(a6)
	moveq	#0x15,d0
	movl	d0,-(sp)
	movl	#0x401,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	bges	TS1883
	movl	d6,-(sp)
	moveq	#0x1,d0
	bras	TS1887

TS1883:
	movl	d6,d7
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x9,d0
	movl	d0,-(sp)
	pea	0xfff4(a6)
	moveq	#0x15,d0
	movl	d0,-(sp)
	movl	#0x408,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	bges	TS1884
	movl	d6,-(sp)
	moveq	#0x8,d0
	movl	d0,-(sp)
	bsr	_swaperr
	addql	#8,sp
	movl	d7,-(sp)
	jsr	_close
	addql	#4,sp
	bra	TS1885

TS1884:
	movl	d7,d0

TS1886:
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_swclose
_swclose:
	link	a6,#0x0
	movw	0x3a8124,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_close
	addql	#4,sp
	unlk	a6
	rts

	.globl	_swseek
_swseek:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	movl	0x8(a6),d7
	clrl	-(sp)
	movl	d7,-(sp)
	movw	0x3a8124,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_seek
	addw	#0xc,sp
	movl	d0,d6
	bges	TS2000
	movl	d6,-(sp)
	moveq	#0x22,d0
	movl	d0,-(sp)
	bsr	_swaperr
	addql	#8,sp

TS2000:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_swwrite
_swwrite:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a5)
	movw	0x3a8124,d0
	extl	d0
	movl	d0,-(sp)
	movl	#0x405,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	bges	TS1877
	movl	d6,-(sp)
	moveq	#0x5,d0
	movl	d0,-(sp)
	bsrs	_swaperr
	addql	#8,sp

TS1877:
	movl	d6,d0
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_swread
_swread:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a5)
	movw	0x3a8124,d0
	extl	d0
	movl	d0,-(sp)
	movl	#0x404,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	bges	TS1986
	movl	d6,-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	bsrs	_swaperr
	addql	#8,sp

TS1986:
	movl	d6,d0
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_swaperr
_swaperr:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	d7,-(sp)
	movl	d6,-(sp)

	| "Error %d at parameter copy, cmd=%d"

	movl	#_swapname+40,-(sp)
	movl	_runtcb,-(sp)
	movl	#0x80,-(sp)
	jsr	_ERR_MESS
	addw	#0x14,sp
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_fexit
_fexit:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	movl	d7,d0
	andl	#0xff,d0
	asll	#8,d0
	movl	d0,-(sp)
	bsrs	_exitp
	addql	#4,sp
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_exitp
_exitp:
	link	a6,#0x0
	moveml	#0x13c,-(sp)	| d7 a2 a3 a4 a5
	movl	_runtcb,a3
	clrl	0x2e(a3)
	clrl	0x3a802a
	tstb	_stmmode
	beqs	TS1368
	jsr	_stmreq

TS1368:
	tstl	_accounting
	beqs	TS1369
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_acctout
	addql	#4,sp

TS1369:
	tstl	0xec(a3)
	beqs	TS1370
	pea	(a3)
	jsr	_semexit
	addql	#4,sp

TS1370:
	jsr	_spl6
	pea	(a3)
	jsr	_aqout
	addql	#4,sp
	jsr	_spl0
	lea	0x4e(a3),a0
	movl	a0,a4
	bras	TS1376

TS1377:
	pea	(a5)
	jsr	_eqout
	addql	#4,sp
	pea	(a5)
	jsr	_cancex
	addql	#4,sp

TS1376:
	pea	(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1377
	clrw	d7

TS1382:
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_close2
	addql	#4,sp
	addqw	#1,d7
	cmpw	#0x18,d7
	blts	TS1382
	lea	0x44(a3),a0
	movl	a0,a4
	bras	TS1383

TS1384:
	moveq	#0xffffffcd,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp

TS1383:
	pea	(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1384
	lea	0x62(a3),a0
	movl	a0,a4
	bras	TS1385

TS1386:
	pea	(a5)
	jsr	_closeop
	addql	#4,sp

TS1385:
	pea	(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1386
	movb	0x28(a3),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	jsr	_closect
	addql	#4,sp
	movb	0x25(a3),d0
	extw	d0
	cmpw	_initppn,d0
	bnes	TS1392
	tstl	_accounting
	beqs	TS1454
	clrl	-(sp)
	jsr	_acct
	addql	#4,sp

TS1454:
	jsr	_pg_cleanup
	jsr	_fh_stop
	tstw	0xa(a6)
	bnes	TS1478

	| "\nOS: INFO: System halted\n"

	movl	#_swapname+76,-(sp)
	jsr	_PRINT
	addql	#4,sp
	clrl	-(sp)
	jsr	_stopcpu
	addql	#4,sp

TS1478:
	moveq	#0xe,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1392:
	pea	(a3)
	jsr	_pg_retus
	addql	#4,sp
	movb	#0x5,0x24(a3)
	movb	0x25(a3),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cixproc
	addql	#4,sp
	subqw	#1,_Naproc
	movl	0x3a807e,d0
	addl	0x3a8076,d0
	movl	d0,0xe4(a3)
	movl	0x3a8082,d0
	addl	0x3a807a,d0
	movl	d0,0xe8(a3)
	movw	0xa(a6),d0
	extl	d0
	movl	d0,0x40(a3)
	tstw	_initppn
	bnes	TS1436
	moveq	#0x12,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1436:
	lea	0x58(a3),a0
	movl	a0,a4
	bras	TS1437

TS1438:
	pea	(a2)
	jsr	_eqout
	addql	#4,sp
	pea	(a2)
	movw	_initppn,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),d0
	addl	#0x58,d0
	movl	d0,-(sp)
	jsr	_addeq
	addql	#8,sp
	movl	_inittcb,0x1e(a2)
	cmpb	#0x5,0x24(a2)
	bnes	TS1439
	pea	(a2)
	movw	_initppn,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),-(sp)
	bsrs	_waikw
	addql	#8,sp
	tstl	d0
	beqs	TS1439
	pea	(a2)
	jsr	_puttnod
	addql	#4,sp

TS1439:
	cmpb	#0x6,0x24(a2)
	bnes	TS1437
	clrl	-(sp)
	pea	(a2)
	jsr	_waikpr
	addql	#8,sp

TS1437:
	pea	(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	bne	TS1438
	pea	(a3)
	movl	0x1e(a3),-(sp)
	bsrs	_waikw
	addql	#8,sp
	tstl	d0
	beqs	TS1450
	moveq	#0x1,d0
	movl	d0,-(sp)
	bras	TS1453

TS1450:
	clrl	-(sp)

TS1453:
	jsr	_stoppr
	addql	#4,sp
	moveml	(sp)+,#0x3c80	| d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_waikw
_waikw:
	link	a6,#0xfffc
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	pea	0x4e(a5)
	jsr	_firstq
	bras	TS1440

TS1447:
	movl	0x40(a4),-(sp)
	pea	(a3)
	jsr	_ssuword
	addql	#8,sp
	movl	0xe8(a4),-(sp)
	movl	0xe4(a4),-(sp)
	pea	(a5)
	jsr	_copytim
	addw	#0xc,sp
	movw	0x3a(a4),d0
	extl	d0
	movl	d0,-(sp)
	pea	(a3)
	jsr	_termreq
	addql	#8,sp
	pea	(a4)
	jsr	_eqout
	addql	#4,sp

TS1449:
	moveq	#0x1,d0
	bras	TS1448

TS1441:
	cmpb	#0x19,0x47(a3)
	bnes	TS1442
	cmpb	#0x5,0x46(a3)
	beqs	TS1445

TS1442:
	pea	(a3)
	jsr	_nexteq

TS1440:
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	bnes	TS1441

TS1445:
	movl	a3,d0
	beqs	TS1446
	cmpb	#0x5,0x24(a4)
	beqs	TS1447
	cmpb	#0x6,0x24(a4)
	bnes	TS1446
	bset	#5,0x23(a4)
	movl	0x2a(a4),-(sp)
	jsr	_fsig
	addql	#4,sp
	asll	#8,d0
	orl	#0x7f,d0
	movl	d0,0xfffc(a6)
	movl	d0,-(sp)
	pea	(a3)
	jsr	_ssuword
	addql	#8,sp
	movw	0x3a(a4),d0
	extl	d0
	movl	d0,-(sp)
	pea	(a3)
	jsr	_termreq
	addql	#8,sp
	bras	TS1449

TS1446:
	clrl	d0

TS1448:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_waitp
_waitp:
	link	a6,#0xfffc
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	_runtcb,d0
	addl	#0x58,d0
	movl	d0,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	bnes	TS2225
	moveq	#0xfffffff6,d0
	bra	TS2228

TS2225:
	cmpb	#0x5,0x24(a4)
	bnes	TS2226
	movw	0x3a(a4),d0
	extl	d0
	movl	d0,0xfffc(a6)
	movl	0x40(a4),-(sp)
	pea	(a5)
	jsr	_ssuword
	addql	#8,sp
	movl	0xe4(a4),d0
	addl	d0,0x3a807e
	movl	0xe8(a4),d0
	addl	d0,0x3a8082
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	jsr	_eqout
	addql	#4,sp
	pea	(a4)
	jsr	_puttnod
	addql	#4,sp
	movl	0xfffc(a6),d0
	bras	TS2228

TS2226:
	cmpb	#0x6,0x24(a4)
	bnes	TS2227
	btst	#5,0x23(a4)
	bnes	TS2227
	bset	#5,0x23(a4)
	movl	0x2a(a4),-(sp)
	jsr	_fsig
	addql	#4,sp
	asll	#8,d0
	orl	#0x7f,d0
	movl	d0,0xfffc(a6)
	movl	d0,-(sp)
	pea	(a5)
	jsr	_ssuword
	addql	#8,sp
	movw	0x3a(a4),d0
	extl	d0
	bras	TS2228

TS2227:
	pea	(a4)
	jsr	_nexteq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	bne	TS2225
	movb	#0x5,0x46(a5)
	moveq	#0xffffff80,d0

TS2228:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_gentcb
_gentcb:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	jsr	_gettnod
	movl	d0,a5
	movl	a5,d0
	beq	TS1695
	pea	(a5)
	jsr	_ininhea
	addql	#4,sp
	movw	#0x6,0x8(a5)
	clrl	0x1a(a5)
	movw	#0x1,0x4c(a5)
	lea	0x44(a5),a0
	movl	a0,0x44(a5)
	movl	a0,0x48(a5)
	movw	#0x1,0x56(a5)
	lea	0x4e(a5),a0
	movl	a0,0x4e(a5)
	movl	a0,0x52(a5)
	movw	#0x1,0x60(a5)
	lea	0x58(a5),a0
	movl	a0,0x58(a5)
	movl	a0,0x5c(a5)
	movw	#0x1,0x6a(a5)
	lea	0x62(a5),a0
	movl	a0,0x62(a5)
	movl	a0,0x66(a5)
	clrb	0x24(a5)
	clrw	0x22(a5)
	clrl	0x2a(a5)
	clrl	0x2e(a5)
	clrw	0x3e(a5)
	clrl	0xec(a5)
	clrl	0xf0(a5)
	clrw	d7

TS1696:
	pea	(a5)
	clrl	-(sp)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	addqw	#1,d7
	cmpw	#0x18,d7
	blts	TS1696
	clrb	0xfc(a5)
	pea	(a5)
	jsr	_pg_itcb
	addql	#4,sp

TS1695:
	movl	a5,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_gsystcb
_gsystcb:
	link	a6,#0x0
	movl	a5,-(sp)
	bsr	_gentcb
	movl	d0,a5
	tstl	d0
	bnes	TS1697
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS1697:
	movb	#0x3,0x24(a5)
	clrb	0x26(a5)
	clrb	0x25(a5)
	movl	a5,0x1e(a5)
	movl	a5,_proc
	clrw	0x3a(a5)
	movl	a5,d0
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_creproc
_creproc:
	link	a6,#0xfffc
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	_runtcb,a4
	bsr	_gentcb
	movl	d0,a5
	tstl	d0
	beqs	TS1801
	pea	(a5)
	jsr	_sixproc
	addql	#4,sp
	movw	d0,0xfffe(a6)
	blts	TS1809
	clrl	d0
	movw	_oscfig,d0
	movw	_Naproc,d1
	extl	d1
	subl	d1,d0
	cmpl	#0x1,d0
	bnes	TS1811
	jsr	_suser
	tstl	d0
	bnes	TS1811
	movw	0xfffe(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cixproc
	addql	#4,sp

TS1809:
	pea	(a5)
	jsr	_puttnod
	bras	TS1810

TS1812:
	pea	(a4)
	pea	(a5)
	jsr	_shmcopy
	addql	#8,sp
	tstl	d0
	bnes	TS1817
	pea	(a5)
	jsr	_putnode

TS1810:
	addql	#4,sp

TS1801:
	clrl	d0
	bra	TS1802

TS1811:
	tstl	0xf0(a4)
	bnes	TS1812

TS1817:
	addqw	#1,_Naproc
	movb	#0x3,0x24(a5)
	movw	0x22(a4),d0
	andl	#0x1800,d0
	bset	#3,d0
	movw	d0,0x22(a5)
	movb	0x26(a4),0x26(a5)
	movw	0x36(a4),0x36(a5)
	movw	0x38(a4),0x38(a5)
	movw	0x3c(a4),0x3c(a5)
	movb	0xffff(a6),0x25(a5)
	movl	0x2e(a4),0x2e(a5)
	movl	0x32(a4),0x32(a5)
	jsr	_getnpid
	movw	d0,0x3a(a5)
	movl	a4,0x1e(a5)
	movl	_time,0xe8(a5)
	pea	(a5)
	pea	0x58(a4)
	jsr	_addeq
	addql	#8,sp
	clrw	d7

TS1824:
	movl	_runtcb,-(sp)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a3
	tstl	d0
	beqs	TS1823
	pea	(a5)
	pea	(a3)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	pea	(a5)
	pea	(a4)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_getluf
	addql	#8,sp
	extw	d0
	extl	d0
	movl	d0,-(sp)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setluf
	addw	#0xc,sp

TS1823:
	addqw	#1,d7
	cmpw	#0x18,d7
	blts	TS1824
	movb	0x28(a4),0x28(a5)
	movb	0x28(a4),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvsnodpo
	addql	#4,sp
	movl	d0,a3
	tstl	d0
	beqs	TS1825
	addqw	#1,(a3)

TS1825:
	movl	a5,d0

TS1802:
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_ffork
_ffork:
	link	a6,#0xfff8
	moveml	#0xc,-(sp)	| a4 a5
	tstb	_stmmode
	beqs	TS2229
	jsr	_stmreq

TS2229:
	movl	_runtcb,a4
	bsr	_creproc
	movl	d0,a5
	tstl	d0
	bnes	TS2230
	movl	#0xfffffff5,0xfffc(a6)
	movl	0x3a801a,a0
	addql	#2,0x44(a0)
	movl	0xfffc(a6),d0
	bras	TS2233

TS2230:
	movw	0x3a(a4),0xfffa(a6)
	movw	0x3a(a5),0xfff8(a6)
	jsr	_fpsave
	pea	(a5)
	jsr	_pg_fork
	addql	#4,sp
	pea	(a5)
	jsr	_startpr
	addql	#4,sp
	tstl	d0
	beqs	TS2231
	movw	0xfffa(a6),d0
	bras	TS2232

TS2231:
	movl	0x3a801a,a0
	addql	#2,0x44(a0)
	movw	0xfff8(a6),d0

TS2232:
	extl	d0

TS2233:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_initrdq
_initrdq:
	link	a6,#0xfff8
	movl	d7,-(sp)
	clrl	d7

TS1665:
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq+8,d0
	movl	d0,a0
	movw	#0x1,(a0)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq,d0
	movl	d0,0xfffc(a6)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq+4,d0
	movl	d0,0xfff8(a6)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq,d0
	movl	0xfffc(a6),a0
	movl	d0,(a0)
	movl	0xfff8(a6),a1
	movl	d0,(a1)
	addql	#1,d7
	cmpl	#0x10,d7
	blts	TS1665
	movw	#0x1,BS1666
	movl	#_reqtq,_reqtq
	movl	_reqtq,BS1667
	movw	#0x1,BS1668
	movl	#_genslpq,_genslpq
	movl	_genslpq,BS1669
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_addrdq
_addrdq:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),a5
	jsr	_spl6
	movl	d0,d7
	movb	0x26(a5),d0
	extw	d0
	extl	d0
	movl	d0,d6
	cmpl	#0x10,d6
	bles	TS14
	moveq	#0xf,d6
	movb	d6,0x26(a5)

TS14:
	movb	#0x3,0x24(a5)
	movl	_time,0xe4(a5)
	pea	(a5)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq,d0
	movl	d0,-(sp)
	jsr	_addlq
	addql	#8,sp
	movb	_hpri,d0
	extw	d0
	extl	d0
	cmpl	d0,d6
	bges	TS18
	movb	d6,_hpri
	movb	#0x1,_reschf

TS18:
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_waiksig
_waiksig:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	jsr	_spl6
	movl	d0,d7
	cmpb	#0x1,0x24(a5)
	bnes	TS12
	bset	#7,0x23(a5)
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	pea	(a5)
	bsr	_addrdq
	addql	#4,sp

TS12:
	movb	#0x1,_reschf
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_waikpr
_waikpr:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),0x40(a5)
	jsr	_spl6
	movl	d0,d7
	clrl	0x1a(a5)
	cmpb	#0x1,0x24(a5)
	beqs	TS672
	cmpb	#0x6,0x24(a5)
	bnes	TS673

TS672:
	pea	(a5)
	bsr	_addrdq
	addql	#4,sp

TS673:
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_waitrq
_waitrq:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	_runtcb,a4
	cmpb	#0x3,0x46(a5)
	beqs	TS552
	jsr	_spl6
	movl	a5,0x1a(a4)
	movb	DS553,0x27(a4)

TS623:
	movb	#0x1,0x24(a4)
	movl	_time,0xe4(a4)
	tstl	0x2a(a4)
	beqs	TS554
	jsr	_issig
	tstl	d0
	beqs	TS554
	jsr	_spl0
	pea	(a5)
	jsr	_cancel2
	addql	#4,sp
	bras	TS732

TS554:
	jsr	_spl0

TS732:
	bsr	_swtch
	btst	#7,0x23(a4)
	beqs	TS552
	jsr	_spl6
	bclr	#7,0x23(a4)
	tstl	0x1a(a4)
	bnes	TS623
	jsr	_spl0

TS552:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_sleep
_sleep:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	movl	_runtcb,a4

TS657:
	jsr	_spl6
	movl	d0,d7
	tstl	0xc(a6)
	bnes	TS654
	jsr	_issig
	tstl	d0
	bnes	TS658

TS654:
	movb	DS553,0x27(a4)
	movb	#0x1,0x24(a4)
	pea	(a4)
	pea	(a5)
	jsr	_addlq
	addql	#8,sp
	jsr	_spl0
	bsr	_swtch
	btst	#7,0x23(a4)
	beqs	TS655
	bclr	#7,0x23(a4)
	tstl	0xc(a6)
	beqs	TS657

TS655:
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	bras	TS656

TS658:
	jsr	_spl0
	movl	#0x3a80ca,-(sp)
	movl	0xfe(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_resume
	addql	#8,sp

TS656:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_wakeup
_wakeup:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	jsr	_spl6
	movl	d0,d7
	bras	TS257

TS258:
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	bsr	_addrdq
	addql	#4,sp

TS257:
	pea	(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	bnes	TS258
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_stoppr
_stoppr:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	_runtcb,a5
	pea	(a5)
	jsr	_pg_retss
	addql	#4,sp
	tstl	0x8(a6)
	beqs	TS1452
	pea	(a5)
	jsr	_puttnod
	addql	#4,sp

TS1452:
	bsrs	_swtch
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_swtch
_swtch:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	jsr	_fpsave
	movl	#0x3a8086,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beq	TS555
	movl	_runtcb,-(sp)
	jsr	_pg_map
	addql	#4,sp
	bra	TS622

TS561:
	pea	(a3)
	jsr	_qout
	addql	#4,sp
	jsr	_spl0
	movl	0x26(a3),-(sp)
	pea	(a3)
	jsr	_termreq
	addql	#8,sp
	jsr	_spl6

TS560:
	movl	#_reqtq,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a3
	tstl	d0
	bnes	TS561
	clrb	_iodnflg

TS556:
	movb	_hpri,d0
	extw	d0
	muls	#0xa,d0
	addl	#_readyq,d0
	movl	d0,a5
	bras	TS557

TS558:
	pea	(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	bnes	TS559
	addw	#0xa,a5

TS557:
	cmpl	#_mess,a5
	bcss	TS558
	movl	#0x1,_halted
	jsr	_idle
	clrl	_halted

TS555:
	jsr	_spl6
	tstb	_iodnflg
	beqs	TS556
	bras	TS560

TS559:
	clrb	_reschf
	movb	0x26(a4),_hpri
	movb	_hpri,_curpri
	movl	a4,_runtcb
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	jsr	_spl0
	movl	#0x3a8086,-(sp)
	movl	0xfe(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_resume
	addql	#8,sp

TS622:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_exitlv2
_exitlv2:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	jsr	_spl6
	tstb	_iodnflg
	bnes	TS21
	bras	TS1360

TS24:
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	jsr	_spl0
	movl	0x26(a5),-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	jsr	_spl6

TS21:
	movl	#_reqtq,-(sp)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS24
	clrb	_iodnflg

TS1360:
	tstb	_reschf
	beq	TS1355
	tstb	_stmmode
	beqs	TS1356
	jsr	_spl0
	jsr	_stmreq
	jsr	_spl6

TS1356:
	movl	_runtcb,a4
	movl	_time,0xe4(a4)
	movb	0x26(a4),d0
	extw	d0
	extl	d0
	movl	d0,d7
	tstb	0x27(a4)
	bgts	TS1357
	movb	DS553,0x27(a4)
	pea	(a4)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq,d0
	movl	d0,-(sp)
	jsr	_addlq
	bras	TS1359

TS1357:
	pea	(a4)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_readyq,d0
	movl	d0,-(sp)
	jsr	_addfq

TS1359:
	addql	#8,sp
	movb	_hpri,d0
	extw	d0
	extl	d0
	cmpl	d0,d7
	bges	TS1358
	movb	d7,_hpri

TS1358:
	bsr	_swtch
	jsr	_spl6

TS1355:
	jsr	_spl0
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_startpr
_startpr:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	pea	(a5)
	jsr	_pg_gupage
	addql	#4,sp
	movl	#0x3a8086,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS1827
	movl	_runtcb,-(sp)
	jsr	_pg_map
	addql	#4,sp
	clrl	0x3a8082
	clrl	0x3a807a
	clrl	0x3a807e
	clrl	0x3a8076
	clrl	0x3a813a
	clrl	0x3a8136
	clrl	0x3a813e
	moveq	#0x1,d0
	bras	TS1828

TS1827:
	movl	0xfe(a5),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	movl	_runtcb,a0
	movl	0xfe(a0),a0
	clrl	d0
	movw	0x2(a0),d0
	movl	d0,-(sp)
	jsr	_copy_cp
	addql	#8,sp
	movb	#0x1,0x24(a5)
	pea	(a5)
	bsr	_addrdq
	addql	#4,sp
	clrl	d0

TS1828:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_setpri
_setpri:
	link	a6,#0xfffc
	movl	d7,-(sp)
	movl	0x8(a6),d7
	movb	_curpri,d0
	extw	d0
	extl	d0
	addl	d0,d7
	movb	0x3a8026,d0
	extw	d0
	extl	d0
	cmpl	d0,d7
	bges	TS2234
	movb	0x3a8026,d0
	extw	d0
	extl	d0
	movl	d0,d7

TS2234:
	movb	0x3a8027,d0
	extw	d0
	extl	d0
	cmpl	d0,d7
	bles	TS2235
	movb	0x3a8027,d0
	extw	d0
	extl	d0
	movl	d0,d7

TS2235:
	movl	_runtcb,a0
	movb	d7,0x26(a0)
	movb	_curpri,d0
	extw	d0
	extl	d0
	movl	d0,0xfffc(a6)
	movb	d7,_curpri
	cmpl	d7,d0
	bges	TS2236
	movb	#0x1,_reschf

TS2236:
	movl	0xfffc(a6),d0
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_sprilim
_sprilim:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	tstl	d7
	bges	TS2237
	clrl	d7

TS2237:
	jsr	_suser
	tstl	d0
	bnes	TS2238
	cmpl	#0x4,d7
	bges	TS2238
	moveq	#0x4,d7

TS2238:
	cmpl	#0x10,d7
	blts	TS2239
	moveq	#0xf,d7

TS2239:
	cmpl	d7,d6
	bges	TS2240
	movl	d7,d6

TS2240:
	cmpl	#0x10,d6
	blts	TS2241
	moveq	#0xf,d6

TS2241:
	movb	d7,0x3a8026
	movb	d6,0x3a8027
	clrl	d0
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_nap
_nap:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2242
	moveq	#0xfffffffc,d0
	bra	TS2247

TS2242:
	movl	_Hz,-(sp)
	movl	#0x3e8,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	ldiv
	addql	#8,sp
	addql	#1,d0
	movl	d0,d7
	jsr	_spl6
	tstw	_napdec
	beqs	TS2243
	movw	_napdec,d0
	extl	d0
	cmpl	d7,d0
	bles	TS2246

TS2243:
	movl	_Hz,d0
	asll	#4,d0
	cmpl	d0,d7
	bges	TS2244
	movl	d7,d0
	bras	TS2245

TS2244:
	movl	_Hz,d0
	asll	#4,d0

TS2245:
	movw	d0,_napdec

TS2246:
	movw	_napinc,d0
	extl	d0
	addl	d7,d0
	movl	d0,d7
	movl	_runtcb,a0
	movl	d7,0x40(a0)
	clrl	-(sp)
	movl	#_napq,-(sp)
	bsr	_sleep
	addql	#8,sp
	jsr	_spl0
	movl	_Hz,-(sp)
	movl	#0x3e8,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,-(sp)
	movl	d7,d0
	subql	#1,d0
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp

TS2247:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_ssignal
_ssignal:
	link	a6,#0xfffc
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),d7
	bles	TS2248
	cmpl	#0x12,d7
	bgts	TS2248
	cmpl	#0x9,d7
	bnes	TS2250

TS2248:
	moveq	#0xffffffea,d0
	bras	TS2249

TS2250:
	subql	#1,d7
	movl	d7,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	movl	(a0),d0
	movl	d0,0xfffc(a6)
	movl	d7,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	movl	0xc(a6),(a0)
	moveq	#0x1,d0
	asll	d7,d0
	movl	d0,d6
	movl	_runtcb,a5
	tstl	0xc(a6)
	bnes	TS2251
	movl	d6,d0
	notl	d0
	andl	d0,0x32(a5)
	bras	TS2254

TS2251:
	cmpl	#0x1,0xc(a6)
	bnes	TS2252
	movl	d6,d0
	notl	d0
	andl	d0,0x32(a5)
	movl	d6,d0
	notl	d0
	andl	d0,0x2e(a5)
	bras	TS2253

TS2252:
	orl	d6,0x32(a5)

TS2254:
	orl	d6,0x2e(a5)

TS2253:
	movl	0x2e(a5),d0
	andl	d0,0x2a(a5)
	movl	0xfffc(a6),d0

TS2249:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_kill
_kill:
	link	a6,#0x0
	moveml	#0x3f1c,-(sp)	| d2 d3 d4 d5 d6 d7 a3 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	blts	TS2255
	cmpl	#0x12,d6
	bles	TS2257

TS2255:
	moveq	#0xffffffea,d0
	bra	TS2256

TS2257:
	tstl	d7
	bles	TS2258
	movl	d7,-(sp)
	jsr	_cvpidtp
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2282
	moveq	#0xfffffffd,d0
	bra	TS2256

TS2282:
	movl	d6,-(sp)
	pea	(a5)
	bsr	_senpsig
	addql	#8,sp
	tstl	d0
	bnes	TS2283
	moveq	#0xffffffff,d0
	bra	TS2256

TS2283:
	clrl	d0
	bra	TS2256

TS2258:
	movl	_runtcb,a0
	movw	0x3c(a0),d5
	moveq	#0xfffffffd,d2
	moveq	#0x2,d4
	bra	TS2259

TS2260:
	movw	d4,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),a5
	movl	a5,d0
	beq	TS2261
	tstl	d7
	bnes	TS2262
	tstw	d5
	beq	TS2261
	cmpw	0x3c(a5),d5
	bne	TS2261
	movl	d6,-(sp)
	pea	(a5)
	bsr	_senpsig
	addql	#8,sp
	tstl	d0
	bne	TS2268
	bra	TS2261

TS2262:
	cmpl	#0xffffffff,d7
	bne	TS2263
	jsr	_suser
	tstl	d0
	bnes	TS2276
	movw	0x3a801e,d0
	cmpw	0x38(a5),d0
	bnes	TS2263

TS2276:
	tstl	d6
	bnes	TS2277
	bra	TS2268

TS2264:
	cmpl	#0xfffffffe,d7
	beqs	TS2265
	cmpl	#0xfffffffd,d7
	bnes	TS2271

TS2265:
	clrw	d3

TS2267:
	pea	(a5)
	movw	d3,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_lurqnp
	addql	#8,sp
	movl	d0,a4
	tstl	d0
	beqs	TS2266
	cmpl	#0xfffffffd,d7
	bnes	TS2269
	pea	0x1e(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	beqs	TS2270
	pea	(a3)
	jsr	_nexteq
	addql	#4,sp
	tstl	d0
	bnes	TS2269

TS2270:
	subl	a4,a4

TS2266:
	addqw	#1,d3
	cmpw	#0x18,d3
	blts	TS2267

TS2269:
	movl	a4,d0
	bnes	TS2261

TS2277:
	movl	d6,-(sp)
	pea	(a5)
	bsr	_psignal
	addql	#8,sp
	bras	TS2268

TS2263:
	movl	_runtcb,a0
	movb	0x25(a0),d0
	extw	d0
	cmpw	_initppn,d0
	beqs	TS2264

TS2271:
	cmpl	#0xffffffff,d7
	bges	TS2261
	movl	d7,d0
	negl	d0
	movw	0x3c(a5),d1
	extl	d1
	cmpl	d1,d0
	bnes	TS2261
	movl	d6,-(sp)
	pea	(a5)
	bsrs	_senpsig
	addql	#8,sp
	tstl	d0
	beqs	TS2261

TS2268:
	clrl	d2

TS2261:
	addqw	#1,d4

TS2259:
	cmpw	_hproc,d4
	blt	TS2260
	movl	d2,d0

TS2256:
	moveml	(sp)+,#0x38fc	| d2 d3 d4 d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_senpsig
_senpsig:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	_runtcb,a4
	jsr	_suser
	tstl	d0
	bnes	TS2272
	cmpl	a5,a4
	beqs	TS2272
	movw	0x36(a4),d0
	cmpw	0x36(a5),d0
	beqs	TS2272
	cmpw	0x38(a5),d0
	beqs	TS2272
	movw	0x38(a4),d0
	cmpw	0x36(a5),d0
	beqs	TS2272
	cmpw	0x38(a5),d0
	bnes	TS2275

TS2272:
	tstl	d7
	beqs	TS2273
	movl	d7,-(sp)
	pea	(a5)
	bsrs	_psignal
	addql	#8,sp

TS2273:
	moveq	#0x1,d0
	bras	TS2274

TS2275:
	clrl	d0

TS2274:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_signal
_signal:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),d7
	beqs	TS297
	moveq	#0x1,d6
	bras	TS298

TS299:
	movl	d6,d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),a5
	movl	a5,d0
	beqs	TS300
	movw	0x3c(a5),d0
	extl	d0
	cmpl	d7,d0
	bnes	TS300
	movl	0xc(a6),-(sp)
	pea	(a5)
	bsrs	_psignal
	addql	#8,sp

TS300:
	addql	#1,d6

TS298:
	movw	_hproc,d0
	extl	d0
	cmpl	d0,d6
	blts	TS299

TS297:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_psignal
_psignal:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	bles	TS11
	cmpl	#0x12,d7
	bgts	TS11
	movl	d7,d0
	subql	#1,d0
	moveq	#0x1,d1
	asll	d0,d1
	orl	d1,0x2a(a5)
	pea	(a5)
	jsr	_waiksig
	addql	#4,sp

TS11:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_stop
_stop:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	bras	TS1557

TS1559:
	movb	#0x6,0x24(a4)
	pea	(a4)
	pea	(a5)
	jsr	_waikw
	addql	#8,sp
	jsr	_swtch
	btst	#4,0x23(a4)
	beqs	TS1560
	bsr	_procxmt
	tstl	d0
	bnes	TS1560

TS1557:
	movl	_runtcb,a4
	movl	0x1e(a4),a5
	cmpl	BS1558,a5
	bnes	TS1559
	movl	0x2a(a4),-(sp)
	bsr	_fsig
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_exitp
	addql	#4,sp

TS1560:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_issig
_issig:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	_runtcb,a5
	tstl	0x2a(a5)
	beqs	TS624
	movl	0x2e(a5),d0
	andl	d0,0x2a(a5)
	btst	#4,0x23(a5)
	beqs	TS625
	moveq	#0x5,d0
	bras	TS629

TS625:
	tstl	0x2a(a5)
	beqs	TS624
	movl	0x2a(a5),-(sp)
	bsr	_fsig
	addql	#4,sp
	bras	TS629

TS624:
	clrl	d0

TS629:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_psig
_psig:
	link	a6,#0xfffc
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	_runtcb,a5
	btst	#4,0x23(a5)
	beqs	TS1364
	bsr	_stop

TS1364:
	movl	0x2a(a5),-(sp)
	bsr	_fsig
	addql	#4,sp
	movl	d0,d7
	beq	TS1365
	movl	d7,d0
	subql	#1,d0
	moveq	#0x1,d1
	asll	d0,d1
	movl	d1,d6
	movl	d6,d0
	notl	d0
	andl	d0,0x2a(a5)
	movl	0x32(a5),d0
	andl	d6,d0
	beqs	TS1366
	movl	d7,d0
	subql	#1,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	movl	(a0),0xfffc(a6)
	cmpl	#0x4,d7
	beqs	TS1556
	cmpl	#0x5,d7
	beqs	TS1556
	movl	d6,d0
	notl	d0
	andl	d0,0x32(a5)
	movl	d7,d0
	subql	#1,d0
	asll	#2,d0
	addl	#0x3a802e,d0
	movl	d0,a0
	clrl	(a0)

TS1556:
	movl	d7,-(sp)
	movl	0xfffc(a6),-(sp)
	jsr	_sendsig
	addql	#8,sp
	bras	TS1365

TS1366:
	movl	d7,d0
	subl	#0x3,d0
	cmpl	#0x9,d0
	bhis	TS1367
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)
	.word	0x0020
	.word	0x0020
	.word	0x0020
	.word	0x0020
	.word	0x0020
	.word	0x0020
	.word	0x0014
	.word	0x0020
	.word	0x0020
	.word	0x0020

TS1367:
	movl	d7,-(sp)
	jsr	_exitp
	addql	#4,sp
	bras	TS1365
	movl	d7,-(sp)
	jsr	_pg_core
	addql	#4,sp
	tstl	d0
	beqs	TS1367
	addl	#0x80,d7
	bras	TS1367

TS1365:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_fsig
_fsig:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	movl	0x8(a6),d7
	moveq	#0x1,d6

TS627:
	btst	#0,d7
	beqs	TS626
	movl	d6,d0
	bras	TS628

TS626:
	asrl	#1,d7
	addql	#1,d6
	cmpl	#0x12,d6
	bles	TS627
	clrl	d0

TS628:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_procxmt
_procxmt:
	link	a6,#0xfff4
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	_runtcb,a4
	clrl	0xfffc(a6)
	movl	0x1e(a4),d0
	addl	#0x4e,d0
	movl	d0,-(sp)
	jsr	_firstq
	bras	TS1561

TS1562:
	cmpb	#0x1b,0x47(a5)
	bnes	TS1563
	cmpb	#0x5,0x46(a5)
	bnes	TS1563
	movw	0x3a(a4),d0
	extl	d0
	movl	0x32(a5),d1
	cmpl	d0,d1
	beqs	TS1564

TS1563:
	pea	(a5)
	jsr	_nexteq

TS1561:
	addql	#4,sp
	movl	d0,a5
	movl	a5,d0
	bnes	TS1562

TS1564:
	movl	a5,d0
	beqs	TS1565
	movl	0x1e(a5),a3
	movl	0x22(a5),d0
	movl	d0,d7
	movl	0x26(a5),d0
	subl	#0x1,d0
	cmpl	#0x8,d0
	bhi	TS1567
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)
	.word	0x0026
	.word	0x003C
	.word	0x0052
	.word	0x007A
	.word	0x008E
	.word	0x00A4
	.word	0x0126
	.word	0x015C
	.word	0x011A

TS1568:
	movl	0xfffc(a6),-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp

TS1565:
	clrl	d0
	bra	TS1566
	pea	0xfffc(a6)
	pea	(a3)
	jsr	_pg_rdtrc
	addql	#8,sp
	tstl	d0
	bnes	TS1568
	bra	TS1567
	pea	0xfffc(a6)
	pea	(a3)
	jsr	_pg_rdtrc
	addql	#8,sp
	tstl	d0
	bnes	TS1568
	bra	TS1567
	movl	a3,d0
	movl	d0,0xfff8(a6)
	blt	TS1567
	cmpl	#0x7fc,d0
	bgt	TS1567
	addl	#0x3a8000,d0
	andl	#0xfffffffe,d0
	movl	d0,a0
	movl	(a0),0xfffc(a6)
	bras	TS1568
	movl	d7,-(sp)
	pea	(a3)
	jsr	_pg_wrtrc
	addql	#8,sp
	tstl	d0
	bnes	TS1568
	bra	TS1567
	movl	d7,-(sp)
	pea	(a3)
	jsr	_pg_wrtrc
	addql	#8,sp
	tstl	d0
	bne	TS1568
	bra	TS1567
	movl	a3,d0
	movl	d0,0xfff8(a6)
	addl	#0x3a8000,d0
	bclr	#0,d0
	movl	d0,0xfff4(a6)
	movl	0x3a801a,d0
	addl	#0x40,d0
	movl	0xfff4(a6),d1
	cmpl	d0,d1
	bnes	TS4356
	bclr	#13,d7
	andl	#0xfffff8ff,d7
	andl	#0xffff,d7
	movl	d1,a0
	movl	(a0),d0
	andl	#0xffff0000,d0
	orl	d0,d7

TS4357:
	movl	0xfff4(a6),a0
	movl	d7,(a0)
	bra	TS1568

TS4356:
	clrl	0xfff8(a6)

TS4358:
	cmpl	#0x12,0xfff8(a6)
	bges	TS1567
	movl	0xfff8(a6),d0
	asll	#2,d0
	addl	0x3a801a,d0
	movl	0xfff4(a6),d1
	cmpl	d0,d1
	beqs	TS4357
	addql	#1,0xfff8(a6)
	bras	TS4358
	movl	0x3a801a,a0
	bset	#7,0x42(a0)
	cmpl	#0x1,a3
	beqs	TS4359
	movl	a3,d0
	movl	0x3a801a,a0
	movl	d0,0x44(a0)

TS4359:
	clrl	0x2a(a4)
	tstl	d7
	beqs	TS4360
	movl	d7,-(sp)
	pea	(a4)
	bsr	_psignal
	addql	#8,sp

TS4360:
	clrl	-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	moveq	#0x1,d0
	bras	TS1566
	clrl	-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	movl	0x2a(a4),-(sp)
	bsr	_fsig
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_exitp
	addql	#4,sp

TS1567:
	movl	#0xfffffffb,0xfffc(a6)
	bra	TS1568

TS1566:
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_tracep
_tracep:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0xc(a6),a5
	movl	a5,d0
	bnes	TS2284
	movl	_runtcb,a0
	bset	#4,0x23(a0)
	clrl	d0
	bras	TS2285

TS2284:
	bclr	#5,0x23(a5)
	clrl	-(sp)
	pea	(a5)
	jsr	_waikpr
	addql	#8,sp
	movl	0x8(a6),a0
	movb	#0x5,0x46(a0)
	moveq	#0xffffff80,d0

TS2285:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_t1req
_t1req:
	link	a6,#0xfff4
	moveml	#0xf3c,-(sp)	| d4 d5 d6 d7 a2 a3 a4 a5
	movl	0x14(a6),d6
	movl	0x18(a6),d7
	movw	0xa(a6),d0
	andl	#0x7f,d0
	movw	d0,d4
	subl	a3,a3
	tstb	_stmmode
	beqs	TS520
	jsr	_stmreq

TS520:
	jsr	_getnode
	movl	d0,a5
	tstl	d0
	bnes	TS523
	moveq	#0xffffffce,d0
	bra	TS733

TS523:
	pea	(a5)
	jsr	_inirn
	addql	#4,sp
	movb	d4,0x47(a5)
	movl	0x10(a6),0x1e(a5)
	movl	d6,0x22(a5)
	movl	d7,0x26(a5)
	movl	0x24(a6),0x2a(a5)
	btst	#3,0xa(a6)
	beqs	TS526
	movw	0x3a812e,0x36(a5)
	movw	0x3a8130,0x38(a5)
	movl	0x3a812a,0x3e(a5)
	movl	0x3a8126,0x3a(a5)

TS526:
	btst	#7,0xb(a6)
	beqs	TS527
	movl	0x20(a6),-(sp)
	jsr	_lutqnp
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	bnes	TS780

TS749:
	moveq	#0xfffffff7,d5
	bra	TS533

TS780:
	movl	a3,0x1a(a5)
	addqw	#1,0x1c(a3)
	bset	#0,0x4b(a5)

TS527:
	btst	#2,0xa(a6)
	beqs	TS528
	bset	#1,0x4a(a5)

TS528:
	pea	(a5)
	movl	_runtcb,d0
	addl	#0x4e,d0
	movl	d0,-(sp)
	jsr	_addeq
	addql	#8,sp
	cmpw	#0x16,d4
	bgt	TS531
	cmpw	#0x12,d4
	beq	TS531
	btst	#4,0xa(a6)
	beqs	TS734
	movl	0xc(a6),a4

TS738:
	movw	0x8(a4),0xfffe(a6)
	cmpw	#0x2,0xfffe(a6)
	bnes	TS739
	tstl	0x2a(a4)
	bnes	TS778
	movw	0x1a(a4),d0
	andw	#0x3,d0
	bnes	TS778
	bras	TS749

TS734:
	movl	_runtcb,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a4
	movl	a4,d0
	bnes	TS738
	bra	TS749

TS778:
	movl	a4,0x5e(a5)
	movw	d4,d0
	extl	d0
	addl	d0,d0
	addl	#_fcpriv,d0
	movl	d0,a0
	tstw	(a0)
	beqs	TS777
	movw	d4,d0
	extl	d0
	addl	d0,d0
	addl	#_fcpriv,d0
	movl	d0,a0
	movw	0x28(a4),d0
	andw	(a0),d0
	bnes	TS777
	movw	d4,d0
	extl	d0
	addl	d0,d0
	addl	#_fcpriv,d0
	movl	d0,a0
	movw	(a0),d0
	andw	#0x6,d0
	bne	TS749

TS776:
	moveq	#0xfffffff3,d5
	bra	TS533

TS739:
	cmpw	#0x3,0xfffe(a6)
	beqs	TS740
	cmpw	#0x4,0xfffe(a6)
	bnes	TS777

TS740:
	tstl	0x1c(a6)
	bne	TS741

TS777:
	clrl	0xfff8(a6)
	tstl	0x1c(a6)
	beq	TS742
	movl	_runtcb,-(sp)
	movl	0x1c(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,0xfff8(a6)
	beq	TS741
	movl	0x10(a6),d0
	addl	d6,d0
	movl	0xfff8(a6),a0
	cmpl	0x22(a0),d0
	bhi	TS741
	movw	d4,d0
	extl	d0
	addl	#_fcflag,d0
	movl	d0,a0
	movb	(a0),d0
	btst	#0,d0
	beqs	TS775
	movl	0xfff8(a6),a0
	movb	0x47(a0),d0
	extw	d0
	extl	d0
	addl	#_fcflag,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	btst	#0,d0
	beq	TS776

TS775:
	movl	0x10(a6),d0
	movl	0xfff8(a6),a0
	addl	0x1e(a0),d0
	movl	d0,0x10(a6)

TS743:
	cmpw	#0x2,d4
	beqs	TS744
	movw	d4,d0
	extl	d0
	addl	#_fcflag,d0
	movl	d0,a0
	movb	(a0),d0
	btst	#0,d0
	beqs	TS744
	movw	0xa(a6),d0
	andl	#0x400,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	movl	0x10(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS744
	moveq	#0xfffffff2,d5
	bra	TS533

TS742:
	cmpw	#0x2,d4
	beqs	TS743
	movw	0xa(a6),d0
	andl	#0x400,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	movl	0x10(a6),-(sp)
	jsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS743

TS741:
	moveq	#0xffffffea,d5
	bra	TS533

TS744:
	tstl	0xfff8(a6)
	beqs	TS745
	movw	0x1e(a6),0x42(a5)
	movl	0xfff8(a6),a0
	addqb	#1,0x48(a0)

TS745:
	movw	0xfffe(a6),d0
	extl	d0
	cmpl	#0x2,d0
	beqs	TS746
	cmpl	#0x3,d0
	beqs	TS748
	cmpl	#0x4,d0
	beqs	TS756
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp
	bra	TS533

TS746:
	movl	0x1c(a4),0x32(a5)
	movw	0x36(a4),0x72(a5)
	btst	#0,0x1b(a4)
	beqs	TS747
	bset	#2,0x4b(a5)

TS747:
	pea	(a4)
	pea	(a5)
	movw	d4,d0
	extl	d0
	asll	#2,d0
	addl	#_fscall,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)

TS755:
	addql	#8,sp

TS4366:
	movl	d0,d5
	bras	TS533

TS756:
	cmpw	#0x4,d4
	bne	TS749
	pea	(a4)
	pea	(a5)
	jsr	_readtq
	bras	TS755

TS748:
	cmpw	#0x4,d4
	bne	TS749
	pea	(a4)
	pea	(a5)
	jsr	_readrq
	bras	TS755

TS531:
	movw	d4,d0
	extl	d0
	subl	#0x12,d0
	cmpl	#0x9,d0
	bhi	TS532
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)
	.word	0x018A
	.word	0x01C0
	.word	0x01C0
	.word	0x01C0
	.word	0x01C0
	.word	0x0022
	.word	0x0022
	.word	0x00C0
	.word	0x017E
	.word	0x0126

TS533:
	movl	d5,-(sp)
	pea	(a5)
	bsr	_postreq
	addql	#8,sp
	bra	TS733
	btst	#2,0xa(a6)
	beqs	TS4361
	moveq	#0x13,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS4361:
	movl	_runtcb,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a2
	tstl	d0
	beq	TS741
	tstl	0x1c(a6)
	bne	TS741
	cmpl	0x22(a2),d7
	bhi	TS741
	movl	d7,d0
	addl	d6,d0
	movl	0x22(a2),d1
	cmpl	d0,d1
	bccs	TS4362
	movl	d1,d0
	subl	d7,d0
	movl	d0,d6
	movl	d6,0x22(a5)

TS4362:
	cmpw	#0x17,d4
	bnes	TS4363
	movb	0x47(a2),d0
	extw	d0
	extl	d0
	addl	#_fcflag,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	btst	#0,d0
	beq	TS776

TS4363:
	cmpw	#0x17,d4
	bnes	TS4364
	moveq	#0x1,d0
	bras	TS4365

TS4364:
	clrl	d0

TS4365:
	movl	d0,-(sp)
	movl	d7,-(sp)
	movl	d6,-(sp)
	movl	0x10(a6),-(sp)
	pea	(a2)
	jsr	_urdwr
	addw	#0x14,sp
	bra	TS4366
	movw	0xa(a6),d0
	andl	#0x400,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	movl	0x10(a6),-(sp)
	jsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	bne	TS741
	cmpl	#0x4,d6
	bne	TS741
	btst	#0,0x13(a6)
	bne	TS741
	movw	0xa(a6),d0
	andl	#0x400,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	movl	0x10(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	bne	TS776
	pea	(a5)
	jsr	_waitp

TS4370:
	addql	#4,sp
	bra	TS4366
	clrl	0xfff4(a6)
	tstl	d7
	bles	TS4367
	movl	0xc(a6),-(sp)
	jsr	_cvpidtp
	addql	#4,sp
	movl	d0,0xfff4(a6)
	beqs	TS4368
	movl	d0,a0
	cmpw	#0x6,0x8(a0)
	bnes	TS4368
	movl	d0,a0
	cmpb	#0x6,0x24(a0)
	bnes	TS4368
	movl	d0,a0
	movl	0x1e(a0),d0
	cmpl	_runtcb,d0
	beqs	TS4367

TS4368:
	moveq	#0xfffffffd,d5
	bra	TS533

TS4367:
	movl	0xc(a6),0x32(a5)
	movl	0xfff4(a6),-(sp)
	pea	(a5)
	jsr	_tracep
	bra	TS755
	movb	#0x5,0x46(a5)
	moveq	#0xffffff80,d5
	bra	TS533
	jsr	_getnode
	movl	d0,a4
	tstl	d0
	bnes	TS4369
	moveq	#0xffffffce,d5
	bra	TS533

TS4369:
	pea	(a4)
	jsr	_inion
	addql	#4,sp
	pea	(a4)
	jsr	_cvnodnr
	addql	#4,sp
	movw	d0,0x44(a5)
	pea	(a5)
	jsr	_pipecreat
	bra	TS4370

TS532:
	moveq	#0xffffffcc,d5
	bra	TS533

TS733:
	moveml	(sp)+,#0x3cf0	| d4 d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_t1urw
_t1urw:
	link	a6,#0xfff8
	clrl	0xfff8(a6)
	movw	0xa(a6),d0
	andw	#0x7f,d0
	cmpw	#0x17,d0
	bnes	TS2286
	movl	#0x1,0xfff8(a6)

TS2286:
	btst	#7,0xb(a6)
	bnes	TS2287
	movl	0xfff8(a6),-(sp)
	movl	0x18(a6),-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	jsr	_t2urw
	addw	#0x14,sp
	movl	d0,0xfffc(a6)
	cmpl	#0xffffffca,d0
	bnes	TS2294

TS2287:
	movl	0x24(a6),-(sp)
	movl	0x20(a6),-(sp)
	movl	0x1c(a6),-(sp)
	movl	0x18(a6),-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	bsr	_t1req
	addw	#0x20,sp
	bras	TS2288

TS2294:
	movl	0xfffc(a6),d0

TS2288:
	unlk	a6
	rts

	.globl	_t2tot1
_t2tot1:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	0x1a(a6),d0
	andl	#0x7f,d0
	movl	d0,d7
	cmpl	#0x1,d7
	blts	TS2295
	cmpl	#0x1e,d7
	blts	TS2297

TS2295:
	moveq	#0xffffffea,d0
	bras	TS2296

TS2297:
	jsr	_suser
	tstl	d0
	beqs	TS2298
	movl	0x8(a6),0x3a8126
	movl	0xc(a6),0x3a812a
	movw	0x12(a6),0x3a812e
	movw	0x16(a6),0x3a8130
	movl	0x34(a6),-(sp)
	movl	0x30(a6),-(sp)
	movl	0x2c(a6),-(sp)
	movl	0x28(a6),-(sp)
	movl	0x24(a6),-(sp)
	movl	0x20(a6),-(sp)
	movl	0x1c(a6),-(sp)
	movw	0x1a(a6),d0
	extl	d0
	addl	#0x800,d0
	movl	d0,-(sp)
	bsr	_t1req
	addw	#0x20,sp
	bras	TS2296

TS2298:
	moveq	#0xffffffff,d0

TS2296:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_postreq
_postreq:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	bgts	TS534
	cmpl	#0xffffff80,d7
	beqs	TS534

TS537:
	pea	(a5)
	jsr	_giveurn
	addql	#4,sp
	bras	TS551

TS534:
	btst	#0,0x4b(a5)
	bnes	TS535
	cmpl	#0xffffff80,d7
	bnes	TS537
	pea	(a5)
	jsr	_waitrq
	addql	#4,sp
	movl	_runtcb,a0
	movl	0x40(a0),d7
	bras	TS551

TS535:
	cmpl	#0xffffff80,d7
	beqs	TS536
	movl	d7,-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp

TS536:
	pea	(a5)
	jsr	_cvnodnr
	addql	#4,sp
	movl	d0,d7

TS551:
	movl	d7,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_seek
_seek:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	tstb	_stmmode
	beqs	TS1989
	jsr	_stmreq

TS1989:
	tstl	0x10(a6)
	blts	TS1990
	cmpl	#0x1,0x10(a6)
	bles	TS1992

TS1990:
	moveq	#0xffffffea,d0
	bras	TS1991

TS1992:
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	beqs	TS1994
	movw	0x1a(a5),d0
	andw	#0x5,d0
	beqs	TS1995
	moveq	#0xffffffe3,d7
	bras	TS1998

TS1995:
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	cmpl	#0x1,0x10(a6)
	bnes	TS1996
	movl	0x20(a5),d0
	addl	0xc(a6),d0
	movl	d0,d7
	bras	TS1999

TS1996:
	movl	0xc(a6),d7

TS1999:
	tstl	d7
	blts	TS1997
	movl	d7,0x20(a5)
	bras	TS1998

TS1997:
	moveq	#0xffffffea,d7
	bras	TS1998

TS1994:
	moveq	#0xfffffff7,d7

TS1998:
	movl	d7,d0

TS1991:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_opentq
_opentq:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	_runtcb,-(sp)
	jsr	_getflu
	addql	#4,sp
	movl	d0,d7
	blts	TS2299
	jsr	_genqon
	movl	d0,a5
	movl	a5,d0
	beqs	TS2300
	movw	#0x4,0x8(a5)
	movl	_runtcb,-(sp)
	pea	(a5)
	movl	d7,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	bras	TS2299

TS2300:
	moveq	#0xffffffce,d7

TS2299:
	movl	d7,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_openrq
_openrq:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	_runtcb,-(sp)
	jsr	_getflu
	addql	#4,sp
	movl	d0,d7
	bges	TS1702
	moveq	#0xffffffe8,d0
	bras	TS1706

TS1702:
	jsr	_genqon
	movl	d0,a5
	tstl	d0
	bnes	TS1705
	moveq	#0xffffffce,d0
	bras	TS1706

TS1705:
	movw	#0x3,0x8(a5)
	movl	_runtcb,-(sp)
	pea	(a5)
	movl	d7,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	d7,d0

TS1706:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_openlur
_openlur:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lurqnp
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1711
	moveq	#0xfffffff7,d0
	bras	TS1714

TS1711:
	movl	_runtcb,-(sp)
	jsr	_getflu
	addql	#4,sp
	movl	d0,d7
	bges	TS1712
	moveq	#0xffffffe8,d0
	bras	TS1714

TS1712:
	jsr	_getnode
	movl	d0,a4
	tstl	d0
	bnes	TS1713
	moveq	#0xffffffce,d0
	bras	TS1714

TS1713:
	pea	(a4)
	jsr	_inion
	addql	#4,sp
	movl	_runtcb,-(sp)
	pea	(a4)
	movl	d7,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	a5,0x2a(a4)
	movl	0xc(a6),0x1c(a4)
	movw	0x12(a6),0x28(a4)
	pea	(a4)
	pea	0x1e(a5)
	jsr	_addeq
	addql	#8,sp
	movl	d7,d0

TS1714:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_getpid
_getpid:
	link	a6,#0x0
	movl	_runtcb,a0
	movw	0x3a(a0),d0
	extl	d0
	unlk	a6
	rts

	.globl	_fgetpp
_fgetpp:
	link	a6,#0x0
	movl	_runtcb,a0
	movl	0x1e(a0),a0
	movw	0x3a(a0),d0
	extl	d0
	unlk	a6
	rts

	.globl	_fgetpg
_fgetpg:
	link	a6,#0x0
	movl	_runtcb,a0
	movw	0x3c(a0),d0
	extl	d0
	unlk	a6
	rts

	.globl	_fsetpg
_fsetpg:
	link	a6,#0x0
	movl	_runtcb,a0
	movl	a0,a1
	movw	0x3a(a0),0x3c(a1)
	movw	0x3c(a1),d0
	extl	d0
	unlk	a6
	rts

	.globl	_funame
_funame:
	link	a6,#0xffb0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	cmpl	#0x4e,0xc(a6)
	bhis	TS2301
	clrl	-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2303

TS2301:
	moveq	#0xffffffea,d0
	bras	TS2302

TS2303:
	movl	#_sysinfo,a5
	lea	0xffb2(a6),a0
	movl	a0,a4
	moveq	#0x4e,d7
	bras	TS2304

TS2305:
	movb	(a5)+,(a4)+

TS2304:
	movl	d7,d0
	subql	#1,d7
	tstl	d0
	bnes	TS2305
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	pea	0xffb2(a6)
	jsr	_copy_out
	addw	#0xc,sp
	clrl	d0

TS2302:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_ffcntl
_ffcntl:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	_runtcb,a4
	cmpl	#0x62,0xc(a6)
	bnes	TS2306
	bsr	_clrct
	bra	TS2310

TS2306:
	pea	(a4)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2307
	moveq	#0xfffffff7,d0
	bra	TS2310

TS2307:
	movl	0xc(a6),d0
	cmpl	#0x4,d0
	beq	TS2308
	bgts	TS2311
	tstl	d0
	beqs	TS2325
	cmpl	#0x1,d0
	beq	TS2330
	cmpl	#0x2,d0
	beq	TS2331
	cmpl	#0x3,d0
	beq	TS2333

TS2311:
	cmpl	#0x5,d0
	beqs	TS2312
	cmpl	#0x6,d0
	beqs	TS2312
	cmpl	#0x7,d0
	beqs	TS2312
	cmpl	#0x61,d0
	beq	TS2313
	cmpl	#0x63,d0
	beq	TS2319

TS2312:
	moveq	#0xffffffea,d0
	bra	TS2310

TS2325:
	tstl	0x10(a6)
	blts	TS2312
	cmpl	#0x18,0x10(a6)
	bges	TS2312
	movl	0x10(a6),d7
	bras	TS2326

TS2327:
	lea	0x6c(a4),a0
	movl	d7,d0
	asll	#2,d0
	addl	d0,a0
	tstl	(a0)
	beqs	TS2328
	addql	#1,d7

TS2326:
	cmpl	#0x18,d7
	blts	TS2327

TS2328:
	cmpl	#0x18,d7
	blts	TS2329
	moveq	#0xffffffe8,d0
	bra	TS2310

TS2329:
	pea	(a4)
	pea	(a5)
	movl	d7,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	pea	(a4)
	pea	(a4)
	movl	0x8(a6),-(sp)
	jsr	_getluf
	addql	#8,sp
	extw	d0
	extl	d0
	bclr	#0,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	_setluf
	addw	#0xc,sp

TS2324:
	movl	d7,d0
	bra	TS2310

TS2330:
	pea	(a4)
	movl	0x8(a6),-(sp)
	jsr	_getluf
	addql	#8,sp
	btst	#0,d0
	beqs	TS2309
	moveq	#0x1,d0
	bra	TS2310

TS2331:
	clrl	d7
	btst	#0,0x13(a6)
	beqs	TS2332
	moveq	#0x1,d7

TS2332:
	pea	(a4)
	movl	0x8(a6),-(sp)
	jsr	_getluf
	addql	#8,sp
	extw	d0
	extl	d0
	bclr	#0,d0
	orl	d7,d0
	movl	d0,d7
	pea	(a4)
	movl	d7,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_setluf
	addw	#0xc,sp

TS2309:
	clrl	d0
	bra	TS2310

TS2333:
	movw	0x24(a5),d0
	andl	#0x3,d0
	beqs	TS2334
	movw	0x24(a5),d0
	extl	d0
	subql	#1,d0
	bras	TS2310

TS2334:
	movw	0x24(a5),d0
	extl	d0
	bras	TS2310

TS2308:
	movl	0x10(a6),d0
	andl	#0xc,d0
	movw	0x24(a5),d1
	extl	d1
	andl	#0xfffffff3,d1
	orl	d1,d0
	movw	d0,0x24(a5)
	bras	TS2309

TS2319:
	clrl	d7
	btst	#2,0x1b(a5)
	beqs	TS2320
	bset	#6,d7

TS2320:
	btst	#3,0x1b(a5)
	beqs	TS2321
	bset	#7,d7

TS2321:
	btst	#4,0x1b(a5)
	beqs	TS2322
	bset	#8,d7

TS2322:
	btst	#5,0x1b(a5)
	beqs	TS2323
	bset	#5,d7

TS2323:
	movw	0x28(a5),d0
	extl	d0
	andl	#0xfffffe07,d0
	orl	d0,d7
	bra	TS2324

TS2313:
	movl	0x8(a6),-(sp)
	bsrs	_setct
	addql	#4,sp

TS2310:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_setct
_setct:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2314
	moveq	#0xfffffff7,d0
	bras	TS2318

TS2314:
	jsr	_getsnode
	movl	d0,a4
	tstl	d0
	bnes	TS2316
	moveq	#0xffffffce,d0
	bras	TS2318

TS2316:
	bsrs	_clrct
	movw	#0x1,(a4)
	movl	a5,0x2(a4)
	movl	a4,0x32(a5)
	pea	(a4)
	jsr	_cvsnodnr
	addql	#4,sp
	movl	_runtcb,a0
	movb	d0,0x28(a0)
	btst	#1,0x1b(a5)
	beqs	TS2317
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x10,d0
	movl	d0,-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x7,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS2317:
	clrl	d0

TS2318:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_clrct
_clrct:
	link	a6,#0x0
	movl	_runtcb,a0
	movb	0x28(a0),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	jsr	_closect
	addql	#4,sp
	movl	_runtcb,a0
	clrb	0x28(a0)
	clrl	d0
	unlk	a6
	rts

	.globl	_getruid
_getruid:
	link	a6,#0x0
	movw	0x3a8022,d0
	extl	d0
	unlk	a6
	rts

	.globl	_geteuid
_geteuid:
	link	a6,#0x0
	movw	0x3a801e,d0
	extl	d0
	unlk	a6
	rts

	.globl	_setuid
_setuid:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	0xa(a6),d7
	movw	0x3a8022,d0
	cmpw	d7,d0
	beqs	TS2335
	jsr	_suser
	tstl	d0
	beqs	TS2337

TS2335:
	movw	d7,0x3a801e
	movw	d7,0x3a8022
	movl	_runtcb,a0
	movw	d7,0x36(a0)
	movl	_runtcb,a0
	movw	d7,0x38(a0)
	clrl	d0
	bras	TS2336

TS2337:
	moveq	#0xffffffff,d0

TS2336:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_getrgid
_getrgid:
	link	a6,#0x0
	movw	0x3a8024,d0
	extl	d0
	unlk	a6
	rts

	.globl	_getegid
_getegid:
	link	a6,#0x0
	movw	0x3a8020,d0
	extl	d0
	unlk	a6
	rts

	.globl	_setgid
_setgid:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	0xa(a6),d7
	movw	0x3a8024,d0
	cmpw	d7,d0
	beqs	TS2338
	jsr	_suser
	tstl	d0
	beqs	TS2340

TS2338:
	movw	d7,0x3a8020
	movw	d7,0x3a8024
	clrl	d0
	bras	TS2339

TS2340:
	moveq	#0xffffffff,d0

TS2339:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_duplu
_duplu:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	bnes	TS2341
	moveq	#0xfffffff7,d7
	bras	TS2342

TS2341:
	movl	_runtcb,-(sp)
	jsr	_getflu
	addql	#4,sp
	movw	d0,d7
	blts	TS2342
	movl	_runtcb,-(sp)
	pea	(a5)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	_runtcb,-(sp)
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_getluf
	addql	#8,sp
	extw	d0
	extl	d0
	movl	d0,-(sp)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setluf
	addw	#0xc,sp

TS2342:
	movw	d7,d0
	extl	d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_setdlu
_setdlu:
	link	a6,#0xfffc
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	beqs	TS1707
	tstl	d6
	blts	TS1707
	cmpl	#0x18,d6
	blts	TS1709

TS1707:
	movw	#0xfff7,0xfffe(a6)
	bras	TS1708

TS1709:
	movl	d6,-(sp)
	jsr	_close2
	addql	#4,sp
	movl	_runtcb,-(sp)
	pea	(a5)
	movl	d6,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	_runtcb,-(sp)
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	jsr	_getluf
	addql	#8,sp
	extw	d0
	extl	d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	_setluf
	addw	#0xc,sp
	movw	d6,0xfffe(a6)

TS1708:
	movw	0xfffe(a6),d0
	extl	d0
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_sluf
_sluf:
	link	a6,#0x0
	moveml	#0x700,-(sp)	| d5 d6 d7
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	jsr	_lunp
	addql	#8,sp
	tstl	d0
	beqs	TS2343
	cmpl	#0x6601,d6
	bnes	TS2344
	movl	_runtcb,-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	bras	TS2347

TS2344:
	cmpl	#0x6602,d6
	bnes	TS2345
	movl	_runtcb,-(sp)
	clrl	-(sp)

TS2347:
	movl	d7,-(sp)
	jsr	_setluf
	addw	#0xc,sp

TS2345:
	clrl	d5
	bras	TS2346

TS2343:
	moveq	#0xfffffff7,d5

TS2346:
	movl	d5,d0
	moveml	(sp)+,#0xe0	| d5 d6 d7
	unlk	a6
	rts

	.globl	_setcmsk
_setcmsk:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	0x3a8028,d7
	movw	0xa(a6),d0
	andl	#0x1ff,d0
	movw	d0,0x3a8028
	movw	d7,d0
	extl	d0
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_acmount
_acmount:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2348
	cmpb	#0xe,0x47(a5)
	beqs	TS2350

TS2348:
	moveq	#0xffffffea,d7
	bras	TS2349

TS2350:
	pea	(a5)
	jsr	_amount
	addql	#4,sp
	movl	d0,d7

TS2349:
	movl	d7,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_termin
_termin:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2356
	moveq	#0xffffffea,d7
	bras	TS2358

TS2356:
	cmpb	#0x16,0x47(a5)
	bles	TS2357
	moveq	#0xffffffcc,d7
	bras	TS2358

TS2357:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	pea	(a5)
	movb	0x47(a5),d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_tscall,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addw	#0xc,sp
	movl	d0,d7
	bles	TS2358
	clrl	d7

TS2358:
	movl	d7,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_passrq
_passrq:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x10(a6),d7
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a4
	tstl	d0
	beqs	TS2359
	tstl	0x2a(a4)
	beqs	TS2359
	btst	#4,0x28(a4)
	bnes	TS2361

TS2359:
	moveq	#0xfffffff7,d6
	bra	TS2360

TS2361:
	movl	_runtcb,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2362
	movb	0x47(a5),d0
	extw	d0
	extl	d0
	addl	d0,d0
	addl	#_fcpriv,d0
	movl	d0,a0
	cmpw	#0x1000,(a0)
	beqs	TS2363

TS2362:
	moveq	#0xffffffea,d6
	bras	TS2360

TS2363:
	cmpb	#0x12,0x47(a5)
	bles	TS2364
	moveq	#0xffffffcc,d6
	bras	TS2360

TS2364:
	btst	#3,0x4b(a5)
	beqs	TS2365
	moveq	#0xffffffcd,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	clrl	d6
	bras	TS2360

TS2365:
	tstl	d7
	beqs	TS2366
	cmpl	0x22(a5),d7
	bhis	TS2362
	tstw	0x42(a5)
	bnes	TS2362
	addl	d7,0x1e(a5)
	subl	d7,0x22(a5)

TS2366:
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	clrb	0x49(a5)
	pea	(a5)
	jsr	_clrqop
	addql	#4,sp
	movl	0x1c(a4),0x32(a5)
	pea	(a4)
	pea	(a5)
	movb	0x47(a5),d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_pscall,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#8,sp
	movl	d0,d6

TS2360:
	movl	d6,d0
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_tpasslu
_tpasslu:
	link	a6,#0x0
	moveml	#0x71c,-(sp)	| d5 d6 d7 a3 a4 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2367
	movb	0x47(a5),d0
	extw	d0
	movw	d0,d6
	cmpw	#0x1,d0
	beqs	TS2369
	cmpw	#0x3,d6
	beqs	TS2369
	cmpw	#0xa,d6
	bnes	TS2367

TS2369:
	movl	_runtcb,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a4
	tstl	d0
	bnes	TS2370

TS2367:
	moveq	#0xffffffea,d7
	bras	TS2368

TS2370:
	subqw	#1,0x26(a4)
	movl	_runtcb,-(sp)
	clrl	-(sp)
	movl	0xc(a6),-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	0x56(a5),a3
	movl	a3,d0
	beqs	TS2371
	pea	(a3)
	jsr	_getflu
	addql	#4,sp
	movl	d0,d5
	bges	TS2373

TS2371:
	pea	(a4)
	jsr	_closeop
	addql	#4,sp
	moveq	#0xffffffe8,d0
	movl	d0,-(sp)
	bras	TS2372

TS2373:
	pea	(a3)
	pea	(a4)
	movl	d5,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	d5,-(sp)

TS2372:
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	clrl	d7

TS2368:
	movl	d7,d0
	moveml	(sp)+,#0x38e0	| d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_tmkio
_tmkio:
	link	a6,#0x0
	moveq	#0xffffffcc,d0
	unlk	a6
	rts

	.globl	_stime
_stime:
	link	a6,#0x0
	jsr	_suser
	tstl	d0
	beqs	TS2374
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	0x8(a6)
	movl	_runtcb,-(sp)
	clrl	-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	jsr	_ERR_LOG
	addw	#0x14,sp
	movl	0x8(a6),_time
	clrl	d0
	bras	TS2375

TS2374:
	moveq	#0xffffffff,d0

TS2375:
	unlk	a6
	rts

	.globl	_gtime
_gtime:
	link	a6,#0xfff0
	movl	d7,-(sp)
	clrl	0xfffc(a6)
	cmpl	#0xc,0xc(a6)
	beqs	TS2376
	cmpl	#0x4,0xc(a6)
	beqs	TS2376
	btst	#0,0xb(a6)
	beqs	TS2376
	moveq	#0xffffffea,d0
	bra	TS2379

TS2376:
	clrl	-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2377
	moveq	#0xfffffff2,d0
	bras	TS2379

TS2377:
	jsr	_spl6
	movl	_time,0xfff0(a6)
	movw	_lbolt,d0
	extl	d0
	movl	d0,d7
	jsr	_spl0
	cmpl	_Hz,d7
	bles	TS2378
	subl	_Hz,d7
	addql	#1,0xfff0(a6)

TS2378:
	movl	_Timezone,0xfff4(a6)
	movw	_Stimef,0xfff8(a6)
	movl	_Hz,-(sp)
	movl	#0x3e8,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movw	d0,0xfffa(a6)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	pea	0xfff0(a6)
	jsr	_copy_out
	addw	#0xc,sp
	movl	0xfffc(a6),d0

TS2379:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_pstat
_pstat:
	link	a6,#0xff44
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),a5
	movw	0xe(a6),d7
	clrl	-(sp)
	movl	#0xa8,-(sp)
	pea	(a5)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2380
	moveq	#0xfffffff2,d0
	bra	TS2399

TS2380:
	cmpw	_oscfig,d7
	bcss	TS2381
	moveq	#0xffffffe4,d0
	bra	TS2399

TS2381:
	clrl	d0
	movw	d7,d0
	lsll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),a4
	movl	a4,d0
	bnes	TS2382
	moveq	#0xfffffffd,d0
	bra	TS2399

TS2382:
	movb	0x24(a4),d0
	extw	d0
	movw	d0,0xff58(a6)
	movw	0x22(a4),0xff5a(a6)
	movb	0x26(a4),d0
	extw	d0
	movw	d0,0xff5c(a6)
	movb	0x27(a4),d0
	extw	d0
	movw	d0,0xff5e(a6)
	movw	0x36(a4),0xff62(a6)
	movw	0x3c(a4),0xff64(a6)
	movw	0x3a(a4),0xff66(a6)
	movl	0x1e(a4),a0
	movw	0x3a(a0),0xff68(a6)
	movw	0x3e(a4),0xff6a(a6)
	movl	_time,d0
	subl	0xe4(a4),d0
	movl	d0,0xff6c(a6)
	movl	_time,d0
	subl	0xe8(a4),d0
	movl	d0,0xff70(a6)
	cmpw	#0x7c0,0x110(a4)
	bnes	TS2383
	clrl	-(sp)
	bras	TS2398

TS2383:
	clrl	d0
	movw	0x112(a4),d0
	clrl	d1
	movw	0x110(a4),d1
	subl	d1,d0
	addql	#1,d0
	movl	d0,-(sp)

TS2398:
	pea	0xff78(a6)
	bsr	_psasd
	addql	#8,sp
	tstw	0x114(a4)
	bnes	TS2384
	clrl	-(sp)
	bras	TS2397

TS2384:
	clrl	d0
	movw	0x116(a4),d0
	clrl	d1
	movw	0x114(a4),d1
	subl	d1,d0
	addql	#1,d0
	movl	d0,-(sp)

TS2397:
	pea	0xff86(a6)
	bsr	_psasd
	addql	#8,sp
	tstw	0x11c(a4)
	bnes	TS2385
	clrl	-(sp)
	bras	TS2396

TS2385:
	clrl	d0
	movw	0x11c(a4),d0
	movl	#0x7c0,d1
	subl	d0,d1
	movl	d1,-(sp)

TS2396:
	pea	0xff94(a6)
	bsr	_psasd
	addql	#8,sp
	moveq	#0x2,d0
	movl	d0,-(sp)
	pea	0xffa2(a6)
	bsr	_psasd
	addql	#8,sp
	movl	0xfe(a4),a0
	clrl	d0
	movw	0x2(a0),d0
	moveq	#0xb,d1
	lsll	d1,d0
	movl	d0,0xffa2(a6)
	movl	0x128(a4),0xffa2(a6)
	movl	0x12c(a4),0xff94(a6)
	movl	0xfe(a4),a0
	movw	0x2(a0),0xffaa(a6)
	clrw	0xff46(a6)
	movb	0x28(a4),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvsnodpo
	addql	#4,sp
	movl	d0,0xff4c(a6)
	beqs	TS2386
	movl	d0,a0
	movl	0x2(a0),0xff48(a6)
	beqs	TS2386
	movl	0xff48(a6),a0
	cmpw	#0x2,0x8(a0)
	bnes	TS2386
	tstl	0x2a(a0)
	beqs	TS2386
	movl	a0,-(sp)
	jsr	_fh_ctty
	addql	#4,sp
	movw	d0,0xff46(a6)

TS2386:
	movw	0xff46(a6),0xff60(a6)
	clrb	0xffb0(a6)
	clrb	0xffb1(a6)
	cmpb	#0x5,0x24(a4)
	beqs	TS2387
	clrl	0xff50(a6)
	moveq	#0x4,d0
	movl	d0,-(sp)
	movl	#0x3a802a,-(sp)
	pea	(a4)
	pea	0xff50(a6)
	jsr	_cpyUSU
	addw	#0x10,sp
	tstl	0xff50(a6)
	beqs	TS2387
	movl	0xff50(a6),d0
	movl	#0x3e0000,d1
	subl	d0,d1
	movl	d1,0xff54(a6)
	subql	#4,0xff54(a6)
	beqs	TS2387
	cmpl	#0x50,0xff54(a6)
	blss	TS2388
	movl	#0x50,0xff54(a6)

TS2388:
	clrl	-(sp)
	pea	(a4)
	movl	0xff54(a6),-(sp)
	pea	0xffb0(a6)
	movl	0xff50(a6),-(sp)
	jsr	_copy_uu
	addw	#0x14,sp

TS2387:
	movl	#0xa8,-(sp)
	pea	(a5)
	pea	0xff58(a6)
	jsr	_copy_out
	addw	#0xc,sp
	clrl	d0

TS2399:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_psasd
_psasd:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	clrl	(a5)
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	movl	d0,0x4(a5)
	clrw	0x8(a5)
	clrw	0xa(a5)
	clrw	0xc(a5)
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_falarm
_falarm:
	link	a6,#0xfffc
	movl	a5,-(sp)
	movl	_runtcb,a5
	jsr	_spl6
	pea	(a5)
	jsr	_aqout
	addql	#4,sp
	movw	0x3e(a5),d0
	extl	d0
	movl	d0,0xfffc(a6)
	movw	0xa(a6),0x3e(a5)
	tstw	0xa(a6)
	beqs	TS2400
	pea	(a5)
	movl	#_alarmq,-(sp)
	jsr	_addaq
	addql	#8,sp

TS2400:
	jsr	_spl0
	movl	0xfffc(a6),d0
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_defspr
_defspr:
	link	a6,#0x0
	moveq	#0xffffffcc,d0
	unlk	a6
	rts

	.globl	_setpg
_setpg:
	link	a6,#0x0
	jsr	_suser
	tstl	d0
	bnes	TS2403
	movl	_runtcb,a0
	movw	0x3c(a0),d0
	extl	d0
	cmpl	0x8(a6),d0
	bnes	TS2405

TS2403:
	movl	_runtcb,a0
	movw	0xa(a6),0x3c(a0)
	movl	0x8(a6),d0
	bras	TS2404

TS2405:
	moveq	#0xffffffea,d0

TS2404:
	unlk	a6
	rts

	.globl	_rdhireq
_rdhireq:
	link	a6,#0xffcc
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	0xc(a6),a5
	movl	0x10(a6),d7
	movl	0x14(a6),d6
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a4
	tstl	d0
	bnes	TS2406

TS2407:
	moveq	#0xffffffea,d0
	bra	TS2408

TS2406:
	tstl	d7
	blts	TS2407
	cmpl	#0x24,d7
	bgts	TS2407
	tstl	d6
	blts	TS2407
	cmpl	#0x10,d6
	bgts	TS2407
	clrl	-(sp)
	movl	d7,d0
	addl	d6,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2409
	moveq	#0xfffffff2,d0
	bras	TS2408

TS2409:
	lea	0xffcc(a6),a0
	movl	a0,a3
	lea	0xfff0(a6),a0
	movl	a0,a2
	tstl	d7
	beqs	TS2410
	pea	(a4)
	pea	(a3)
	jsr	_filireq
	addql	#8,sp
	movl	d7,-(sp)
	pea	(a5)
	pea	(a3)
	jsr	_copy_out
	addw	#0xc,sp

TS2410:
	tstl	d6
	beqs	TS2411
	pea	(a4)
	pea	(a2)
	jsr	_filhireq
	addql	#8,sp
	movl	d6,-(sp)
	movl	a5,d0
	addl	d7,d0
	movl	d0,-(sp)
	pea	(a2)
	jsr	_copy_out
	addw	#0xc,sp

TS2411:
	movl	d7,d0
	addl	d6,d0

TS2408:
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_wrhireq
_wrhireq:
	link	a6,#0xfff0
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0xc(a6),a5
	movl	0x10(a6),d7
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a4
	tstl	d0
	beqs	TS2412
	tstl	d7
	blts	TS2412
	cmpl	#0x10,d7
	bles	TS2414

TS2412:
	moveq	#0xffffffea,d0
	bras	TS2413

TS2414:
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a5)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2415
	moveq	#0xfffffff2,d0
	bras	TS2413

TS2415:
	lea	0xfff0(a6),a0
	movl	a0,a3
	movl	d7,-(sp)
	pea	(a3)
	pea	(a5)
	jsr	_copy_in
	addw	#0xc,sp
	movl	(a3),0x12(a4)
	movl	0x4(a3),0x16(a4)
	movl	0x8(a3),0x62(a4)
	movl	0xc(a3),d0
	movl	d0,0x66(a4)
	movl	d7,d0

TS2413:
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_t2urd
_t2urd:
	link	a6,#0x0
	clrl	-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_t2urw
	addw	#0x14,sp
	unlk	a6
	rts

	.globl	_t2uwr
_t2uwr:
	link	a6,#0x0
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_t2urw
	addw	#0x14,sp
	unlk	a6
	rts

	.globl	_t2urw
_t2urw:
	link	a6,#0x0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0xc(a6),a5
	movl	0x10(a6),d7
	movl	0x14(a6),d6
	movl	0x18(a6),d5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a4
	tstl	d0
	bnes	TS2289

TS2290:
	moveq	#0xffffffea,d0
	bras	TS2291

TS2289:
	cmpl	0x22(a4),d6
	bhis	TS2290
	movl	d6,d0
	addl	d7,d0
	movl	0x22(a4),d1
	cmpl	d0,d1
	bccs	TS2292
	movl	d1,d0
	subl	d6,d0
	movl	d0,d7

TS2292:
	tstl	d5
	beqs	TS2293
	movb	0x47(a4),d0
	extw	d0
	extl	d0
	addl	#_fcflag,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	btst	#0,d0
	bnes	TS2293
	moveq	#0xfffffff3,d0
	bras	TS2291

TS2293:
	movl	d5,-(sp)
	movl	d6,-(sp)
	movl	d7,-(sp)
	pea	(a5)
	pea	(a4)
	jsr	_urdwr
	addw	#0x14,sp

TS2291:
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_groinf
_groinf:
	link	a6,#0x0
	movl	a5,-(sp)
	tstl	0xc(a6)
	bnes	TS2416
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvchkrn
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2416
	movl	0x56(a5),a0
	movw	0x3c(a0),d0
	extl	d0
	bras	TS2417

TS2416:
	moveq	#0xffffffea,d0

TS2417:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_nodev
_nodev:
	link	a6,#0x0
	moveq	#0xfffffffa,d0
	unlk	a6
	rts

	.globl	_nulldev
_nulldev:
	link	a6,#0x0
	clrl	d0
	unlk	a6
	rts

	.globl	_toioch
_toioch:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	movl	0x32(a5),d7
	tstl	0xc(a6)
	bges	TS2418
	movl	0x56(a5),-(sp)
	movl	d7,-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a4
	movl	0x56(a5),-(sp)
	clrl	-(sp)
	movl	d7,-(sp)
	jsr	_setlup
	addw	#0xc,sp
	pea	(a4)
	jsr	_putnode
	addql	#4,sp
	movl	0xc(a6),0x26(a5)
	bras	TS2419

TS2418:
	movl	d7,0x26(a5)

TS2419:
	jsr	_spl6
	movl	d0,d6
	pea	(a5)
	movl	#_reqtq,-(sp)
	jsr	_addlq
	addql	#8,sp
	movb	#0x1,_iodnflg
	movl	d6,-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_iohreq
_iohreq:
	link	a6,#0x0
	moveml	#0xf1c,-(sp)	| d4 d5 d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0x10(a6),a3
	movw	0x36(a3),d0
	extl	d0
	movl	d0,d4
	movb	0x47(a5),d0
	extw	d0
	extl	d0
	movl	d0,d5
	movl	d4,0x32(a5)
	movw	d4,0x72(a5)
	movl	0x20(a4),0x2e(a5)
	movb	#0x1,0x46(a5)
	bset	#5,0x4b(a5)
	movl	d4,d0
	lsrl	#8,d0
	andl	#0x1f,d0
	movl	d0,d7
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d4,d0
	lsrl	#8,d0
	andl	#0x1f,d0
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+8,d0
	movl	d0,a0
	cmpl	#_nodev,(a0)
	beq	TS803
	cmpl	#0x4,d5
	beqs	TS807
	cmpl	#0x5,d5
	bne	TS805

TS807:
	pea	(a5)
	jsr	_pg_lock
	addql	#4,sp
	movl	d0,0x1e(a5)
	bnes	TS1054
	moveq	#0xfffffff4,d6
	bra	TS805

TS1054:
	bset	#4,0x4b(a5)
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	pea	0x4c(a5)
	jsr	_addlq
	addql	#8,sp
	movl	0x2e(a5),d0
	moveq	#0x9,d1
	asrl	d1,d0
	movl	d0,0x62(a5)
	clrl	0x66(a5)
	clrw	0x36(a5)
	movw	0x28(a5),0x6a(a5)
	movl	0x22(a5),0x26(a5)
	clrw	0x6c(a5)
	cmpl	#0x4,d5
	bnes	TS1055
	bset	#0,0x6d(a5)

TS1055:
	pea	(a5)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+8,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#4,sp
	moveq	#0xffffff80,d6
	bras	TS805

TS803:
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS804
	moveq	#0xfffffffc,d6
	bras	TS805

TS804:
	movl	d5,d0
	subl	#0x4,d0
	cmpl	#0x3,d0
	bhis	TS805
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0xe
	.word	0x50
	.word	0x8e
	.word	0x8e

TS805:
	movl	d6,d0
	bra	TS806
	clrl	0x26(a5)
	pea	(a5)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+12,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#4,sp
	movl	d0,d6
	bles	TS805
	btst	#7,0x4b(a5)
	bnes	TS4371
	addl	d6,0x20(a4)

TS4371:
	tstl	_accounting
	beqs	TS805

TS4373:
	addl	d6,0x3a8136
	bras	TS805
	clrl	0x26(a5)
	pea	(a5)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+16,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#4,sp
	movl	d0,d6
	bles	TS805
	btst	#7,0x4b(a5)
	bnes	TS4372
	addl	d6,0x20(a4)

TS4372:
	tstl	_accounting
	bnes	TS4373
	bra	TS805
	pea	(a5)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+20,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#4,sp
	movl	d0,d6
	bra	TS805

TS806:
	moveml	(sp)+,#0x38f0	| d4 d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_physio
_physio:
	link	a6,#0x0
	movl	a5,-(sp)
	jsr	_getnode
	movl	d0,a5
	tstl	d0
	bnes	TS853
	moveq	#0xffffffce,d0
	bra	TS859

TS853:
	pea	(a5)
	jsr	_inirn
	addql	#4,sp
	tstl	_accounting
	beqs	TS854
	movl	0x18(a6),d0
	moveq	#0x9,d1
	asrl	d1,d0
	addl	d0,0x3a813a

TS854:
	movb	0xb(a6),0x47(a5)
	clrw	0x6a(a5)
	movw	0xe(a6),0x72(a5)
	movl	0x10(a6),0x1e(a5)
	movl	0x18(a6),0x22(a5)
	movl	0x18(a6),0x26(a5)
	movb	#0x1,0x46(a5)
	movw	#0x20,0x4a(a5)
	movl	0x14(a6),d0
	moveq	#0x9,d1
	lsrl	d1,d0
	movl	d0,0x62(a5)
	movl	0x14(a6),0x2e(a5)
	movl	0x8(a6),d0
	andl	#0x7f,d0
	cmpl	#0x4,d0
	bnes	TS855
	movw	#0x1,0x6c(a5)

TS855:
	btst	#5,0xa(a6)
	beqs	TS856
	bset	#3,0x6c(a5)

TS856:
	movl	0x20(a6),0x1a(a5)
	movl	0x1c(a6),0x74(a5)
	bnes	TS857
	pea	(a5)
	movl	_runtcb,d0
	addl	#0x4e,d0
	movl	d0,-(sp)
	jsr	_addeq
	addql	#8,sp

TS857:
	pea	(a5)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movw	0xe(a6),d0
	extl	d0
	lsrl	#8,d0
	andl	#0x1f,d0
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+8,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#4,sp
	tstl	0x1c(a6)
	beqs	TS858
	movl	a5,d0
	bras	TS859

TS858:
	moveq	#0xffffff80,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_postreq
	addql	#8,sp

TS859:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_iohclose
_iohclose:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_iocanrq
_iocanrq:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movw	0x72(a5),d0
	extl	d0
	movl	d0,d7
	pea	(a5)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d7,d0
	lsrl	#8,d0
	andl	#0x1f,d0
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+28,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addql	#4,sp
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_iodone
_iodone:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	btst	#2,0x6d(a5)
	beqs	TS2420
	tstw	0x36(a5)
	bnes	TS2421
	movw	#0xfffb,0x36(a5)

TS2421:
	movw	0x36(a5),d0
	extl	d0
	movl	d0,0x26(a5)
	bras	TS2422

TS2420:
	movl	0x66(a5),d0
	subl	d0,0x26(a5)
	movl	0x26(a5),d0
	addl	d0,0x2e(a5)

TS2422:
	jsr	_spl6
	movl	d0,d7
	pea	(a5)
	movl	#_reqtq,-(sp)
	jsr	_addlq
	addql	#8,sp
	movb	#0x1,_iodnflg
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_ioinirn
_ioinirn:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	pea	(a5)
	jsr	_inirn
	addql	#4,sp
	movb	#0x1,0x46(a5)
	bset	#5,0x4b(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_suser
_suser:
	link	a6,#0x0
	tstw	0x3a801e
	bnes	TS1479
	moveq	#0x1,d0
	bras	TS1480

TS1479:
	clrl	d0

TS1480:
	unlk	a6
	rts

	.globl	_lunp
_lunp:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	blts	TS735
	cmpl	#0x18,d7
	blts	TS737

TS735:
	clrl	d0
	bras	TS736

TS737:
	movl	0xc(a6),d0
	addl	#0x6c,d0
	movl	d7,d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	movl	(a0),d0

TS736:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_luopnp
_luopnp:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),-(sp)
	movl	d7,-(sp)
	bsrs	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	beqs	TS1993
	cmpw	#0x2,0x8(a5)
	beqs	TS1993
	subl	a5,a5

TS1993:
	movl	a5,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_lutqnp
_lutqnp:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),d7
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	bsrs	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	beqs	TS779
	cmpw	#0x4,0x8(a5)
	beqs	TS779
	subl	a5,a5

TS779:
	movl	a5,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_lurqnp
_lurqnp:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsr	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	beqs	TS1710
	cmpw	#0x3,0x8(a5)
	beqs	TS1710
	subl	a5,a5

TS1710:
	movl	a5,d0
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_ininhea
_ininhea:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	clrl	(a5)
	clrl	0x4(a5)
	clrl	0xa(a5)
	clrl	0xe(a5)
	clrl	0x12(a5)
	clrl	0x16(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_inirn
_inirn:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	clrl	(a5)
	clrl	0x4(a5)
	clrl	0xa(a5)
	clrl	0xe(a5)
	clrl	0x12(a5)
	clrl	0x16(a5)
	movw	#0x5,0x8(a5)
	clrw	0x42(a5)
	clrl	0x1a(a5)
	clrb	0x48(a5)
	clrb	0x46(a5)
	clrw	0x4a(a5)
	movw	#0x1,0x54(a5)
	lea	0x4c(a5),a0
	movl	a0,0x4c(a5)
	movl	a0,0x50(a5)
	movl	_runtcb,0x56(a5)
	clrb	0x49(a5)
	clrl	0x5a(a5)
	clrw	0x44(a5)
	clrw	0x6c(a5)
	movw	0x3a801e,0x36(a5)
	movw	0x3a8020,0x38(a5)
	movl	DS524,0x3e(a5)
	movl	_runtcb,a0
	movw	0x3a(a0),d0
	extl	d0
	moveq	#0x10,d1
	asll	d1,d0
	orl	DS525,d0
	movl	d0,0x3a(a5)
	clrl	0x62(a5)
	clrl	0x66(a5)
	clrw	0x72(a5)
	clrl	0x5e(a5)
	clrl	0x74(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_inion
_inion:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	clrl	(a5)
	clrl	0x4(a5)
	clrl	0xa(a5)
	clrl	0xe(a5)
	clrl	0x12(a5)
	clrl	0x16(a5)
	movw	#0x2,0x8(a5)
	clrl	0x20(a5)
	clrw	0x26(a5)
	clrl	0x2a(a5)
	clrw	0x1a(a5)
	clrw	0x24(a5)
	clrl	0x32(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_genqon
_genqon:
	link	a6,#0x0
	movl	a5,-(sp)
	jsr	_getnode
	movl	d0,a5
	movl	a5,d0
	bnes	TS1703
	clrl	d0
	bras	TS1704

TS1703:
	clrl	(a5)
	clrl	0x4(a5)
	clrl	0xa(a5)
	clrl	0xe(a5)
	clrl	0x12(a5)
	clrl	0x16(a5)
	clrw	0x1a(a5)
	clrw	0x1c(a5)
	clrw	0x3c(a5)
	clrw	0x3e(a5)
	movw	#0x1,0x30(a5)
	lea	0x28(a5),a0
	movl	a0,0x28(a5)
	movl	a0,0x2c(a5)
	movw	#0x1,0x3a(a5)
	lea	0x32(a5),a0
	movl	a0,0x32(a5)
	movl	a0,0x36(a5)
	movw	#0x1,0x26(a5)
	lea	0x1e(a5),a0
	movl	a0,0x1e(a5)
	movl	a0,0x22(a5)
	movl	a5,d0

TS1704:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_getflu
_getflu:
	link	a6,#0x0
	movl	d7,-(sp)
	clrl	d7

TS1700:
	movl	0x8(a6),d0
	addl	#0x6c,d0
	movl	d7,d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	tstl	(a0)
	bnes	TS1699
	movl	d7,d0
	bras	TS1701

TS1699:
	addql	#1,d7
	cmpl	#0x18,d7
	blts	TS1700
	moveq	#0xffffffe8,d0

TS1701:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_setlup
_setlup:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0xc(a6),a5
	movl	0x10(a6),d0
	addl	#0x6c,d0
	movl	0x8(a6),d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	movl	a5,(a0)
	movl	0x10(a6),d0
	addl	#0xcc,d0
	addl	0x8(a6),d0
	movl	d0,a0
	clrb	(a0)
	movl	a5,d0
	beqs	TS1073
	movw	0x8(a5),d0
	extl	d0
	movl	d0,d7
	cmpl	#0x2,d7
	bnes	TS1074
	addqw	#1,0x26(a5)
	bras	TS1073

TS1074:
	cmpl	#0x3,d7
	beqs	TS1075
	cmpl	#0x4,d7
	bnes	TS1073

TS1075:
	addqw	#1,0x1a(a5)

TS1073:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_getluf
_getluf:
	link	a6,#0x0
	movl	0xc(a6),d0
	addl	#0xcc,d0
	addl	0x8(a6),d0
	movl	d0,a0
	movb	(a0),d0
	unlk	a6
	rts

	.globl	_setluf
_setluf:
	link	a6,#0x0
	movl	0x10(a6),d0
	addl	#0xcc,d0
	addl	0x8(a6),d0
	movl	d0,a0
	movb	0xf(a6),(a0)
	unlk	a6
	rts

	.globl	_cvchkrn
_cvchkrn:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	beqs	TS772
	cmpw	#0x5,0x8(a5)
	bnes	TS772
	cmpb	#0x1,0x46(a5)
	bnes	TS772
	movb	0x49(a5),d0
	movl	0xc(a6),a0
	movb	0x25(a0),d1
	cmpb	d1,d0
	beqs	TS774

TS772:
	clrl	d0
	bras	TS773

TS774:
	movl	a5,d0

TS773:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_clrqop
_clrqop:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0x5a(a5),a4
	movl	a4,d0
	beqs	TS1353
	clrl	0x5a(a5)
	subqw	#1,0x1c(a4)
	cmpw	#0x3,0x8(a4)
	bnes	TS1353
	tstw	0x1a(a4)
	bnes	TS1353
	tstw	0x1c(a4)
	bnes	TS1353
	pea	(a4)
	jsr	_closerq
	addql	#4,sp

TS1353:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_jointq
_jointq:
	link	a6,#0xfff4
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	clrw	0xfff4(a6)
	pea	(a4)
	jsr	_cvnodnr
	addql	#4,sp
	movw	d0,0xfff6(a6)
	movl	0x2a(a4),0xfff8(a6)
	movl	0x26(a4),0xfffc(a6)
	movw	0x4a(a5),d0
	andl	#0x200,d0
	movl	d0,-(sp)
	moveq	#0xc,d0
	movl	d0,-(sp)
	movl	0x1e(a5),-(sp)
	movl	0x56(a5),-(sp)
	pea	0xfff4(a6)
	jsr	_copysu
	addw	#0x14,sp
	pea	(a4)
	jsr	_eqout
	addql	#4,sp
	pea	(a4)
	jsr	_putnode
	addql	#4,sp
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_termreq
_termreq:
	link	a6,#0xfffc
	moveml	#0x3c,-(sp)	| a2 a3 a4 a5
	movl	0x8(a6),a5
	movb	#0x3,0x46(a5)
	movl	0xc(a6),0x26(a5)
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	tstl	0x74(a5)
	beqs	TS25
	movl	0x1a(a5),-(sp)
	pea	(a5)
	movl	0x74(a5),a0
	jsr	(a0)
	addql	#8,sp

TS1352:
	pea	(a5)
	jsr	_putnode

TS1349:
	addql	#4,sp
	bra	TS1348

TS25:
	btst	#6,0x4b(a5)
	beqs	TS26
	bclr	#6,0x4b(a5)
	movl	0x5a(a5),a4
	movl	a4,d0
	beqs	TS26
	subqw	#1,0x3c(a4)

TS26:
	btst	#4,0x4b(a5)
	beqs	TS27
	pea	(a5)
	jsr	_pg_ulock
	addql	#4,sp
	bclr	#4,0x4b(a5)

TS27:
	pea	0x4c(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	beqs	TS28
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	cmpw	#0x2,0x8(a4)
	bnes	TS1354
	movl	0x2e(a5),0x20(a4)
	bras	TS28

TS1354:
	movl	0x2e(a5),0x2e(a4)
	pea	(a4)
	movl	0x5a(a4),-(sp)
	bsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS28
	moveq	#0xfffffff7,d0
	movl	d0,-(sp)
	pea	(a4)
	bsr	_termreq
	addql	#8,sp

TS28:
	tstl	0x5a(a5)
	beqs	TS29
	pea	(a5)
	bsr	_clrqop
	addql	#4,sp

TS29:
	tstw	0x44(a5)
	beqs	TS30
	movw	0x44(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a4
	pea	(a4)
	jsr	_putnode
	addql	#4,sp
	clrw	0x44(a5)

TS30:
	tstw	0x42(a5)
	beqs	TS31
	movw	0x42(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a4
	clrw	0x42(a5)
	subqb	#1,0x48(a4)
	tstb	0x48(a4)
	bnes	TS31
	cmpb	#0x2,0x46(a4)
	bnes	TS31
	movl	0x26(a4),-(sp)
	pea	(a4)
	bsr	_termreq
	addql	#8,sp

TS31:
	tstb	0x48(a5)
	beqs	TS32
	movb	#0x2,0x46(a5)
	bra	TS1348

TS32:
	movw	0x4a(a5),d0
	andw	#0x102,d0
	beqs	TS33
	btst	#0,0x4a(a5)
	beqs	TS1351
	movl	0x56(a5),a0
	bclr	#5,0x22(a0)

TS1351:
	pea	(a5)
	jsr	_eqout
	addql	#4,sp
	bra	TS1352

TS33:
	btst	#0,0x4b(a5)
	bnes	TS34
	movl	0x56(a5),0xfffc(a6)
	pea	(a5)
	jsr	_eqout
	addql	#4,sp
	pea	(a5)
	jsr	_putnode
	addql	#4,sp
	movl	0xc(a6),-(sp)
	movl	0xfffc(a6),-(sp)
	jsr	_waikpr
	bras	TS1350

TS34:
	movl	0x1a(a5),a3
	subqw	#1,0x1c(a3)
	tstw	0x3e(a3)
	bnes	TS35
	tstw	0x1a(a3)
	bnes	TS1347
	pea	(a5)
	jsr	_eqout
	addql	#4,sp
	pea	(a5)
	jsr	_putnode
	addql	#4,sp
	pea	(a3)
	jsr	_closetq
	bra	TS1349

TS1347:
	pea	(a5)
	pea	0x28(a3)
	jsr	_addlq
	addql	#8,sp
	addqw	#1,0x3c(a3)
	bras	TS1348

TS35:
	pea	0x32(a3)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	subqw	#1,0x3e(a3)
	pea	(a5)
	pea	(a2)
	bsr	_jointq
	addql	#8,sp
	moveq	#0xc,d0
	movl	d0,-(sp)
	pea	(a2)
	bsr	_termreq

TS1350:
	addql	#8,sp

TS1348:
	moveml	(sp)+,#0x3c00	| a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_giveurn
_giveurn:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	tstw	0x42(a5)
	beqs	TS538
	movw	0x42(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a4
	subqb	#1,0x48(a4)
	clrw	0x42(a5)

TS538:
	btst	#0,0x4b(a5)
	beqs	TS539
	movl	0x1a(a5),a4
	subqw	#1,0x1c(a4)

TS539:
	btst	#4,0x4b(a5)
	beqs	TS540
	pea	(a5)
	jsr	_pg_ulock
	addql	#4,sp
	bclr	#4,0x4b(a5)

TS540:
	pea	(a5)
	jsr	_eqout
	addql	#4,sp
	pea	(a5)
	jsr	_putnode
	addql	#4,sp
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_joinrq
_joinrq:
	link	a6,#0xffdc
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movb	0x47(a4),d0
	extw	d0
	extl	d0
	movl	d0,d7
	btst	#3,0x4b(a4)
	beqs	TS648
	moveq	#0x20,d7
	bclr	#6,0x4b(a4)

TS648:
	movw	d7,0xffdc(a6)
	pea	(a4)
	jsr	_cvnodnr
	addql	#4,sp
	movw	d0,0xffde(a6)
	movl	0x32(a4),0xffe0(a6)
	movl	0x22(a4),0xffe4(a6)
	movl	0x26(a4),0xffe8(a6)
	movl	0x2e(a4),0xffec(a6)
	movw	0x36(a4),0xfff0(a6)
	movw	0x38(a4),0xfff2(a6)
	movl	_time,0xfff4(a6)
	movl	0x3e(a4),0xfffc(a6)
	movl	0x3a(a4),0xfff8(a6)
	movw	0x4a(a5),d0
	andl	#0x200,d0
	movl	d0,-(sp)
	movl	0x22(a5),-(sp)
	movl	0x1e(a5),-(sp)
	movl	0x56(a5),-(sp)
	pea	0xffdc(a6)
	jsr	_copysu
	addw	#0x14,sp
	btst	#1,0x4b(a4)
	beqs	TS649
	clrl	-(sp)
	pea	(a4)
	bsr	_termreq
	addql	#8,sp
	bras	TS650

TS649:
	movb	#0x1,0x46(a4)
	movl	0x56(a5),a3
	pea	(a4)
	pea	0x44(a3)
	jsr	_addlq
	addql	#8,sp
	movb	0x25(a3),0x49(a4)

TS650:
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_filireq
_filireq:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movb	0x47(a4),d0
	extw	d0
	movw	d0,(a5)
	pea	(a4)
	jsr	_cvnodnr
	addql	#4,sp
	movw	d0,0x2(a5)
	movl	0x32(a4),0x4(a5)
	movl	0x22(a4),0x8(a5)
	movl	0x26(a4),0xc(a5)
	movl	0x2e(a4),0x10(a5)
	movw	0x36(a4),0x14(a5)
	movw	0x38(a4),0x16(a5)
	movl	_time,0x18(a5)
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_filhireq
_filhireq:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0x12(a4),d0
	movl	d0,(a5)
	movl	0x16(a4),d0
	movl	d0,0x4(a5)
	movl	0x62(a4),d0
	movl	d0,0x8(a5)
	movl	0x66(a4),d0
	movl	d0,0xc(a5)
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_hangreq
_hangreq:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	btst	#2,0x4b(a4)
	beqs	TS639
	pea	(a4)
	jsr	_pipereq
	bras	TS720

TS642:
	movb	#0x1,0x46(a4)
	pea	(a4)
	jsr	_fh_req

TS720:
	addql	#4,sp
	bras	TS645

TS639:
	tstw	0x1a(a5)
	bnes	TS640
	clrl	d0
	bras	TS651

TS640:
	tstl	0x5a(a4)
	bnes	TS641
	movl	a5,0x5a(a4)
	addqw	#1,0x1c(a5)

TS641:
	cmpl	_fhrqp,a5
	beqs	TS642
	btst	#3,0x4b(a4)
	bnes	TS646
	clrb	0x46(a4)

TS646:
	tstw	0x3e(a5)
	bnes	TS647
	pea	(a4)
	pea	0x28(a5)
	jsr	_addlq
	addql	#8,sp
	addqw	#1,0x3c(a5)
	bras	TS645

TS647:
	pea	0x32(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a3
	pea	(a3)
	jsr	_qout
	addql	#4,sp
	subqw	#1,0x3e(a5)
	pea	(a4)
	pea	(a3)
	bsr	_joinrq
	addql	#8,sp
	movl	0x22(a3),-(sp)
	pea	(a3)
	bsr	_termreq
	addql	#8,sp

TS645:
	moveq	#0x1,d0

TS651:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_segpro
_segpro:
	link	a6,#0xffd0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),d6
	jsr	_suser
	tstl	d0
	bnes	TS2423
	moveq	#0xffffffff,d0
	bra	TS2428

TS2423:
	clrl	-(sp)
	movl	d7,-(sp)
	pea	(a5)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2424
	moveq	#0xfffffff2,d0
	bra	TS2428

TS2424:
	cmpl	#0x5,d6
	bges	TS2425
	cmpl	#0x8,d7
	beqs	TS2425
	cmpl	#0x10,d7
	bne	TS2427

TS2425:
	cmpl	#0x5,d6
	bnes	TS2426
	cmpl	#0x20,d7
	bne	TS2427

TS2426:
	movl	_runtcb,a4
	clrl	0xfff0(a6)
	clrl	0xfff4(a6)
	clrl	0xfff8(a6)
	clrl	0xfffc(a6)
	movl	d6,d0
	subl	#0x1,d0
	cmpl	#0x4,d0
	bhi	TS2427
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x3e
	.word	0x6e
	.word	0x76
	.word	0xaa
	.word	0xb4
XXXXXX:
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_pg_mapiop
	addql	#8,sp
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_pg_mapgraf
	addql	#8,sp
	movl	d7,-(sp)
	pea	(a5)
	pea	0xfff0(a6)
	jsr	_copy_out
	addw	#0xc,sp

TS4374:
	movl	d7,d0
	bra	TS2428
	bset	#4,0x22(a4)
	movl	#0xfe0000,0xfff0(a6)
	movl	#0x20000,0xfff4(a6)
	cmpl	#0x10,d7
	bnes	XXXXXX
	movl	#0x100000,0xfff8(a6)
	movl	#0x800,0xfffc(a6)
	bras	XXXXXX
	bclr	#4,0x22(a4)
	bras	XXXXXX
	bset	#3,0x22(a4)
	movl	#0x400000,0xfff0(a6)
	movl	#0x80000,0xfff4(a6)
	cmpl	#0x10,d7
	bne	XXXXXX
	movl	#0x480000,0xfff8(a6)
	movl	#0x80000,0xfffc(a6)
	bra	XXXXXX
	bclr	#3,0x22(a4)
	bra	XXXXXX
	movl	0x14(a6),-(sp)
	pea	0xffd0(a6)
	jsr	_dbpsetup
	addql	#8,sp
	movl	d7,-(sp)
	pea	(a5)
	pea	0xffd0(a6)
	jsr	_copy_out
	addw	#0xc,sp
	btst	#4,0x22(a4)
	bne	TS4374
	bset	#4,0x22(a4)
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	(a4)
	jsr	_pg_mapiop
	addql	#8,sp
	bra	TS4374

TS2427:
	moveq	#0xffffffea,d0

TS2428:
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_reqhd
_reqhd:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	pea	(a5)
	movl	0x2a(a4),-(sp)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS2429
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2429:
	moveq	#0xffffff80,d0
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_reqln
_reqln:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	_runtcb,-(sp)
	movl	0x26(a5),-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a3
	tstl	d0
	beqs	TS2430
	movw	0x1a(a3),d0
	andw	#0x3,d0
	beqs	TS2432

TS2430:
	moveq	#0xfffffff7,d0
	bras	TS2431

TS2432:
	movw	0x28(a5),0x6a(a5)
	movl	0x2a(a3),d0
	cmpl	0x2a(a4),d0
	beqs	TS2433
	movl	#0xffffffff,0x26(a5)
	bras	TS2434

TS2433:
	movl	0x1c(a3),0x26(a5)

TS2434:
	pea	(a4)
	pea	(a5)
	bsr	_reqhd
	addql	#8,sp

TS2431:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_preqln
_preqln:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0x56(a5),-(sp)
	movw	0x6a(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a3
	tstl	d0
	beqs	TS2435
	movw	0x1a(a3),d0
	andw	#0x3,d0
	beqs	TS2437

TS2435:
	moveq	#0xfffffff7,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	clrl	d0
	bras	TS2436

TS2437:
	movl	0x2a(a3),d0
	cmpl	0x2a(a4),d0
	beqs	TS2438
	movl	#0xffffffff,0x26(a5)
	bras	TS2440

TS2438:
	movl	0x1c(a3),0x26(a5)

TS2440:
	pea	(a4)
	pea	(a5)
	bsrs	_preqhd
	addql	#8,sp

TS2436:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_reqioc
_reqioc:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0x20(a4),0x2e(a5)
	pea	(a5)
	movl	0x2a(a4),-(sp)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS2441
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2441:
	moveq	#0xffffff80,d0
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_preqhd
_preqhd:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	movl	0xc(a6),a0
	movl	0x2a(a0),-(sp)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS2439
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2439:
	clrl	d0
	unlk	a6
	rts

	.globl	_treqhd
_treqhd:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_termreq
	addql	#8,sp
	clrl	d0
	unlk	a6
	rts

	.globl	_rewrhd
_rewrhd:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	btst	#3,0x25(a4)
	beqs	TS781
	btst	#5,0x1b(a4)
	bnes	TS781
	moveq	#0xffffffea,d0
	bra	TS792

TS781:
	btst	#1,0x1b(a4)
	beqs	TS782
	pea	(a4)
	pea	(a4)
	pea	(a5)
	jsr	_iohreq
	addw	#0xc,sp
	bra	TS792

TS782:
	movw	0x24(a4),d0
	extl	d0
	movl	d0,0x26(a5)
	btst	#0,0x1b(a4)
	beqs	TS783
	bset	#2,0x4b(a5)

TS783:
	cmpl	#0x10,0x22(a5)
	bccs	TS784
	cmpb	#0x5,0x47(a5)
	bnes	TS784
	btst	#3,0x1b(a4)
	beqs	TS784
	movl	_runtcb,a0
	movw	0x22(a0),d0
	btst	#13,d0
	bnes	TS784
	jsr	_getnode
	movl	d0,_stmrnp
	beqs	TS784
	movl	d0,-(sp)
	jsr	_inirn
	addql	#4,sp
	movl	a4,_stmonp
	movb	#0x1,_stmmode
	movw	#0x20,_stmspc
	movl	#0x3a814a,_stmpnt
	movl	0x22(a5),-(sp)
	movl	0x1e(a5),-(sp)
	bsr	_stmmove
	addql	#8,sp
	movl	0x22(a5),d0
	bra	TS792

TS784:
	btst	#2,0x1b(a4)
	beqs	TS785
	pea	(a5)
	movl	0x2a(a4),-(sp)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bne	TS789

TS790:
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp
	bra	TS789

TS785:
	tstl	0x3a8132
	beqs	TS786
	cmpb	#0x5,0x47(a5)
	bnes	TS786
	movl	0x20(a4),d0
	addl	0x22(a5),d0
	cmpl	0x3a8132,d0
	blss	TS786
	movl	0x20(a4),d0
	cmpl	0x3a8132,d0
	blts	TS791
	moveq	#0xffffffe5,d0
	bras	TS792

TS791:
	movl	0x3a8132,d0
	subl	0x20(a4),d0
	movl	d0,0x22(a5)

TS786:
	tstl	0x4(a4)
	bnes	TS787
	movl	0x20(a4),0x2e(a5)
	pea	(a4)
	pea	0x4c(a5)
	jsr	_addlq
	addql	#8,sp
	pea	(a5)
	movl	0x2a(a4),-(sp)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS789
	bras	TS790

TS787:
	pea	(a5)
	pea	(a4)
	jsr	_addbq
	addql	#8,sp
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	pea	0x4c(a5)
	jsr	_addlq
	addql	#8,sp
	movl	0x2a(a4),0x5a(a5)
	tstl	0x2a(a4)
	beqs	TS788
	movl	0x2a(a4),a0
	addqw	#1,0x1c(a0)

TS788:
	movb	#0x4,0x46(a5)

TS789:
	moveq	#0xffffff80,d0

TS792:
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_trewrhd
_trewrhd:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	blts	TS2442
	cmpb	#0x5,0x47(a5)
	bnes	TS2444
	btst	#3,0x29(a5)
	beqs	TS2444
	movl	0x10(a6),0x2e(a5)
	bras	TS2443

TS2444:
	addl	d7,0x2e(a5)
	bras	TS2443

TS2442:
	cmpl	#0xffffffe0,d7
	bnes	TS2443
	btst	#2,0x4b(a5)
	beqs	TS2443
	tstl	0x56(a5)
	beqs	TS2443
	moveq	#0xd,d0
	movl	d0,-(sp)
	movl	0x56(a5),-(sp)
	jsr	_psignal
	addql	#8,sp

TS2443:
	movl	d7,-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	clrl	d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_oclhd
_oclhd:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	_runtcb,-(sp)
	jsr	_getflu
	addql	#4,sp
	tstl	d0
	bges	TS2445
	moveq	#0xffffffe8,d0
	bras	TS2451

TS2445:
	btst	#0,0x1b(a4)
	beqs	TS2446
	bset	#2,0x4b(a5)

TS2446:
	cmpb	#0x3,0x47(a5)
	bnes	TS2447
	movw	0x3a8028,d0
	notw	d0
	extl	d0
	andl	d0,0x26(a5)

TS2447:
	jsr	_getnode
	movl	d0,a3
	tstl	d0
	bnes	TS2448
	moveq	#0xffffffce,d0
	bras	TS2451

TS2448:
	pea	(a3)
	jsr	_inion
	addql	#4,sp
	pea	(a3)
	jsr	_cvnodnr
	addql	#4,sp
	movw	d0,0x44(a5)
	cmpb	#0x16,0x47(a5)
	bnes	TS2449
	movl	0x20(a4),0x2e(a5)

TS2449:
	movl	0x2a(a4),a3
	pea	(a5)
	pea	(a3)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS2450
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2450:
	moveq	#0xffffff80,d0

TS2451:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_poclhd
_poclhd:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	pea	(a5)
	jsr	_clrqop
	addql	#4,sp
	movl	0xc(a6),a0
	movl	0x2a(a0),a4
	pea	(a5)
	pea	(a4)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS2452
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2452:
	clrl	d0
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_toclhd
_toclhd:
	link	a6,#0xfff4
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movl	0x10(a6),d6
	movl	0x56(a5),a2
	tstl	d7
	bges	TS2453
	cmpl	#0xffffffc8,d7
	bnes	TS2471
	clrl	d7

TS2471:
	cmpl	#0xffffffc7,d7
	bnes	TS2472
	pea	0x62(a2)
	jsr	_firstq

TS2475:
	addql	#4,sp
	movl	d0,a4
	movl	a4,d0
	beqs	TS2473
	movl	0x38(a4),d0
	cmpl	0x3a(a5),d0
	bnes	TS2474
	movl	0x3c(a4),d0
	cmpl	0x3e(a5),d0
	bnes	TS2474
	pea	(a4)
	jsr	_eqout
	addql	#4,sp
	pea	(a4)
	jsr	_qout
	addql	#4,sp
	pea	(a4)
	jsr	_putnode
	addql	#4,sp

TS2473:
	clrl	d7

TS2472:
	movl	d7,-(sp)

TS2459:
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	clrl	d0
	bra	TS2460

TS2474:
	pea	(a4)
	jsr	_nextq
	bras	TS2475

TS2453:
	movw	0x44(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a4
	clrw	0x44(a5)
	movw	0x1a(a4),d0
	andl	#0x2,d0
	movl	d0,0xfff8(a6)
	movw	0x36(a4),d0
	extl	d0
	movl	d0,0xfff4(a6)
	pea	(a4)
	jsr	_inion
	addql	#4,sp
	movw	0xfffa(a6),0x1a(a4)
	movw	0xfff6(a6),0x36(a4)
	movl	0x5a(a5),a3
	movl	d7,0x1c(a4)
	movl	d6,d0
	andl	#0x1f8,d0
	beqs	TS2454
	btst	#6,d6
	beqs	TS2467
	bset	#2,0x1b(a4)

TS2467:
	btst	#7,d6
	beqs	TS2468
	bset	#3,0x1b(a4)

TS2468:
	btst	#8,d6
	beqs	TS2469
	bset	#4,0x1b(a4)

TS2469:
	btst	#5,d6
	beqs	TS2470
	bset	#5,0x1b(a4)

TS2470:
	andl	#0xfffffe07,d6

TS2454:
	movw	d6,0x28(a4)
	cmpb	#0x12,0x47(a5)
	beqs	TS2455
	cmpb	#0x1,0x47(a5)
	bnes	TS2465
	btst	#2,0x4b(a5)
	beqs	TS2465

TS2455:
	bset	#0,0x1b(a4)
	bras	TS2456

TS2466:
	movl	a3,0x2a(a4)
	pea	(a4)
	pea	0x1e(a3)
	jsr	_addeq
	addql	#8,sp

TS2456:
	cmpb	#0x16,0x47(a5)
	bnes	TS2457
	pea	(a4)
	pea	0x62(a2)
	jsr	_addlq
	addql	#8,sp
	movl	d7,-(sp)
	bra	TS2464

TS2465:
	movl	0x3a(a5),0x38(a4)
	movl	0x3e(a5),0x3c(a4)
	movl	a3,d0
	beqs	TS2456
	tstw	0x1a(a3)
	bnes	TS2466
	pea	(a4)
	jsr	_closeop
	addql	#4,sp
	moveq	#0xfffffff7,d0
	movl	d0,-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	moveq	#0xfffffff7,d0
	bras	TS2460

TS2457:
	movl	a2,d0
	beqs	TS2458
	pea	(a2)
	jsr	_getflu
	addql	#4,sp
	movl	d0,0xfffc(a6)
	bges	TS2461

TS2458:
	pea	(a4)
	jsr	_closeop
	addql	#4,sp
	moveq	#0xffffffe8,d0
	movl	d0,-(sp)
	bra	TS2459

TS2461:
	pea	(a2)
	pea	(a4)
	movl	0xfffc(a6),-(sp)
	jsr	_setlup
	addw	#0xc,sp
	cmpb	#0x3,0x47(a5)
	bnes	TS2462
	movw	#0x302,0x24(a4)
	bras	TS2463

TS2462:
	cmpb	#0x1,0x47(a5)
	bnes	TS2463
	movl	0x26(a5),d0
	andl	#0xfffc,d0
	movl	0x26(a5),d1
	addql	#1,d1
	andl	#0x3,d1
	orl	d1,d0
	movw	d0,0x24(a4)

TS2463:
	movl	0xfffc(a6),-(sp)

TS2464:
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	moveq	#0x1,d0

TS2460:
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_mknodhd
_mknodhd:
	link	a6,#0x0
	movl	0xc(a6),a0
	movw	0x1a(a0),d0
	andw	#0x3,d0
	beqs	TS2476
	moveq	#0xffffffea,d0
	bras	TS2478

TS2476:
	movw	0x3a8028,d0
	notw	d0
	extl	d0
	movl	0x8(a6),a0
	andl	d0,0x26(a0)
	movl	0x8(a6),-(sp)
	movl	0xc(a6),a0
	movl	0x2a(a0),-(sp)
	jsr	_hangreq
	addql	#8,sp
	tstl	d0
	bnes	TS2477
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2477:
	moveq	#0xffffff80,d0

TS2478:
	unlk	a6
	rts

	.globl	_tmknod
_tmknod:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_termreq
	addql	#8,sp
	clrl	d0
	unlk	a6
	rts

	.globl	_fmount
_fmount:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsr	_oclhd
	addql	#8,sp
	unlk	a6
	rts

	.globl	_amount
_amount:
	link	a6,#0xfff8
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	pea	(a5)
	jsr	_qout
	addql	#4,sp
	movl	_runtcb,-(sp)
	jsr	_getflu
	addql	#4,sp
	movl	d0,0xfff8(a6)
	blts	TS2351
	tstl	0x56(a5)
	beqs	TS2351
	movl	0x56(a5),-(sp)
	jsr	_getflu
	addql	#4,sp
	movl	d0,0xfffc(a6)
	bges	TS2353

TS2351:
	moveq	#0xffffffe8,d0
	bra	TS2352

TS2353:
	jsr	_getnode
	movl	d0,a3
	movl	a3,d0
	bnes	TS2354
	moveq	#0xffffffce,d0
	bra	TS2352

TS2354:
	pea	(a3)
	jsr	_inion
	addql	#4,sp
	movl	_runtcb,-(sp)
	pea	(a3)
	movl	0xfff8(a6),-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movw	0x44(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,-(sp)
	jsr	_putnode
	addql	#4,sp
	clrw	0x44(a5)
	jsr	_genqon
	movl	d0,a4
	movl	a4,d0
	bnes	TS2355
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS2355:
	movw	#0x3,0x8(a4)
	movl	0x56(a5),-(sp)
	pea	(a4)
	movl	0xfffc(a6),-(sp)
	jsr	_setlup
	addw	#0xc,sp
	movl	a4,0x2a(a3)
	movl	0x26(a5),0x1c(a3)
	movw	#0x1000,0x28(a3)
	pea	(a3)
	pea	0x1e(a4)
	jsr	_addeq
	addql	#8,sp
	movl	0xfffc(a6),-(sp)
	pea	(a5)
	jsr	_termreq
	addql	#8,sp
	movl	0xfff8(a6),d0

TS2352:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_tmount
_tmount:
	link	a6,#0x0
	tstl	0xc(a6)
	blts	TS2479
	moveq	#0xffffffea,d0
	bras	TS2480

TS2479:
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_termreq
	addql	#8,sp
	clrl	d0

TS2480:
	unlk	a6
	rts

	.globl	_tdpure
_tdpure:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	moveq	#0xffffffea,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_readtq
_readtq:
	link	a6,#0x0
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	cmpl	#0xc,0x22(a5)
	bnes	TS757
	btst	#0,0x21(a5)
	beqs	TS759

TS757:
	moveq	#0xffffffea,d7
	bras	TS758

TS759:
	tstw	0x3c(a4)
	bnes	TS760
	pea	(a4)
	pea	(a5)
	bsr	_areqoq
	addql	#8,sp
	moveq	#0xffffff80,d7
	bras	TS758

TS760:
	pea	0x28(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	bnes	TS761
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS761:
	pea	(a3)
	jsr	_qout
	addql	#4,sp
	subqw	#1,0x3c(a4)
	pea	(a3)
	pea	(a5)
	jsr	_jointq
	addql	#8,sp
	moveq	#0xc,d7

TS758:
	movl	d7,d0
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_readrq
_readrq:
	link	a6,#0x0
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	cmpl	#0x24,0x22(a5)
	bhis	TS750
	tstl	0x22(a5)
	btst	#0,0x21(a5)
	beqs	TS752

TS750:
	moveq	#0xffffffea,d7
	bras	TS751

TS752:
	tstw	0x3c(a4)
	bnes	TS753
	pea	(a4)
	pea	(a5)
	bsrs	_areqoq
	addql	#8,sp
	moveq	#0xffffff80,d7
	bras	TS751

TS753:
	pea	0x28(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	bnes	TS754
	moveq	#0x10,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp

TS754:
	pea	(a3)
	jsr	_qout
	addql	#4,sp
	subqw	#1,0x3c(a4)
	pea	(a3)
	pea	(a5)
	jsr	_joinrq
	addql	#8,sp
	movl	0x22(a5),d7

TS751:
	movl	d7,d0
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_areqoq
_areqoq:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	pea	(a5)
	pea	0x32(a4)
	jsr	_addlq
	addql	#8,sp
	addqw	#1,0x3e(a4)
	movb	#0x6,0x46(a5)
	movl	a4,0x5a(a5)
	addqw	#1,0x1c(a4)
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_stmreq
_stmreq:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	_runtcb,a3
	clrb	_stmmode
	bset	#5,0x22(a3)
	movl	_stmrnp,a5
	movl	_stmonp,a4
	movb	#0x5,0x47(a5)
	movl	#0x3a814a,0x1e(a5)
	movl	_stmpnt,d0
	subl	#0x3a814a,d0
	movl	d0,0x22(a5)
	clrl	0x26(a5)
	clrl	0x2a(a5)
	orw	#0x300,0x4a(a5)
	pea	(a5)
	pea	0x4e(a3)
	jsr	_addeq
	addql	#8,sp
	movl	0x1c(a4),0x32(a5)
	pea	(a4)
	pea	(a5)
	bsr	_rewrhd
	addql	#8,sp
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_stmmove
_stmmove:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	movw	_stmspc,d0
	extl	d0
	cmpl	d0,d7
	blss	TS793
	movw	_stmspc,d0
	extl	d0
	movl	d0,d7

TS793:
	cmpl	#0x1,d7
	bnes	TS794
	pea	(a5)
	jsr	_copy_fb
	addql	#4,sp
	movl	_stmpnt,a0
	movb	d0,(a0)
	addql	#1,_stmpnt
	bras	TS802

TS794:
	movl	d7,-(sp)
	movl	_stmpnt,-(sp)
	pea	(a5)
	jsr	_copy_in
	addw	#0xc,sp
	addl	d7,_stmpnt

TS802:
	subw	d7,_stmspc
	bnes	TS801
	bsr	_stmreq

TS801:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_getnpid
_getnpid:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5

TS1822:
	addqw	#1,_mpid
	cmpw	#0x7530,_mpid
	blts	TS1818
	movw	#0x1,_mpid

TS1818:
	clrl	d7
	bras	TS1819

TS1820:
	movl	d7,d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),a5
	movl	a5,d0
	beqs	TS1821
	movw	0x3a(a5),d0
	cmpw	_mpid,d0
	beqs	TS1822
	movw	0x3c(a5),d0
	cmpw	_mpid,d0
	beqs	TS1822

TS1821:
	addql	#1,d7

TS1819:
	movw	_hproc,d0
	extl	d0
	cmpl	d0,d7
	blts	TS1820
	movw	_mpid,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_cvpidtp
_cvpidtp:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movw	0xa(a6),d7
	clrl	d6
	bras	TS2278

TS2279:
	movl	d6,d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	(a0),a5
	movl	a5,d0
	beqs	TS2280
	movw	0x3a(a5),d0
	cmpw	d7,d0
	bnes	TS2280
	movl	a5,d0
	bras	TS2281

TS2280:
	addql	#1,d6

TS2278:
	movw	_hproc,d0
	extl	d0
	cmpl	d0,d6
	blts	TS2279
	clrl	d0

TS2281:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_sixproc
_sixproc:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	_Naproc,d0
	cmpw	_oscfig,d0
	bnes	TS1803
	moveq	#0xffffffff,d0
	bras	TS1807

TS1803:
	cmpw	#0x1,_hproc
	bles	TS1804
	movw	_hproc,d0
	extl	d0
	subql	#1,d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	tstl	(a0)
	bnes	TS1804
	subqw	#1,_hproc
	bras	TS1803

TS1804:
	movw	_Naproc,d0
	cmpw	_hproc,d0
	bnes	TS1805
	movw	_hproc,d7
	addqw	#1,_hproc

TS1806:
	movw	d7,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	movl	0x8(a6),(a0)
	movw	d7,d0
	bras	TS1807

TS1805:
	clrw	d7

TS1808:
	cmpw	_hproc,d7
	bges	TS1806
	movw	d7,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	tstl	(a0)
	beqs	TS1806
	addqw	#1,d7
	bras	TS1808

TS1807:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_cixproc
_cixproc:
	link	a6,#0x0
	movl	d7,-(sp)
	movw	0xa(a6),d7
	movw	d7,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	clrl	(a0)
	movw	d7,d0
	extl	d0
	movw	_hproc,d1
	extl	d1
	subql	#1,d1
	cmpl	d1,d0
	beqs	TS1432
	bras	TS1435

TS1433:
	movw	d7,d0
	extl	d0
	asll	#2,d0
	addl	#_proc,d0
	movl	d0,a0
	tstl	(a0)
	bnes	TS1434
	subqw	#1,d7

TS1432:
	tstw	d7
	bgts	TS1433

TS1434:
	movw	d7,d0
	extl	d0
	addql	#1,d0
	movw	d0,_hproc

TS1435:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_getmess
_getmess:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	blts	TS2481
	clrl	d0
	movw	DS2483,d0
	cmpl	d0,d7
	bcss	TS2484

TS2481:
	clrl	d0
	bras	TS2482

TS2484:
	moveq	#0x32,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	_msgarray,d0
	movl	d0,a0
	tstl	0x4(a0)
	beqs	TS2481
	moveq	#0x32,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	_msgarray,d0

TS2482:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_inimsg
_inimsg:
	link	a6,#0x0
	movw	#0x1,BS1682
	movl	#_mess+2,BS1683
	movl	BS1683,BS1684
	unlk	a6
	rts

	.globl	_msgctl
_msgctl:
	link	a6,#0xffe0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	#_mess,-(sp)
	jsr	_WAIT
	addql	#4,sp
	movl	_runtcb,a4
	clrl	d5
	pea	(a4)
	movl	d7,-(sp)
	bsr	_getmess
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bne	TS2485

TS2488:
	moveq	#0xffffffea,d5
	bra	TS2489

TS2487:
	cmpl	#0x12,d0
	bnes	TS2488
	movl	#0x100,-(sp)
	pea	0x14(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2491
	moveq	#0xfffffff3,d5
	bra	TS2489

TS2491:
	moveq	#0x1e,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	pea	0x14(a5)
	jsr	_copy_out
	addw	#0xc,sp
	tstl	d0
	beq	TS2489

TS2494:
	moveq	#0xfffffff2,d5
	bra	TS2489

TS2492:
	movw	0x3a801e,d0
	cmpw	0x14(a5),d0
	beqs	TS2493
	bra	TS2496

TS2486:
	cmpl	#0x11,d0
	bnes	TS2487
	jsr	_suser
	tstl	d0
	beqs	TS2492

TS2493:
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffe2(a6)
	movl	0x10(a6),-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	bnes	TS2494
	movw	0xffee(a6),d0
	cmpw	0x20(a5),d0
	blss	TS2495
	jsr	_suser
	tstl	d0
	beqs	TS2496

TS2495:
	cmpw	#0x2000,0xffee(a6)
	bhi	TS2488
	movw	0xffe2(a6),0x14(a5)
	movw	0xffe4(a6),0x16(a5)
	clrl	d0
	movw	0xffea(a6),d0
	andl	#0x1ff,d0
	movw	d0,0x1c(a5)
	movw	0xffee(a6),0x20(a5)

TS2499:
	pea	0xa(a5)
	jsr	_wakeup
	addql	#4,sp
	bras	TS2489

TS2497:
	movw	0x3a801e,d0
	cmpw	0x14(a5),d0
	beqs	TS2498

TS2496:
	moveq	#0xffffffff,d5

TS2489:
	movl	#_mess,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d5,d0
	bras	TS2490

TS2485:
	movl	d6,d0
	cmpl	#0x10,d0
	bne	TS2486
	jsr	_suser
	tstl	d0
	beqs	TS2497

TS2498:
	movl	#0x2000,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_PG_free
	addql	#8,sp
	clrl	0x4(a5)
	bras	TS2499

TS2490:
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_msgget
_msgget:
	link	a6,#0x0
	moveml	#0x70c,-(sp)	| d5 d6 d7 a4 a5
	movl	0x8(a6),d6
	movl	0xc(a6),d7
	movl	#_mess,-(sp)
	jsr	_WAIT
	addql	#4,sp
	subl	a4,a4
	movl	_msgarray,a5

TS2511:
	movw	DS2483,d0
	mulu	#0x32,d0
	addl	_msgarray,d0
	cmpl	d0,a5
	bccs	TS2500
	tstl	0x4(a5)
	beqs	TS2508
	tstl	d6
	beqs	TS2510
	cmpl	(a5),d6
	bnes	TS2510

TS2500:
	movw	DS2483,d0
	mulu	#0x32,d0
	addl	_msgarray,d0
	cmpl	d0,a5
	bne	TS2501
	btst	#12,d7
	bnes	TS2506
	moveq	#0xfffffffe,d5
	bra	TS2504

TS2508:
	movl	a4,d0
	bnes	TS2509
	movl	a5,a4

TS2509:
	tstl	d6
	bnes	TS2510
	movw	DS2483,d0
	mulu	#0x32,d0
	addl	_msgarray,d0
	movl	d0,a5
	bras	TS2500

TS2510:
	addw	#0x32,a5
	bras	TS2511

TS2506:
	movl	a4,a5
	movl	a5,d0
	bnes	TS2507
	moveq	#0xffffffe4,d5
	bra	TS2504

TS2507:
	movl	#0x2000,-(sp)
	jsr	_PG_alloc
	addql	#4,sp
	movl	d0,d5
	ble	TS2504
	movw	#0x1,0x12(a5)
	lea	0xa(a5),a0
	movl	a0,0xa(a5)
	movl	a0,0xe(a5)
	movl	d6,(a5)
	movl	d5,0x4(a5)
	clrw	0x8(a5)
	movw	0x3a801e,0x14(a5)
	movw	0x3a801e,0x18(a5)
	movw	0x3a8020,0x16(a5)
	movw	0x3a8020,0x1a(a5)
	movl	d7,d0
	andl	#0x1ff,d0
	movw	d0,0x1c(a5)
	clrw	0x1e(a5)
	clrw	0x22(a5)
	clrw	0x24(a5)
	clrl	0x26(a5)
	clrl	0x2a(a5)
	movl	_time,0x2e(a5)
	movw	#0x2000,0x20(a5)
	moveq	#0x32,d0
	movl	d0,-(sp)
	movl	a5,d0
	subl	_msgarray,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d5
	bras	TS2504

TS2501:
	moveq	#0x32,d0
	movl	d0,-(sp)
	movl	a5,d0
	subl	_msgarray,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d5
	btst	#12,d7
	beqs	TS2502
	btst	#13,d7
	beqs	TS2502
	moveq	#0xffffffef,d5
	bras	TS2504

TS2502:
	btst	#8,d7
	beqs	TS2503
	movl	#0x100,-(sp)
	pea	0x14(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bnes	TS2505

TS2503:
	btst	#7,d7
	beqs	TS2504
	movl	#0x80,-(sp)
	pea	0x14(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2504

TS2505:
	moveq	#0xfffffff3,d5

TS2504:
	movl	#_mess,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d5,d0
	moveml	(sp)+,#0x30e0	| d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_msgsnd
_msgsnd:
	link	a6,#0xfffc
	moveml	#0x1f0c,-(sp)	| d3 d4 d5 d6 d7 a4 a5
	movl	0x8(a6),d7
	movl	0x10(a6),d6
	movl	0x14(a6),d5
	movl	#_mess,-(sp)
	jsr	_WAIT
	addql	#4,sp
	movl	_runtcb,a4
	clrl	d3
	pea	(a4)
	movl	d7,-(sp)
	bsr	_getmess
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	beqs	TS2512
	tstl	d6
	blts	TS2512
	cmpl	#0x2000,d6
	bges	TS2512
	addql	#4,d6
	clrl	-(sp)
	movl	d6,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2515
	moveq	#0xfffffff2,d3
	bras	TS2513

TS2515:
	movl	0xc(a6),-(sp)
	jsr	_copy_fl
	addql	#4,sp
	tstl	d0
	bles	TS2512
	addql	#2,d6

TS2522:
	clrl	d0
	movw	0x20(a5),d0
	cmpl	d0,d6
	blss	TS2516

TS2512:
	moveq	#0xffffffea,d3
	bras	TS2513

TS2517:
	moveq	#0xfffffff3,d3

TS2513:
	movl	#_mess,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d3,d0
	bra	TS2514

TS2516:
	movl	#0x80,-(sp)
	pea	0x14(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bnes	TS2517
	clrl	d0
	movw	0x8(a5),d0
	movl	d0,d4
	clrl	d0
	movw	0x20(a5),d0
	subl	d4,d0
	cmpl	d0,d6
	blss	TS2518
	btst	#14,d5
	beqs	TS2520
	moveq	#0xfffffff5,d3
	bras	TS2513

TS2520:
	movl	#_mess,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2521
	moveq	#0xfffffffc,d0
	bra	TS2514

TS2521:
	clrl	-(sp)
	pea	0xa(a5)
	jsr	_sleep
	addql	#8,sp
	movl	#_mess,-(sp)
	jsr	_WAIT
	addql	#4,sp
	tstl	0x4(a5)
	bne	TS2522
	moveq	#0xffffffdb,d3
	bra	TS2513

TS2518:
	movw	d6,0xfffe(a6)
	movl	_proc,-(sp)
	clrl	-(sp)
	moveq	#0x2,d0
	movl	d0,-(sp)
	movl	0x4(a5),d0
	addl	d4,d0
	movl	d0,-(sp)
	pea	0xfffe(a6)
	jsr	_copy_uu
	addw	#0x14,sp
	addql	#2,d4
	movl	_proc,-(sp)
	pea	(a4)
	movl	d6,d0
	subql	#2,d0
	movl	d0,-(sp)
	movl	0x4(a5),d0
	addl	d4,d0
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_copy_uu
	addw	#0x14,sp
	addqw	#1,0x1e(a5)
	movw	0x3a(a4),0x22(a5)
	movl	_time,0x26(a5)
	btst	#0,d6
	beqs	TS2519
	addql	#1,d6

TS2519:
	addw	d6,0x8(a5)
	pea	0xa(a5)
	jsr	_wakeup
	addql	#4,sp
	bra	TS2513

TS2514:
	moveml	(sp)+,#0x30f8	| d3 d4 d5 d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_msgrcv
_msgrcv:
	link	a6,#0xffec
	moveml	#0x1f1c,-(sp)	| d3 d4 d5 d6 d7 a3 a4 a5
	movl	0x8(a6),d7
	movl	0x10(a6),d6
	movl	0x14(a6),d5
	movl	0x18(a6),d4
	movl	#_mess,-(sp)
	jsr	_WAIT
	addql	#4,sp
	movl	_runtcb,a4
	clrl	d3
	tstl	d6
	blts	TS2523
	pea	(a4)
	movl	d7,-(sp)
	bsr	_getmess
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2525

TS2523:
	moveq	#0xffffffea,d3
	bra	TS2524

TS2525:
	addql	#4,d6
	clrl	-(sp)
	movl	d6,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2526
	moveq	#0xfffffff2,d3
	bra	TS2524

TS2526:
	movl	#0x100,-(sp)
	pea	0x14(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2527
	moveq	#0xfffffff3,d3
	bra	TS2524

TS2527:
	movl	#0x2000,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_PG_map
	addql	#8,sp
	movl	d0,a3
	clrl	0xfff0(a6)
	tstl	d5
	bnes	TS2528
	tstw	0x8(a5)
	beq	TS2534

TS2538:
	movl	a3,d0
	addl	0xfff0(a6),d0
	movl	d0,a0
	movw	(a0),d0
	extl	d0
	movl	d0,0xfff4(a6)
	subql	#2,d0
	cmpl	d0,d6
	bge	TS2539
	btst	#0,d4
	bne	TS2541
	moveq	#0xfffffff9,d3
	bra	TS2524

TS2528:
	tstl	d5
	bles	TS2529

TS2542:
	clrl	d0
	movw	0x8(a5),d0
	cmpl	0xfff0(a6),d0
	bls	TS2534
	movl	a3,d0
	addl	0xfff0(a6),d0
	movl	d0,a0
	movl	0x2(a0),0xfffc(a6)
	movl	0xfffc(a6),d0
	cmpl	d5,d0
	beqs	TS2538
	movl	a3,d0
	addl	0xfff0(a6),d0
	movl	d0,a0
	movw	(a0),d0
	extl	d0
	addl	d0,0xfff0(a6)
	btst	#0,0xfff3(a6)
	beqs	TS2542
	addql	#1,0xfff0(a6)
	bras	TS2542

TS2529:
	clrl	0xfff8(a6)
	bras	TS2530

TS2531:
	movl	a3,d0
	addl	0xfff0(a6),d0
	movl	d0,a0
	movl	0x2(a0),0xfffc(a6)
	movl	d5,d0
	negl	d0
	movl	0xfffc(a6),d1
	cmpl	d0,d1
	bgts	TS2532
	tstl	0xfff8(a6)
	beqs	TS2533
	movl	0xfff8(a6),d0
	cmpl	d1,d0
	bles	TS2532

TS2533:
	movl	0xfffc(a6),0xfff8(a6)
	movl	0xfff0(a6),0xffec(a6)

TS2532:
	movl	a3,d0
	addl	0xfff0(a6),d0
	movl	d0,a0
	movw	(a0),d0
	extl	d0
	addl	d0,0xfff0(a6)
	btst	#0,0xfff3(a6)
	beqs	TS2530
	addql	#1,0xfff0(a6)

TS2530:
	clrl	d0
	movw	0x8(a5),d0
	cmpl	0xfff0(a6),d0
	bhis	TS2531
	tstl	0xfff8(a6)
	beqs	TS2534
	movl	0xffec(a6),0xfff0(a6)
	bra	TS2538

TS2534:
	btst	#14,d4
	beqs	TS2535
	moveq	#0xffffffda,d3
	bra	TS2524

TS2535:
	movl	#_mess,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2536
	moveq	#0xfffffffc,d0
	bra	TS2537

TS2536:
	clrl	-(sp)
	pea	0xa(a5)
	jsr	_sleep
	addql	#8,sp
	movl	#_mess,-(sp)
	jsr	_WAIT
	addql	#4,sp
	tstl	0x4(a5)
	bne	TS2526
	moveq	#0xffffffdb,d3
	bra	TS2524

TS2539:
	movl	0xfff4(a6),d0
	subql	#2,d0
	movl	d0,d6

TS2541:
	tstl	d3
	bne	TS2524
	pea	(a4)
	movl	_proc,-(sp)
	movl	d6,-(sp)
	movl	0xc(a6),-(sp)
	movl	0x4(a5),d0
	addl	0xfff0(a6),d0
	addql	#2,d0
	movl	d0,-(sp)
	jsr	_copy_uu
	addw	#0x14,sp
	movl	d6,d0
	subql	#4,d0
	movl	d0,d3
	btst	#0,0xfff7(a6)
	beqs	TS2540
	addql	#1,0xfff4(a6)

TS2540:
	movw	0xfff6(a6),d0
	subw	d0,0x8(a5)
	subqw	#1,0x1e(a5)
	movw	0x3a(a4),0x24(a5)
	movl	_time,0x2a(a5)
	movl	#0x2000,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_PG_map
	addql	#8,sp
	clrl	d0
	movw	0x8(a5),d0
	subl	0xfff0(a6),d0
	movl	d0,-(sp)
	movl	a3,d0
	addl	0xfff0(a6),d0
	movl	d0,-(sp)
	movl	a3,d0
	addl	0xfff0(a6),d0
	addl	0xfff4(a6),d0
	movl	d0,-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	pea	0xa(a5)
	jsr	_wakeup
	addql	#4,sp

TS2524:
	movl	#_mess,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d3,d0

TS2537:
	moveml	(sp)+,#0x38f8	| d3 d4 d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_getsem
_getsem:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),d7
	blts	TS1497
	clrl	d0
	movw	DS1499,d0
	cmpl	d0,d7
	bcss	TS1500

TS1497:
	clrl	d0
	bras	TS1498

TS1500:
	moveq	#0x26,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	_semarray,d0
	movl	d0,a5
	tstl	0x4(a5)
	beqs	TS1497
	movl	a5,d0

TS1498:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_inisem
_inisem:
	link	a6,#0x0
	movl	a5,-(sp)
	movw	#0x1,BS1676
	movl	#_sema+2,BS1677
	movl	BS1677,BS1678
	movl	_adjarray,_freesadj
	movl	_adjarray,a5
	bras	TS1679

TS1681:
	lea	0xa(a5),a0
	movl	a0,(a5)
	addw	#0xa,a5

TS1679:
	moveq	#0xa,d0
	movl	d0,-(sp)
	clrl	d0
	movw	DS1680,d0
	subql	#1,d0
	movl	d0,-(sp)
	jsr	ulmul
	addql	#8,sp
	addl	_adjarray,d0
	cmpl	d0,a5
	bcss	TS1681
	clrl	(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_semctl
_semctl:
	link	a6,#0xffe8
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5
	movl	#_sema,-(sp)
	jsr	_WAIT
	addql	#4,sp
	movl	_runtcb,a5
	clrl	d7
	tstl	0xc(a6)
	blts	TS2543
	movl	0x8(a6),-(sp)
	bsr	_getsem
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	beqs	TS2543
	clrl	d0
	movw	0x1c(a4),d0
	movl	0xc(a6),d1
	cmpl	d0,d1
	bcss	TS2546

TS2543:
	moveq	#0xffffffea,d7
	bra	TS2544

TS2546:
	movl	0x10(a6),d0
	subl	#0x3,d0
	cmpl	#0xf,d0
	bhis	TS2543
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x0102
	.word	0x0102
	.word	0x0102
	.word	0x0102
	.word	0x0102
	.word	0x20a
	.word	0x20a
	.word	0xffde
	.word	0xffde
	.word	0xffde
	.word	0xffde
	.word	0xffde
	.word	0xffde
	.word	0xc6
	.word	0x5e
	.word	0x24

	bra	TS2544
	movl	#0x100,-(sp)
	pea	0x12(a4)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bne	TS4375
	moveq	#0x14,d0
	movl	d0,-(sp)
	movl	0x14(a6),-(sp)
	pea	0x12(a4)
	jsr	_copy_out
	addw	#0xc,sp
	tstl	d0
	beq	TS2544

TS4377:
	moveq	#0xfffffff2,d7
	bra	TS2544
	jsr	_suser
	tstl	d0
	bnes	TS4376
	movw	0x3a801e,d0
	cmpw	0x12(a4),d0
	beqs	TS4376

TS4379:
	moveq	#0xffffffff,d7
	bra	TS2544

TS4376:
	moveq	#0x14,d0
	movl	d0,-(sp)
	pea	0xffec(a6)
	movl	0x14(a6),-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	bnes	TS4377
	movw	0xffec(a6),0x12(a4)
	movw	0xffee(a6),0x14(a4)
	clrl	d0
	movw	0xfff4(a6),d0
	andl	#0x1ff,d0
	movw	d0,0x1a(a4)
	movl	_time,0x22(a4)

TS4380:
	pea	0x8(a4)
	jsr	_wakeup
	addql	#4,sp
	bras	TS2544
	jsr	_suser
	tstl	d0
	bnes	TS4378
	movw	0x3a801e,d0
	cmpw	0x12(a4),d0
	bnes	TS4379

TS4378:
	movl	#0x2000,-(sp)
	movl	0x4(a4),-(sp)
	jsr	_PG_free
	addql	#8,sp
	clrl	0x4(a4)
	moveq	#0xffffffff,d0
	movl	d0,-(sp)

TS4387:
	movl	0x8(a6),-(sp)
	bsr	_semrst
	addql	#8,sp
	bras	TS4380
	movl	#0x100,-(sp)
	pea	0x12(a4)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS4381

TS4375:
	moveq	#0xfffffff3,d7

TS2544:
	movl	#_sema,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	bra	TS2545

TS4381:
	movl	#0x2000,-(sp)
	movl	0x4(a4),-(sp)
	jsr	_PG_map
	addql	#8,sp
	movl	d0,a3
	movl	0x10(a6),d0
	subl	#0x3,d0
	cmpl	#0x4,d0
	bhis	TS2544
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x0030
	.word	0x001E
	.word	0x000C
	.word	0x0050
	.word	0x0040

	bras	TS2544
	movl	0xc(a6),d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a0
	clrl	d0
	movw	(a0),d0

TS4382:
	movl	d0,d7
	bras	TS2544
	movl	0xc(a6),d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a0
	movw	0xa(a0),d0

TS4383:
	extl	d0
	bras	TS4382
	movl	0xc(a6),d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a0
	movw	0xc(a0),d0
	bras	TS4383
	movl	0xc(a6),d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a0
	movw	0xe(a0),d0
	bras	TS4383
	clrl	-(sp)
	clrl	d0
	movw	0x1c(a4),d0
	addl	d0,d0
	movl	d0,-(sp)
	movl	0x14(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	bne	TS4375
	clrl	d6

TS4384:
	clrl	d0
	movw	0x1c(a4),d0
	cmpl	d0,d6
	bcc	TS2544
	pea	(a5)
	movl	_proc,-(sp)
	moveq	#0x2,d0
	movl	d0,-(sp)
	movl	d6,d0
	addl	d0,d0
	addl	0x14(a6),d0
	movl	d0,-(sp)
	movl	d6,d0
	asll	#4,d0
	addl	0x4(a4),d0
	movl	d0,-(sp)
	jsr	_copy_uu
	addw	#0x14,sp
	addql	#1,d6
	bras	TS4384
	movl	#0x80,-(sp)
	pea	0x12(a4)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bne	TS4375
	cmpl	#0x8,0x10(a6)
	bnes	TS4385
	cmpl	#0x7530,0x14(a6)
	bles	TS4386

TS4389:
	moveq	#0xffffffde,d7
	bra	TS2544

TS4386:
	movl	#0x2000,-(sp)
	movl	0x4(a4),-(sp)
	jsr	_PG_map
	addql	#8,sp
	movl	d0,a3
	movl	0xc(a6),d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a0
	movw	0x16(a6),(a0)
	movl	0xc(a6),-(sp)
	bra	TS4387

TS4385:
	clrl	d6
	bras	TS4388

TS4390:
	moveq	#0x2,d0
	movl	d0,-(sp)
	pea	0xffea(a6)
	movl	d6,d0
	addl	d0,d0
	addl	0x14(a6),d0
	movl	d0,-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	bne	TS4377
	cmpw	#0x7530,0xffea(a6)
	bhis	TS4389
	addql	#1,d6

TS4388:
	clrl	d0
	movw	0x1c(a4),d0
	cmpl	d0,d6
	bcss	TS4390
	clrl	d6

TS4391:
	clrl	d0
	movw	0x1c(a4),d0
	cmpl	d0,d6
	bcc	TS4380
	movl	_proc,-(sp)
	pea	(a5)
	moveq	#0x2,d0
	movl	d0,-(sp)
	movl	d6,d0
	asll	#4,d0
	addl	0x4(a4),d0
	movl	d0,-(sp)
	movl	d6,d0
	addl	d0,d0
	addl	0x14(a6),d0
	movl	d0,-(sp)
	jsr	_copy_uu
	addw	#0x14,sp
	movl	d6,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_semrst
	addql	#8,sp
	addql	#1,d6
	bras	TS4391

TS2545:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_semget
_semget:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	#_sema,-(sp)
	jsr	_WAIT
	addql	#4,sp
	subl	a4,a4
	movl	_semarray,a5

TS2561:
	movw	DS1499,d0
	mulu	#0x26,d0
	addl	_semarray,d0
	cmpl	d0,a5
	bccs	TS2547
	tstl	0x4(a5)
	beqs	TS2558
	tstl	0x8(a6)
	beqs	TS2560
	movl	0x8(a6),d0
	cmpl	(a5),d0
	bnes	TS2560

TS2547:
	movw	DS1499,d0
	mulu	#0x26,d0
	addl	_semarray,d0
	cmpl	d0,a5
	bne	TS2548
	btst	#4,0x12(a6)
	bnes	TS2555
	moveq	#0xfffffffe,d7
	bra	TS2552

TS2558:
	movl	a4,d0
	bnes	TS2559
	movl	a5,a4

TS2559:
	tstl	0x8(a6)
	bnes	TS2560
	movw	DS1499,d0
	mulu	#0x26,d0
	addl	_semarray,d0
	movl	d0,a5
	bras	TS2547

TS2560:
	addw	#0x26,a5
	bras	TS2561

TS2555:
	movl	a4,a5
	movl	a5,d0
	bnes	TS2556
	moveq	#0xffffffe4,d7
	bra	TS2552

TS2556:
	tstl	0xc(a6)
	bles	TS2554
	cmpl	#0x200,0xc(a6)
	bles	TS2557

TS2554:
	moveq	#0xffffffea,d7
	bra	TS2552

TS2557:
	movl	#0x2000,-(sp)
	jsr	_PG_alloc
	addql	#4,sp
	movl	d0,d7
	ble	TS2552
	movw	#0x1,0x10(a5)
	lea	0x8(a5),a0
	movl	a0,0x8(a5)
	movl	a0,0xc(a5)
	movl	0x8(a6),(a5)
	movl	d7,0x4(a5)
	movw	0x3a801e,0x12(a5)
	movw	0x3a801e,0x16(a5)
	movw	0x3a8020,0x14(a5)
	movw	0x3a8020,0x18(a5)
	movl	0x10(a6),d0
	andl	#0x1ff,d0
	movw	d0,0x1a(a5)
	movw	0xe(a6),0x1c(a5)
	clrl	0x1e(a5)
	movl	_time,0x22(a5)
	moveq	#0x26,d0
	movl	d0,-(sp)
	movl	a5,d0
	subl	_semarray,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d7
	bra	TS2552

TS2548:
	moveq	#0x26,d0
	movl	d0,-(sp)
	movl	a5,d0
	subl	_semarray,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d7
	tstl	0xc(a6)
	beqs	TS2549
	clrl	d0
	movw	0x1c(a5),d0
	movl	0xc(a6),d1
	cmpl	d0,d1
	bhi	TS2554

TS2549:
	btst	#4,0x12(a6)
	beqs	TS2550
	btst	#5,0x12(a6)
	beqs	TS2550
	moveq	#0xffffffef,d7
	bras	TS2552

TS2550:
	btst	#0,0x12(a6)
	beqs	TS2551
	movl	#0x100,-(sp)
	pea	0x12(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bnes	TS2553

TS2551:
	btst	#7,0x13(a6)
	beqs	TS2552
	movl	#0x80,-(sp)
	pea	0x12(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2552

TS2553:
	moveq	#0xfffffff3,d7

TS2552:
	movl	#_sema,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_semop
_semop:
	link	a6,#0x0
	tstl	0x10(a6)
	bges	TS2562
	moveq	#0xfffffff9,d0
	bras	TS2563

TS2562:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_sem_op
	addw	#0xc,sp

TS2563:
	unlk	a6
	rts

	.globl	_sem_op
_sem_op:
	link	a6,#0xff7c
	moveml	#0x73c,-(sp)	| d5 d6 d7 a2 a3 a4 a5
	movl	#_sema,-(sp)
	jsr	_WAIT
	addql	#4,sp
	movl	_runtcb,0xfffc(a6)
	clrl	d7
	movl	0x8(a6),-(sp)
	bsr	_getsem
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS1501
	moveq	#0xffffffea,d7
	bras	TS1519

TS1502:
	movl	0x10(a6),d0
	negl	d0
	movl	d0,0x10(a6)
	moveq	#0x6,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	jsr	lmul
	addql	#8,sp
	movl	d0,-(sp)
	pea	0xff7e(a6)
	movl	0xc(a6),-(sp)
	jsr	_copy_ss
	addw	#0xc,sp

TS1550:
	movl	#0x2000,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_PG_map
	addql	#8,sp
	movl	d0,a3

TS1521:
	movl	#0x100,-(sp)
	pea	0x12(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS1512
	moveq	#0xfffffff3,d7
	bras	TS1519

TS1549:
	moveq	#0xfffffff9,d7

TS1519:
	movl	#_sema,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	bra	TS1520

TS1501:
	tstl	0x10(a6)
	blts	TS1502
	cmpl	#0x15,0x10(a6)
	bgts	TS1549
	moveq	#0x6,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	jsr	lmul
	addql	#8,sp
	movl	d0,-(sp)
	pea	0xff7e(a6)
	movl	0xc(a6),-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	beqs	TS1550
	moveq	#0xfffffff2,d7
	bras	TS1519

TS1512:
	lea	0xff7e(a6),a0
	movl	a0,a4

TS1537:
	moveq	#0x6,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	jsr	lmul
	addql	#8,sp
	lea	0xff7e(a6),a0
	addl	d0,a0
	cmpl	a0,a4
	bcc	TS1513
	movw	(a4),d0
	extl	d0
	movl	d0,d5
	movw	0x2(a4),d0
	extl	d0
	movl	d0,d6
	tstl	d5
	blts	TS1531
	clrl	d0
	movw	0x1c(a5),d0
	cmpl	d0,d5
	bcss	TS1532

TS1531:
	moveq	#0xffffffe5,d7
	bra	TS1513

TS1532:
	cmpl	#0x7530,d6
	bgts	TS1533
	movl	d6,d0
	negl	d0
	cmpl	#0x7530,d0
	bgts	TS1533
	movl	d5,d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a2
	tstl	d6
	bges	TS1534
	clrl	d0
	movw	(a2),d0
	movl	d6,d1
	negl	d1
	cmpl	d1,d0
	bccs	TS1547
	btst	#6,0x4(a4)
	beqs	TS1548

TS1538:
	moveq	#0xfffffff5,d7
	bras	TS1513

TS1548:
	addqw	#1,0xc(a2)
	bras	TS1513

TS1547:
	btst	#0,0x5(a4)
	beqs	TS1536
	movl	d6,-(sp)
	movl	d5,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_semchk
	addw	#0xc,sp
	movl	d0,d7
	bnes	TS1513
	bras	TS1536

TS1534:
	tstl	d6
	bles	TS1535
	clrl	d0
	movw	(a2),d0
	addl	d6,d0
	cmpl	#0x7530,d0
	blss	TS1539

TS1533:
	moveq	#0xffffffde,d7
	bras	TS1513

TS1540:
	movl	d6,-(sp)
	movl	d5,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_semchk
	addw	#0xc,sp
	movl	d0,d7
	bnes	TS1513
	bras	TS1536

TS1535:
	tstw	(a2)
	beqs	TS1536
	btst	#6,0x4(a4)
	bnes	TS1538
	addqw	#1,0xe(a2)

TS1513:
	tstl	d7
	bges	TS1514
	bra	TS1519

TS1539:
	btst	#0,0x5(a4)
	bnes	TS1540

TS1536:
	addql	#6,a4
	bra	TS1537

TS1514:
	moveq	#0x6,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	jsr	lmul
	addql	#8,sp
	lea	0xff7e(a6),a0
	addl	d0,a0
	cmpl	a0,a4
	bnes	TS1515
	lea	0xff7e(a6),a0
	movl	a0,a4
	bras	TS1524

TS1525:
	movw	(a4),d0
	extl	d0
	asll	#4,d0
	addl	a3,d0
	movl	d0,a2
	movw	0x2(a4),d0
	addw	d0,(a2)
	movl	0xfffc(a6),a0
	movw	0x3a(a0),0xa(a2)
	btst	#0,0x5(a4)
	beqs	TS1526
	movw	0x2(a4),d0
	extl	d0
	movl	d0,-(sp)
	movw	(a4),d0
	extl	d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_semadj
	addw	#0xc,sp

TS1526:
	addql	#6,a4

TS1524:
	moveq	#0x6,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	jsr	lmul
	addql	#8,sp
	lea	0xff7e(a6),a0
	addl	d0,a0
	cmpl	a0,a4
	bcss	TS1525
	pea	0x8(a5)
	jsr	_wakeup
	addql	#4,sp
	clrl	d0
	movw	(a2),d0
	movl	d0,d7
	bra	TS1519

TS1515:
	movl	#_sema,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS1516
	moveq	#0xfffffffc,d7
	bras	TS1523

TS1516:
	clrl	-(sp)
	pea	0x8(a5)
	jsr	_sleep
	addql	#8,sp

TS1523:
	movl	#_sema,-(sp)
	jsr	_WAIT
	addql	#4,sp
	tstl	0x4(a5)
	bnes	TS1517
	moveq	#0xffffffdb,d7
	bra	TS1519

TS1517:
	movl	#0x2000,-(sp)
	movl	0x4(a5),-(sp)
	jsr	_PG_map
	addql	#8,sp
	tstl	d6
	bnes	TS1518
	subqw	#1,0xe(a2)
	bras	TS1522

TS1518:
	subqw	#1,0xc(a2)

TS1522:
	tstl	d7
	bne	TS1519
	bra	TS1521

TS1520:
	moveml	(sp)+,#0x3ce0	| d5 d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_semrst
_semrst:
	link	a6,#0x0
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	#_proc+4,a4
	bras	TS2564

TS2565:
	movl	(a4),a5
	movl	a5,d0
	beqs	TS2566
	lea	0xec(a5),a0
	movl	a0,a2
	bras	TS2567

TS2569:
	cmpl	#0xffffffff,d6
	beqs	TS2570
	clrl	d0
	movw	0x6(a3),d0
	cmpl	d6,d0
	bnes	TS2571

TS2570:
	movl	(a3),(a2)
	movl	_freesadj,(a3)
	movl	a3,_freesadj
	bras	TS2567

TS2568:
	movl	(a2),a3
	clrl	d0
	movw	0x4(a3),d0
	cmpl	d7,d0
	beqs	TS2569

TS2571:
	movl	a3,a2

TS2567:
	tstl	(a2)
	bnes	TS2568

TS2566:
	addql	#4,a4

TS2564:
	cmpl	#_nodebuf,a4
	bcss	TS2565
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_semadj
_semadj:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	_runtcb,a0
	movl	0xec(a0),a5
	bras	TS1527

TS1528:
	clrl	d0
	movw	0x4(a5),d0
	cmpl	d7,d0
	bnes	TS1529
	clrl	d0
	movw	0x6(a5),d0
	cmpl	d6,d0
	bnes	TS1529
	movw	0x12(a6),d0
	subw	d0,0x8(a5)
	bras	TS1530

TS1529:
	movl	(a5),a5

TS1527:
	movl	a5,d0
	bnes	TS1528

TS1530:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_semchk
_semchk:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	_runtcb,d0
	addl	#0xec,d0
	movl	d0,a5

TS1545:
	tstl	(a5)
	beqs	TS1541
	movl	(a5),a5
	clrl	d0
	movw	0x4(a5),d0
	cmpl	d7,d0
	bnes	TS1545
	clrl	d0
	movw	0x6(a5),d0
	cmpl	d6,d0
	bnes	TS1545
	movw	0x8(a5),d0
	extl	d0
	movl	d0,d5
	subl	0x10(a6),d5
	blts	TS1542
	cmpl	#0x7530,d5
	bles	TS1546

TS1542:
	moveq	#0xffffffde,d0
	bras	TS1543

TS1541:
	movl	0x10(a6),d0
	negl	d0
	movl	d0,d5
	blts	TS1542
	cmpl	#0x7530,d5
	bgts	TS1542
	movl	_freesadj,(a5)
	bnes	TS1544
	moveq	#0xffffffe4,d0
	bras	TS1543

TS1544:
	movl	(a5),a5
	movl	(a5),_freesadj
	clrl	(a5)
	movw	d7,0x4(a5)
	movw	d6,0x6(a5)
	clrw	0x8(a5)

TS1546:
	clrl	d0

TS1543:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_semexit
_semexit:
	link	a6,#0xfff8
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0xec(a5),a3
	bras	TS1494

TS1495:
	movl	a3,a4
	movl	(a3),a3
	tstw	0x8(a4)
	bles	TS1496
	movw	0x6(a4),0xfffa(a6)
	movw	0x8(a4),0xfffc(a6)
	movw	#0x1,0xfffe(a6)
	moveq	#0xffffffff,d0
	movl	d0,-(sp)
	pea	0xfffa(a6)
	clrl	d0
	movw	0x4(a4),d0
	movl	d0,-(sp)
	bsr	_sem_op
	addw	#0xc,sp

TS1496:
	movl	_freesadj,(a4)
	movl	a4,_freesadj

TS1494:
	movl	a3,d0
	bnes	TS1495
	clrl	0xec(a5)
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_inishm
_inishm:
	link	a6,#0x0
	movl	a5,-(sp)
	movw	#0x1,BS1685
	movl	#_shm+2,BS1686
	movl	BS1686,BS1687
	movl	_shmatarray,_freeshmat
	movl	_shmatarray,a5
	bras	TS1688

TS1690:
	lea	0xe(a5),a0
	movl	a0,(a5)
	addw	#0xe,a5

TS1688:
	moveq	#0xe,d0
	movl	d0,-(sp)
	clrl	d0
	movw	DS1689,d0
	subql	#1,d0
	movl	d0,-(sp)
	jsr	ulmul
	addql	#8,sp
	addl	_shmatarray,d0
	cmpl	d0,a5
	bcss	TS1690
	clrl	(a5)
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_getshm
_getshm:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),d7
	blts	TS2572
	clrl	d0
	movw	DS2574,d0
	cmpl	d0,d7
	bcss	TS2575

TS2572:
	clrl	d0
	bras	TS2573

TS2575:
	moveq	#0x2a,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	_shmarray,d0
	movl	d0,a5
	tstl	0x24(a5)
	beqs	TS2572
	movl	a5,d0

TS2573:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_shmctl
_shmctl:
	link	a6,#0xffe0
	moveml	#0x71c,-(sp)	| d5 d6 d7 a3 a4 a5
	movl	#_shm,-(sp)
	jsr	_WAIT
	addql	#4,sp
	clrl	d7
	movl	0x8(a6),-(sp)
	bsrs	_getshm
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bne	TS2576

TS2583:
	moveq	#0xffffffea,d7
	bras	TS2582

TS2585:
	cmpl	#0x12,d0
	bnes	TS2583
	movl	#0x100,-(sp)
	pea	(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2586
	moveq	#0xfffffff3,d7
	bras	TS2582

TS2586:
	moveq	#0x20,d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	pea	(a5)
	jsr	_copy_out
	addw	#0xc,sp
	tstl	d0
	beqs	TS2582

TS2588:
	moveq	#0xfffffff2,d7
	bras	TS2582

TS2584:
	cmpl	#0x11,d0
	bnes	TS2585
	jsr	_suser
	tstl	d0
	bnes	TS2587
	movw	0x3a801e,d0
	cmpw	(a5),d0
	beqs	TS2587

TS2579:
	moveq	#0xffffffff,d7

TS2582:
	movl	#_shm,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	bra	TS2580

TS2587:
	moveq	#0x20,d0
	movl	d0,-(sp)
	pea	0xffe0(a6)
	movl	0x10(a6),-(sp)
	jsr	_copy_in
	addw	#0xc,sp
	tstl	d0
	bnes	TS2588
	movw	0xffe0(a6),(a5)
	movw	0xffe2(a6),0x2(a5)
	clrl	d0
	movw	0xffe8(a6),d0
	andl	#0x1ff,d0
	movw	d0,0x8(a5)
	bras	TS2582

TS2577:
	cmpl	#0x2,d0
	beq	TS2578
	cmpl	#0x10,d0
	bnes	TS2584
	jsr	_suser
	tstl	d0
	bnes	TS2589
	movw	0x3a801e,d0
	cmpw	(a5),d0
	bnes	TS2579

TS2589:
	tstw	0x12(a5)
	beqs	TS2590
	movl	#_proc+4,a3
	bras	TS2591

TS2592:
	movl	(a3),a4
	movl	a4,d0
	beqs	TS2593
	tstl	0xf0(a4)
	beqs	TS2593
	pea	(a5)
	pea	(a4)
	bsr	_detach
	addql	#8,sp
	tstw	0x12(a5)
	beqs	TS2590

TS2593:
	addql	#4,a3

TS2591:
	clrl	d0
	movw	_oscfig,d0
	lsll	#2,d0
	addl	#_proc,d0
	cmpl	d0,a3
	bcss	TS2592

TS2590:
	movl	0xa(a5),-(sp)
	movl	0x24(a5),-(sp)
	jsr	_PG_free
	addql	#8,sp
	clrl	0x24(a5)
	bra	TS2582

TS2576:
	movl	0xc(a6),d0
	cmpl	#0x1,d0
	bne	TS2577

TS2578:
	jsr	_suser
	tstl	d0
	beq	TS2579
	movl	0x24(a5),d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d6
	movl	0x24(a5),d0
	addl	0xa(a5),d0
	subql	#1,d0
	moveq	#0xb,d1
	asrl	d1,d0
	movl	d0,d5
	cmpl	#0x2,0xc(a6)
	bnes	TS2581
	tstw	0x28(a5)
	beq	TS2583
	clrl	-(sp)
	movl	d5,-(sp)
	movl	d6,-(sp)
	movl	_proc,-(sp)
	jsr	_memres
	addw	#0x10,sp
	clrw	0x28(a5)
	bra	TS2582

TS2581:
	tstw	0x28(a5)
	bne	TS2582
	moveq	#0x1,d0
	movl	d0,-(sp)
	movl	d5,-(sp)
	movl	d6,-(sp)
	movl	_proc,-(sp)
	jsr	_memres
	addw	#0x10,sp
	movw	#0x1,0x28(a5)
	bra	TS2582

TS2580:
	moveml	(sp)+,#0x38e0	| d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_shmget
_shmget:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	#_shm,-(sp)
	jsr	_WAIT
	addql	#4,sp
	subl	a4,a4
	movl	_shmarray,a5

TS2607:
	movw	DS2574,d0
	mulu	#0x2a,d0
	addl	_shmarray,d0
	cmpl	d0,a5
	bccs	TS2594
	tstl	0x24(a5)
	beqs	TS2604
	tstl	0x8(a6)
	beqs	TS2606
	movl	0x8(a6),d0
	cmpl	0x20(a5),d0
	bnes	TS2606

TS2594:
	movw	DS2574,d0
	mulu	#0x2a,d0
	addl	_shmarray,d0
	cmpl	d0,a5
	bne	TS2595
	tstl	0xc(a6)
	bles	TS2596
	cmpl	#0x100000,0xc(a6)
	bles	TS2601

TS2596:
	moveq	#0xffffffea,d7
	bra	TS2597

TS2604:
	movl	a4,d0
	bnes	TS2605
	movl	a5,a4

TS2605:
	tstl	0x8(a6)
	bnes	TS2606
	movw	DS2574,d0
	mulu	#0x2a,d0
	addl	_shmarray,d0
	movl	d0,a5
	bras	TS2594

TS2606:
	addw	#0x2a,a5
	bras	TS2607

TS2601:
	btst	#4,0x12(a6)
	bnes	TS2602
	moveq	#0xfffffffe,d7
	bra	TS2597

TS2602:
	movl	a4,a5
	movl	a5,d0
	bnes	TS2603
	moveq	#0xffffffe4,d7
	bra	TS2597

TS2603:
	movl	0xc(a6),-(sp)
	jsr	_PG_alloc
	addql	#4,sp
	movl	d0,d7
	ble	TS2597
	movl	0x8(a6),0x20(a5)
	movl	d7,0x24(a5)
	movw	0x3a801e,(a5)
	movw	0x3a801e,0x4(a5)
	movw	0x3a8020,0x2(a5)
	movw	0x3a8020,0x6(a5)
	movl	0x10(a6),d0
	andl	#0x1ff,d0
	movw	d0,0x8(a5)
	movl	0xc(a6),0xa(a5)
	clrw	0xe(a5)
	movl	_runtcb,a0
	movw	0x3a(a0),0x10(a5)
	clrl	0x14(a5)
	clrl	0x18(a5)
	movl	_time,0x1c(a5)
	clrw	0x12(a5)
	moveq	#0x2a,d0
	movl	d0,-(sp)
	movl	a5,d0
	subl	_shmarray,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d7
	bras	TS2597

TS2595:
	moveq	#0x2a,d0
	movl	d0,-(sp)
	movl	a5,d0
	subl	_shmarray,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d7
	movl	0xa(a5),d0
	cmpl	0xc(a6),d0
	blt	TS2596
	btst	#4,0x12(a6)
	beqs	TS2598
	btst	#5,0x12(a6)
	beqs	TS2598
	moveq	#0xffffffef,d7
	bras	TS2597

TS2598:
	btst	#0,0x12(a6)
	beqs	TS2599
	movl	#0x100,-(sp)
	pea	(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bnes	TS2600

TS2599:
	btst	#7,0x13(a6)
	beqs	TS2597
	movl	#0x80,-(sp)
	pea	(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2597

TS2600:
	moveq	#0xfffffff3,d7

TS2597:
	movl	#_shm,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_shmat
_shmat:
	link	a6,#0x0
	moveml	#0x91c,-(sp)	| d4 d7 a3 a4 a5
	movl	#_shm,-(sp)
	jsr	_WAIT
	addql	#4,sp
	movl	_runtcb,a4
	clrl	d7
	pea	(a4)
	movl	0x8(a6),-(sp)
	bsr	_getshm
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2608
	moveq	#0xffffffea,d7
	bra	TS2610

TS2608:
	btst	#0,0x13(a6)
	bnes	TS2609
	movl	#0x100,-(sp)
	pea	(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	bnes	TS2609
	movl	#0x80,-(sp)
	pea	(a5)
	jsr	_chkaccess
	addql	#8,sp
	tstl	d0
	beqs	TS2611

TS2609:
	moveq	#0xfffffff3,d7
	bras	TS2610

TS2611:
	tstl	_freeshmat
	bnes	TS2612
	moveq	#0xffffffe8,d7
	bras	TS2610

TS2612:
	tstl	0xc(a6)
	bnes	TS2613
	clrl	d4
	bras	TS2615

TS2613:
	btst	#1,0x13(a6)
	beqs	TS2614
	movl	0xc(a6),d0
	andl	#0xffff8000,d0
	movl	d0,d4
	bras	TS2615

TS2614:
	movl	0xc(a6),d4

TS2615:
	movl	0x24(a5),-(sp)
	movl	0xa(a5),-(sp)
	movl	d4,-(sp)
	pea	(a4)
	jsr	_PG_attach
	addw	#0x10,sp
	movl	d0,d7
	bles	TS2610
	movl	_time,0x14(a5)
	movw	0x3a(a4),0xe(a5)
	addqw	#1,0x12(a5)
	movl	_freeshmat,a3
	movl	(a3),_freeshmat
	movl	0xf0(a4),(a3)
	movl	a3,0xf0(a4)
	movl	d7,0x8(a3)
	movl	a5,0x4(a3)
	clrw	0xc(a3)

TS2610:
	movl	#_shm,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	moveml	(sp)+,#0x3890	| d4 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_shmdt
_shmdt:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	#_shm,-(sp)
	jsr	_WAIT
	addql	#4,sp
	moveq	#0xffffffea,d7
	movl	_runtcb,a0
	movl	0xf0(a0),a5

TS2619:
	movl	a5,d0
	beqs	TS2616
	movl	0x8(a5),d0
	cmpl	0x8(a6),d0
	bnes	TS2618
	movl	0x4(a5),-(sp)
	movl	_runtcb,-(sp)
	bsrs	_detach
	addql	#8,sp
	clrl	d7

TS2616:
	movl	#_shm,-(sp)
	jsr	_SIGNAL
	addql	#4,sp
	movl	d7,d0
	bras	TS2617

TS2618:
	movl	(a5),a5
	bras	TS2619

TS2617:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_detach
_detach:
	link	a6,#0x0
	moveml	#0x3c,-(sp)	| a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	lea	0xf0(a5),a0
	movl	a0,a3
	subl	a2,a2
	bras	TS1426

TS1427:
	movl	(a3),a0
	movl	0x4(a0),d0
	cmpl	a4,d0
	bnes	TS1428
	movl	a0,a2
	pea	(a5)
	jsr	_pg_demap
	addql	#4,sp
	movl	0xa(a4),-(sp)
	movl	0x8(a2),-(sp)
	pea	(a5)
	jsr	_PG_detach
	addw	#0xc,sp
	movl	_time,0x18(a4)
	movw	0x3a(a5),0xe(a4)
	subqw	#1,0x12(a4)
	movl	(a2),(a3)
	movl	_freeshmat,(a2)
	movl	a2,_freeshmat
	bras	TS1431

TS1428:
	movl	(a3),a3

TS1426:
	tstl	(a3)
	bnes	TS1427

TS1431:
	moveml	(sp)+,#0x3c00	| a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_shmcopy
_shmcopy:
	link	a6,#0x0
	moveml	#0x3c,-(sp)	| a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	0xf0(a4),a3
	bras	TS1813

TS1814:
	movl	_freeshmat,a2
	movl	a2,d0
	bnes	TS1815
	pea	(a5)
	bsrs	_shmexit
	addql	#4,sp
	clrl	d0
	bras	TS1816

TS1815:
	movl	0x4(a3),a0
	addqw	#1,0x12(a0)
	movl	(a2),_freeshmat
	movl	0xf0(a5),(a2)
	movl	a2,0xf0(a5)
	movl	0x8(a3),0x8(a2)
	movl	0x4(a3),0x4(a2)
	movw	0xc(a3),0xc(a2)
	movl	(a3),a3

TS1813:
	movl	a3,d0
	bnes	TS1814
	moveq	#0x1,d0

TS1816:
	moveml	(sp)+,#0x3c00	| a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_shmexit
_shmexit:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	bras	TS1424

TS1425:
	movl	0x4(a4),-(sp)
	pea	(a5)
	bsr	_detach
	addql	#8,sp

TS1424:
	movl	0xf0(a5),a4
	movl	a4,d0
	bnes	TS1425
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_shmchk
_shmchk:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	0xc(a6),a5
	movl	0x8(a6),d0
	moveq	#0xb,d1
	asll	d1,d0
	movl	d0,d5
	movl	0x8(a5),d7
	movl	0x4(a5),a0
	movl	0xa(a0),d0
	addl	d7,d0
	bras	TS2036

TS2038:
	movl	0x8(a5),d0
	cmpl	d7,d0
	bcss	TS2039
	cmpl	d6,d0
	blss	TS2037
	movl	0x4(a5),a0
	movl	0xa(a0),d0
	addl	0x8(a5),d0

TS2036:
	movl	d0,d6
	bras	TS2037

TS2039:
	movl	0x8(a5),d7

TS2037:
	movl	(a5),a5
	movl	a5,d0
	bnes	TS2038
	tstl	0x10(a6)
	beqs	TS2040
	cmpl	d7,d5
	bcss	TS2043

TS2041:
	moveq	#0x1,d0
	bras	TS2042

TS2040:
	movl	d6,d0
	addl	#0x8000,d0
	cmpl	d0,d5
	blss	TS2041

TS2043:
	clrl	d0

TS2042:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_chkaccess
_chkaccess:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	movl	0xc(a6),d7
	jsr	_suser
	tstl	d0
	bnes	TS1506
	movw	0x3a801e,d0
	cmpw	(a5),d0
	beqs	TS1507
	cmpw	0x4(a5),d0
	bnes	TS1510

TS1507:
	clrl	d0
	movw	0x8(a5),d0
	andl	d7,d0
	beqs	TS1508
	bras	TS1506

TS1511:
	clrl	d0
	movw	0x8(a5),d0
	movl	d7,d1
	asrl	#3,d1
	andl	d1,d0
	bnes	TS1506

TS1508:
	moveq	#0x1,d0
	bras	TS1509

TS1510:
	movw	0x3a8020,d0
	cmpw	0x2(a5),d0
	beqs	TS1511
	cmpw	0x6(a5),d0
	beqs	TS1511
	clrl	d0
	movw	0x8(a5),d0
	movl	d7,d1
	asrl	#6,d1
	andl	d1,d0
	beqs	TS1508

TS1506:
	clrl	d0

TS1509:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_acct
_acct:
	link	a6,#0xffe0
	moveml	#0x300,-(sp)	| d6 d7
	jsr	_suser
	tstl	d0
	bnes	TS1481
	moveq	#0xffffffff,d0
	bra	TS1491

TS1481:
	tstl	0x8(a6)
	bnes	TS1482
	tstl	_accounting
	beq	TS1493
	movl	_accounting,a0
	subqw	#1,0x26(a0)
	movl	_accounting,-(sp)
	jsr	_closeop
	addql	#4,sp
	clrl	_accounting
	bra	TS1493

TS1482:
	tstl	_accounting
	beqs	TS1483
	moveq	#0xfffffff0,d0
	bra	TS1491

TS1483:
	moveq	#0x9,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	jsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	bges	TS1487
	movl	d7,d0
	bra	TS1491

TS1487:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffe2(a6)
	movl	d7,-(sp)
	movl	#0x406,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	cmpl	#0x1e,d0
	bnes	TS1488
	movw	0xffe6(a6),d0
	andw	#0xf000,d0
	cmpw	#0x8000,d0
	beqs	TS1492

TS1488:
	movl	d7,-(sp)
	jsr	_close
	addql	#4,sp
	moveq	#0xfffffff3,d0
	bras	TS1491

TS1492:
	movl	_runtcb,d0
	addl	#0x6c,d0
	movl	d7,d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	movl	(a0),_accounting
	movl	_accounting,a0
	bset	#2,0x1b(a0)
	movl	_runtcb,d0
	addl	#0x6c,d0
	movl	d7,d1
	asll	#2,d1
	addl	d1,d0
	movl	d0,a0
	clrl	(a0)

TS1493:
	clrl	d0

TS1491:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_itocp
_itocp:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	movl	0x8(a6),d7
	clrl	d6
	bras	TS1554

TS1555:
	addql	#1,d6
	lsrl	#3,d7

TS1554:
	movl	d7,d0
	andl	#0xffffe000,d0
	bnes	TS1555
	movl	d6,d0
	moveq	#0xd,d1
	lsll	d1,d0
	orl	d7,d0
	andl	#0xffff,d0
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_acctout
_acctout:
	link	a6,#0xffe0
	moveml	#0x3c,-(sp)	| a2 a3 a4 a5
	lea	0xffe0(a6),a0
	movl	a0,a2
	movl	_runtcb,a5
	clrb	(a2)
	jsr	_suser
	tstl	d0
	beqs	TS1551
	bset	#1,(a2)

TS1551:
	btst	#3,0x23(a5)
	beqs	TS1552
	bset	#0,(a2)

TS1552:
	movb	0xb(a6),0x1(a2)
	movw	0x3a801e,0x2(a2)
	movw	0x3a8020,0x4(a2)
	clrw	0x6(a2)
	movb	0x28(a5),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvsnodpo
	addql	#4,sp
	movl	d0,a4
	tstl	d0
	beqs	TS1553
	movl	0x2(a4),a3
	movl	a3,d0
	beqs	TS1553
	movw	0x36(a3),0x6(a2)

TS1553:
	movl	0xe8(a5),0x8(a2)
	movl	0x3a8076,-(sp)
	bsr	_itocp
	addql	#4,sp
	movw	d0,0xc(a2)
	movl	0x3a807a,-(sp)
	bsr	_itocp
	addql	#4,sp
	movw	d0,0xe(a2)
	movl	_Hz,-(sp)
	movl	_time,d0
	subl	0xe8(a5),d0
	movl	d0,-(sp)
	jsr	lmul
	addql	#8,sp
	movl	d0,-(sp)
	bsr	_itocp
	addql	#4,sp
	movw	d0,0x10(a2)
	movl	0x3a813e,-(sp)
	bsr	_itocp
	addql	#4,sp
	movw	d0,0x12(a2)
	movl	0x3a8136,-(sp)
	bsr	_itocp
	addql	#4,sp
	movw	d0,0x14(a2)
	movl	0x3a813a,-(sp)
	bsr	_itocp
	addql	#4,sp
	movw	d0,0x16(a2)
	moveq	#0x8,d0
	movl	d0,-(sp)
	pea	0x18(a2)
	movl	#0x3a8142,-(sp)
	jsr	_copy_ss
	addw	#0xc,sp
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x20,d0
	movl	d0,-(sp)
	pea	(a2)
	movl	_accounting,-(sp)
	movl	#0x1405,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	moveml	(sp)+,#0x3c00	| a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_plock
_plock:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	jsr	_suser
	tstl	d0
	bnes	TS2620
	moveq	#0xffffffff,d0
	bra	TS2624

TS2620:
	tstl	d7
	beqs	TS2621
	movl	d7,-(sp)
	jsr	_cvpidtp
	addql	#4,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2623
	moveq	#0xfffffffd,d0
	bras	TS2624

TS2621:
	movl	_runtcb,a5

TS2623:
	movw	0x22(a5),d0
	extl	d0
	movl	d0,d5
	movl	d6,d0
	cmpl	#0x4,d0
	bhis	TS2622
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x0040
	.word	0x0024
	.word	0x0010
	.word	0x004A
	.word	0x001A

	bras	TS2622
TS4393:
	clrl	d6
	bras	TS4392
	btst	#1,d5
	bnes	TS2622
	moveq	#0x2,d6
	bras	TS4392
	btst	#2,d5
	bnes	TS2622
	moveq	#0x4,d6
	bras	TS4392
	movl	d5,d0
	andl	#0x6,d0
	bnes	TS2622
	moveq	#0x6,d6

TS4392:
	movl	d6,-(sp)
	pea	(a5)
	jsr	_pg_memres
	addql	#8,sp
	clrl	d0
	bras	TS2624
	movl	d5,d0
	andl	#0x6,d0
	bnes	TS4393

TS2622:
	moveq	#0xffffffea,d0

TS2624:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_uxnice
_uxnice:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	bges	TS2625
	jsr	_suser
	tstl	d0
	bnes	TS2625
	clrl	d7

TS2625:
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d7,d0
	asll	#4,d0
	movl	d0,-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d7
	movl	d7,-(sp)
	jsr	_setpri
	addql	#4,sp
	clrl	d0
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_st1
_st1:
	link	a6,#0x0
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	unlk	a6
	rts

	.globl	_uxcop
_uxcop:
	link	a6,#0x0
	movl	d7,-(sp)
	tstl	0xc(a6)
	bnes	TS1484
	moveq	#0xfffffff2,d0
	bras	TS1486

TS1484:
	moveq	#0x17,d7
	movl	0xc(a6),-(sp)
	jsr	_copy_fb
	addql	#4,sp
	cmpl	#0x2f,d0
	bnes	TS1485
	addql	#1,0xc(a6)
	moveq	#0x15,d7

TS1485:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x10(a6),-(sp)
	movl	#0x400,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_copy_sts
	addql	#8,sp
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	movl	d7,-(sp)
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS1486:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_uxalarm
_uxalarm:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	jsr	_falarm
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxclose
_uxclose:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	jsr	_close
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxfork
_uxfork:
	link	a6,#0x0
	jsr	_ffork
	unlk	a6
	rts

	.globl	_uxgetpid
_uxgetpid:
	link	a6,#0x0
	movl	_runtcb,a0
	movl	0x1e(a0),a0
	movw	0x3a(a0),d0
	extl	d0
	movl	d0,0x3a811e
	movl	_runtcb,a0
	movw	0x3a(a0),d0
	extl	d0
	unlk	a6
	rts

	.globl	_uxsetprgp
_uxsetprgp:
	link	a6,#0x0
	tstl	0x8(a6)
	beqs	TS2626
	movl	_runtcb,a0
	movl	a0,a1
	movw	0x3a(a0),0x3c(a1)
	movw	0x3c(a1),d0
	bras	TS2627

TS2626:
	movl	_runtcb,a0
	movw	0x3c(a0),d0

TS2627:
	extl	d0
	unlk	a6
	rts

	.globl	_uxgetprgp
_uxgetprgp:
	link	a6,#0x0
	movl	_runtcb,a0
	movw	0x3c(a0),d0
	extl	d0
	unlk	a6
	rts

	.globl	_uxgetuid
_uxgetuid:
	link	a6,#0x0
	movw	0x3a801e,d0
	extl	d0
	movl	d0,0x3a811e
	movw	0x3a8022,d0
	extl	d0
	unlk	a6
	rts

	.globl	_uxgetgid
_uxgetgid:
	link	a6,#0x0
	movw	0x3a8020,d0
	extl	d0
	movl	d0,0x3a811e
	movw	0x3a8024,d0
	extl	d0
	unlk	a6
	rts

	.globl	_uxsetuid
_uxsetuid:
	link	a6,#0x0
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setuid
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxsetgid
_uxsetgid:
	link	a6,#0x0
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_setgid
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxread
_uxread:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2628

TS2630:
	moveq	#0xfffffff7,d0
	bra	TS2631

TS2628:
	cmpw	#0x2,0x8(a5)
	bne	TS2629
	btst	#2,0x29(a5)
	beqs	TS2630
	btst	#0,0x1b(a5)
	beqs	TS2632
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	pea	(a5)
	jsr	_readpipe
	bras	TS2711

TS2633:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	pea	(a5)
	jsr	_fh_read

TS2711:
	addw	#0xc,sp
	bra	TS2631

TS2632:
	movl	0x2a(a5),d0
	cmpl	_fhrqp,d0
	bne	TS2629
	btst	#1,0x1b(a5)
	beqs	TS2633
	movw	0x36(a5),d7
	movw	d7,d0
	extl	d0
	lsrl	#8,d0
	andl	#0x1f,d0
	movl	d0,d6
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+32,d0
	movl	d0,a0
	cmpl	#_nodev,(a0)
	beqs	TS2629
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2695
	moveq	#0xfffffffc,d0
	bras	TS2631

TS2695:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+32,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addw	#0xc,sp
	movl	d0,d5
	bles	TS2696
	addl	d5,0x20(a5)
	tstl	_accounting
	beqs	TS2696
	addl	d5,0x3a8136

TS2696:
	movl	d5,d0
	bras	TS2631

TS2629:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS2631:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_uxwrite
_uxwrite:
	link	a6,#0x0
	moveml	#0x704,-(sp)	| d5 d6 d7 a5
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	tstl	d0
	bnes	TS2712

TS2716:
	moveq	#0xfffffff7,d0
	bra	TS2715

TS2712:
	cmpw	#0x2,0x8(a5)
	bne	TS2713
	btst	#1,0x29(a5)
	beqs	TS2716
	btst	#0,0x1b(a5)
	beqs	TS2717
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	pea	(a5)
	jsr	_writepipe
	bras	TS2758

TS2718:
	tstl	0x3a8132
	beqs	TS2719
	movl	0x20(a5),d0
	addl	0x10(a6),d0
	cmpl	0x3a8132,d0
	blss	TS2719
	movl	0x3a8132,d0
	subl	0x20(a5),d0
	movl	d0,0x10(a6)
	bnes	TS2719
	moveq	#0xffffffe5,d0
	bra	TS2715

TS2719:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	pea	(a5)
	jsr	_fh_write

TS2758:
	addw	#0xc,sp
	bra	TS2715

TS2717:
	movl	0x2a(a5),d0
	cmpl	_fhrqp,d0
	bne	TS2713
	btst	#1,0x1b(a5)
	beqs	TS2718
	movw	0x36(a5),d7
	movw	d7,d0
	extl	d0
	lsrl	#8,d0
	andl	#0x1f,d0
	movl	d0,d6
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+36,d0
	movl	d0,a0
	cmpl	#_nodev,(a0)
	beqs	TS2713
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2741
	moveq	#0xfffffffc,d0
	bra	TS2715

TS2741:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movw	d7,d0
	extl	d0
	movl	d0,-(sp)
	moveq	#0x28,d0
	movl	d0,-(sp)
	movl	d6,-(sp)
	jsr	lmul
	addql	#8,sp
	addl	#_devtab+36,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addw	#0xc,sp
	movl	d0,d5
	bles	TS2742
	addl	d5,0x20(a5)
	tstl	_accounting
	beqs	TS2742
	addl	d5,0x3a8136

TS2742:
	movl	d5,d0
	bras	TS2715

TS2713:
	tstb	_stmmode
	beqs	TS2714
	cmpl	_stmonp,a5
	bnes	TS2714
	movw	_stmspc,d0
	extl	d0
	movl	0x10(a6),d1
	cmpl	d0,d1
	bhis	TS2714
	movl	d1,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_stmmove
	addql	#8,sp
	movl	0x10(a6),d0
	bras	TS2715

TS2714:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x5,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS2715:
	moveml	(sp)+,#0x20e0	| d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_uxdup
_uxdup:
	link	a6,#0x0
	cmpl	#0x40,0x8(a6)
	blts	TS2759
	movl	0xc(a6),-(sp)
	movl	0x8(a6),d0
	andl	#0x3f,d0
	movl	d0,-(sp)
	jsr	_setdlu
	addql	#8,sp
	bras	TS2760

TS2759:
	movl	0x8(a6),-(sp)
	jsr	_duplu
	addql	#4,sp

TS2760:
	unlk	a6
	rts

	.globl	_uxfcntl
_uxfcntl:
	link	a6,#0x0
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_ffcntl
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxkill
_uxkill:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_kill
	addql	#8,sp
	unlk	a6
	rts

	.globl	_uxsignal
_uxsignal:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_ssignal
	addql	#8,sp
	unlk	a6
	rts

	.globl	_uxwait
_uxwait:
	link	a6,#0xfff8
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	0xfffc(a6)
	clrl	-(sp)
	movl	#0x419,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,0xfff8(a6)
	movl	0xfffc(a6),0x3a811e
	unlk	a6
	rts

	.globl	_uxpause
_uxpause:
	link	a6,#0x0
	moveq	#0x1a,d0
	movl	d0,-(sp)
	bsr	_st1
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxtrace
_uxtrace:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	jsr	_cvpidtp
	addql	#4,sp
	cmpl	_runtcb,d0
	bnes	TS2761
	cmpl	#0x4,0x8(a6)
	bnes	TS2762
	movl	0x14(a6),-(sp)
	movl	0x10(a6),-(sp)
	jsr	_pg_wrtrc
	addql	#8,sp
	tstl	d0
	bnes	TS2764

TS2762:
	moveq	#0xfffffffb,d0
	bras	TS2763

TS2764:
	clrl	d0
	bras	TS2763

TS2761:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	movl	0x14(a6),d0
	movl	d0,-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	moveq	#0x1b,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS2763:
	unlk	a6
	rts

	.globl	_uxstime
_uxstime:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	jsr	_stime
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxtime
_uxtime:
	link	a6,#0x0
	movl	_time,d0
	unlk	a6
	rts

	.globl	_uxftime
_uxftime:
	link	a6,#0xfff4
	movl	d7,-(sp)
	jsr	_spl7
	movl	_time,0xfff6(a6)
	movw	_lbolt,d0
	extl	d0
	movl	d0,d7
	jsr	_spl0
	cmpl	_Hz,d7
	blss	TS2765
	subl	_Hz,d7
	addql	#1,0xfff6(a6)

TS2765:
	movl	_Hz,-(sp)
	movl	#0x3e8,-(sp)
	movl	d7,-(sp)
	jsr	ulmul
	addql	#8,sp
	movl	d0,-(sp)
	jsr	uldiv
	addql	#8,sp
	movw	d0,0xfffa(a6)
	moveq	#0x3c,d0
	movl	d0,-(sp)
	movl	_Timezone,-(sp)
	jsr	ldiv
	addql	#8,sp
	movw	d0,0xfffc(a6)
	movw	_Dstflag+2,0xfffe(a6)
	clrl	-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2767
	moveq	#0xfffffff2,d0
	bras	TS2768

TS2767:
	moveq	#0xa,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	pea	0xfff6(a6)
	jsr	_copy_out
	addw	#0xc,sp
	clrl	d0

TS2768:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_uxtimes
_uxtimes:
	link	a6,#0xfff0
	clrl	-(sp)
	moveq	#0x10,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2769
	moveq	#0xfffffff2,d0
	bras	TS2770

TS2769:
	movl	0x3a8076,0xfff0(a6)
	movl	0x3a807a,0xfff4(a6)
	movl	0x3a807e,0xfff8(a6)
	movl	0x3a8082,0xfffc(a6)
	moveq	#0x10,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	pea	0xfff0(a6)
	jsr	_copy_out
	addw	#0xc,sp
	movl	_clockticks,d0

TS2770:
	unlk	a6
	rts

	.globl	_uxumask
_uxumask:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	jsr	_setcmsk
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxprofil
_uxprofil:
	link	a6,#0x0
	movl	0x8(a6),0x3a810e
	movl	0xc(a6),0x3a8112
	movl	0x10(a6),0x3a8116
	movl	0x14(a6),0x3a811a
	cmpl	#0x1,0x14(a6)
	blss	TS2771
	movb	#0x1,0x3a8123
	bras	TS2772

TS2771:
	clrb	0x3a8123

TS2772:
	clrl	d0
	unlk	a6
	rts

	.globl	_uxpipe
_uxpipe:
	link	a6,#0xfff8
	moveq	#0x12,d0
	movl	d0,-(sp)
	bsr	_st1
	addql	#4,sp
	movl	d0,0xfffc(a6)
	blts	TS2773
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d0,-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,0xfff8(a6)
	bges	TS2774
	movl	0xfffc(a6),-(sp)
	jsr	_close
	addql	#4,sp
	bras	TS2775

TS2774:
	movl	0xfffc(a6),0x3a811e

TS2775:
	movl	0xfff8(a6),d0

TS2773:
	unlk	a6
	rts

	.globl	_uxexit
_uxexit:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	jsr	_fexit
	addql	#4,sp
	unlk	a6
	rts

	.globl	_uxlseek
_uxlseek:
	link	a6,#0xfffc
	cmpl	#0x2,0x10(a6)
	beqs	TS2776
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	bras	TS2778

TS2776:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,0xfffc(a6)
	blts	TS2777
	clrl	-(sp)
	addl	0xc(a6),d0
	movl	d0,-(sp)

TS2778:
	movl	0x8(a6),-(sp)
	jsr	_seek
	addw	#0xc,sp
	movl	d0,0xfffc(a6)

TS2777:
	movl	0xfffc(a6),d0
	unlk	a6
	rts

	.globl	_uxopen
_uxopen:
	link	a6,#0x0
	btst	#0,0xe(a6)
	bnes	TS2779
	clrl	0x10(a6)

TS2779:
	movl	0x10(a6),d0
	moveq	#0x10,d1
	lsll	d1,d0
	movl	0xc(a6),d1
	andl	#0xffff,d1
	orl	d0,d1
	movl	d1,-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxcreate
_uxcreate:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x3,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	cmpl	#0xffffffe6,d0
	bnes	TS2780
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x3,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	bras	TS2781

TS2780:
	movl	d7,d0

TS2781:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_uxmknod
_uxmknod:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xf,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxunlink
_uxunlink:
	link	a6,#0x0
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x8,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxstat
_uxstat:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	bges	TS2782
	movl	d7,d0
	bras	TS2786

TS2782:
	movl	0xc(a6),-(sp)
	movl	d7,-(sp)
	bsrs	_uxfstat
	addql	#8,sp
	movl	d0,d6
	movl	d7,-(sp)
	jsr	_close
	addql	#4,sp
	movl	d6,d0

TS2786:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_uxfstat
_uxfstat:
	link	a6,#0xffe0
	movl	a5,-(sp)
	movl	_runtcb,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_lunp
	addql	#8,sp
	movl	d0,a5
	movl	a5,d0
	bnes	TS2783
	moveq	#0xfffffff7,d0
	bras	TS2785

TS2783:
	movl	0x2a(a5),d0
	cmpl	_fhrqp,d0
	bnes	TS2784
	pea	0xffe2(a6)
	movl	0x1c(a5),-(sp)
	jsr	_fh_fstat
	addql	#8,sp
	moveq	#0x1e,d0
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	pea	0xffe2(a6)
	jsr	_copy_out
	addw	#0xc,sp
	moveq	#0x1e,d0
	bras	TS2785

TS2784:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS2785:
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_uxustat
_uxustat:
	link	a6,#0x0
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movw	0xa(a6),d0
	extl	d0
	moveq	#0x10,d1
	asll	d1,d0
	orl	#0x11,d0
	movl	d0,-(sp)
	moveq	#0x12,d0
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	moveq	#0x15,d0
	movl	d0,-(sp)
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	unlk	a6
	rts

	.globl	_uxuname
_uxuname:
	link	a6,#0x0
	moveq	#0x2c,d0
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_funame
	addql	#8,sp
	unlk	a6
	rts

	.globl	_uxchmod
_uxchmod:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xb,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxchown
_uxchown:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x10(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xd,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	bges	TS2787
	movl	d7,d0
	bras	TS2788

TS2787:
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xc,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp

TS2788:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_uxchdir
_uxchdir:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	moveq	#0x17,d0
	movl	d0,-(sp)
	bsrs	_uxcdir
	addql	#8,sp
	unlk	a6
	rts

	.globl	_uxchroot
_uxchroot:
	link	a6,#0x0
	jsr	_suser
	tstl	d0
	beqs	TS2795
	movl	0x8(a6),-(sp)
	moveq	#0x15,d0
	movl	d0,-(sp)
	bsrs	_uxcdir
	addql	#8,sp
	bras	TS2796

TS2795:
	moveq	#0xffffffff,d0

TS2796:
	unlk	a6
	rts

	.globl	_uxcdir
_uxcdir:
	link	a6,#0xffe0
	moveml	#0x304,-(sp)	| d6 d7 a5
	clrl	-(sp)
	movl	0xc(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	bges	TS2789
	movl	d7,d0
	bras	TS2793

TS2789:
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a5
	btst	#4,0x28(a5)
	bnes	TS2790
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffe2(a6)
	movl	d7,-(sp)
	movl	#0x406,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	tstl	d0
	blts	TS2791
	btst	#6,0xffe6(a6)
	beqs	TS2794

TS2791:
	moveq	#0xfffffff3,d6
	bras	TS2792

TS2794:
	moveq	#0xffffffec,d6

TS2792:
	movl	d7,-(sp)
	jsr	_close
	addql	#4,sp
	movl	d6,d0
	bras	TS2793

TS2790:
	movl	0x8(a6),-(sp)
	movl	d7,-(sp)
	jsr	_setdlu
	addql	#8,sp
	movl	d7,-(sp)
	jsr	_close
	addql	#4,sp
	clrl	d0

TS2793:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_uxutime
_uxutime:
	link	a6,#0xfff8
	moveml	#0x300,-(sp)	| d6 d7
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	bges	TS2797
	movl	d7,d0
	bras	TS2800

TS2797:
	tstl	0xc(a6)
	bnes	TS2798
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x5,d0
	movl	d0,-(sp)
	clrl	-(sp)
	pea	0xfff8(a6)
	movl	d7,-(sp)
	movl	#0x407,-(sp)
	bras	TS2799

TS2798:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x5,d0
	movl	d0,-(sp)
	moveq	#0x8,d0
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	movl	d7,-(sp)
	moveq	#0x7,d0
	movl	d0,-(sp)

TS2799:
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	movl	d7,-(sp)
	jsr	_close
	addql	#4,sp
	movl	d6,d0

TS2800:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_uxaccess
_uxaccess:
	link	a6,#0xffd8
	movl	d7,-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,0xffde(a6)
	blt	TS2801
	tstw	0x3a8022
	beq	TS2802
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffe2(a6)
	movl	0xffde(a6),-(sp)
	movl	#0x406,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,0xffda(a6)
	bges	TS2803
	movl	0xffde(a6),-(sp)
	jsr	_close
	addql	#4,sp
	movl	0xffda(a6),d0
	bras	TS2801

TS2803:
	clrl	d0
	movw	0xffe6(a6),d0
	movl	d0,d7
	andl	#0x7,0xc(a6)
	movl	d7,d0
	andl	0xc(a6),d0
	cmpl	0xc(a6),d0
	beqs	TS2802
	movw	0xffec(a6),d0
	cmpw	0x3a8024,d0
	bnes	TS2804
	movl	d7,d0
	asrl	#3,d0
	andl	0xc(a6),d0
	cmpl	0xc(a6),d0
	beqs	TS2802

TS2804:
	movw	0xffea(a6),d0
	cmpw	0x3a8022,d0
	bnes	TS2805
	movl	d7,d0
	asrl	#6,d0
	andl	0xc(a6),d0
	cmpl	0xc(a6),d0
	beqs	TS2802

TS2805:
	movl	0xffde(a6),-(sp)
	jsr	_close
	addql	#4,sp
	moveq	#0xfffffff3,d0
	bras	TS2801

TS2802:
	movl	0xffde(a6),-(sp)
	jsr	_close
	addql	#4,sp
	clrl	d0

TS2801:
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_uxlink
_uxlink:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d6
	bges	TS2806
	movl	d6,d0
	bras	TS2807

TS2806:
	movl	d6,-(sp)
	movl	0xc(a6),-(sp)
	moveq	#0x9,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,d7
	movl	d6,-(sp)
	jsr	_close
	addql	#4,sp
	movl	d7,d0

TS2807:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_uxexec
_uxexec:
	link	a6,#0x0
	clrl	-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_uxexece
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxexece
_uxexece:
	link	a6,#0x0
	moveml	#0x300,-(sp)	| d6 d7
	tstl	0x8(a6)
	bnes	TS2808
	moveq	#0xfffffff2,d0
	bras	TS2812

TS2808:
	moveq	#0x17,d7
	movl	0x8(a6),-(sp)
	jsr	_copy_fb
	addql	#4,sp
	cmpl	#0x2f,d0
	bnes	TS2809
	addql	#1,0x8(a6)
	moveq	#0x15,d7

TS2809:
	clrl	-(sp)
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	#0x400,-(sp)
	movl	0x8(a6),-(sp)
	jsr	_copy_sts
	addql	#8,sp
	movl	d0,-(sp)
	movl	0x8(a6),-(sp)
	movl	d7,-(sp)
	jsr	_fexec
	addw	#0x18,sp
	movl	d0,d6
	blts	TS2810
	movl	0x3a801a,-(sp)
	jsr	_execstk
	addql	#4,sp

TS2810:
	movl	d6,d0

TS2812:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_uxbreak
_uxbreak:
	link	a6,#0x0
	clrl	-(sp)
	jsr	_sbreak
	addql	#4,sp
	movl	0x8(a6),d1
	subl	d0,d1
	movl	d1,-(sp)
	jsr	_sbreak
	addql	#4,sp
	tstl	d0
	bges	TS2813
	moveq	#0xfffffff4,d0
	bras	TS2814

TS2813:
	clrl	d0

TS2814:
	unlk	a6
	rts

	.globl	_uxstty
_uxstty:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	#0x7409,-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_uxioctl
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxgtty
_uxgtty:
	link	a6,#0x0
	movl	0xc(a6),-(sp)
	movl	#0x7408,-(sp)
	movl	0x8(a6),-(sp)
	bsrs	_uxioctl
	addw	#0xc,sp
	unlk	a6
	rts

	.globl	_uxioctl
_uxioctl:
	link	a6,#0xfff4
	moveml	#0xf04,-(sp)	| d4 d5 d6 d7 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	#0x6,0xfff6(a6)
	cmpl	#0x6601,d6
	beqs	TS2815
	cmpl	#0x6602,d6
	bnes	TS2817

TS2815:
	movl	d6,-(sp)
	movl	d7,-(sp)
	jsr	_sluf
	addql	#8,sp
	bra	TS2816

TS2817:
	clrl	d5
	cmpl	#0x10,d6
	bne	TS2818
	movl	_runtcb,a5
	tstw	0x3c(a5)
	bne	TS2829
	movw	0x3a(a5),0x3c(a5)
	movl	d7,-(sp)
	jsr	_setct
	addql	#4,sp
	movl	d0,d5
	bras	TS2829

TS2819:
	bgt	TS2820
	cmpl	#0x5401,d0
	beqs	TS2827
	cmpl	#0x5402,d0
	beqs	TS2828
	cmpl	#0x5403,d0
	beqs	TS2828
	cmpl	#0x5404,d0
	bnes	TS2826

TS2828:
	movl	#0x12,0xfff6(a6)
	bras	TS2826

TS2827:
	movl	#0x12,0xfff6(a6)

TS2825:
	moveq	#0x6,d4

TS2822:
	tstl	0x10(a6)
	bnes	TS2823
	lea	0xfffa(a6),a0
	movl	a0,0x10(a6)
	movl	d4,d0
	bset	#10,d0
	movl	d0,d4

TS2823:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d6,-(sp)
	movl	0xfff6(a6),-(sp)
	movl	0x10(a6),-(sp)
	movl	d7,-(sp)
	movl	d4,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d5
	cmpl	#0x1,d5
	bgts	TS2824

TS2829:
	movl	d5,d0
	bras	TS2816

TS2818:
	movl	d6,d0
	cmpl	#0x5405,d0
	bne	TS2819

TS2821:
	moveq	#0x3,d0
	movl	d0,-(sp)
	moveq	#0x2,d0
	movl	d0,-(sp)
	jsr	_gadnuxa
	addql	#8,sp
	movl	d0,0x10(a6)
	movl	#0x4,0xfff6(a6)

TS2826:
	moveq	#0x7,d4
	bras	TS2822

TS2820:
	cmpl	#0x5406,d0
	beqs	TS2821
	cmpl	#0x5407,d0
	beqs	TS2821
	cmpl	#0x7400,d0
	beq	TS2825
	cmpl	#0x7408,d0
	beq	TS2825
	cmpl	#0x7412,d0
	bnes	TS2826
	bra	TS2825

TS2824:
	clrl	d0

TS2816:
	moveml	(sp)+,#0x20f0	| d4 d5 d6 d7 a5
	unlk	a6
	rts

	.globl	_uxsync
_uxsync:
	link	a6,#0xfffc
	moveml	#0x300,-(sp)	| d6 d7
	clrb	0xffff(a6)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	pea	0xffff(a6)
	moveq	#0x15,d0
	movl	d0,-(sp)
	movl	#0x401,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d6
	bges	TS2830
	movl	d6,d0
	bras	TS2831

TS2830:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x2,d0
	movl	d0,-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d6,-(sp)
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d7
	movl	d6,-(sp)
	jsr	_close
	addql	#4,sp
	clrl	d0

TS2831:
	moveml	(sp)+,#0xc0	| d6 d7
	unlk	a6
	rts

	.globl	_uxlock
_uxlock:
	link	a6,#0x0
	moveml	#0x700,-(sp)	| d5 d6 d7
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	d6,-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	0x10(a6)
	movl	d7,-(sp)
	movl	#0x416,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,d5
	movl	d5,d0
	moveml	(sp)+,#0xe0	| d5 d6 d7
	unlk	a6
	rts

	.globl	_uxplock
_uxplock:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	clrl	-(sp)
	jsr	_plock
	addql	#8,sp
	unlk	a6
	rts

	.globl	_uxchsiz
_uxchsiz:
	link	a6,#0x0
	tstl	0x3a8132
	beqs	TS2832
	movl	0xc(a6),d0
	cmpl	0x3a8132,d0
	bles	TS2832
	moveq	#0xffffffe5,d0
	bras	TS2833

TS2832:
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x8,d0
	movl	d0,-(sp)
	moveq	#0x4,d0
	movl	d0,-(sp)
	pea	0xc(a6)
	movl	0x8(a6),-(sp)
	movl	#0x407,-(sp)
	jsr	_t1req
	addw	#0x20,sp

TS2833:
	unlk	a6
	rts

	.globl	_uxrdchk
_uxrdchk:
	link	a6,#0x0
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x12,d0
	movl	d0,-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	unlk	a6
	rts

	.globl	_uxmount
_uxmount:
	link	a6,#0xffd4
	jsr	_suser
	tstl	d0
	bnes	TS2834
	moveq	#0xffffffff,d0
	bra	TS2835

TS2834:
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,0xfffc(a6)
	blt	TS2835
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffd6(a6)
	movl	0xfffc(a6),-(sp)
	movl	#0x406,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	movl	d0,0xfff4(a6)
	movl	0xfffc(a6),-(sp)
	jsr	_close
	addql	#4,sp
	tstl	0xfff4(a6)
	blts	TS2836
	movw	0xffda(a6),d0
	andw	#0xf000,d0
	cmpw	#0x2000,d0
	beqs	TS2837
	movw	0xffda(a6),d0
	andw	#0xf000,d0
	cmpw	#0x6000,d0
	beqs	TS2837
	moveq	#0xfffffff1,d0
	bras	TS2835

TS2837:
	clrl	-(sp)
	movl	0xc(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,0xfff8(a6)
	blts	TS2835
	movl	_runtcb,-(sp)
	movl	d0,-(sp)
	jsr	_luopnp
	addql	#8,sp
	movl	d0,a0
	movl	0x1c(a0),-(sp)
	movl	0x10(a6),d0
	andl	#0x1,d0
	movl	d0,-(sp)
	clrl	-(sp)
	movw	0xffe2(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_fh_mount
	addw	#0x10,sp
	movl	d0,0xfff4(a6)
	movl	0xfff8(a6),-(sp)
	jsr	_close
	addql	#4,sp

TS2836:
	movl	0xfff4(a6),d0

TS2835:
	unlk	a6
	rts

	.globl	_uxumount
_uxumount:
	link	a6,#0xffd8
	jsr	_suser
	tstl	d0
	bnes	TS2838
	moveq	#0xffffffff,d0
	bra	TS2839

TS2838:
	clrl	-(sp)
	movl	0x8(a6),-(sp)
	moveq	#0xa,d0
	movl	d0,-(sp)
	bsr	_uxcop
	addw	#0xc,sp
	movl	d0,0xfffc(a6)
	blts	TS2839
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	pea	0xffda(a6)
	movl	0xfffc(a6),-(sp)
	movl	#0x406,-(sp)
	jsr	_t1req
	addw	#0x20,sp
	tstl	d0
	blts	TS2840
	movw	0xffde(a6),d0
	andw	#0xf000,d0
	cmpw	#0x2000,d0
	beqs	TS2842
	movw	0xffde(a6),d0
	andw	#0xf000,d0
	cmpw	#0x6000,d0
	beqs	TS2842

TS2840:
	movl	#0xfffffff1,0xfff8(a6)
	bras	TS2841

TS2842:
	movw	0xffe6(a6),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_fh_umount
	addql	#4,sp
	movl	d0,0xfff8(a6)

TS2841:
	movl	0xfffc(a6),-(sp)
	jsr	_close
	addql	#4,sp
	movl	0xfff8(a6),d0

TS2839:
	unlk	a6
	rts

	.globl	_pipecreat
_pipecreat:
	link	a6,#0x0
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	#0x1400,-(sp)
	jsr	_PG_alloc
	addql	#4,sp
	movl	d0,d7
	bles	TS2865
	movw	0x44(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_cvnodepo
	addql	#4,sp
	movl	d0,a3
	lea	0x38(a3),a0
	movl	a0,a4
	movb	#0x1,(a4)
	movb	#0x1,0x1(a4)
	movl	d7,0x6(a4)
	movl	d7,0x2(a4)
	movl	0x2(a4),0xa(a4)
	movw	#0x1,0x16(a4)
	lea	0xe(a4),a0
	movl	a0,0xe(a4)
	movl	a0,0x12(a4)
	movw	#0x1,0x20(a4)
	lea	0x18(a4),a0
	movl	a0,0x18(a4)
	movl	a0,0x1c(a4)
	pea	0x22(a4)
	jsr	_INITSEM
	addql	#4,sp
	movl	a3,d0
	movl	d0,d7

TS2865:
	movl	#0x1042,-(sp)
	movl	d7,-(sp)
	pea	(a5)
	bsrs	_TERMRQ
	addw	#0xc,sp
	moveq	#0xffffff80,d0
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_TERMRQ
_TERMRQ:
	link	a6,#0x0
	movl	0x8(a6),-(sp)
	jsr	_qout
	addql	#4,sp
	movl	0x8(a6),a0
	cmpw	#0x6,0x8(a0)
	bnes	TS671
	clrl	-(sp)
	movl	a0,-(sp)
	jsr	_waikpr
	addql	#8,sp
	bras	TS674

TS671:
	movl	0x10(a6),-(sp)
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	movl	0x8(a6),a0
	movb	0x47(a0),d0
	extw	d0
	extl	d0
	asll	#2,d0
	addl	#_tscall,d0
	movl	d0,a0
	movl	(a0),a0
	jsr	(a0)
	addw	#0xc,sp

TS674:
	unlk	a6
	rts

	.globl	_pipeopen
_pipeopen:
	link	a6,#0x0
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5
	movl	0x8(a6),a5
	moveq	#0xfffffff7,d7
	movl	0x5e(a5),a3
	lea	0x38(a3),a0
	movl	a0,a4
	cmpb	#0x1,(a4)
	bnes	TS719
	addqb	#1,(a4)
	movl	a3,d0
	movl	d0,d7

TS719:
	moveq	#0x44,d0
	movl	d0,-(sp)
	movl	d7,-(sp)
	pea	(a5)
	bsr	_TERMRQ
	addw	#0xc,sp
	moveq	#0xffffff80,d0
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_pipeclose
_pipeclose:
	link	a6,#0x0
	moveml	#0x3c,-(sp)	| a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0x1c(a5),a3
	lea	0x38(a3),a0
	movl	a0,a4
	pea	0x22(a4)
	jsr	_WAIT
	addql	#4,sp
	bset	#1,0x1(a4)
	cmpl	a5,a3
	bnes	TS1185
	clrl	-(sp)
	pea	(a4)
	bsr	_emptybuf
	addql	#8,sp

TS1197:
	pea	0x18(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	beqs	TS1196
	clrl	-(sp)
	clrl	-(sp)
	pea	(a2)
	bsr	_TERMRQ
	addw	#0xc,sp
	bras	TS1197

TS1186:
	clrl	-(sp)
	moveq	#0xffffffe0,d0
	movl	d0,-(sp)
	pea	(a2)
	bsr	_TERMRQ
	addw	#0xc,sp

TS1185:
	pea	0xe(a4)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	bnes	TS1186
	pea	(a5)
	jsr	_putnode
	addql	#4,sp

TS1196:
	pea	0x22(a4)
	jsr	_SIGNAL
	addql	#4,sp
	subqb	#1,(a4)
	bnes	TS1187
	movl	#0x1400,-(sp)
	movl	0xa(a4),-(sp)
	jsr	_PG_free
	addql	#8,sp
	pea	(a3)
	jsr	_putnode
	addql	#4,sp

TS1187:
	moveml	(sp)+,#0x3c00	| a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_pipecancel
_pipecancel:
	link	a6,#0x0
	moveml	#0x1c,-(sp)	| a3 a4 a5
	movl	0x8(a6),a5
	movl	0x32(a5),d0
	addl	#0x38,d0
	movl	d0,a4
	pea	0x22(a4)
	jsr	_WAIT
	addql	#4,sp
	pea	0x18(a4)
	jsr	_firstq

TS730:
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	beqs	TS722
	cmpl	a3,a5
	bnes	TS729
	clrl	-(sp)
	moveq	#0xffffffcb,d0
	movl	d0,-(sp)
	pea	(a3)
	bsr	_TERMRQ
	addw	#0xc,sp

TS722:
	movl	a3,d0
	bnes	TS723
	pea	0xe(a4)
	jsr	_firstq

TS728:
	addql	#4,sp
	movl	d0,a3
	movl	a3,d0
	beqs	TS723
	cmpl	a3,a5
	bnes	TS725
	clrl	-(sp)
	moveq	#0xffffffcb,d0
	movl	d0,-(sp)
	pea	(a3)
	bsr	_TERMRQ
	addw	#0xc,sp

TS723:
	pea	0x22(a4)
	jsr	_SIGNAL
	addql	#4,sp
	bras	TS724

TS729:
	pea	(a3)
	jsr	_nextq
	bras	TS730

TS725:
	pea	(a3)
	jsr	_nextq
	bras	TS728

TS724:
	moveml	(sp)+,#0x3800	| a3 a4 a5
	unlk	a6
	rts

	.globl	_pipereq
_pipereq:
	link	a6,#0x0
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0x8(a6),a5
	movb	0x47(a5),d0
	extw	d0
	extl	d0
	movl	d0,d7
	cmpl	#0x1,d0
	bnes	TS652
	pea	(a5)
	bsr	_pipeopen
	addql	#4,sp
	bra	TS700

TS652:
	movl	0x32(a5),d0
	addl	#0x38,d0
	movl	d0,a4
	pea	0x22(a4)
	jsr	_WAIT
	addql	#4,sp
	movl	d7,d0
	cmpl	#0x4,d0
	beqs	TS660
	cmpl	#0x5,d0
	beqs	TS702
	cmpl	#0x6,d0
	beq	TS706

TS707:
	moveq	#0xffffffcc,d6

TS696:
	pea	0x22(a4)
	jsr	_SIGNAL
	addql	#4,sp
	cmpl	#0xffffff80,d6
	beqs	TS699
	clrl	-(sp)
	movl	d6,-(sp)
	pea	(a5)
	bsr	_TERMRQ
	addw	#0xc,sp

TS699:
	moveq	#0xffffff80,d0
	bra	TS700

TS660:
	btst	#0,0x1(a4)
	beqs	TS661
	btst	#1,0x1(a4)
	bnes	TS701
	btst	#2,0x29(a5)
	beqs	TS661

TS701:
	clrl	d6
	bras	TS696

TS661:
	pea	(a5)
	pea	0x18(a4)

TS705:
	jsr	_addlq
	addql	#8,sp
	pea	(a5)
	pea	(a4)
	bsr	_rwpipe

TS718:
	addql	#8,sp
	movl	d0,d6
	bras	TS696

TS702:
	btst	#1,0x1(a4)
	beqs	TS703
	moveq	#0xffffffe0,d6
	bras	TS696

TS703:
	movl	0x6(a4),d0
	cmpl	0x2(a4),d0
	bnes	TS704
	btst	#0,0x1(a4)
	bnes	TS704
	btst	#2,0x29(a5)
	bnes	TS701

TS704:
	movl	#0xffffff80,0x26(a5)
	pea	(a5)
	pea	0xe(a4)
	bras	TS705

TS706:
	cmpl	#0x1,0x26(a5)
	bne	TS707
	movl	0x1e(a5),-(sp)
	pea	(a4)
	bsrs	_iocr
	bras	TS718

TS700:
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_iocr
_iocr:
	link	a6,#0xffe0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	clrw	0xffe2(a6)
	movw	#0x8000,0xffe6(a6)
	movw	a5,0xffe4(a6)
	movl	0x6(a5),d0
	subl	0x2(a5),d0
	movl	d0,d7
	blts	TS708
	tstl	d7
	bnes	TS717
	btst	#0,0x1(a5)
	bnes	TS717

TS708:
	addl	#0x1400,d7

TS717:
	movl	d7,0xfff0(a6)
	moveq	#0x1e,d0
	movl	d0,-(sp)
	movl	0xc(a6),-(sp)
	pea	0xffe2(a6)
	jsr	_copy_out
	addw	#0xc,sp
	tstl	d0
	beqs	TS715
	moveq	#0xfffffff2,d0
	bras	TS716

TS715:
	moveq	#0x1e,d0

TS716:
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_rwpipe
_rwpipe:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	movl	#0xffffff80,0x26(a4)
	clrl	0x6e(a4)

TS679:
	pea	(a4)
	pea	(a5)
	bsrs	_fillbuf
	addql	#8,sp
	tstl	d0
	bnes	TS679
	pea	(a4)
	pea	(a5)
	bsr	_emptybuf
	addql	#8,sp
	tstl	d0
	bnes	TS679
	movl	0x26(a4),d0
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts

	.globl	_fillbuf
_fillbuf:
	link	a6,#0x0
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	pea	0xe(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	bnes	TS662

TS677:
	clrl	d0
	bra	TS678

TS662:
	movl	0x6(a5),d0
	cmpl	0x2(a5),d0
	bnes	TS663
	btst	#0,0x1(a5)
	beqs	TS677

TS663:
	cmpw	#0x6,0x8(a2)
	bnes	TS664
	pea	(a2)
	jsr	_qout
	addql	#4,sp
	clrl	-(sp)
	pea	(a2)
	jsr	_waikpr
	addql	#8,sp
	bra	TS675

TS664:
	movl	0x1e(a2),d0
	addl	0x6e(a2),d0
	movl	d0,a3
	movl	0x22(a2),d0
	subl	0x6e(a2),d0
	movl	d0,d6
	movl	0x6(a5),d0
	cmpl	0x2(a5),d0
	bcss	TS665
	movl	0xa(a5),d0
	addl	#0x1400,d0
	bras	TS676

TS665:
	movl	0x2(a5),d0

TS676:
	subl	0x6(a5),d0
	movl	d0,d7
	cmpl	d6,d7
	bles	TS666
	movl	d6,d7

TS666:
	tstl	d7
	beqs	TS667
	movl	_proc,-(sp)
	movl	0x56(a2),-(sp)
	movl	d7,-(sp)
	movl	0x6(a5),-(sp)
	pea	(a3)
	jsr	_copy_uu
	addw	#0x14,sp
	addl	d7,a3
	addl	d7,0x6(a5)
	subl	d7,d6
	bclr	#0,0x1(a5)
	movl	0xa(a5),d0
	addl	#0x1400,d0
	movl	0x6(a5),d1
	cmpl	d0,d1
	bnes	TS667
	movl	0xa(a5),0x6(a5)

TS667:
	tstl	d6
	bnes	TS668
	movl	0x22(a2),0x26(a2)
	cmpl	a4,a2
	bnes	TS670
	pea	(a2)
	jsr	_qout
	addql	#4,sp
	bras	TS675

TS670:
	clrl	-(sp)
	movl	0x22(a2),-(sp)
	pea	(a2)
	bsr	_TERMRQ
	addw	#0xc,sp
	bras	TS675

TS668:
	movl	0x22(a2),d0
	subl	d6,d0
	movl	d0,0x6e(a2)

TS675:
	pea	0xe(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	beqs	TS669
	movl	0x6(a5),d0
	cmpl	0x2(a5),d0
	bne	TS663

TS669:
	moveq	#0x1,d0

TS678:
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_emptybuf
_emptybuf:
	link	a6,#0x0
	moveml	#0x33c,-(sp)	| d6 d7 a2 a3 a4 a5
	movl	0x8(a6),a5
	movl	0xc(a6),a4
	pea	0x18(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	bnes	TS680

TS694:
	clrl	d0
	bra	TS695

TS680:
	movl	0x6(a5),d0
	cmpl	0x2(a5),d0
	bnes	TS681
	btst	#0,0x1(a5)
	bnes	TS694

TS681:
	cmpw	#0x6,0x8(a2)
	bnes	TS682
	pea	(a2)
	jsr	_qout
	addql	#4,sp
	clrl	-(sp)
	pea	(a2)
	jsr	_waikpr
	addql	#8,sp
	bra	TS691

TS682:
	movl	0x1e(a2),d0
	addl	0x6e(a2),d0
	movl	d0,a3
	movl	0x22(a2),d0
	subl	0x6e(a2),d0
	movl	d0,d6
	movl	0x6(a5),d0
	cmpl	0x2(a5),d0
	bhis	TS683
	movl	0xa(a5),d0
	addl	#0x1400,d0
	bras	TS693

TS683:
	movl	0x6(a5),d0

TS693:
	subl	0x2(a5),d0
	movl	d0,d7
	cmpl	d6,d7
	bles	TS684
	movl	d6,d7

TS684:
	tstl	d7
	beqs	TS685
	movl	0x56(a2),-(sp)
	movl	_proc,-(sp)
	movl	d7,-(sp)
	pea	(a3)
	movl	0x2(a5),-(sp)
	jsr	_copy_uu
	addw	#0x14,sp
	addl	d7,a3
	addl	d7,0x2(a5)
	subl	d7,d6
	movl	0xa(a5),d0
	addl	#0x1400,d0
	movl	0x2(a5),d1
	cmpl	d0,d1
	bnes	TS692
	movl	0xa(a5),0x2(a5)

TS692:
	movl	0x2(a5),d0
	cmpl	0x6(a5),d0
	bnes	TS685
	bset	#0,0x1(a5)

TS685:
	tstl	d6
	bnes	TS686
	movl	0x22(a2),0x26(a2)
	cmpl	a4,a2
	bnes	TS690
	pea	(a2)
	jsr	_qout
	addql	#4,sp
	bras	TS691

TS690:
	clrl	-(sp)
	movl	0x26(a2),-(sp)
	pea	(a2)
	bsr	_TERMRQ
	addw	#0xc,sp
	bras	TS691

TS686:
	movl	0x22(a2),d0
	subl	d6,d0
	movl	d0,0x6e(a2)

TS691:
	pea	0x18(a5)
	jsr	_firstq
	addql	#4,sp
	movl	d0,a2
	tstl	d0
	beqs	TS687
	movl	0x6(a5),d0
	cmpl	0x2(a5),d0
	bne	TS681

TS687:
	movl	a2,d0
	beqs	TS688
	cmpw	#0x6,0x8(a2)
	beqs	TS688
	tstl	0x6e(a2)
	beqs	TS688
	movl	0x6e(a2),0x26(a2)
	cmpl	a4,a2
	bnes	TS689
	pea	(a2)
	jsr	_qout
	addql	#4,sp
	bras	TS688

TS689:
	clrl	-(sp)
	movl	0x26(a2),-(sp)
	pea	(a2)
	bsr	_TERMRQ
	addw	#0xc,sp

TS688:
	moveq	#0x1,d0

TS695:
	moveml	(sp)+,#0x3cc0	| d6 d7 a2 a3 a4 a5
	unlk	a6
	rts

	.globl	_readpipe
_readpipe:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	0x10(a6),d7
	clrl	-(sp)
	movl	d7,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_pg_wrcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2697
	moveq	#0xfffffff2,d0
	bra	TS2710

TS2697:
	movl	0x1c(a5),d0
	addl	#0x38,d0
	movl	d0,a3
	pea	0x22(a3)
	jsr	_WAIT
	addql	#4,sp
	btst	#0,0x1(a3)
	beqs	TS2698
	btst	#2,0x25(a5)
	beqs	TS2706
	pea	0x22(a3)
	jsr	_SIGNAL
	addql	#4,sp

TS2709:
	clrl	d0
	bra	TS2710

TS2706:
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2707
	moveq	#0xfffffffc,d0
	bra	TS2710

TS2708:
	clrl	-(sp)
	pea	0x18(a3)
	jsr	_sleep
	addql	#8,sp
	pea	0x22(a3)
	jsr	_WAIT
	addql	#4,sp

TS2707:
	btst	#0,0x1(a3)
	beqs	TS2698
	pea	0x22(a3)
	jsr	_SIGNAL
	addql	#4,sp
	btst	#1,0x1(a3)
	beqs	TS2708
	bras	TS2709

TS2698:
	movl	0xc(a6),a4
	bras	TS2699

TS2700:
	btst	#0,0x1(a3)
	bnes	TS2701
	movl	0x6(a3),d0
	cmpl	0x2(a3),d0
	bhis	TS2702
	movl	0xa(a3),d0
	addl	#0x1400,d0
	bras	TS2705

TS2702:
	movl	0x6(a3),d0

TS2705:
	subl	0x2(a3),d0
	movl	d0,d6
	cmpl	d7,d6
	bles	TS2703
	movl	d7,d6

TS2703:
	movl	_runtcb,-(sp)
	movl	_proc,-(sp)
	movl	d6,-(sp)
	pea	(a4)
	movl	0x2(a3),-(sp)
	jsr	_copy_uu
	addw	#0x14,sp
	addl	d6,0x2(a3)
	addl	d6,a4
	subl	d6,d7
	movl	0xa(a3),d0
	addl	#0x1400,d0
	movl	0x2(a3),d1
	cmpl	d0,d1
	bnes	TS2704
	movl	0xa(a3),0x2(a3)

TS2704:
	movl	0x2(a3),d0
	cmpl	0x6(a3),d0
	bnes	TS2699
	bset	#0,0x1(a3)

TS2699:
	tstl	d7
	bnes	TS2700

TS2701:
	clrl	-(sp)
	pea	(a3)
	bsr	_fillbuf
	addql	#8,sp
	tstl	d0
	bnes	TS2701
	clrl	-(sp)
	pea	(a3)
	bsr	_emptybuf
	addql	#8,sp
	tstl	d0
	bnes	TS2701
	pea	0x22(a3)
	jsr	_SIGNAL
	addql	#4,sp
	movl	a4,d0
	subl	0xc(a6),d0

TS2710:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_writepipe
_writepipe:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5
	movl	0x8(a6),a5
	movl	0x10(a6),d7
	clrl	-(sp)
	movl	d7,-(sp)
	movl	0xc(a6),-(sp)
	jsr	_pg_rdcm
	addw	#0xc,sp
	tstl	d0
	beqs	TS2743
	moveq	#0xfffffff2,d0
	bra	TS2754

TS2743:
	movl	0x1c(a5),d0
	addl	#0x38,d0
	movl	d0,a3
	movl	0xc(a6),a4

TS2757:
	pea	0x22(a3)
	jsr	_WAIT
	addql	#4,sp

TS2749:
	movb	0x1(a3),d0
	andb	#0x3,d0
	beqs	TS2744

TS2746:
	btst	#1,0x1(a3)
	beq	TS2747
	pea	0x22(a3)
	jsr	_SIGNAL
	addql	#4,sp
	moveq	#0xd,d0
	movl	d0,-(sp)
	movl	_runtcb,-(sp)
	jsr	_psignal
	addql	#8,sp
	moveq	#0xffffffe0,d0
	bra	TS2754

TS2744:
	movl	0x2(a3),d0
	subl	0x6(a3),d0
	movl	d0,d6
	bges	TS2745
	addl	#0x1400,d6

TS2745:
	cmpl	d7,d6
	bges	TS2746
	pea	0x22(a3)
	jsr	_SIGNAL
	addql	#4,sp
	btst	#2,0x25(a5)
	beqs	TS2755
	clrl	d0
	bra	TS2754

TS2755:
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2756
	moveq	#0xfffffffc,d0
	bra	TS2754

TS2756:
	clrl	-(sp)
	pea	0xe(a3)
	jsr	_sleep
	addql	#8,sp
	bra	TS2757

TS2751:
	movl	0x2(a3),d0

TS2753:
	subl	0x6(a3),d0
	movl	d0,d6
	cmpl	d7,d6
	bles	TS2752
	movl	d7,d6

TS2752:
	movl	_proc,-(sp)
	movl	_runtcb,-(sp)
	movl	d6,-(sp)
	movl	0x6(a3),-(sp)
	pea	(a4)
	jsr	_copy_uu
	addw	#0x14,sp
	addl	d6,0x6(a3)
	addl	d6,a4
	subl	d6,d7
	bclr	#0,0x1(a3)
	movl	0xa(a3),d0
	addl	#0x1400,d0
	movl	0x6(a3),d1
	cmpl	d0,d1
	bnes	TS2747
	movl	0xa(a3),0x6(a3)

TS2747:
	tstl	d7
	beqs	TS2748
	btst	#0,0x1(a3)
	bnes	TS2750
	movl	0x2(a3),d0
	cmpl	0x6(a3),d0
	beqs	TS2748

TS2750:
	movl	0x6(a3),d0
	cmpl	0x2(a3),d0
	bcss	TS2751
	movl	0xa(a3),d0
	addl	#0x1400,d0
	bras	TS2753

TS2748:
	clrl	-(sp)
	pea	(a3)
	bsr	_emptybuf
	addql	#8,sp
	tstl	d0
	bnes	TS2748
	clrl	-(sp)
	pea	(a3)
	bsr	_fillbuf
	addql	#8,sp
	tstl	d0
	bnes	TS2748
	tstl	d7
	bne	TS2749
	pea	0x22(a3)
	jsr	_SIGNAL
	addql	#4,sp
	movl	a4,d0
	subl	0xc(a6),d0

TS2754:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_ERR_LOG
_ERR_LOG:
	link	a6,#0xffe8
	moveml	#0x71c,-(sp)	| d5 d6 d7 a3 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),d6
	movl	0x10(a6),a5
	lea	0xffe8(a6),a0
	movl	a0,a4
	movl	a5,d0
	bnes	TS47
	movl	_proc,a5

TS47:
	movw	d7,(a4)
	movw	d6,0x2(a4)
	movw	0x3a(a5),0x4(a4)
	movw	0x36(a5),0x6(a4)
	movl	_time,0xc(a4)
	moveq	#0x8,d0
	movl	d0,-(sp)
	movl	#0x3a8142,-(sp)
	pea	(a5)
	pea	0x10(a4)
	jsr	_cpyUSU
	addw	#0x10,sp
	clrb	0x17(a4)
	movl	0x18(a6),d0
	addl	#0x18,d0
	movw	d0,0x8(a4)
	btst	#0,d0
	beqs	TS52
	addqw	#1,0x8(a4)

TS52:
	jsr	_spl6
	movl	d0,d5
	movw	_logcnt,0xa(a4)
	addqw	#1,_logcnt
	cmpl	#0xff,d6
	beqs	TS53
	movl	#_logcnt,d0
	subl	_Logpnt,d0
	movw	0x8(a4),d1
	extl	d1
	cmpl	d1,d0
	bles	TS53
	movl	_Logpnt,a3
	movw	0x8(a4),d0
	extl	d0
	addl	d0,_Logpnt
	movl	d5,-(sp)
	jsr	_splx
	addql	#4,sp
	moveq	#0x18,d0
	movl	d0,-(sp)
	pea	(a3)
	pea	(a4)
	jsr	_copy_ss
	addw	#0xc,sp
	tstl	0x18(a6)
	beqs	TS1328
	movl	0x18(a6),-(sp)
	pea	0x18(a3)
	movl	0x14(a6),-(sp)
	jsr	_copy_ss
	addw	#0xc,sp

TS1328:
	movl	#_logq,-(sp)
	jsr	_wakeup
	addql	#4,sp
	tstl	_logtout
	beqs	TS1329
	bra	TS54

TS53:
	clrl	_logtout
	movl	d5,-(sp)
	jsr	_splx
	addql	#4,sp

TS1329:
	cmpl	#0x40,d6
	blt	TS54

	| "\n\0"

	movl	#_chr+448,-(sp)
	jsr	_putstring
	addql	#4,sp
	pea	0x10(a4)
	jsr	_putstring
	addql	#4,sp
	cmpl	#0xff,d6
	bnes	TS1317

	| ": PANIC: "

	movl	#_chr+450,-(sp)
	bras	TS1327

TS1317:
	cmpl	#0xc0,d6
	blts	TS1318

	| ": HALT: "

	movl	#_chr+460,-(sp)
	bras	TS1327

TS1318:
	cmpl	#0x80,d6
	blts	TS1319

	| ": ERROR: "

	movl	#_chr+469,-(sp)
	bras	TS1327

TS1319:
	| ": WARNING: "

	movl	#_chr+479,-(sp)

TS1327:
	jsr	_putstring
	addql	#4,sp
	cmpw	#0x1,(a4)
	bnes	TS1320
	movl	0x14(a6),-(sp)
	bras	TS1326

TS1320:
	movw	(a4),d0
	extl	d0
	asll	#2,d0
	addl	#_errmess,d0
	movl	d0,a0
	movl	(a0),-(sp)

TS1326:
	jsr	_putstring
	addql	#4,sp
	cmpl	#0xff,d6
	bnes	TS1321

	| " - SYSTEM HALTED!\n"

	movl	#_chr+491,-(sp)
	jsr	_putstring
	addql	#4,sp
	clrl	-(sp)
	jsr	_debug
	addql	#4,sp
	movw	(a4),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_stopcpu
	addql	#4,sp

TS1321:
	| "\n\0"

	movl	#_chr+510,-(sp)
	jsr	_putstring
	addql	#4,sp

TS54:
	moveml	(sp)+,#0x38e0	| d5 d6 d7 a3 a4 a5
	unlk	a6
	rts

	.globl	_getloginfo
_getloginfo:
	link	a6,#0x0
	moveml	#0x304,-(sp)	| d6 d7 a5
	movl	0xc(a6),d7
	movl	#0x3c,_logtout
	movl	#0x3a80ca,-(sp)
	jsr	_save
	addql	#4,sp
	tstl	d0
	beqs	TS2866
	moveq	#0xfffffffc,d0
	bra	TS2869

TS2866:
	jsr	_spl6
	movl	_Logpnt,a5
	jsr	_spl0
	cmpl	#_Logbuf,a5
	bhis	TS2867
	clrl	-(sp)
	movl	#_logq,-(sp)
	jsr	_sleep
	addql	#8,sp
	bras	TS2866

TS2867:
	movl	a5,d0
	subl	#_Logbuf,d0
	movl	d0,d6
	cmpl	d7,d0
	bgts	TS2868
	movl	d6,-(sp)
	movl	0x8(a6),-(sp)
	movl	#_Logbuf,-(sp)
	jsr	_copy_out
	addw	#0xc,sp
	tstl	d0
	beqs	TS2870

TS2868:
	moveq	#0xfffffff2,d0
	bras	TS2869

TS2870:
	jsr	_spl6
	movl	_Logpnt,d0
	subl	a5,d0
	movl	d0,d7
	beqs	TS2871
	movl	d7,-(sp)
	movl	#_Logbuf,-(sp)
	pea	(a5)
	jsr	_copy_ss
	addw	#0xc,sp

TS2871:
	movl	d7,d0
	addl	#_Logbuf,d0
	movl	d0,_Logpnt
	jsr	_spl0
	movl	d6,d0

TS2869:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts

	.globl	_logcon
_logcon:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),d7
	movl	0xc(a6),a5
	jsr	_suser
	tstl	d0
	bnes	TS2872
	moveq	#0xffffffff,d0
	bras	TS2880

TS2872:
	cmpl	#0xff,d7
	blss	TS2873
	movl	d7,a5
	moveq	#0x40,d7

TS2873:
	andl	#0xff,d7
	cmpl	#0xff,d7
	bnes	TS2874
	moveq	#0xffffffea,d0
	bras	TS2880

TS2874:
	clrl	-(sp)
	clrl	-(sp)
	pea	(a5)
	clrl	-(sp)
	bsr	_SPRINT
	addw	#0x10,sp
	movl	d0,a5
	movl	a5,a4
	bras	TS2875

TS2876:
	addql	#1,a4

TS2875:
	tstb	(a4)
	bnes	TS2876
	bras	TS2877

TS2878:
	cmpb	#0xa,0xffff(a4)
	bnes	TS2879
	subql	#1,a4
	clrb	(a4)

TS2877:
	cmpl	a5,a4
	bnes	TS2878

TS2879:
	movl	a4,d0
	subl	a5,d0
	addql	#1,d0
	movl	d0,-(sp)
	pea	(a5)
	movl	_runtcb,-(sp)
	movl	d7,-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	bsr	_ERR_LOG
	addw	#0x14,sp

TS2880:
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_ERR_MESS
_ERR_MESS:
	link	a6,#0x0
	moveml	#0x10c,-(sp)	| d7 a4 a5
	movl	0x8(a6),d7
	movl	0x10(a6),a5
	pea	0x18(a6)
	movl	0x14(a6),-(sp)
	pea	(a5)
	moveq	#0x1,d0
	movl	d0,-(sp)
	bsrs	_SPRINT
	addw	#0x10,sp
	movl	d0,a5
	movl	a5,a4
	bras	TS924

TS925:
	addql	#1,a4

TS924:
	tstb	(a4)
	bnes	TS925
	bras	TS926

TS927:
	cmpb	#0xa,0xffff(a4)
	bnes	TS928
	subql	#1,a4
	clrb	(a4)

TS926:
	cmpl	a5,a4
	bnes	TS927

TS928:
	movl	a4,d0
	subl	a5,d0
	addql	#1,d0
	movl	d0,-(sp)
	pea	(a5)
	movl	0xc(a6),-(sp)
	movl	d7,-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	bsr	_ERR_LOG
	addw	#0x14,sp
	moveml	(sp)+,#0x3080	| d7 a4 a5
	unlk	a6
	rts

	.globl	_PRINT
_PRINT:
	link	a6,#0x0
	movl	a5,-(sp)
	movl	0x8(a6),a5
	pea	0x10(a6)
	movl	0xc(a6),-(sp)
	pea	(a5)
	moveq	#0x1,d0
	movl	d0,-(sp)
	bsrs	_SPRINT
	addw	#0x10,sp
	movl	d0,-(sp)
	jsr	_putstring
	addql	#4,sp
	movl	(sp)+,a5
	unlk	a6
	rts

	.globl	_SPRINT
_SPRINT:
	link	a6,#0xfffc
	moveml	#0x30c,-(sp)	| d6 d7 a4 a5
	movl	0xc(a6),a5
	movl	0x14(a6),a4
	movl	#_prbuf,_prbufpnt
	tstl	0x8(a6)
	beqs	TS900
	movl	0x10(a6),d6
	bras	TS901

TS900:
	movl	0x3a801a,a0
	movl	0x3c(a0),d0
	addl	#0xc,d0
	movl	d0,a4
	movl	a4,-(sp)
	addql	#4,a4
	jsr	_copy_fl
	addql	#4,sp
	movl	d0,d6
	movl	a5,d0
	cmpl	d0,d6
	bnes	TS901

TS912:
	movl	a4,-(sp)
	addql	#4,a4
	jsr	_copy_fl
	addql	#4,sp

TS913:
	movl	d0,d6

TS901:
	movl	0x8(a6),-(sp)
	movl	a5,-(sp)
	addql	#1,a5
	bsr	_gc
	addql	#8,sp
	movl	d0,d7
	cmpl	#0x25,d0
	beqs	TS904
	movl	d7,-(sp)
	bsr	_logchar
	addql	#4,sp
	tstl	d0
	beqs	TS901

TS922:
	movl	#_prbuf,d0
	bra	TS923

TS904:
	movl	0x8(a6),-(sp)
	movl	a5,-(sp)
	addql	#1,a5
	bsr	_gc
	addql	#8,sp
	movl	d0,d7
	cmpl	#0x63,d7
	bnes	TS905
	movb	d6,d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	bsr	_logchar

TS910:
	addql	#4,sp
	bras	TS911

TS906:
	movl	d6,-(sp)
	bsr	_printx
	bras	TS910

TS905:
	cmpl	#0x78,d7
	beqs	TS906
	cmpl	#0x58,d7
	bnes	TS914
	movl	d6,-(sp)
	bsr	_printX
	bras	TS910

TS915:
	cmpl	#0x6f,d7
	bnes	TS916
	moveq	#0x8,d0
	bras	TS919

TS916:
	moveq	#0xa,d0

TS919:
	movl	d0,-(sp)
	movl	d6,-(sp)
	bsr	_printn
	addql	#8,sp

TS911:
	tstl	0x8(a6)
	beq	TS912
	movl	(a4)+,d0
	bra	TS913

TS914:
	cmpl	#0x6c,d7
	beqs	TS915
	cmpl	#0x44,d7
	beqs	TS915
	cmpl	#0x64,d7
	beqs	TS915
	cmpl	#0x75,d7
	beqs	TS915
	cmpl	#0x6f,d7
	beqs	TS915
	cmpl	#0x73,d7
	bnes	TS920
	movl	d6,0xfffc(a6)

TS921:
	movl	0x8(a6),-(sp)
	movl	0xfffc(a6),-(sp)
	addql	#1,0xfffc(a6)
	bsrs	_gc
	addql	#8,sp
	movl	d0,d7
	beqs	TS911
	movl	d7,-(sp)
	bsr	_logchar
	addql	#4,sp
	tstl	d0
	beqs	TS921
	bra	TS922

TS920:
	movl	d7,-(sp)
	bsr	_logchar
	addql	#4,sp
	bra	TS901

TS923:
	moveml	(sp)+,#0x30c0	| d6 d7 a4 a5
	unlk	a6
	rts

	.globl	_gc
_gc:
	link	a6,#0x0
	moveml	#0x104,-(sp)	| d7 a5
	movl	0x8(a6),a5
	tstl	0xc(a6)
	beqs	TS902
	movb	(a5),d0
	extw	d0
	extl	d0
	movl	d0,d7
	bras	TS903

TS902:
	pea	(a5)
	jsr	_copy_fb
	addql	#4,sp
	movl	d0,d7
	cmpl	#0xffffffff,d7
	bnes	TS903
	clrl	d7

TS903:
	movl	d7,d0
	andl	#0xff,d0
	moveml	(sp)+,#0x2080	| d7 a5
	unlk	a6
	rts

	.globl	_printn
_printn:
	link	a6,#0x0
	movl	d7,-(sp)
	tstl	0x8(a6)
	bges	TS917
	moveq	#0x2d,d0
	movl	d0,-(sp)
	bsr	_logchar
	addql	#4,sp
	movl	0x8(a6),d0
	negl	d0
	movl	d0,0x8(a6)

TS917:
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	ldiv
	addql	#8,sp
	movl	d0,d7
	beqs	TS918
	movl	0xc(a6),-(sp)
	movl	d7,-(sp)
	bsrs	_printn
	addql	#8,sp

TS918:
	movl	0xc(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	lrem
	addql	#8,sp

	| .long   _errslut

	addl	_chr,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	bsr	_logchar
	addql	#4,sp
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_printx
_printx:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	movl	d7,d0
	moveq	#0xc,d1
	asrl	d1,d0
	andl	#0xf,d0
	addl	_chr,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	bsr	_logchar
	addql	#4,sp
	movl	d7,d0
	asrl	#8,d0
	andl	#0xf,d0
	addl	_chr,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	bsrs	_logchar
	addql	#4,sp
	movl	d7,d0
	asrl	#4,d0
	andl	#0xf,d0
	addl	_chr,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	bsrs	_logchar
	addql	#4,sp
	movl	d7,d0
	andl	#0xf,d0
	addl	_chr,d0
	movl	d0,a0
	movb	(a0),d0
	extw	d0
	extl	d0
	movl	d0,-(sp)
	bsrs	_logchar
	addql	#4,sp
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_printX
_printX:
	link	a6,#0x0
	movl	d7,-(sp)
	movl	0x8(a6),d7
	movl	d7,d0
	moveq	#0x10,d1
	asrl	d1,d0
	movl	d0,-(sp)
	bsr	_printx
	addql	#4,sp
	movl	d7,-(sp)
	bsr	_printx
	addql	#4,sp
	movl	(sp)+,d7
	unlk	a6
	rts

	.globl	_logchar
_logchar:
	link	a6,#0x0
	tstb	0xb(a6)
	beqs	TS907
	cmpl	#_prbuf+99,_prbufpnt
	bnes	TS909

TS907:
	movl	_prbufpnt,a0
	clrb	(a0)
	moveq	#0x1,d0
	bras	TS908

TS909:
	movl	_prbufpnt,a0
	movb	0xb(a6),(a0)
	addql	#1,_prbufpnt
	clrl	d0

TS908:
	unlk	a6
	rts

	.globl	_panic
_panic:
	link	a6,#0x0
	movl	0x8(a6),-(sp)

	| "OS: PANIC: %s - SYSTEM HALTED!\n"

	movl	#_chr+529,-(sp)
	bsr	_PRINT
	addql	#8,sp
	clrl	-(sp)
	jsr	_debug
	addql	#4,sp
	moveq	#0x1,d0
	movl	d0,-(sp)
	jsr	_stopcpu
	addql	#4,sp
	unlk	a6
	rts

	.globl	_PANIC
_PANIC:
	link	a6,#0x0
	clrl	-(sp)
	clrl	-(sp)
	clrl	-(sp)
	movl	#0xff,-(sp)
	movl	0x8(a6),-(sp)
	bsr	_ERR_LOG
	addw	#0x14,sp
	unlk	a6
	rts
